{}
unit CTParam;
{parameters of current trafo (transformation ratio, etc) taken/not into account:
 Principle:
   Currents saved/read in current trafors as such, directly from calculations
   Parameters used (if used) after reading currents from the trafos
   What about "simple" relay modules?
   What about voltage levels?

 SaveCurrentsToFile (in Skemproc.pas): No processing, currents saved as such
 Relay_Show (DrawCurrent) in Skemproc.pas: Currents processed

}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, ComCtrls, StdCtrls, utildef, skemadef, routines, imagodef,
  ExtCtrls;

type
  TCTForm = class(TForm)
    ParamPages: TPageControl;
    ParamTab: TTabSheet;
    SpareTab: TTabSheet;
    ParamGrid: TStringGrid;
    SaturGrid: TStringGrid;
    OKBut: TButton;
    ConnPanel: TPanel;
    ConnImage: TImage;
    ModeBox: TComboBox;
    ApplyBut: TButton;
    CancelBut: TButton;
    HintBut: TButton;
    RemarkMemo: TMemo;
    procedure FormCreate(Sender: TObject);
    procedure OKButClick(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormHide(Sender: TObject);
    procedure ParamGridSelectCell(Sender: TObject; Col, Row: Longint;
      var CanSelect: Boolean);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure ParamGridKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ParamGridDrawCell(Sender: TObject; Col, Row: Longint;
      Rect: TRect; State: TGridDrawState);
    procedure ConnImageMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ModeBoxChange(Sender: TObject);
    procedure ApplyButClick(Sender: TObject);
    procedure CancelButClick(Sender: TObject);
    procedure HintButClick(Sender: TObject);
    procedure ParamPagesChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormActivate(Sender: TObject);
//    procedure CurveGridSelectCell(Sender: TObject; Col, Row: Longint;
//      var CanSelect: Boolean);
  private
    { Private declarations }
    CGActRow_f : integer;    {active row on curve grid}
    pComp_f : TpComp;        {pointer to the CT, set in CTParamShow}
  public
    { Public declarations }
    procedure TrafoRatio(pGrid: TpGrid; rect: TRect);
    procedure CTParamShow(ipComp: longint);
    procedure PutpComp(pComp: TpComp);
    function  CTMultIndex: integer;
  end;

procedure HideCTparam(ipComp : longint); far;  {copy param, hide the parameter form}
procedure UpdateCTsymbol(pComp, pRel: TpComp);
var
  CTForm: TCTForm;

implementation

uses
  imagopas, specialCT, emtp, PQRelay,skemproc, Relcurr, shortcir, elplex,
  recloser, CurrPhas;
{$R *.DFM}
const
  {indices for the rows in the parameter grid}
  PrimRow  = 0;
  SecRow   = 1;
  ConnRow  = 2;
  RatioRow = 3;
  ModeRow  = 4;
  MultRow  = 5;
  dec_p   : char    = ' ';   {for the decimal point, deduced in FormCreate}
  act_row : integer = 0;     {the active row, determined in SelectCell}
  PlateRows = 15;            {must be ParamGrid.rowcount...Should check ??}
  SaturRows = 18;            {must be SaturGrid.rowcount}
//CurveRows = 18;            {must be CurveGrid.rowcount}
  {indices for the damage curve of cables - - - - - -}
//DamagCurRow  = 0;
//DamagTimeRow = 1;
//DamagTextRow = 2;
//DamagShowRow = 3;
  {ColorRow}
  {text position, *2?}
  {indices for transformer damage curve - - - }
  {voltage}
  {power}
  {dry - oil ("liquid immersed")}
  {type YY, YD, etc, grounding!}
  {label}
  {show/not}
  {color row?}
  {label position, *2?}
  {indices for motor starting curve - - - - -}
  {normal current}
  {starting current}
  {starting time}
  {label}
  {show/not}
  {color}
  {label position, *2?}  {siis ainakin 21..24 parametria}
var
  SavePlate: array[0..PlateRows-1] of string;   {for saving parameters for possible "cancel"}
  SaveSatur: array[0..SaturRows-1] of string;   {for saving parameters for possible "cancel"}
//SaveCurve: array[0..CurveRows-1] of string;   {for saving parameters for possible "cancel"}

procedure WriteYorD(Toile: TCanvas; YorD: char; width,height: integer);
{write Y and D on the image for selecting the connection type
 But only for a normal current trafo (not special CT, Sum CT)
 Use bold, colored font for the selected type, else gray, normal font
 canvas  the canvas on which written
 YorD    type for the bold font:
         'Y' for Y (wye) connection, 'b' for Delta a-b, or 'c', for Delta a-c
 width   total width of the image (canvas) on which written
 height  height of the image}
var
  name : string;
begin
  if (CTForm.pComp_f <> nil) then begin
    CTForm.pComp_f^.GetName(name);
  end else begin
    name := gCurrT;              {default value}
  end;
  {clear first = draw an empty rectangle}
  Toile.pen.width := 1;
  Toile.pen.color := clBtnFace;
  Toile.brush.style := bsSolid;
  Toile.brush.color := clBtnFace;
  Toile.rectangle(0,0,width,height);
  {next, the texts}
  Toile.Font.name := 'arial';
  Toile.font.size := 8;
  if (name = gCurrT) {or (name = gSpecCT)} then begin
    {first, write the Y}
    if (YorD = 'Y') then begin            {wye = Y}
      Toile.Font.Style := [fsBold];
      Toile.font.Color := clBlue;
    end else if (YorD = 'b') or (YorD = 'c') or
                (YorD = 'B') or (YorD = 'C') then begin {Delta a-b or Delta a-c}
      Toile.Font.Style := [];
      Toile.font.Color := clGray;
    end;
    Toile.TextOut(2,-1,' Y ');
    {next, write the Delta a-b}
    if (YorD = 'Y') or (YorD = 'c') or (YorD = 'C') then begin
      Toile.Font.Style := [];
      Toile.font.Color := clGray;
    end else begin
      Toile.Font.Style := [fsBold];
      Toile.font.Color := clBlue;
    end;
    Toile.Font.name := 'symbol';
    Toile.TextOut(width div 3,-2,'D');
    Toile.Font.name := 'arial';
    Toile.TextOut((width div 3)+10,-1,'a-b');
    {finally, write the Delta a-c}
    if (YorD = 'Y') or (YorD = 'b') or (YorD = 'B') then begin
      Toile.Font.Style := [];
      Toile.font.Color := clGray;
    end else begin
      Toile.Font.Style := [fsBold];
      Toile.font.Color := clBlue;
    end;
    Toile.Font.name := 'symbol';
    Toile.TextOut(2*(width div 3),-2,'D');
    Toile.Font.name := 'arial';
    Toile.TextOut(2*(width div 3)+10,-1,'a-c');
  end else if (name = gSpecCT) then begin     {special or sum current trafo, only Y possible}
    Toile.Font.color := clGray;
    Toile.Font.style := [];
    Toile.textOut(2,-1,'  Y (only)');
  end else begin
    Toile.Font.color := clGray;
    Toile.Font.style := [];
    Toile.textOut(2,-1,'not applicable');
  end;
end;

function  TCTForm.CTMultIndex: integer;
{index of the multiplication parameter}
begin
  CTMultIndex := MultRow+1;
end;

procedure TCTForm.FormCreate(Sender: TObject);
begin
  {texts for the parameters}
  with ParamGrid do begin
    cells[0,PrimRow ] := 'Primary current';
    cells[0,SecRow  ] := 'Secondary current';
    cells[0,ConnRow ] := 'Connection';
    cells[0,RatioRow] := 'Transformation ratio';
    cells[0,ModeRow]  := 'Relay setting mode';
    cells[0,MultRow]  := 'Multiplier';
    cells[0,6] := 'spare';
    cells[0,7] := 'spare';
    cells[0,8] := 'spare';
    cells[0,9] := 'spare';
    cells[0,11] := 'spare';
    cells[0,12] := 'spare';
    cells[0,13] := 'spare';
  end;
//  with CurveGrid do begin
//    cells[0,DamagCurRow] := 'Cbl Damage Curr (A)';
//    cells[0,DamagTimeRow] := 'Cbl Damage Time (s)';
//    cells[0,DamagTextRow] := 'Name';
//    cells[0,DamagShowRow] := 'Show curve (0=no)';
//  end;
  pComp_f := nil;
  DecimalPoint(dec_p);       {determine decimal point, '.' or ',' in routines.pas}
  {prepare the image (and panel) for determining the connection type, Y or D (wye or delta)}
  ConnPanel.width := ParamGrid.DefaultColWidth;
  ConnPanel.height := ParamGrid.DefaultRowHeight;
  ConnPanel.left := ParamPages.left+ParamTab.left+ParamGrid.left+
                    ParamGrid.DefaultColWidth+ParamGrid.GridLineWidth+1;
  ConnPanel.top := ParamPages.top+ParamTab.top+ParamGrid.top+
                  (ParamGrid.DefaultRowHeight+ParamGrid.GridLineWidth)*ConnRow+1;
  ConnImage.width := ConnPanel.width-4;
  ConnImage.height := ConnPanel.height-4;
  ConnImage.left := 2;
  ConnImage.top := 2;
  ConnPanel.visible := true;
  ConnPanel.BringToFront;
  {initialize parameters..}
  ParamGrid.cells[1,PrimRow] := '1';
  ParamGrid.cells[1,SecRow] := '1';
  ParamGrid.cells[1,RatioRow] := '1';
  ParamGrid.cells[1,ConnRow] := '0';
  ParamGrid.cells[1,ModeRow] := '0';
  ParamGrid.cells[1,MultRow] := '1';
  {..and the image for the connection type}
  WriteYorD(ConnImage.Canvas,'Y',ConnImage.width,ConnImage.height);
  {put the mode selector in place}
  ModeBox.left := ParamGrid.left+ParamGrid.DefaultColWidth+1;
  ModeBox.top := ParamGrid.top+(ParamGrid.DefaultRowHeight+1)*ModeRow;
  ModeBox.BringToFront;
  CGActRow_f := 0;      {initialize the active row on curve grid}
  top := 0;
  left := 0;
  {add flag that form created}
  Imagoo.ReadyEdit.text := Imagoo.ReadyEdit.text+'C';
  {add flag that form created}
  Imagoo.ReadyEdit.text := Imagoo.ReadyEdit.text+'t';
  {add flag that form created}
  Imagoo.ReadyEdit.text := Imagoo.ReadyEdit.text+'p';
end;

procedure HideCTparam(ipComp : longint);
{copy the parameters from the  grids, hide the form}
begin
  CTForm.visible := false;
end;

procedure TCTForm.TrafoRatio(pGrid: TpGrid; rect: TRect);
{calculate and show the transformation ratio prim.current/sec.current
 pGrid  pointer to the grid with the parameters
 rect   rectangle defining the cell}
var
  text : string;  {temporary}
begin
  pGrid^.canvas.pen.color := clBtnFace;
  pGrid^.canvas.brush.color := clBtnFace;
  pGrid^.canvas.rectangle(rect.left,rect.top,rect.left+
               pGrid^.DefaultColWidth,rect.top+pGrid^.DefaultRowHeight);
  {calculate the transformation ratio. LATER...}
  text := '120';        {temporary...}
  pGrid^.canvas.font.name := 'arial';
  pGrid^.canvas.font.size := 8;
  pGrid^.canvas.font.color := clBlack;
  pGrid^.canvas.font.style := [];
  pGrid^.canvas.TextOut(4+rect.left,rect.top+2,text);
end;

procedure TCTForm.PutpComp(pComp: TpComp);
begin
  pComp_f := pComp;
end;

procedure TCTForm.CTParamShow(ipComp: longint);
{show the parameters of a current transformer
 Called in ShowCurrPhasors of CurrPhas}
var
  apu,apv : single;    {temporary}
  apw     : single;    {temporary}
  ii      : integer;   {index}
  ipu     : integer;   {temporary}
  istr    : integer;   {counts string parameters}
  ix,iy   : integer;   {coordinates}
  lbl     : string;    {label}
  ll      : longint;   {temporary}
  name    : string;    {name = type of the component}
  npar    : integer;   {number of parameters}
  offs    : integer;   {offset for parameter index}
  pComp   : TpComp;    {pointer to the trafo}
  pSet    : TpCompSet; {pointer to the common}
//strpar  : string;    {all string parameters in one string}
  txt     : string;    {temporary}
begin
  pComp := TpComp(ipComp);    {pointer to the trafo}
  pComp_f := pComp;           {so that available elsewhere}
  pComp^.GetipSet(ll);        {pointer to the common, as integer}
  pSet := TpCompSet(ll);      {pointer to the common}
  pComp^.GetName(name);       {name = type of the component: plain or special CT}
  {special (summing) trafos have coefficient parameters}
  if (name = gSpecCT) then offs := gSCT_prim-1{2*SummingForm.CTGrid.rowcount}
  else offs := 0;
  {show parameter window only if allowed}
  {check the two first parameters}
{??  use indices given in imagodef.pas !!}
  pComp^.GetPar(PrimRow+1+offs,apu);
  if (apu <= 0) then begin
    apu := 1;
    pComp^.PutPar(PrimRow+1+offs,apu);
  end;
  pComp^.GetPar(SecRow+1+offs,apv);
  if (apv <= 0) then begin
    apv := 1;
    pComp^.PutPar(SecRow+1+offs,apv);
  end;
  {the transformation ratio}
  pComp^.GetPar(ConnRow+1+offs,apw);       {connection}
  if (apw > 0) then apv := apv*sqrt(3);    {delta connected = ratio changes}
  pComp^.PutPar(RatioRow+1+offs,apu/apv);
  pComp^.GetName(name);         {name = type of the component: plain or special CT}
  {special (summing) trafos have coefficient parameters}
  if (name = gSpecCT) then offs := gSCT_prim-1{2*SummingForm.CTGrid.rowcount}
  else offs := 0;
  istr := 0;
//pComp^.GetStringPar(strpar,0);     {string parameters in one string}
  {move parameters to the grid}
  if (pSet^.pCTBox^.checked) then begin
    pComp^.GetNpar(npar);       {number of parameters}
    {parameter values to the grids.}
    for ii:= 1 to npar do begin
      pComp^.Getpar(ii+offs,apu);           {get value of parameter i}
//      if (apu = improbg) then begin         {flag for string-parameter}
//        inc(istr);                          {count string parameters}
//        ExtractParam(istr,';',strpar,txt);  {get string parameter}
//      end else begin
      RemoveSpaces(apu,txt);              {format, and remove spaces, in routines.pas}
//      end;
      if (ii <= ParamGrid.rowcount) then begin  {first parameters in the first grid}
        ParamGrid.Cells[1,ii-1] := txt;   {parameter to grid}
      end else if (ii <= ParamGrid.RowCount+SaturGrid.RowCount) then begin
        {second set of parameters to the second (saturation?) grid}
        SaturGrid.Cells[1,ii-ParamGrid.rowcount-1] := txt;
      end else begin
//      {remaining parameters into the grid for the curves}
//      CurveGrid.Cells[1,ii-ParamGrid.rowcount-SaturGrid.RowCount-1] := txt;
      end;
    end;
    {connection type}
    pComp^.GetPar(gCT_conn+offs,apu);       {connection 0 = Y, else delta}
    if (apu = 0) then WriteYorD(ConnImage.Canvas,'Y',ConnImage.width,ConnImage.height)
    else if (apu = 1) then WriteYorD(ConnImage.Canvas,'b',ConnImage.width,ConnImage.height)
    else   WriteYorD(ConnImage.Canvas,'c',ConnImage.width,ConnImage.height);
    {relay setting mode}
    pComp^.GetPar(gCT_mode+offs,apu);   {0 = prim.curr, 1 = sec.curr, 2 = relative sec.curr}
    ipu := round(apu);
    if (ipu >= 0) and (ipu <= 2) then begin
      ModeBox.text := ModeBox.items[ipu];
    end else begin                      {error case}
      pComp^.PutPar(gCT_mode+offs,0);
      ModeBox.text := ModeBox.items[0];
    end;
    {save the parameters (as strings) for a possible "cancel"}
    for ii := 0 to ParamGrid.RowCount-1 do SavePlate[ii] := ParamGrid.cells[1,ii];
    for ii := 0 to SaturGrid.RowCount-1 do SaveSatur[ii] := SaturGrid.cells[1,ii];
//  for ii := 0 to CurveGrid.RowCount-1 do SaveCurve[ii] := CurveGrid.cells[1,ii];    
    {show the parameters}
    CTForm.visible := true;
  end;
end;

procedure TCTForm.OKButClick(Sender: TObject);
var
  pComp : TpComp;   {pointer to the relay}
begin
  {copy parameters, hide the form}
  CTForm.visible := false;
end;

procedure UpdateRelayRes(pCT: TpComp);
{update the result box of relay(s) connected to the current transformer
pCT   pointer to the  current transformer}
var
  err   : integer;   {error flag}
  ipCT  : longint;   {pointer to the CT as integer}
  jcomp : integer;   {counts components}
  ll    : longint;
  name  : string;    {name = type of the component}
  pComp : TpComp;    {pointer to a component}
  pRes  : TpResMemo; {pointer to the result memo}
  pSet  : TpCompSet; {pointer to the common}
begin
  pCT^.GetipSet(ll);
  pSet := TpCompSet(ll);           {pointer to the common}
  ipCT := longint(pCT);            {pointer to the CT, as integer, for comparisons}
  {scan all components, look for relays}
  pComp := nil;                    {initialize pointer to comp.}
  err := 0;
  jcomp := 0;
  while (err = 0) do begin                     {scan all components}
    pSet^.NextComp(pComp, err,jcomp,true);     {pointer to next component}
    if (err = 0) then begin                    {no errors, else no more components}
      pComp^.GetName(name);                    {name (type) of the component}
      if (name = gPQrel) or (name = gEMrel) or {combined relay}
         (name = gRCrel) or (name = gUDrel) or
         (name = gRelay) or IsInvTimeRelay(name) then begin  { simple relays, in Shorcir.pas}
        pComp^.GetipComp(ll);                  {pointer to the connected CT, as integer}
        {is it this CT?}
        if (ll = ipCT) then begin
          RelayCurrFromCT(pComp); {in Elplex.pas}{get, process and save currents from the CT}
          {simple relays show results in polar form}
          if (name = gRelay) or IsInvTimeRelay(name) then { simple relays, in Shorcir.pas}
            PolarToRelay(pComp, ll);
{relay activation time?, calculate and display?}
          {update the result box (ONLY if visible...}
          pComp^.GetResPoint(pRes);
          if (pRes <> nil) then begin
            if (pRes^.visible) then pComp^.ShowResults;
          end;
        end;
      end;
    end;
  end;
end;

procedure UpdateCTsymbol(pComp, pRel: TpComp);
{add/remove 's' or 'x', change the color of the arrow,
 all this according to the parameters of the CT
 pComp  pointer to the current trafo
 pRel   pointer to the relay connected to the current trafo, if known; nil if not known
 Called in this unit, in Locate.pas,}
var
  AorM : char;       {auto or manual mode}
  indx : integer;    {index of the parameter group}
  ll   : longint;    {temporary}
  name : string;     {name = type of the component}
  pSet : TpCompSet;  {pointer to the common}
begin
  {indicate the mode in the symbol of the current trafo (and the parameter group of the relay)}
  if (pComp <> nil) then begin
    pComp^.GetipSet(ll);
    pSet := TpCompSet(ll);
    {try to find connected relay, if relay not yet known}
    if (pRel = nil) then pSet^.FindRelay(pComp,pRel);       {try to find connected relay}
    {proceed differently, if there is/is not a connected relay}
    if (pRel = nil) then begin                              {there really is no relay}
      pSet^.WriteIndexToCurrTrafo(nil,pComp, 0,' ');        {only mode flag written, no group index}
    end else begin                                          {there is a connected relay}
      pRel^.GetName(name);                                  {name = type of the relay}
      if (name = gRelay) or (IsInvTimeRelay(name)) then begin  {simple relay}
{}        pSet^.WriteIndexToCurrTrafo(nil,pComp, 0,' ');    {only mode flag written, no group index}
      end else begin                  {combined relay, must find index, in skemadef.pas}
        IndexForGroupIndex(longint(pRel), indx,AorM);       {find index for the param.group}
        pSet^.WriteIndexToCurrTrafo(pRel,pComp, indx,AorM); {write mode and group index}
      end;
    end;
  end;
end;

procedure TCTForm.FormDeactivate(Sender: TObject);
{copy parameters from grid to component}
var
  apu,apv : single;    {temporary}
  apw,apx : single;    {temporary}
  errc    : integer;   {error flag}
  errl    : integer;   {error flag}
  gpar    : integer;   {number of parameters in the grid}
  ii      : integer;   {index}
  indx    : integer;   {index for group index}
  inHelp  : boolean;   {cursor in the Help-memo}
  ipu     : integer;   {temporary}
  line    : string;    {one line of text}
  ll      : longint;   {temporary}
  mode    : integer;   {connection mode of the current trafo}
  name    : string;    {name = type of the component}
  npar    : integer;   {number of parameters}
  offs    : integer;   {index offset for the parameters of the special ct}
  oldval  : single;    {old value of the parameter}
  pComp   : TpComp;    {pointer to the CT}
  pCTRel  : TpComp;    {pointer to the relay connected to this CT, if known}
  pRel    : TpComp;    {pointer to the relay connected to this ct}
  pSCT    : TpCOmp;    {pointer to a special current trafo}
  pSet    : TpCompSet; {pointer to the common}
  pSList  : TpList;    {pointer to list of special CT's connected to this CT}
//strpar  : string;    {all string parameters in one string}
  st1,st2 : string;    {temporary}
  st3,st4 : string;    {temporary}
begin
  {check first that the help-memo was not clicked (see pqrelay.pas, or parametr.pas)}
  inHelp := HelpClicked(pComp_f);       {in PQ-relay}
  {must not do this, when deleting, copying or when clicking the help memo}
  pComp := nil;                         {initialize, to keep the compiler happy}
  pSet := nil;
  pRel := nil;
  if (not appl_close) and (not inHelp) and
     (not SetComp.copy_click) then begin
     {must still check the cancel-button . . .}
    if (pComp_f <> nil) then begin      {pointer to the CT, set in CTparamShow}
      pComp := pComp_f;                 {to local}
      pComp^.GetipSet(ll);              {pointer to the common, as integer}
      pSet := TpCompSet(ll);
      pComp^.GetName(name);       {name = type of the component: plain or special CT}
      {special (summing) trafos have coefficient parameters}
      if (name = gSpecCT) then offs := gSCT_prim-1{2*SummingForm.CTGrid.rowcount}
      else offs := 0;
      if (not pComp^.delete_s) then begin
        pComp^.GetNpar(npar);           {number of parameters}
        {number of parameters in the grid}
        gpar := ParamGrid.RowCount+SaturGrid.RowCount{+CurveGrid.RowCount};
        {continue, if enought parameters in the grids}
        if (gpar+offs <= npar) and (npar > 0) then begin
//        strpar := '';
          for ii:=1 to gpar do begin
            if (ii <= ParamGrid.RowCount) then
              line := ParamGrid.Cells[1,ii-1]      {read parameter grid first}
            else if (ii <= ParamGrid.RowCount+SaturGrid.RowCount) then
              {the "saturation" grid next}
              line := SaturGrid.Cells[1,ii-ParamGrid.RowCount-1]
            else
             {};
              {remaining from the grid for the curves}
//            line := CurveGrid.Cells[1,ii-ParamGrid.RowCount-SaturGrid.RowCount-1];
            {pick string parameters separately, only in parameters for curves}
//            if (ii-ParamGrid.RowCount-SaturGrid.RowCount-1 = DamagTextRow) then begin
//              strpar := strpar+line+';';
//              apu := Improbg;                       {as a flag}
//            end else begin
            ValuesFromLine(line,1,true,ipu, apu,apv,apw,apx,st1,st2,st3,st4,errc); {one parameter a time}
//            end;
            {set error flag, it is checked and reset in TCompSet.FormMouseDown. IS it??}
            if (errc <> 0) then begin
              pSet^.err_cs := 1;
            end else begin
              pComp^.getpar(ii+offs,oldval);        {get the old value, for comparisons}
              pComp^.putpar(ii+offs,apu);           {save the parameter to the component}
              if (oldval <> apu) then pSet^.IsChanged := true; {flag the change}
            end;
          end;
//        pComp^.PutStringPar(strpar,0);
        end;
        {if in list (=sum) of a special current trafo, update spec.CT}
        if (name = gSpecCT) then begin        {itself = special CT}
          SummingForm.UpdateConnImage(pComp);
          UpdateAndDisplay(pComp);            {update and display the sum of the spec.CT}
        end else begin                        {ordinary CT}
          pComp^.GetpList(pSList);            {pointer to list of special CT's}
          if (pSList <> nil) then begin       {there is a list}
            if (pSlist^.count > 0) then begin
              for ii := 0 to pSlist^.count-1 do begin
                pSCT := pSlist^.Items[ii];      {pointer to the special ct}
                SummingForm.UpdateConnImage(pSCT);
                UpdateAndDisplay(pSCT);         {update and display the sum of the spec.CT}
              end;
            end;
          end;
        end;
//      pComp^.GetipComp(ll);      {pointer to the special CT}
//        if (ll <> 0) then begin
//          pSCT := TpComp(ll);
//          UpdateAndDisplay(pSCT);  {update and display the sum of the spec.CT}
//        end;
      end;
    end;
    if (Sender <> ApplyBut) then CTForm.visible := false;   {done also elsewhere...}
    {update the graph, if visible}
    if (RelayCurr.visible) then begin
      pRel := TpComp(RelayCharact.tag);
      Relay_Show(pRel,'real');              {update graph, if visible}
    end else begin
      {recalculate activation time (part of Relay_Show),but only after a short
       circuit calculation.}
      if (SetComp.appl_op = 6) or (SetComp.appl_op = 7) or
         (SetComp.appl_op = 8) or (SetComp.appl_op = 11) then begin
        {Pointer to relay saved as descrP, in GroupActivation, of Shortcmp.pas}
        pComp^.GetDescrP(st1,st2,st3);
        if (st2 <> '') then begin
          LongintFromLine(st2,1,ll,errl);     {in routines.pas}
          if (ll <> 0) then begin
            pRel := TpComp(ll);
            {now, finally, calculate and show the activation time}
            RelayActTime(pRel);               {in Relcurr.pas}
          end;
        end;
      end;
    end;
    {update the result box of the connected relay(s), if any, and if visible}
    if (pComp <> nil) then UpdateRelayRes(pComp);    {this unit}
    {clear the grids, initialize, for the next component, but not when apply button clicked}
    if (Sender <> ApplyBut) then begin
      for ii := 0 to ParamGrid.rowcount-1 do ParamGrid.cells[1,ii] := '0';
      for ii := 0 to SaturGrid.rowcount-1 do SaturGrid.cells[1,ii] := '0';
      {initialize nominal currents and transformation ratio}
      ParamGrid.cells[1,PrimRow] := '1';
      ParamGrid.cells[1,SecRow] := '1';
      ParamGrid.cells[1,RatioRow] := '1';
      {initialize connection image Y or D}
      WriteYorD(ConnImage.Canvas,'Y',ConnImage.width,ConnImage.height);
      {initialize mode}
      ModeBox.text := ModeBox.items[0];
    end;
    {update CT parameter display in PQ- etc. relays, if relay form visible}
    if (PQform.visible) then begin
      GridCalc.displayCTpar;        {in any case, even if different CT+relay, in PQRelay.pas}
    end;
    if (RecloserForm.visible) then begin
      RCGridCalc.displayCTpar;
    end;
    {update phasor display        (if visible}
    UpdateCurrPhasors;            {in CurrPhas.pas}
   {pRel fetched above may not be correct for this CT}
    if (pRel <> nil) then begin
      pRel^.GetipComp(ll);        {pointer to CT connected to this relay}
      if (ll = longint(pComp)) then pCTRel := pRel
      else pCTRel := nil;
    end else begin
      pCTRel := nil;              {connected relay not known}
    end;
    UpdateCTsymbol(pComp, pCTRel);  {some parameters indicated with small changes in the symbol}

//    {indicate the mode in the symbol of the current trafo (and the parameter group of the relay)}
//    if (pComp <> nil) then begin
//      {try to find connected relay, if relay not yet known}
//      if (pRel = nil) then pSet^.FindRelay(pComp,pRel);      {try to find connected relay}
//      {proceed differently, if there is/is not a connected relay}
//      if (pRel = nil) then begin                     {there really is no relay}
//        pSet^.WriteIndexToCurrTrafo(nil,pComp, 0);   {only mode flag written, no group index}
//      end else begin                                 {there is a connected relay}
//        pRel^.GetName(name);                         {name = type of the relay}
//        if (name = gRelay) or (IsInvTimeRelay(name)) then begin  {simple relay}
//{}          pSet^.WriteIndexToCurrTrafo(nil,pComp, 0); {only mode flag written, no group index}
//        end else begin                               {combined relay, must find index}
//          IndexForGroupIndex(longint(pRel), indx);   {find index for the param.group}
//          pSet^.WriteIndexToCurrTrafo(pRel,pComp, indx); {write mode and group index}
//        end;
//      end;
//    end;

  end;
end;

procedure TCTForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  ll      : longint;   {temporary}
  pSet    : TpCompSet; {pointer to the common}
begin
  {eventual "delete component" must be handled here, because the form has focus}
  if (pComp_f <> nil) then begin
    pComp_f^.GetipSet(ll);
    pSet := TpCompSet(ll);                    {pointer to the common}
    if (pSet^.pActComp <> nil) then begin     {some component active}
      if (key = 46) then begin                {delete-key}
        pSet^.FormKeyDown(Key, Shift);        {delete the component}
      end;
    end;
  end;
end;


procedure TCTForm.FormHide(Sender: TObject);
var
  ll : longint;
begin
  if (not appl_close) then begin
//    if (pHelp <> nil) then pHelp^.visible := false;
//    pHelp := nil;
    pComp_f^.GetipSet(ll);
    unmark(ll);
  end;
end;

procedure TCTForm.ParamGridSelectCell(Sender: TObject; Col, Row: Longint;
  var CanSelect: Boolean);
begin
  {save the row-index}
  act_row := row;
  {must not write to the transformation ratio-cell}
  if (row = RatioRow) or (row = ConnRow) then begin
    ParamGrid.options := ParamGrid.options-[goEditing,goAlwaysShowEditor];
  end else begin                           {writing allowed in other cells}
    ParamGrid.options := ParamGrid.options+[goEditing,goAlwaysShowEditor];
  end;
end;

procedure TCTForm.FormKeyPress(Sender: TObject; var Key: Char);
begin
  {only numbers and . or , accepted}
  if not(((key >= '0') and (key <= '9')) or
          (key  = ',') or  (key  = '.')  or
         {(key  = 'e') or  (key  = 'E')  or}
         {(key  = '-') or  (key  = '+')  or}
          (key  = #8 ) or
          (key =  #3 ) or (key = #22)) then       {"copy" and "paste"}
           key := #0;                             {neglect other keys }
  {check correct char for decimal point}
  if      (dec_p = ',') and (key = '.') then key := ','
  else if (dec_p = '.') and (key = ',') then key := '.';
end;

procedure TCTForm.ParamGridKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  apu   : single;  {temp}
  conn  : integer; {connection type: 0 = Y, 1 and 2 = delta}
  e1,e2 : integer; {error flag}
  e3    : integer; {error flag}
  pri   : single;  {primary current}
  ratio : single;  {transformation ratio}
  sec   : single;  {secondary current}
  txc   : string;  {checked string}
  txt   : string;  {temporary}
begin
  {calculate and display the transformation ratio, if editing prim. or sec.current}
  if (act_row = primrow) or (act_row = secrow) or
     (act_row = connrow) then begin
    {check that reasonable data}
    txt := ParamGrid.cells[1,primRow];       {get primary current}
    chkfloat(txt,e1,txc);
    if (e1 = 0) then pri := strtofloat(txc) else pri := 1;
    txt := ParamGrid.cells[1,secRow];       {get secondary current}
    chkfloat(txt,e2,txc);
    if (e2 = 0) then sec := strtofloat(txc) else sec := 1;
    txt := ParamGrid.cells[1,connRow];       {get connection type}
    chkfloat(txt,e3,txc);
    if (e3 = 0) then apu := strtofloat(txc) else apu := 0;
    if (apu >= 0) and (apu <= 2) then conn := round(apu) else conn := 0;
    {calculate only, if reasonable currents}
    if (e1+e2 = 0) and (pri > 0) and (sec > 0) then begin
      apu := pri/sec;
      if (conn <> 0) then ratio := apu/sqrt(3) else ratio := apu; {Delta = smaller ratio}
      txt := SixPlaces(ratio){TwoDecimalsAtMost(ratio)}; {transform to string, in emtp.pas}
      ParamGrid.cells[1,ratioRow] := txt;
    end else begin
      ParamGrid.cells[1,ratioRow] := '';
    end;
  end;
end;

procedure TCTForm.ParamGridDrawCell(Sender: TObject; Col, Row: Longint;
  Rect: TRect; State: TGridDrawState);
begin
  {gray out the ratio, because it cannot be edited}
  if (col = 1) and (row = RatioRow) then begin
    ParamGrid.canvas.pen.color := clBtnFace;
    ParamGrid.canvas.brush.color := clBtnFace;
    ParamGrid.canvas.brush.style := bsSolid;
    ParamGrid.canvas.rectangle(rect.left,rect.top,rect.left+
               ParamGrid.DefaultColWidth,rect.top+ParamGrid.DefaultRowHeight);
    {write the ratio, because the text is hidden by the gray color}
    ParamGrid.canvas.font.name := 'arial';
    ParamGrid.canvas.font.size := 8;
    ParamGrid.canvas.font.color := clBlack;
    ParamGrid.canvas.font.style := [];
    ParamGrid.canvas.TextOut(4+rect.left,rect.top+2,ParamGrid.cells[1,RatioRow]);
  end;
end;

procedure TCTForm.ConnImageMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
{determine connection type, Y or delta.
  = Y, if clicked on the left part of the image
  = D, if clicked on the right part of the image
 only Y possible for a special(summing) CT}
var
  key  : word;
  name : string;
begin
  pComp_f^.GetName(name);                           {name = type of the CT}
  if (name = gCurrT) or (name = gSpecCT) then begin {not summing trafo}
    if (X < ConnImage.width div 3) then begin       {first third, = Y}
      WriteYorD(ConnImage.Canvas,'Y',ConnImage.width,ConnImage.height);
      ParamGrid.cells[1,ConnRow] := '0';
    end else if (X < 2*(ConnImage.width div 3)) then begin  {second third: Delta a-b}
      WriteYorD(ConnImage.Canvas,'b',ConnImage.width,ConnImage.height);
      ParamGrid.cells[1,ConnRow] := '1';
    end else begin                                  {third third: Delta a-c}
      WriteYorD(ConnImage.Canvas,'c',ConnImage.width,ConnImage.height);
      ParamGrid.cells[1,ConnRow] := '2';
    end;
  end else begin
    ParamGrid.cells[1,ConnRow] := '0';              {only Y possible}
  end;
  {must "simulate" a key-up event, to change the ratio, if needed}
  key := 0;
  ParamGridKeyUp(Sender,key,[]);                    {no parameters needed}
end;

procedure TCTForm.ModeBoxChange(Sender: TObject);
{change the contents in the corresponding cell (= change the parameter)}
var
  found : boolean;  {mode found}
  ii    : integer;  {index}
  nm    : integer;  {number of items}
begin
  nm := ModeBox.items.count;  {number of items (modes)}
  found := false;             {initialize}
  if (nm > 0) then begin
    for ii := 0 to nm-1 do begin
      if (ModeBox.text = ModeBox.Items[ii]) then begin    {mode found?}
        ParamGrid.cells[1,ModeRow] := inttostr(ii);       {corresponding parameter}
        found := true;
        break;
      end;
    end;
  end else begin              {error case, modes not found???}
    found := false;
  end;
  {default value, if not found, or if false}
  if (not found) then begin
    ParamGrid.cells[1,ModeRow] := '0';
    ModeBox.text := ModeBox.items[0];
  end else begin
    {showmessage('found');}
  end;
end;

procedure TCTForm.ApplyButClick(Sender: TObject);
begin
  {parameters to the component, but do not hide the form}
  FormDeactivate(ApplyBut);
end;

procedure TCTForm.CancelButClick(Sender: TObject);
{recall the original (unchanged) parameters, hide the form}
var
  ii : integer;  {index}
begin
  {recall the original parameters, as strings}
  for ii := 0 to ParamGrid.RowCount-1 do ParamGrid.cells[1,ii] := SavePlate[ii];
  for ii := 0 to SaturGrid.RowCount-1 do SaturGrid.cells[1,ii] := SaveSatur[ii];
//for ii := 0 to CurveGrid.RowCount-1 do CurveGrid.cells[1,ii] := SaveCurve[ii];
  {parameters to the component, and hide the form}
  FormDeactivate(CancelBut);
end;

procedure TCTForm.HintButClick(Sender: TObject);
{display the help-memo}
var
  pHelp : TpMemo;     {pointer to the help-memo}
  pMod  : TpElComp;   {pointer to the model component}
begin
  if (pComp_f <> nil) then begin
    pComp_f^.GetpMod(pMod);
    pMod^.GetpHelp(pHelp);
    if (pHelp <> nil) then begin
      pHelp.top := 200;
      pHelp.left := 100;
      pHelp.width := 450;
      pHelp.height := 300;
      pHelp.visible := true;
    end;
  end;
end;

procedure TCTForm.ParamPagesChange(Sender: TObject);
begin
  {display/not the "menu" for connections}
  ConnPanel.visible := (ParamPages.ActivePage = ParamTab);
  {on curve grid, text is allowed on some row(s)}
//  if (ParamPages.ActivePage = CurveTab) then begin
//    {may be already on the text row}
//    if (CGActRow_f = DamagTextRow) then KeyPreview := false
//    else KeyPreview := true;
//  end else begin
//    KeyPreview := true;   {only numbers accepted, as a default}
//  end;
end;

//procedure TCTForm.CurveGridSelectCell(Sender: TObject; Col, Row: Longint;
//  var CanSelect: Boolean);
//begin
//  CGActRow_f := row;     {save active row}
//  {allow all (character) on the text row}
//  if (row = DamagTextRow) then KeyPreview := false else KeyPreview := true;
//end;

procedure TCTForm.FormShow(Sender: TObject);
begin
  ActiveControl := nil; {focus to main form, for the case of delete-key pressed...}
  {... does not work..?, repeated in FormActivate, below}
end;

procedure TCTForm.FormActivate(Sender: TObject);
begin
  ActiveControl := nil; {focus to main form, for the case of delete-key pressed}
end;



(*  NOT needed, similar exists, in Skemadef.pas . . .
procedure FindRelay(pCT: TpComp; var pRel : TpComp);
{find relay (if any) connected to this current trafo.
 pCT   pointer to the current trafo
 pRel  pointer to the relay (if found)}
var
  err   : integer;   {error flag, end-flag}
  ipCT  : longint;   {pointer to this current trafo, as integer}
  jcomp : integer;   {counts components}
  ll    : longint;   {temporary}
  name  : string;    {name = type of the component}
  pComp : TpComp;    {pointer to a component}
  pSet  : TpCompSet; {pointer to the common}

begin
  ipCT := longint(pCT);                        {pointer as integer}
  pCT^.GetipSet(ll);
  pSet := TpCompSet(ll);                       {pointer to the common}
  {scan all components, look for relays}
  pComp := nil;                                {initialize pointer to comp.}
  err := 0;
  jcomp := 0;
  while (err = 0) do begin                     {scan all components}
    pSet^.NextComp(pComp, err,jcomp,true);     {pointer to next component}
    if (err = 0) then begin                    {no errors, else no more components}
      pComp^.GetName(name);                    {name (type) of the component}
      if (name = gPQrel) or (name = gEMrel) or {combined relay}
         (name = gRCrel) or (name = gUDrel) or

         (name = gRelay) or IsInvTimeRelay(name) then begin  { simple relays, in Shorcir.pas}
        pComp^.GetipComp(ll);                  {pointer to the connected CT, as integer}
        {is it this CT?}
        if (ll = ipCT) then begin
UNFINISHED, not needed ...
        end;
      end;
    end;
  end;
end;
*)


end.
