unit CapCalc;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls, ExtCtrls, Grids, Buttons, Routines, Skemadef, Imagodef,
  ComCtrls;

type
  TCapForm = class(TForm)
    WyeBut: TSpeedButton;
    DeltaBut: TSpeedButton;
    Wye2But: TSpeedButton;
    Wye2gBut: TSpeedButton;
    MesButton: TSpeedButton;
    ResultsLabel: TLabel;
    F50But: TRadioButton;
    f60But: TRadioButton;
    ValueGrid: TStringGrid;
    ResultGrid: TStringGrid;
    CalcPanel: TPanel;
    CalculateBut: TButton;
    VoltTextEdit: TEdit;
    VoltEdit: TEdit;
    TopMenu: TMainMenu;
    FileMenu: TMenuItem;
    ExitItem: TMenuItem;
    CapCopyBut: TSpeedButton;
    CapLabel: TLabel;
    HelpMenu: TMenuItem;
    HelpPageControl: TPageControl;
    CloseSheet: TTabSheet;
    PurposeSheet: TTabSheet;
    HowSheet: TTabSheet;
    EquationsSheet: TTabSheet;
    EquationsMemo: TMemo;
    CloseBut: TButton;
    SelectLabel: TLabel;
    DeltaImg: TImage;
    WyeImg: TImage;
    Wye2Img: TImage;
    Wye2gImg: TImage;
    DeltaLabel: TLabel;
    WyeLabel: TLabel;
    Wye2label: TLabel;
    Wye2Label2: TLabel;
    Wye2gLabel: TLabel;
    Wye2gLabel2: TLabel;
    ParamLabel: TLabel;
    ParamMemo: TMemo;
    Wye2Label3: TLabel;
    SeparShape: TShape;
    CalcLabel: TLabel;
    CalcLabel2: TLabel;
    Note1Label: TLabel;
    TermSheet: TTabSheet;
    Note1Label1: TLabel;
    Note1Label2: TLabel;
    CapButImage: TImage;
    Note1Label3: TLabel;
    TermImage: TImage;
    TermMemo: TMemo;
    Note2Label: TLabel;
    Note2Memo: TMemo;
    Note2Image: TImage;
    FaultMemo: TMemo;
    FaultLabel: TLabel;
    PurposeMemo: TMemo;
    PurposeLabel: TLabel;
    NpNsImage: TImage;
    procedure ExitItemClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CalculateButClick(Sender: TObject);
    procedure DeltaButClick(Sender: TObject);
    procedure WyeButClick(Sender: TObject);
    procedure Wye2ButClick(Sender: TObject);
    procedure Wye2gButClick(Sender: TObject);
    procedure F50ButClick(Sender: TObject);
    procedure f60ButClick(Sender: TObject);
    procedure ValueGridKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure DeltaButMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure WyeButMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Wye2ButMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Wye2gButMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure VoltEditKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure CapCopyButClick(Sender: TObject);
    procedure HelpMenuClick(Sender: TObject);
    procedure CloseButClick(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
    procedure CopyParam(ipComp: longint);
  end;

var
  CapForm: TCapForm;

implementation

uses Imagopas;

{$R *.DFM}

const
  d_p : char = ',';   {may be changed} {is this needed ??}
  ValueGridHeight : integer = 100;
  faulted : string = '0';
  {rows of input parameters}
  VoltRow = 0;   {nominal voltage}
  VAnRow = 1;    {nominal apparent power}
  NpRow = 2;     {number in parallel}
  NsRow = 3;     {number in series}
  StepRow = 4;   {number of steps}
  FaultRow = 5;  {number of faulted}
  {rows of the results}
  CcRow   =  0;    {capacitance of one capacitor}
  IcRow   =  1;    {nom. current of one capacitor}
  VcRow   =  2;    {voltage applied to one capacitor}
  VpcRow  =  3;    {volt. applied to one cap. in % of nominal voltage}
  IbRow   =  4;    {current of one branch}
  CbRow   =  5;    {equivalent capacitance of one branch}
  XbRow   =  6;    {impedance of one branch}
  ItRow   =  7;    {total line current of one step}
  VarRow  =  8;    {total VAR of one step}
  IlRow   =  9;    {total line current of the bank}
  VartRow = 10;    {total VAR of the bank}
  InRow   = 11;    {neutral current (when fault)}
  VxRow   = 12;    {overvoltage (when fault)}
  WidthNoHelp  = 480;  {width without the help memo}
  WidthHelp    = 577;  {widht with the help memo}
  HeightNoHelp = 320;  {height without the help memo}
  HeightHelp   = 610;  {height with the help memo}

var
  MesBut : TSpeedButton;
  Vn   : single;        {nominal voltage}
  Qn   : single;        {nominal apparent power}
  Np   : single;        {number in parallel}
  Ns   : single;        {number in series}
  Nstp : single;        {number of "steps" = capacitor blocks}
  Vll  : single;        {line-line voltage}
  freq : single;        {frequency}

procedure TCapForm.ExitItemClick(Sender: TObject);
begin
//  application.terminate;
  CapForm.visible := false;
end;

procedure TCapForm.FormCreate(Sender: TObject);
begin
  {names of the parameters}
  ValueGrid.cells[0,VoltRow] := 'nominal voltage (one cap.) V';
  ValueGrid.cells[0,VAnRow] := 'nominal VAR (one cap.) VA' ;
  ValueGrid.cells[0,NpRow] := 'number of cap. in parallel';
  ValueGrid.cells[0,NsRow] := 'number of cap. in series';
  ValueGrid.cells[0,StepRow] := 'number of steps (stages)';
  {default values of the parameters}
  ValueGrid.cells[1,VoltRow] := '7620';
  ValueGrid.cells[1,VAnRow] := '200e3';
  ValueGrid.cells[1,NpRow] := '2';
  ValueGrid.cells[1,NsRow] := '4';
  ValueGrid.cells[1,StepRow] := '1';
  {names of the results}
  ResultGrid.cells[0,CcRow] := 'capacitance of one cap.';
  ResultGrid.cells[0,IcRow] := 'nom. current of one cap.';
  ResultGrid.cells[0,VcRow] := 'voltage over one cap.';
  ResultGrid.cells[0,VpcRow] := 'voltage over one cap % of Vnom';
  ResultGrid.cells[0,IbRow] := 'current in one branch (leg)';
  ResultGrid.cells[0,CbRow] := 'equiv.capac. of one branch (leg)';
  ResultGrid.cells[0,XbRow] := 'impedance of one branch (leg)';
  ResultGrid.cells[0,ItRow] := 'total line current of one step (stage)';
  ResultGrid.cells[0,VarRow]:= 'total VAR of one step (stage)';
  ResultGrid.cells[0,IlRow] := 'total line current of the bank';
  ResultGrid.cells[0,VartRow] := 'total VAR of the bank';
  ResultGrid.cells[0,InRow] := 'neutral current (when fault)';
  ResultGrid.cells[0,VxRow] := 'overvoltage (when fault)';
  ResultGrid.color := $00F0F0F0;  {light gray}
  MesBut := MesButton;
  DecimalPoint(d_p);
  ValueGridHeight := ValueGrid.height;  {save original heights}
  {set the size without the help memo}
  width := WidthNoHelp;
  Height := HeightNoHelp;
  {add flag that form created}
  Imagoo.ReadyEdit.text := Imagoo.ReadyEdit.text+'c';
end;

procedure TCapForm.CalculateButClick(Sender: TObject);
{calculate the currents, etc.}
const
  pi = 3.14159265;
  sqrt3 = 1.7320508;
var
  apu,apv     : single;   {temporary}
  Cn          : single;   {capacitance of one capacitor}
  Cb          : single;   {capacitance of one branch}
  er,er1,er2  : integer;  {error flag}
  errGrid     : boolean;  {error flag for parameters in the grid}
  errVll      : boolean;  {error in line-line voltage}
  flt         : single;   {number of faulted chains (?)}
  ii          : integer;  {index}
  Ibr         : single;   {(total) current in one branch of wye or delta}
  Inom        : single;   {nominal current}
  Ig          : single;   {neutral current}
  ipar        : integer;  {number of parameters}
  Iph         : single;   {phase current (line current) of one "step"}
  Ipht        : single;   {total phase current}
  line        : string;   {temporary}
  p1,p2,p3,p4 : single;   {temporary = the parameters on the line}
  Qtotn       : single;   {total nominal apparent power}
  s1,s2,s3,s4 : string;   {temporary = parameters as strings}
  VArstp      : single;   {total VAr of one step}
  Vcap        : single;   {voltage of one cap.}
  Vcappc      : single;   {voltage of one cap. in percent}
  Vover       : single;   {overvoltage, when fault}
  txt         : string;   {temporary}
  Zc          : single;   {impedance}
  param : array[0..FaultRow-1] of single;  {the parameters}
begin
  {read parameters from the table}
  er := 0;
  for ii := 0 to FaultRow-1 do begin
    line := ValueGrid.cells[1,ii];                                {parameter as string}
    ValuesFromLine(line,1,false,ipar,p1,p2,p3,p4,s1,s2,s3,s4,er); {change to numerical}
    if (er = 0) then param[ii] := p1
    else break;
  end;
  {the line-line voltage separately}
  line := VoltEdit.text;                                         {parameter as string}
  ValuesFromLine(line,1,false,ipar,p1,p2,p3,p4,s1,s2,s3,s4,er2); {change to numerical}
  if (er = 0) then Vll := p1
  else Vll := 1;                                                 {just some value}
  {if connected wyes, read number of faulted units}
  if (Wye2But.down) then begin
    line := ValueGrid.cells[1,FaultRow];                            {parameter as string}
    flt := -1;                                                      {initialize}
    ValuesFromLine(line,1,false,ipar,flt,p2,p3,p4,s1,s2,s3,s4,er1); {change to numerical}
  end else begin
    er1 := 0;
    flt := 0;
  end;
  {error flag for in parameters in grid}
  errGrid := (er <> 0) or (er1 <> 0) or (flt < 0) or
             (param[0] <= 0) or (param[1] <= 0) or (param[2] <= 0) or
             (param[3] <= 0) or (param[4] <= 0);
  {error flag for line-line voltage}
  errVll := (er2 <>0) or (Vll <= 0);
  {continue, if no errors}
  if not (errgrid or errVll) then begin
    {copy parameters to named variables}
    Vn := param[VoltRow];
    Qn := param[VAnRow];
    Np := param[NpRow];
    Ns := param[NsRow];
    Nstp := param[StepRow];
    if (f50But.checked) then freq := 50 else freq := 60; {frequency}
    ValueGrid.color := clWhite;
    VoltEdit.color := clWhite;
    {carry out the actual calculations: ... }
    {- total nominal (reactive) power       }
    {- voltage of one capacitor ("cell")    }
    {- nominal capacitance of one capacitor }
    {- nominal current of one capacitor     }
    {- current in Y-branch (and delta?      }
    {- total line current                  -}
    {- impedance of one branch              }
    {- ... and some currents in faulted case}
    Cn := Qn/(2*pi*freq*Vn*Vn);               {capacitance}
    Cb := Cn*Np/Ns;                           {capacitance of one branch}
    Inom := Qn/Vn;                            {nominal current}
    Zc := (Ns/Np)/(2*pi*freq*Cn);             {impedance of one branch}
    apu := 2*pi*freq*Cn*Np*Vll/Ns;            {preliminary current in one branch}
    apv := Vll/Ns;                            {preliminary voltage over one cap.}
    Ig := 0;
    Vover := 0;
    if (DeltaBut.down) then begin             {connected in delta}
      Ibr := apu;                             {current in one branch}
      Iph := Ibr*sqrt3;                       {total line current}
      Vcap := apv;                            {voltage over one cap.}
    end else if (WyeBut.down) then begin      {connected in wye}
      Ibr := apu/sqrt3;
      Iph := Ibr;
      Vcap := apv/sqrt3;
    end else if (Wye2But.down) then begin     {two connected wye's}
      Ibr := apu/sqrt3;
      Iph := 2*Ibr;
      Vcap := apv/sqrt3;
      {calculate neutral current, excess voltage in case of faults}
      if (flt >= 0) and (flt <= Np) then begin
        Ig := (Inom*Np*(Vll/sqrt3)*3*flt)/(Ns*Vn*(6*ns*(Np-flt)+5*flt));
        Vover := ((Vll/sqrt3)/(Ns*Vn))*(600*Ns*Np)/(6*Ns*(Np-flt)+5*flt);
      end else begin
        Ig := -1;
        Vover := -1;
      end;
    end else if (Wye2gBut.down) then begin    {two grounded wye's}
      Ibr := apu/sqrt3;
      Iph := 2*Ibr;
      Vcap := apv/sqrt3;
    end else begin                            {error case}
      Ibr := 0;
      Iph := 0;                               {just some value?}
      Vcap := 0;
    end;
    Vcappc := Vcap*100/Vn;                    {voltage in percent}
    VArstp := Iph*Vll*sqrt3;                  {total VAr of one step}
    Ipht := Iph*nstp;                         {total phase current}
    Qtotn := VArstp*nstp;                     {total VAr of the whole bank}
    {show results}
//  VAtRow = 0;    {total nominal apparent power}
//  VcRow = 1;     {voltage of one capacitor}
//  CcRow = 2;     {capacitance of one capacitor}
//  IcRow = 3;     {nom.current of one capacitor}
//  IbRow = 4;     {current of one branch}
//  ItRow = 5;     {total line current}
//  XbRow = 6;     {impedance of one branch}
//  InRow = 7;     {neutral current (when fault)}
//  VxRow = 8;     {overvoltage (when fault)}
    EngFormat5(Qtotn,txt,true);               {format}
    ResultGrid.cells[1,VartRow] := txt+' VA'; {total nominal power}
    EngFormat5(Vcap,txt,true);
    ResultGrid.cells[1,VcRow] := txt+' V';  {voltage of one cap.}
    EngFormat5(Vcappc,txt,true);
    ResultGrid.cells[1,VpcRow] := txt+' %';  {voltage of one cap. in per cent}
    EngFormat5(Cn,txt,true);
    ResultGrid.cells[1,CcRow] := txt+' F';  {capacitance of one cap.}
    EngFormat5(Inom,txt,true);
    ResultGrid.cells[1,IcRow] := txt+' A';  {nom. current of one cap.}
    EngFormat5(Ibr,txt,true);
    ResultGrid.cells[1,IbRow] := txt+' A';  {current of one branch}
    EngFormat5(Cb,txt,true);
    ResultGrid.cells[1,CbRow] := txt+' F';  {capacitance of one branch}
    EngFormat5(Iph,txt,true);
    ResultGrid.cells[1,ItRow] := txt+' A';  {line current of one step}
    EngFormat5(VArstp,txt,true);
    ResultGrid.cells[1,VarRow] := txt+' VA'; {var of one step}
    EngFormat5(Ipht,txt,true);
    ResultGrid.cells[1,IlRow] := txt+' A';  {total line current}
    EngFormat5(Zc,txt,true);
    ResultGrid.cells[1,XbRow] := txt+' ohm';{impedance of one branch}
    if (Wye2But.down) then begin
      if (Ig >= 0) then begin               {negative value as error flag}
        if (flt > 0) then begin             {there is/are faulted capacitor(s)}
          EngFormat5(Ig,txt,true);          {neutral current}
          ResultGrid.cells[1,InRow] := txt+' A';
          EngFormat5(Vover,txt,true);       {overvoltage}
          ResultGrid.cells[1,VxRow] := txt+' %';
        end else begin
          ResultGrid.cells[1,InRow] := '- - -';
          ResultGrid.cells[1,VxRow] := '- - -';
        end;
      end else begin
        ResultGrid.cells[1,InRow] := '?';
        ResultGrid.cells[1,VxRow] := '?';
      end;
    end else begin
      ResultGrid.cells[1,InRow] := '- - -';  {neutral current}
      ResultGrid.cells[1,VxRow] := '- - -';  {overvoltage}
    end;
  end else begin
    if (errGrid) then ValueGrid.color := clYellow;
    if (errVll) then VoltEdit.color := clYellow;
    {result grid... empty }
  end;
  CalcPanel.color := CapForm.color;
  {enable the frequency buttons, they may have disabled in CopyParam}
  F50But.enabled := true;
  F60But.enabled := true;
end;

procedure TCapForm.DeltaButClick(Sender: TObject);
begin
  CalcPanel.color := clYellow;
  {hide the extra parameter}
  ValueGrid.RowCount := FaultRow;
  ValueGrid.height := ValueGridHeight;
end;

procedure TCapForm.WyeButClick(Sender: TObject);
begin
  CalcPanel.color := clYellow;
  {hide the extra parameter}
  ValueGrid.RowCount := FaultRow;
  ValueGrid.height := ValueGridHeight;
end;

procedure TCapForm.Wye2ButClick(Sender: TObject);
begin
  CalcPanel.color := clYellow;
  {one more parameter}
  ValueGrid.RowCount := FaultRow+1;
  ValueGrid.height := ValueGridHeight+ValueGrid.DefaultRowHeight+1;
  ValueGrid.cells[0,FaultRow] := 'number faulted';
  ValueGrid.cells[1,FaultRow] := faulted;
end;

procedure TCapForm.Wye2gButClick(Sender: TObject);
begin
  CalcPanel.color := clYellow;
  {hide the extra parameter}
  ValueGrid.RowCount := FaultRow;
  ValueGrid.height := ValueGridHeight;
end;

procedure TCapForm.F50ButClick(Sender: TObject);
begin
  CalcPanel.color := clYellow;
end;

procedure TCapForm.f60ButClick(Sender: TObject);
begin
  CalcPanel.color := clYellow;
end;

procedure TCapForm.ValueGridKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  {flag "must calculate", unless arrow keys}
  if (key < 37) or (key > 40) then CalcPanel.color := clYellow;
end;

procedure TCapForm.DeltaButMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if (Wye2But.down) then faulted := ValueGrid.cells[1,FaultRow];  {save value}
end;

procedure TCapForm.WyeButMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if (Wye2But.down) then faulted := ValueGrid.cells[1,FaultRow];  {save value}
end;

procedure TCapForm.Wye2ButMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if (Wye2But.down) then faulted := ValueGrid.cells[1,FaultRow];  {save value}
end;

procedure TCapForm.Wye2gButMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if (Wye2But.down) then faulted := ValueGrid.cells[1,FaultRow];  {save value}
end;

procedure TCapForm.VoltEditKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  CalcPanel.color := clYellow;
end;

procedure TCapForm.CopyParam(ipComp: longint);
{copy parameters from a capacitor in the single line diagram
 pComp   pointer to the capacitor}
//  VoltRow = 0;   {nominal voltage}
//  VAnRow = 1;    {nominal apparent power}
//  NpRow = 2;     {number in parallel}
//  NsRow = 3;     {number in series}
var
  Cap   : single;    {capacitance}
  freq  : single;    {frequency}
  ll    : longint;   {temporary}
  Np    : single;    {number in parallel}
  Ns    : single;    {number in series}
  pComp : TpComp;    {pointer to the capacitor}
  pSet  : TpCompSet; {pointer to the common}
  txt   : string;    {temporary}
  VAn   : single;    {nominal reactive power}
  Volt  : single;    {nominal voltage}
begin
  if (CapForm.visible) and (CapCopyBut.down) then begin
    pComp := TpComp(ipComp);
    pComp^.GetPar(gCap_C,Cap);          {capacitance of one capacitor}
    pComp^.GetPar(gCap_Np,Np);          {capacitors in parallel}
    pComp^.GetPar(gCap_Ns,Ns);          {capacitors in series}
    pComp^.GetPar(gCap_V,Volt);         {voltage}
    pComp^.GetipSet(ll);                {pointer to the common}
    pSet := TpCompSet(ll);
    freq := pSet^.Appl_Hz;              {frequency}
    VAn := 2*pi*freq*Volt*Volt*Cap;     {reactive power}
    {put to the grid}
    EngFormat5(Volt,txt,true);          {in routines.pas}
    ValueGrid.cells[1,VoltRow] := txt;
    EngFormat5(VAn,txt,true);
    ValueGrid.cells[1,VAnRow] := txt;
    EngFormat5(Np,txt,true);
    ValueGrid.cells[1,NpRow] := txt;
    EngFormat5(Ns,txt,true);
    ValueGrid.cells[1,NsRow] := txt;
    {copy also the frequency, if different}
    if (Imagoo.FreqBut50.checked) and (F60But.checked) then begin
      F60But.checked := false;
      F50But.checked := true;
      {must disable, because else the frequency may jump back, ...}
      {...at the first copied capacitor}
      F50But.enabled := false;
      F60But.enabled := false;
    end else if (Imagoo.FreqBut60.checked) and (F50But.checked) then begin
      F50But.checked := false;
      F60But.checked := true;
      F50But.enabled := false;
      F60But.enabled := false;
    end;
    {reset the copy button}
    CapCopyBut.down := false;
    CalcPanel.color := clYellow;        {alert to calculate}
    CapLabel.visible := false;
  end;

end;

procedure TCapForm.CapCopyButClick(Sender: TObject);
begin
  {show/not the (second) hint}
  CapLabel.visible := CapCopyBut.down;
end;

//procedure TCapForm.ResultGridMouseMove(Sender: TObject; Shift: TShiftState;
//  X, Y: Integer);
//var
//  apu : single;
//  row : integer;
//begin
//  row := y div (ResultGrid.DefaultRowHeight+1);
//  CapLabel.caption := 'row '+inttostr(row);
//  CapLabel.visible := true;
//end;

procedure TCapForm.HelpMenuClick(Sender: TObject);
begin
  width := WidthHelp;
  height := HeightHelp;
  HelpPageControl.visible := true;
end;

procedure TCapForm.CloseButClick(Sender: TObject);
begin
  HelpPageControl.visible := false;
  width := WidthNoHelp;
  height := HeightNoHelp;
end;

end.
