unit Decimals;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, Spin, Tab;

type
  TDecimalsDlg = class(TForm)
    CancelBut: TButton;
    OKBut: TButton;
    ManualBut: TSpeedButton;
    AutoBut: TSpeedButton;
    CurrSpinEdit: TSpinEdit;
    CurrLabel: TLabel;
    VoltSpinEdit: TSpinEdit;
    VoltLabel: TLabel;
    PowerSpinEdit: TSpinEdit;
    PowerLabel: TLabel;
    ImpedLabel: TLabel;
    ImpedSpinEdit: TSpinEdit;
    procedure CancelButClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure OKButClick(Sender: TObject);
    procedure ManualButClick(Sender: TObject);
    procedure AutoButClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  DecimalsDlg: TDecimalsDlg;

implementation

uses Imagopas;

{$R *.DFM}

procedure TDecimalsDlg.CancelButClick(Sender: TObject);
begin
  DecimalsDlg.visible := false;
end;



procedure TDecimalsDlg.FormActivate(Sender: TObject);
{fetch the number of decimals}
var
  Ad  : integer;  {number of decimals for current}
  man : boolean;  {flag for manual determination of decimals}
  Vd  : integer;
  Wd  : integer;
  Zd  : integer;
begin
  ReportForm.GetDecimals(Ad,Vd,Wd,Zd,man);
  {fetch number of decimals used presently, current first}
  if (Ad <= CurrSpinEdit.MaxValue) and (Ad >= CurrSpinEdit.MinValue) then begin
    CurrSpinEdit.Value := Ad;         {number of decimals for the current}
  end else begin
    CurrSpinEdit.Value := CurrSpinEdit.MinValue;
  end;
  {then voltage}
  if (Vd <= VoltSpinEdit.MaxValue) and (Vd >= VoltSpinEdit.MinValue) then begin
    VoltSpinEdit.Value := Vd;         {number of decimals for the current}
  end else begin
    VoltSpinEdit.Value := VoltSpinEdit.MinValue;
  end;
  {then power}
  if (Wd <= PowerSpinEdit.MaxValue) and (Wd >= PowerSpinEdit.MinValue) then begin
    PowerSpinEdit.Value := Wd;         {number of decimals for the current}
  end else begin
    PowerSpinEdit.Value := PowerSpinEdit.MinValue;
  end;
  {finally impedance}
  if (Zd <= ImpedSpinEdit.MaxValue) and (Zd >= ImpedSpinEdit.MinValue) then begin
    ImpedSpinEdit.Value := Zd;         {number of decimals for the current}
  end else begin
    ImpedSpinEdit.Value := ImpedSpinEdit.MinValue;
  end;
  {manual or automatic?}
  if (man) then begin
    ManualBut.down := true;
    AutoBut.down := false;
    ManualButClick(sender);
  end else begin
    ManualBut.down := false;
    AutoBut.down := true;
    AutoButClick(sender);
  end;
end;

procedure TDecimalsDlg.OKButClick(Sender: TObject);
{save the state (auto-manual) and number of decimals}
begin
  ReportForm.PutDecimals(CurrSpinEdit.value ,VoltSpinEdit.value ,
                         PowerSpinEdit.value,ImpedSpinEdit.value,ManualBut.down);

  DecimalsDlg.visible := false;
end;

procedure TDecimalsDlg.ManualButClick(Sender: TObject);
{enable the spin edits, set colors}
begin
  CurrSpinEdit.enabled := true;
  VoltSpinEdit.enabled := true;
  PowerSpinEdit.enabled := true;
  ImpedSpinEdit.enabled := true;
  ManualBut.font.color := clBlue;
  ManualBut.font.style := [fsBold];
  AutoBut.font.color := clBlack;
  AutoBut.font.style := [];
  CurrLabel.font.color := clBlue;
  VoltLabel.font.color := clBlue;
  PowerLabel.font.color := clBlue;
  ImpedLabel.font.color := clBlue;
  CurrSpinEdit.color := clWhite;
  VoltSpinEdit.color := clWhite;
  PowerSpinEdit.color := clWhite;
  ImpedSpinEdit.color := clWhite;
end;

procedure TDecimalsDlg.AutoButClick(Sender: TObject);
{disable the spin edits, dull colors}
begin
  CurrSpinEdit.enabled := false;
  VoltSpinEdit.enabled := false;
  PowerSpinEdit.enabled := false;
  ImpedSpinEdit.enabled := false;
  AutoBut.font.color := clBlue;
  AutoBut.font.style := [fsBold];
  ManualBut.font.color := clBlack;
  ManualBut.font.style := [];
  CurrLabel.font.color := clGray;
  VoltLabel.font.color := clGray;
  PowerLabel.font.color := clGray;
  ImpedLabel.font.color := clGray;
  CurrSpinEdit.color := clSilver;
  VoltSpinEdit.color := clSilver;
  PowerSpinEdit.color := clSilver;
  ImpedSpinEdit.color := clSilver;
end;

procedure TDecimalsDlg.FormCreate(Sender: TObject);
begin
{add flag that form created}
  Imagoo.ReadyEdit.text := Imagoo.ReadyEdit.text+'d';
end;

end.
