unit Demoimg;

interface

uses
 SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
 Forms, Dialogs, StdCtrls, ExtCtrls, Imagopas, Utildef;

procedure DrawLogo(pImage : TpImage; Ax,Ay,ABhin : integer; brain : boolean);
procedure ClearImage(pImage : TpImage);
procedure LargeText(pImage : TpImage);
procedure NormalText(pImage : TpImage);
procedure LineAndLogo(pImage : TpImage);
procedure OpeningSlide(pImage : TpImage; hh,ww : integer);
procedure OtherSlides(pImage : TpImage; X,Y : integer);

implementation

const
  nomImgHeight = 700;
  nomImgWidth = 1000;
  nomTitleFont = 30;
  nomTextFont = 24;
  NomTitleX = 50;
  NomTitleY = 50;
  NomTextX = 84;         {x of first line of text}
  NomTextX2 = 120;       {x of second and following lines of text}
  dyTiTeNom = 70;        {nominal spacing between title and text}
  dyTeTeNom = 50;        {nominal spacing between text and text}
  dyTeCoNom = 40;        {nominal spacing between continuation lines}

procedure DrawLogo(pImage : TpImage; Ax,Ay,ABhin : integer; brain : boolean);
{draws the ABB logo on an image and optionally the text "brain power"
 ipImage  pointer to the image as integer
 Ax,Ay   coordinates of the upper left corner of the logo
 ABhin   height of the logo
 brain   if true, the 'Brain Power' is written under the logo}
const
  nomABh = 278;   {the nominal height of the logo}
  nomPw  = 5;     {nominal pen width at the white cross}
  nomBx  = -98;   {nominal x-position of the text relative to the logo}
  nomBy  = 375;   {nominal y-position of the text relative to the logo}
  Aleg = 0.2482;  {the ratio of the width of the leg of A to the height}
  Acros = 0.3597; {the ratio of the length of the cross bar of A to the height}
  Acroy = 0.7986; {the ratio of the elevation of the cross bar of A to the height}
  Atop = 0.3058;  {the ratio of the withd of A at the top to the height}
  Crh = 0.5288;   {position of the white horizontal line in A}
  ChrB = 82;      {nominal position of the white vertical line in B}
  B1x = {298}320;      {nominal x-pos of the first B}
  B2x = {514}555;      {nominal x-pos of the second B}
  nomBw = 172;    {nominal length of the horizontal line in B}
  chx1 = 46;      {nominal x1 of smaller chord}
  chx2 = 176;     {nominal x2 of smaller chord}
  chy2 = 126;     {nominal y2 of smaller chord}
  chx21 = 26;     {nominal x1 of larger chord of B}
  chy21 = 111;    {nominal y1 of larger chord}
  chx22 = 196;    {nominal x2 of larger chord}
  chy22 = 279;    {nominal y2 of larger chord}
  rf = 0.1;       {rounding factor}
var
  ABh             : integer;              {height of the logo}
  apu,apv         : single;               {temporary}
  Aw              : integer;              {the width of A}
  hrat            : single;               {ratio of height to nominal height}
  ii,jj           : integer;              {temporary}
  x1,y1,x2,y2     : integer;              {defines the smaller chord}
  x21,y21,x22,y22 : integer;              {defines the larger chord}
  x1s,x2s         : integer;              {for the smaller chord of the second B}
  x21s,x22s       : integer;              {for the larger chord of the second B}
  points          : array[1..8] of TPoint;{for the polygon of A}
  yy              : integer;              {temporary}
begin
  {check size of the logo}
  if (ABhin < 10)        then ABh := 10
  else if (ABhin <= 400) then ABh := ABhin
  else                        ABh := 400;
  {draw the A}
  Aw := ABh;                   {the widht of A}
  points[1].x := Ax+(Aw div 2)-(round(Atop*ABh)) div 2;
  points[1].y := Ay;
  points[2].x := Ax;
  points[2].y := Ay+ABh;
  points[3].x := Ax+round(Aleg*ABh);
  points[3].y := points[2].y;
  points[4].x := Ax+(Aw div 2)-(round(Acros*ABh)) div 2;
  points[4].y := Ay+round(Acroy*ABh);
  points[5].x := Ax+(Aw div 2)+(round(Acros*ABh)) div 2;
  points[5].y := points[4].y;
  points[6].x := Ax+Aw-round(Aleg*ABh);
  points[6].y := points[2].y;
  points[7].x := Ax+Aw;
  points[7].y := points[2].y;
  points[8].x := Ax+(Aw div 2)+(round(Atop*ABh)) div 2;
  points[8].y := Ay;
  pImage^.canvas.pen.color := clRed;
  pImage^.canvas.brush.color := clRed;
  pImage^.canvas.brush.style := bsSolid;
  pImage^.canvas.Polygon(points);
  {the smaller chord of the B }
  apu := ABh;
  apv := nomABh;
  hrat := apu/apv;               {ratio of height to nominal height}
  x1 := Ax+round((B1x+chx1+rf)*hrat);
  y1 := Ay;
  x2 := Ax+round((B1x+chx2+rf)*hrat);
  y2 := Ay+round(chy2*hrat+rf);
  {the first B}
  pImage^.canvas.Chord(x1,y1,x2,y2,(x1+x2) div 2 ,y2,((x1+x2) div 2), y1);
  {the second B}
  x1s := Ax+round((B2x+chx1)*hrat+rf);
  x2s := Ax+round((B2x+chx2)*hrat+rf);
  pImage^.canvas.Chord(x1s,y1,x2s,y2,(x1s+x2s) div 2 ,y2,((x1s+x2s) div 2), y1);
  {the larger chord of the B }
  x21 := Ax+round((B1x+chx21)*hrat+rf);
  y21 := Ay+round(chy21*hrat+rf);
  x22 := Ax+round((B1x+chx22)*hrat+rf);
  y22 := {Ay+round(chy22*hrat);} Ay+ABh+1;  {1 so that the height is correct !?}
  pImage^.canvas.Chord(x21,y21,x22,y22,((x21+x22) div 2) ,y22,((x21+x22) div 2), y21);
  x21s := Ax+round((B2x+chx21)*hrat+rf);
  x22s := Ax+round((B2x+chx22)*hrat+rf);
  pImage^.canvas.Chord(x21s,y21,x22s,y22,((x21s+x22s) div 2) ,y22,((x21s+x22s) div 2), y21);
  {the rectangles of B }
  pImage^.canvas.rectangle(Ax+round(B1x*hrat+rf),y1,((x1+x2) div 2) ,y2);
  pImage^.canvas.rectangle(Ax+round(B1x*hrat+rf),y21,((x21+x22) div 2),y22);
  pImage^.canvas.rectangle(Ax+round(B2x*hrat+rf),y1,((x1s+x2s) div 2) ,y2);
  pImage^.canvas.rectangle(Ax+round(B2x*hrat+rf),y21,((x21s+x22s) div 2),y22);
  {the white lines in A}
  pImage^.Canvas.Pen.Width := round(nomPw*ABh/nomABh+0.5);
  if (pImage^.Canvas.Pen.Width < 1) then pImage^.Canvas.Pen.Width := 1;
  pImage^.Canvas.Pen.Color := clWhite;
  {the horizontal line in A}
  pImage^.Canvas.MoveTo(Ax+(Aw div 2),Ay);
  pImage^.Canvas.LineTo(Ax+(Aw div 2),points[4].y);
  yy := (ABh div 2)-pImage^.Canvas.Pen.width div 2+Ay;
  pImage^.Canvas.MoveTo((points[1].x+points[2].x) div 2, yy);
  pImage^.Canvas.LineTo((points[7].x+points[8].x) div 2, yy);
  {the white lines in the first B}
  pImage^.Canvas.MoveTo(Ax+round((B1x+ChrB)*hrat), Ay);
  pImage^.Canvas.LineTo(Ax+round((B1x+ChrB)*hrat), Ay+Abh);
  pImage^.Canvas.MoveTo(Ax+round((B1x)*hrat), yy);
  pImage^.Canvas.LineTo(Ax+round((B1x+nomBw)*hrat), yy);
  {the white lines in the second B}
  pImage^.Canvas.MoveTo(Ax+round((B2x+ChrB)*hrat), Ay);
  pImage^.Canvas.LineTo(Ax+round((B2x+ChrB)*hrat), Ay+Abh);
  pImage^.Canvas.MoveTo(Ax+round((B2x)*hrat), yy);
  pImage^.Canvas.LineTo(Ax+round((B2x+nomBw)*hrat), yy);
  {the text, if desired}
  if (brain) then begin
    pImage^.Canvas.Brush.style := bsClear;
    pImage^.Canvas.Font.Color := clBlack;
    pImage^.Canvas.Font.Name := 'Times';
    pImage^.Canvas.Font.Size := round(hrat*135+0.1);
    ii := Ax+round(hrat*nomBx);
    jj := Ay+round(hrat*nomBy);
    pImage^.Canvas.TextOut(ii,jj,'Brain Power.');
  end;
end;

procedure ClearImage(pImage : TpImage);
{draw a white rectangle on the image = clear the mage
 pImage : pointer to the image}
begin
  pImage^.Canvas.Pen.Color := clWhite;
  pImage^.Canvas.Pen.Width := 1;
  pImage^.Canvas.Brush.Color := clWhite;
  pImage^.Canvas.Brush.Style := bsSolid;
  pImage^.Canvas.Rectangle(0,0,pImage^.width,pImage^.height);
end;

procedure LargeText(pImage : TpImage);
{change the text stype to large, bold
 pImage  pointer to the image, where the text will be written}
var
  apu : single;
  ipu : integer;
begin
  pImage^.Canvas.Brush.Style := bsClear;
  pImage^.Canvas.Font.Name := 'Arial';    {font of the title}
  apu := pImage^.width/NomImgWidth;
  ipu := round(apu*nomTitleFont+0.5);
  if (ipu < 8) then ipu := 8;
  pImage^.Canvas.Font.Size := ipu;
  pImage^.Canvas.Font.Style := [fsBold];
  pImage^.Canvas.Font.Color := clBlack;
end;

procedure NormalText(pImage : TpImage);
{change the text font and style to "normal"
 pImage : pointer to the image, where the text will be written}
var
  apu : single;
  ipu : integer;
begin
  pImage^.Canvas.Brush.Style := bsClear;
  pImage^.Canvas.Font.Name := 'Arial';
  apu := pImage^.width/NomImgWidth;
  ipu := round(apu*nomTextFont+0.5);
  if (ipu < 8) then ipu := 8;
  pImage^.Canvas.Font.Size := ipu;
  pImage^.Canvas.Font.Style := [];
  pImage^.Canvas.Font.Color := clBlack;
end;

procedure LineAndLogo(pImage : TpImage);
 {draw the line under the title, and the ABB logo
 pImage   pointer to the image}
var
  apu : single;
  ipu : integer;
begin
  pImage^.Canvas.Pen.Color := clBlue;
  pImage^.Canvas.Pen.Width := 4;
  apu := pImage^.width/nomImgWidth;
  ipu := 70+round(apu*nomTitleFont+0.5);
  pImage^.Canvas.MoveTo(10,ipu{100});
  pImage^.Canvas.LineTo(pImage^.width-100,ipu{100}); {a line under the title}
  {the logo}
  ipu := round(60.0*pImage^.width/NomImgWidth+0.5);
  DrawLogo(pImage,pImage^.width-200,pImage^.height-100,ipu,false);
end;

procedure OpeningSlide(pImage : TpImage; hh, ww : integer);
{define the image position and size, and draw the first slide
 pImage  pointer to the image for the slide
 hh,ww   height, width of the image}
begin
  pImage^.height := hh{558};     {size of the ABB bitmap}
  pImage^.width := ww{968};
  pImage^.top := 0;
  pImage^.left := 4;
  ClearImage(pImage);
  LargeText(pImage);
  pImage^.Canvas.TextOut(50, 50,'A Tool for the Illustration of the Operation');
  pImage^.Canvas.TextOut(50,100,'of Overcurrent Protection Relays');
  NormalText(pImage);
  pImage^.Canvas.TextOut( 84,170,'Ilkka Leikkonen');
  pImage^.Canvas.TextOut( 84,220,'ABB Corporate Research');
  pImage^.Canvas.TextOut( 84,270,'Finland');
  LineAndLogo(pImage);
end;

procedure OtherSlides(pImage : TpImage; X,Y : integer);
{shows the other slides, after the first
 pImage   pointer to the image for the slides
 X,Y      the coordinates of the mouse}
const
  Cnt : integer = 1;    {counts the images}
  n1x = 40;             {first point in "next" arrow}
  n1y = 10;
  n2x = 40;
  n2y = 40;
  n3x = 66;
  Ax = 110;       {nominal position of the large logo}
  Ay = 100;
  locABh = {278}250;   {the local height of the large logo}
var
  forw     : array[1..3] of TPoint;  {defines the forward arrow}
  backw    : array[1..3] of TPoint;  {defines the backward arrow}
  ii,jj    : integer;   {index, temporary}
  Ai,Aj    : integer;   {position of the large logo}
{  dyTiTe   : integer;   {spacing between title and text}
{  dyTeTe   : integer;   {spacing between text and text}
{  dyTeCo   : integer;   {spacing between continuation lines}
{  ImgWidth : integer;   {the width of the image}
{  TitleFont: integer; }
{  TextFont : integer; }
{  TitleX   : integer;   {x-coord. of title}
{  TitleY   : integer;   {y-coord. of title}
{  TextX    : integer;   {x-coord. of text}
{  TextX2   : integer;   {x-coord. of second and following lines of text}
{  wrat     : single;    {ratio of the width to the nominal width}
begin
  {text positions and fonts, depend on the size of the image}
{ wrat := pImage^.width/nomImgWidth;    {ratio of present width to nominal}
{ TitleFont := round(wrat*NomTitleFont+0.5);
{ TextFont := round(wrat*NomTextFont+0.5);
{ TitleX := round(wrat*NomTitleX+0.5);
{ TitleY := round(wrat*NomTitleY+0.5);
{ TextX  := round(wrat*NomTextX+0.5);   {x of first line of text}
{ TextX2 := round(wrat*NomTextX2+0.5);  {x of second and following lines of text}
{ dyTiTe := round(wrat*dyTiTeNom+0.5);  {spacing between title and text}
{ dyTeTe := round(wrat*dyTeTeNom+0.5);  {spacing between text and text}
{ dyTeCo := round(wrat*dyTeCoNom+0.5);  {spacing between continuation lines}
  {data for the navigation arrays, forwards}
  forw[1].x := n1x;
  forw[1].y := n1y;
  forw[2].x := n2x;
  forw[2].y := n2y;
  forw[3].x := n3x;
  forw[3].y := (n1y+n2y) div 2;
  {data for the backwards arrow}
  backw[1].x := n1x+3*(n3x-n1x);
  backw[1].y := n1y;
  backw[2].x := backw[1].x;
  backw[2].y := n2y;
  backw[3].x := n1x+2*(n3x-n1x);
  backw[3].y := (n1y+n2y) div 2;
  {forward or backward, or stop ?}
  if (x > forw[1].x) and (x < forw[3].x) and
     (y > forw[1].y) and (y < forw[2].y) then inc(Cnt)
  else if (x < backw[1].x) and (x > backw[3].x) and
          (y > backw[1].y) and (y < backw[2].y) then dec(Cnt)
  else if (x < forw[1].x-10) and (y < forw[2].y) then begin
    pImage^.visible := false;         {hide the slides}
    pImage^.width := 1;
    pImage^.height := 1;
    imagoo.NetTitle.visible := true;  {but show again the title of the network}
  end else begin
    {ii := 1;          {dummy operation}
  end;
  if (pImage^.visible) then begin    {change + show new image, only if visible}
    {clear the old image}
    ClearImage(pImage);
    {the navigation arrays and the stop rectangle}
    pImage^.Canvas.Brush.Color := clSilver{clGreen};
    pImage^.Canvas.Brush.Style := bsSolid;
    pImage^.Canvas.Polygon(forw);
    pImage^.Canvas.Polygon(backw);
    pImage^.Canvas.Rectangle(0,n1y,n1x-10,n2y);   {the stop rectangle}
    {a line under the title and the logo to lower right corner- - - - - - - - - -}
    if (Cnt <> 5) then LineAndLogo(pImage);  {..but not on last slide}
    {define the font of the title text}
    LargeText(pImage);
    if (Cnt = 1) then begin
      pImage^.Canvas.TextOut(50,50,'The purpose and the principle'); {the title}
      NormalText(pImage);
      pImage^.Canvas.TextOut(84,120,'- to show, when the overcurrent relays react');
      pImage^.Canvas.TextOut(120,160,'in the cases of different faults');
      pImage^.Canvas.TextOut(84,210,'- short circuit calculation + a subroutine that');
      pImage^.Canvas.TextOut(120,250,'checks the activation of the relays');
    end else if (Cnt = 2) then begin
      pImage^.Canvas.TextOut(50,50,'Potential users'); {the title}
      NormalText(pImage);
      pImage^.Canvas.TextOut( 84,120,'- the idea came from the marketing people');
      pImage^.Canvas.TextOut( 84,170,'- useful in education, maybe');
      pImage^.Canvas.TextOut( 84,220,'- perhaps even for the protection engineers ?');
    end else if (Cnt = 3) then begin
      pImage^.Canvas.TextOut(50,50,'Easy to use'); {the title}
      NormalText(pImage);
      pImage^.Canvas.Font.Style := [fsBold];
      pImage^.Canvas.TextOut( 84,120,'- really ? ');
      pImage^.Canvas.Font.Style := [];
      pImage^.Canvas.Font.Color := clBlack;
      pImage^.Canvas.TextOut( 84,170,'- avoid the irritating features of other programs');
      pImage^.Canvas.TextOut(120,220,' ( but introduce new ones :-)');
    end else if (Cnt = 4) then begin
      pImage^.Canvas.TextOut(50,50,'Please Note'); {the title}
      NormalText(pImage);
      pImage^.Canvas.TextOut( 84,120,'- still a prototype, or a feasibility study');
      pImage^.Canvas.TextOut(120,160,'some features missing');
      pImage^.Canvas.TextOut( 84,210,'- not intended for distribution');
    end else if (Cnt = 5) then begin
      {draw the final page = logo + brain power}
      Aj := round((Imagoo.ClientHeight/nomImgHeight)*Ay);
      if (Aj > Ay) then Aj := Ay;
      Ai := round((Imagoo.ClientWidth/nomImgHeight)*Ax);
      if (Ai > Ax) then Ai := Ax;
      ii := round((Imagoo.ClientHeight/nomImgHeight)*locABh);
      jj := round((Imagoo.ClientWidth/nomImgWidth)*locABh);
      if (jj < ii) then ii := jj;
      if (ii > locABh) then ii := locABh;
      DrawLogo(pImage,Ai,Aj,ii, true);  {draw the logo and ..}
    end else if (Cnt = 6) then begin
      pImage^.Canvas.TextOut(50,50,'Limitations'); {the title}
      NormalText(pImage);
      pImage^.Canvas.TextOut( 84,120,'- linear models');
      pImage^.Canvas.TextOut( 84,170,'- stand alone application, for one purpose only');
      pImage^.Canvas.TextOut( 84,220,'- always remember inaccuracies in data+models !');
    end else begin
      OpeningSlide(pImage, pImage^.height, pImage^.width);
      Cnt := 0;
      {repaint the navigation arrays and the stop rectangle}
      pImage^.Canvas.Brush.Color := clSilver{clGreen};
      pImage^.Canvas.Brush.Style := bsSolid;
      pImage^.Canvas.Polygon(forw);
      pImage^.Canvas.Polygon(backw);
      pImage^.Canvas.Rectangle(0,n1y,n1x-10,n2y);   {the stop rectangle}
    end;
  end;

end;


end.
