{pointer to the trafo as integer in DmgCurveForm.tag,
 written in StdImageMouseDown of parametr.pas}
unit DmgCurve;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, Skemadef, Routines, StdCtrls, Buttons, Menus, Userdef, utildef,
  Skemproc,parametr, Imagodef;

type
  TDmgCurveForm = class(TForm)
    DmgGrid: TStringGrid;
    OKButton: TButton;
    CancelButton: TButton;
    FirstMenu: TMainMenu;
    FileMenu: TMenuItem;
    OpenItem: TMenuItem;
    SaveItem: TMenuItem;
    NoteMenu: TMenuItem;
    DownBut: TSpeedButton;
    UpBut: TSpeedButton;
    FlipBut: TSpeedButton;
    SwapBut: TSpeedButton;
    ClearBut: TSpeedButton;
    CopyBut: TSpeedButton;
    PasteBut: TSpeedButton;
    SaveDlg: TSaveDialog;
    OpenDlg: TOpenDialog;
    ApplyBut: TButton;
    StdBut: TButton;
    CurveLabel: TLabel;
    CurveDataLabel: TLabel;
    InomBut: TButton;
    procedure FormCreate(Sender: TObject);
    procedure CancelButtonClick(Sender: TObject);
    procedure DmgGridDrawCell(Sender: TObject; Col, Row: Longint;
      Rect: TRect; State: TGridDrawState);
    procedure DmgGridSelectCell(Sender: TObject; Col, Row: Longint;
      var CanSelect: Boolean);
    procedure CopyButClick(Sender: TObject);
    procedure PasteButClick(Sender: TObject);
    procedure DownButClick(Sender: TObject);
    procedure UpButClick(Sender: TObject);
    procedure FlipButClick(Sender: TObject);
    procedure SwapButClick(Sender: TObject);
    procedure ClearButClick(Sender: TObject);
    procedure OpenItemClick(Sender: TObject);
    procedure SaveItemClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure OKButtonClick(Sender: TObject);
    procedure DmgGridKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ApplyButClick(Sender: TObject);
    procedure DataFromGrid;
    procedure StdButClick(Sender: TObject);
    procedure InomButMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure InomButMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
    procedure DataToGrid;
    procedure UpdateGraph;
  public
    { Public declarations }
    procedure DataToGridForCurve(icurve: integer);
  end;

var
  DmgCurveForm: TDmgCurveForm;
  DataString : string;

implementation

uses Relcurr, Imagopas;

{$R *.DFM}

const
  ActCol   : integer = 0;   {column of active cell}
  ActRow   : integer = 0;   {row of active cell}
  ActChar  : integer = 1;   {index for the characteristics: 1,2 = phase, 3,4 = ground, 5,6 = seq.}
  ErrDat   : integer = 0;   {flag for error in data}
  OldDat   : string = '0';  {data in a cell before editing}
  pActComp : TpComp = nil;  {pointer to the active relay}
  pGrid    : TpGrid = nil;  {pointer to the grid}
  d_p      : char = #190;   {decimal point, correct value set in FormCreate}
  datwidth = 64;            {width of column with data}
  indcol   = 3;             {column for indices}
  indwidth = 32;            {width of column of indices}
  RowCount = 26;            {number of rows in the grid}
  sqrt3    = 1.7320508;
var
  DmgCopy1 : array[1..RowCount-1] of string;   {for copying user defined data}
  DmgCopy2 : array[1..RowCount-1] of string;
  DmgCopy4 : array[1..RowCount-1] of string;
  DmgCopy5 : array[1..RowCount-1] of string;
  DmgBack1 : array[1..RowCount-1] of string;   {for saving data temporarily}
  DmgBack4 : array[1..RowCount-1] of string;

procedure TDmgCurveForm.FormCreate(Sender: TObject);
var
  ii    : integer;  {index}
  ipu   : integer;  {temporary}
  kk    : integer;
begin
  DmgGrid.RowCount := RowCount;          {NOTE....}
  DecimalPoint(d_p);                      {define the decimal point ' or .}
  {set the size of the grid for the data}
  DmgGrid.ColWidths[0] := indwidth;      {column wth indices}
  DmgGrid.ColWidths[1] := datwidth;      {column with data}
  DmgGrid.ColWidths[2] := datwidth;
  DmgGrid.ColWidths[3] := indwidth;
  DmgGrid.ColWidths[4] := datwidth;
  DmgGrid.ColWidths[5] := datwidth;
  {width and height of the grid}
  ipu := DmgGrid.GridLineWidth;
  for ii := 0 to 5 do ipu := ipu+DmgGrid.ColWidths[ii]+DmgGrid.GridLineWidth;
  DmgGrid.width := ipu+16;
  DmgGrid.height := 21*(DmgGrid.DefaultRowHeight+DmgGrid.GridLineWidth)+1;
  {captions}
  DmgGrid.Cells[1,0] := ' pu-current';
  DmgGrid.Cells[2,0] := '  Time';
  DmgGrid.Cells[4,0] := ' pu-current';
  DmgGrid.Cells[5,0] := '  Time';
  for ii := 1 to DmgGrid.RowCount do DmgGrid.Cells[0,ii] := '   '+inttostr(ii);
  {position(s) of the button(s)}
  OKButton.top := DmgGrid.top+DmgGrid.height+8;
  ApplyBut.top := OKButton.top;
  CancelButton.top := OKButton.top;
  CurveDataLabel.top := OKButton.top+1;
  CurveLabel.top := OKButton.top+1;
  CurveLabel.left := CurveDataLabel.left+CurveDataLabel.width+4;
  DmgCurveForm.height := OKButton.top+OKButton.height+48;
  DmgCurveForm.width := DmgGrid.left+DmgGrid.width+8;
  {initialize copy/paste strings}
  for ii := 1 to high(DmgCopy1) do begin
    DmgCopy1[ii] := '0';
    DmgCopy2[ii] := '0';
    DmgCopy4[ii] := '0';
    DmgCopy5[ii] := '0';
  end;
  {add flag that form created}
  Imagoo.ReadyEdit.text := Imagoo.ReadyEdit.text+'m';
end;


procedure TDmgCurveForm.CancelButtonClick(Sender: TObject);
var
  ic : integer;   {index of the curve}
begin
  ic := strtoint(CurveLabel.caption);     {saved in UserButClick or .. of parameter.pas}
  pActComp^.PutStringPar(DataString,ic);  {return the original data}
  DmgCurveForm.visible := false;
  {return the original graph = update graph with original data}
  UpdateGraph;
end;

procedure TDmgCurveForm.DmgGridDrawCell(Sender: TObject; Col, Row: Longint;
  Rect: TRect; State: TGridDrawState);
begin
  {the column for indices in the middle must be of different color}
  if (col = indcol) and (row > 0) then begin
    DmgGrid.canvas.pen.width := 1;
    DmgGrid.canvas.pen.color := clBlack{clBtnFace};
    DmgGrid.canvas.brush.color := clBtnFace;
    DmgGrid.canvas.rectangle(rect.left-1,rect.top-1,rect.left+
                 DmgGrid.ColWidths[3]+1,rect.top+DmgGrid.DefaultRowHeight+1);
    {write the indices}
    DmgGrid.canvas.textout(rect.left+12,rect.top+2,inttostr(row+DmgGrid.RowCount-1));
  end;
end;

procedure TDmgCurveForm.DmgGridSelectCell(Sender: TObject; Col,
  Row: Longint; var CanSelect: Boolean);
begin
  {if error in previous cell, return old data}
  if (ErrDat <> 0) and (ActCol > 0) and (ActRow > 0) then
    DmgGrid.Cells[ActCol,ActRow] := OldDat;
  OldDat := DmgGrid.cells[col,row];   {save data, needed if error}
  ActCol := col;     {save the column and row of the active cell}
  ActRow := row;
  {cannot write to the column for the indices}
  if (col = indcol) then begin
    DmgGrid.options := DmgGrid.options-[goEditing,goAlwaysShowEditor];
  end else begin
    DmgGrid.options := DmgGrid.options+[goEditing,goAlwaysShowEditor];
  end;
end;

procedure TDmgCurveForm.CopyButClick(Sender: TObject);
{copy data to local "clipboard" = arrays}
var
  ii : integer;
begin
  for ii := 1 to high(DmgCopy1) do begin
    DmgCopy1[ii] := DmgGrid.cells[1,ii];
    DmgCopy2[ii] := DmgGrid.cells[2,ii];
    DmgCopy4[ii] := DmgGrid.cells[4,ii];
    DmgCopy5[ii] := DmgGrid.cells[5,ii];
  end;
end;

procedure TDmgCurveForm.PasteButClick(Sender: TObject);
{paste data from local "clipboard" = arrays}
var
  ii : integer;
begin
  for ii := 1 to high(DmgCopy1) do begin
    DmgGrid.cells[1,ii] := DmgCopy1[ii];
    DmgGrid.cells[2,ii] := DmgCopy2[ii];
    DmgGrid.cells[4,ii] := DmgCopy4[ii];
    DmgGrid.cells[5,ii] := DmgCopy5[ii];
  end;

end;

procedure TDmgCurveForm.DownButClick(Sender: TObject);
begin
  InsertRow(@DmgGrid, actrow, actcol);
end;

procedure TDmgCurveForm.UpButClick(Sender: TObject);
begin
  RemoveRow(@DmgGrid, actcol, actrow);
end;

procedure TDmgCurveForm.FlipButClick(Sender: TObject);
begin
  FlipData(@DmgGrid);
end;

procedure TDmgCurveForm.SwapButClick(Sender: TObject);
begin
  SwapData(@DmgGrid);
end;

procedure TDmgCurveForm.ClearButClick(Sender: TObject);
{clear the curve = set all values to 0}
var
  cleared : boolean;  {true, when data cleared}
begin
  ClearData(@DmgGrid, cleared);   {in userdef.pas}
end;

procedure TDmgCurveForm.OpenItemClick(Sender: TObject);
var
  hasRead   : boolean;   {true, when data read from file}
begin
  ReadData(@OpenDlg, @DmgGrid, hasRead); {in userdef.pas}

end;

procedure TDmgCurveForm.SaveItemClick(Sender: TObject);
begin
  SaveData(@SaveDlg, @DmgGrid);
end;

procedure TDmgCurveForm.DataToGridForCurve(icurve: integer);
{move parameters (current-time points) to the grid
 icruve  index of the curve 1..3}
var
  iB,iE   : integer;  {start and end indices for extracting parameters}
  ii      : integer;
  len     : integer;  {length of a string}
  line    : string;   {the parameters as a string}
  rows    : integer;  {number of rows in the grid}
  st1,st2 : string;   {temporary}
begin
  pActComp^.GetStringPar(line,icurve);     {parameters as a string}
  DataString := line;                      {save for cancel}
  rows := pGrid^.rowcount;
  len := length(line);
  if (len > 0) then begin                  {there are some data}
    iB := 1;
    for ii := 1 to rows*2-2 do begin
      ExtractNextParam(iB, {';'}' ', line, st1, iE);
      if (st1 = '') then st1 := '0';    {replace empty values with a zero}
      iB := iE+1;                       {for the next parameter}
      ExtractNextParam(iB, {';'}' ', line, st2, iE);
      if (st2 = '') then st2 := '0';    {replace empty values with a zero}
      iB := iE+1;                       {for the next parameter}
      {parameters in two pairs of columns, separated by a column for indices}
      if (ii < rows) then begin         {first pair of columns}
        pGrid^.Cells[1,ii] := st1;      {current}
        pGrid^.Cells[2,ii] := st2;      {time}
      end else begin                    {second pair of columns}
        pGrid^.Cells[4,ii-rows+1] := st1; {current}
        pGrid^.Cells[5,ii-rows+1] := st2; {time}
      end;
    end;
  end else begin                        {data missing, fill with zeroes}
    for ii := 1 to rows-1 do begin
      pGrid^.Cells[1,ii] := '0';
      pGrid^.Cells[2,ii] := '0';
      pGrid^.Cells[4,ii] := '0';
      pGrid^.Cells[5,ii] := '0';
    end;
  end;
end;

procedure TDmgCurveForm.DataToGrid;
{move parameters (current-time points) to the grid}
//var
//  iB,iE   : integer;  {start and end indices for extracting parameters}
//  ii      : integer;
//  len     : integer;  {length of a string}
//  line    : string;   {the parameters as a string}
//  rows    : integer;  {number of rows in the grid}
//  st1,st2 : string;   {temporary}
begin
(*pActComp^.GetStringPar(line,1);     {parameters as a string}
  DataString := line;                 {save for cancel}
  rows := pGrid^.rowcount;
  len := length(line);
  if (len > 0) then begin             {there are some data}
    iB := 1;
    for ii := 1 to rows*2-2 do begin
      ExtractNextParam(iB, {';'}' ', line, st1, iE);
      if (st1 = '') then st1 := '0';    {replace empty values with a zero}
      iB := iE+1;                       {for the next parameter}
      ExtractNextParam(iB, {';'}' ', line, st2, iE);
      if (st2 = '') then st2 := '0';    {replace empty values with a zero}
      iB := iE+1;                       {for the next parameter}
      {parameters in two pairs of columns, separated by a column for indices}
      if (ii < rows) then begin         {first pair of columns}
        pGrid^.Cells[1,ii] := st1;      {current}
        pGrid^.Cells[2,ii] := st2;      {time}
      end else begin                    {second pair of columns}
        pGrid^.Cells[4,ii-rows+1] := st1; {current}
        pGrid^.Cells[5,ii-rows+1] := st2; {time}
      end;
    end;
  end else begin                        {data missing, fill with zeroes}
    for ii := 1 to rows-1 do begin
      pGrid^.Cells[1,ii] := '0';
      pGrid^.Cells[2,ii] := '0';
      pGrid^.Cells[4,ii] := '0';
      pGrid^.Cells[5,ii] := '0';
    end;
  end;
*)
end;

procedure TDmgCurveForm.DataFromGrid;
{copy the parameters in the grid to the component, as strings}
var
  ic     : integer;     {index for curve}
  ii     : integer;
  rows   : integer;     {number of rows}
  strpar : string;      {all parameters as a string}
begin
  strpar := '';                         {initialize}
  rows := pGrid^.rowcount;              {number of rows in the grid}
  ic := strtoint(CurveLabel.caption);   {saved in UserButClick or .. of parameter.pas}
  for ii := 1 to rows*2-2 do begin
    if (ii < rows) then begin
      strpar := strpar+pGrid^.Cells[1,ii]+{';'}' '+pGrid^.Cells[2,ii]+{';'}' ';
    end else begin
      strpar := strpar+pGrid^.Cells[4,ii-rows+1]+{';'}' '+pGrid^.Cells[5,ii-rows+1]+{';'}' ';
    end;
  end;
  pActComp^.PutStringPar(strpar,ic);    {save the parameters as a string}
end;

procedure TDmgCurveForm.FormShow(Sender: TObject);
{display parameters = current-time-points}
//var
//  icurve : integer;          {index of the curve}
begin
  {pointer to the active component (trafo) in tag}
  pActComp := TpComp(tag);   {pointer saved in StdImageMouseDown of parametr.pas}
  pGrid := @DmgGrid;
  pGrid^.color := clWhite;
//  icurve := strtoint(CurveLabel.caption);  {index written in UserButClick or .. of parameter.pas}
//  DataToGridForCurve(icurve);              {from comp. to grid, for curve 1..3}
  {initialize row and column}
  pGrid^.row := 1;
  pGrid^.col := 1;
  actrow := pGrid^.row;                    {must be the same as pGrid^.row}
  actcol := pGrid^.col;
  {initialize "old" values, needed in case of an error}
  ErrDat := 0;
  OldDat := '0';
end;

procedure TDmgCurveForm.OKButtonClick(Sender: TObject);
begin
  DataFromGrid;
  DmgCurveForm.visible := false;
  UpdateGraph;
end;

procedure TDmgCurveForm.DmgGridKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
{check that reasonable data, formally, at least}
var
  apu,apv : single;   {temporary}
  apw     : single;   {temporary}
  err     : integer;  {error flag}
  ipu     : integer;  {temporary}
  par     : single;   {the parameter}
  s1,s2   : string;   {temporary}
  s3,s4   : string;   {temporary}
  txt     : string;   {temporary}
begin
  {reasonable row, column}
  if (actrow > 0) and (actcol > 0) and (actcol <> 3) then begin
    txt := pGrid^.cells[actcol,actrow];    {the parameter being edited}
    ValuesFromLine(txt, 1, false, ipu, par, apu, apv, apw, s1,s2,s3,s4,ErrDat);
    if (ErrDat = 0) then pGrid^.color := clWhite
    else pGrid^.color := clYellow;
  end;
end;

procedure TDmgCurveForm.UpdateGraph;
{update the graph with the damage curve, char.curve of relay(s), etc,
 if graph visible, and if damage curve of this relay shown}
var
  ll  : longint;
  pSet : TpCompSet;
begin
  pActComp^.GetipSet(ll);
  pSet := TpCompSet(ll);           {pointer to the common}
  if (RelayCurr.visible) and (pSet^.pTrafo_dmg = pActComp) then begin
    ll := RelayCharact.tag;        {pointer to the relay saved in tag}
    RelayShowIf(ll);               {update graphics, if visible, in Skemproc.pas}
  end;
end;

procedure TDmgCurveForm.ApplyButClick(Sender: TObject);
var
  ll   : longint;
  pSet : TpCompSet;    {pointer to the common}
begin
  DataFromGrid;        {move data to component, temporarily}
  {update trafo damage curve, if ...}
  {..if diagram visible, and curve of this trafo shown}
  UpdateGraph;
//  pActComp^.GetipSet(ll);
//  pSet := TpCompSet(ll);    {pointer to the common}
//  if (RelayCurr.visible) and (pSet^.pTrafo_dmg = pActComp) then begin
//    ll := RelayCharact.tag;        {pointer to the relay saved in tag}
//    RelayShowIf(ll);               {update graphics, if visible, in Skemproc.pas}
//  end;
end;

procedure TDmgCurveForm.StdButClick(Sender: TObject);
{fill the table with standard curve data}
var
  cleared : boolean;  {data cleared/not}
  ic      : integer;  {index of curve}
  ii      : integer;
  offs    : integer;  {offset of parameter index}
  OilAir  : single;   {oil (0) or air (1) cooled}
  txt,txx : string;
begin
  ic := strtoint(CurveLabel.caption);                {index of curve}
  offs := (ic-1)*gTrafo_ncp;
  ClearData(@DmgGrid, cleared);                      {in userdef.pas}
  if (cleared) then begin
    GetLatestTrafoPar(pActComp, gTrafo_OorA+offs,OilAir); {oil (0) or air (1) cooled}
    if (OilAir = 0) then begin                       {oil cooled}
      for ii := 0 to high(Coil) do begin
        RemoveSpaces(Coil[ii],txt);                  {format current, table in parametr.pas}
        RemoveSpaces(Toil[ii],txx);                  {format temperature}
        DmgGrid.cells[1,ii+1] := txt;
        DmgGrid.cells[2,ii+1] := txx;
      end;
    end else begin                                   {air cooled}
      for ii := 0 to high(Cair) do begin
        RemoveSpaces(Cair[ii],txt);                  {format current, table in parametr.pas}
        RemoveSpaces(Tair[ii],txx);                  {format temperature}
        DmgGrid.cells[1,ii+1] := txt;
        DmgGrid.cells[2,ii+1] := txx;
      end;
    end;
  end;
end;

procedure TDmgCurveForm.InomButMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{multiply the currents TEMPORARILY with the nominal current (full load amperes)}
var
  curA : single; {current in amperes}
  curp : single; {pu-current}
  err  : integer; {error flag}
  FLA   : single;  {full load amperes = nominal current}
  ii,jj : integer;
  kend  : integer; {first non-read char}
  kk    : integer;
  line  : string;  {temporary string= one line of text}
  txt   : string;  {temporary}
  V1    : single;  {primary voltage}
  VA    : single;  {apparent power}
begin
  {first, get the nominal current, from parametr.pas}
  GetLatestTrafoPar(pActComp, gTrafo_V1,V1); {prim.voltage}
  GetLatestTrafoVA(pActComp, VA);            {apparent power}
  if (V1 > 0) then                           {reasonable voltage, maybe}
    FLA := VA/(sqrt3*V1)                     {full load ampers}
  else
    FLA := 1;                                {just some value}
  {multiply currents}
  for ii := 1 to DmgGrid.rowcount-1 do begin
    for jj := 1 to 2 do begin                  {two columns with data}
      kk := -2+3*jj;                           {column 1 or 4}
      line := DmgGrid.cells[kk,ii];
      if (jj = 1) then DmgBack1[ii] := line    {save, for returning with mouse up}
      else DmgBack4[ii] := line;
      NextValueFromLine(line, 1, kend,curp, txt, err);  {in routines.pas}
      if (err = 0) then begin
        curA := FLA*curp;                      {current in amperes}
        RemoveSpaces(curA,txt);                {format}
        DmgGrid.cells[kk,ii] := txt;
      end;
    end;
  end;
end;

procedure TDmgCurveForm.InomButMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{return the original, pu-currents after multiplying in mousedown}  
var
  ii : integer;
begin
  for ii := 1 to DmgGrid.rowcount-1 do begin
    DmgGrid.cells[1,ii] := DmgBack1[ii];
    DmgGrid.cells[4,ii] := DmgBack4[ii];
  end;
end;

end.
