unit FeederParam;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, ExtCtrls, StdCtrls, ComCtrls, Routines, Skemadef, Imagodef, Utildef,
  Compdef;

type
  TFeederForm = class(TForm)
    ParamPages: TPageControl;
    OhmSheet: TTabSheet;
    PowerSheet: TTabSheet;
    RatioSheet: TTabSheet;
    UpdatePanel: TPanel;
    ChangedLabel: TLabel;
    UpdateLabel: TLabel;
    ChangedLabel2: TLabel;
    AVOhmBut: TButton;
    PerUnitBut: TButton;
    CancelUpdateBut: TButton;
    OhmPanel: TPanel;
    OhmImage: TImage;
    OhmArrowImage: TImage;
    OhmRectGrid: TStringGrid;
    OhmPolarGrid: TStringGrid;
    ButPanel: TPanel;
    OKBut: TButton;
    CancelBut: TButton;
    HelpBut: TButton;
    puCalcBut: TButton;
    PuPanel: TPanel;
    PuRectGrid: TStringGrid;
    PuPolarGrid: TStringGrid;
    PuImage: TImage;
    PuArrowImage: TImage;
    DisplayLabel: TLabel;
    ZLabel: TLabel;
    ZEdit: TEdit;
    MVAEdit: TEdit;
    kVEdit: TEdit;
    MVALabel: TLabel;
    kVLabel: TLabel;
    DisplayLabel2: TLabel;
    PowerPanel: TPanel;
    Image1: TImage;
    PowerArrowImage: TImage;
    CurrentGrid: TStringGrid;
    PowerGrid: TStringGrid;
    PowerLabel: TLabel;
    OhmCheckBox: TCheckBox;
    PowerCheckBox: TCheckBox;
    RatioCheckBox: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure OKButClick(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure CancelButClick(Sender: TObject);
    procedure OhmRectGridKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure OhmRectGridSelectCell(Sender: TObject; Col, Row: Longint;
      var CanSelect: Boolean);
    procedure OhmPolarGridSelectCell(Sender: TObject; Col, Row: Longint;
      var CanSelect: Boolean);
    procedure OhmPolarGridKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure MVAEditKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure kVEditKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure PerUnitButClick(Sender: TObject);
    procedure UpdatePanelMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure CancelUpdateButClick(Sender: TObject);
    procedure MVAEditEnter(Sender: TObject);
    procedure kVEditEnter(Sender: TObject);
    procedure PuRectGridKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure PuPolarGridKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure PuRectGridSelectCell(Sender: TObject; Col, Row: Longint;
      var CanSelect: Boolean);
    procedure PuPolarGridSelectCell(Sender: TObject; Col, Row: Longint;
      var CanSelect: Boolean);
    procedure AVOhmButClick(Sender: TObject);
    procedure CurrentGridKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure CurrentGridSelectCell(Sender: TObject; Col, Row: Longint;
      var CanSelect: Boolean);
    procedure OhmCheckBoxMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PowerCheckBoxMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure RatioCheckBoxMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
    pComp : TpComp;
    procedure ImpedToPU(row: integer; pOhm, pPU : TpGrid);
    procedure ImpedToOhm(row: integer; pPU, pOhm : TpGrid);
    procedure RorXtoPU(RX: single; row: integer; pPU: TpGrid);
    procedure RorXtoOhm(RX: single; row: integer; pOhm: TpGrid);
    procedure VoltToPu;
    procedure PuToVolt;
    procedure RectGridKeyUp(OhmOrPU: string);
    procedure PolarGridKeyUp(OhmOrPu: string);
    procedure SheetInUse;
    procedure ZpFromI3(var I3,Vpp: single; var Zz: complex; var err : integer);
    procedure Z0fromI1;
    procedure UpdateS3(I3,Vpp: single);
    procedure UpdateXpRp(Zp : complex);        
  public
    { Public declarations }
    procedure ParamToGrid(pComp: TpComp);
    procedure PutpComp(ipComp: longint);
    procedure AllParametersToComp;
  end;

var
  FeederForm: TFeederForm;

implementation

uses Imagopas, LineParam;

{$R *.DFM}
const
  sqrt3 = 1.73205081;
  {impedances as real and imag.components}
  Vrow  = 0;
  Firow = 1;
  R1row = 2;
  X1row = 3;
  R0row = 4;
  X0row = 5;
  R2row = 6;
  X2row = 7;
  Rgrow = 8;
  Xgrow = 9;
  {impedances as magnitude and phase}
  Z1row = 0;
  f1row = 1;
  Z0row = 2;
  f0row = 3;
  Z2row = 4;
  f2row = 5;
  Zgrow = 6;
  fgrow = 7;
  {current and power, and ...}
  I3prow = 2;   {three phase (short circuit) current, magnitude}
  F3prow = 3;   { " , phase}
  I1prow = 4;   {one phase (short circuit) current, magnitude}
  F1prow = 5;   { " , phase}
  RgProw = 6;   {earthing resistance, on power page}
  XgProw = 7;   {earthing reactance, on power page}
  P3row  = 0;   {short circuit power}
  XRprow = 1;   {X/R for positive sequence}
  P1row  = 2;
  XR0row = 3;
  ZgProw = 4;
  fgProw = 5;
  {indices of parameters of the component}
  Zindx : array[0..9] of integer = (gFeed_V , gFeed_fi, gFeed_R , gFeed_X , gFeed_R0,
                                    gFeed_X0, gFeed_R2, gFeed_X2, gFeed_Rg, gFeed_Xg);

var
  cancel    : boolean;       {true, when canceling parameters}
  dec_p     : Char;          {decimal point - character}
  baseMVA   : single;        {base power for pu}
  basekV    : single;        {pase voltage for pu}
//baseZ     : single;        {base impedance}
  baseMVA_bu  : single;      {backup for base power for pu}
  basekV_bu   : single;      {backup for base voltage for pu}
  baseMVA_txt : string;      {backup for base power as text}
  basekV_txt  : string;      {backup for base voltage as text}
  baseZ_txt   : string;      {backup for base impedance as text}
  pSet      : TpCompSet;     {pointer to the common}
  Polar_row : integer;       {row in OhmPolarGrid}
  Rect_row  : integer;       {row in OhmRectGrid}
  RectPu_row: integer;       {row in PURectGrid}
  PolPu_row : integer;       {row in PUPolarGrid }
  Curr_row  : integer;       {row in CurrentGrid}

procedure TFeederForm.FormCreate(Sender: TObject);
begin
  pSet := @SetComp;               {pointer to the common}
//  top := 0; left := 0;
  width := ParamPages.width+8;
  DecimalPoint(dec_p);    {determine character for decimal point (. or ,), in Routines.pas}
  cancel := false;
  {rectangular impedance, ohms}
  OhmRectGrid.cells[0,Vrow]  := 'Volt';
  OhmRectGrid.cells[0,firow] := '()';
  OhmRectGrid.cells[0,R1row] := 'R1';
  OhmRectGrid.cells[0,X1row] := 'X1';
  OhmRectGrid.cells[0,R0row] := 'R0';
  OhmRectGrid.cells[0,X0row] := 'X0';
  OhmRectGrid.cells[0,R2row] := 'R2';
  OhmRectGrid.cells[0,X2row] := 'X2';
  OhmRectGrid.cells[0,Rgrow] := 'Rg';
  OhmRectGrid.cells[0,Xgrow] := 'Xg';
  {polar impedance, ohms}
  OhmPolarGrid.cells[0,Z1row] := '|Z1|';
  OhmPolarGrid.cells[0,F1row] := '1()';
  OhmPolarGrid.cells[0,Z0row] := '|Z0|';
  OhmPolarGrid.cells[0,F0row] := '0()';
  OhmPolarGrid.cells[0,Z2row] := '|Z2|';
  OhmPolarGrid.cells[0,F2row] := '2()';
  OhmPolarGrid.cells[0,Zgrow] := '|Zg|';
  OhmPolarGrid.cells[0,Fgrow] := 'g()';
  {the same parameters in pu-form}
  {rectangular impedance, ohms}
  PuRectGrid.cells[0,Vrow]  := 'Volt';
  PuRectGrid.cells[0,firow] := '()';
  PuRectGrid.cells[0,R1row] := 'R1';
  PuRectGrid.cells[0,X1row] := 'X1';
  PuRectGrid.cells[0,R0row] := 'R0';
  PuRectGrid.cells[0,X0row] := 'X0';
  PuRectGrid.cells[0,R2row] := 'R2';
  PuRectGrid.cells[0,X2row] := 'X2';
  PuRectGrid.cells[0,Rgrow] := 'Rg';
  PuRectGrid.cells[0,Xgrow] := 'Xg';
  {polar impedance, ohms}
  PuPolarGrid.cells[0,Z1row] := '|Z1|';
  PuPolarGrid.cells[0,F1row] := '1()';
  PuPolarGrid.cells[0,Z0row] := '|Z0|';
  PuPolarGrid.cells[0,F0row] := '0()';
  PuPolarGrid.cells[0,Z2row] := '|Z2|';
  PuPolarGrid.cells[0,F2row] := '2()';
  PuPolarGrid.cells[0,Zgrow] := '|Zg|';
  PuPolarGrid.cells[0,Fgrow] := 'g()';
  {current and power sheet}
  {voltage and currents}
  CurrentGrid.cells[0,Vrow]   := 'Volt';
  CurrentGrid.cells[0,firow]  := '()';
  CurrentGrid.cells[0,I3prow] := 'I3ph';
  CurrentGrid.cells[0,F3prow] := '3ph';
  CurrentGrid.cells[0,I1prow] := 'I1ph';
  CurrentGrid.cells[0,F1prow] := '1ph';
  CurrentGrid.cells[0,RgProw] := 'Rg';
  CurrentGrid.cells[0,XgProw] := 'Xg';
  PowerGrid.cells[0,P3row] := 'S3ph';
  PowerGrid.cells[0,XRprow] := 'X1/R1';
  PowerGrid.cells[0,P1row] := 'S1ph';
  PowerGrid.cells[0,XR0row] := 'X0/R0';
  PowerGrid.cells[0,ZgProw] := '|Zg|';
  PowerGrid.cells[0,fgProw] := 'g()';
end;

procedure TFeederForm.OKButClick(Sender: TObject);
begin
  FeederForm.visible := false;
  unmark(longint(pSet));       {must do also here, else does not unmark?}
end;

procedure TFeederForm.ParamToGrid(pComp: TpComp);
{read parameters from the component, put to grid
 Called in FeederGrid of Skemproc.pas
 pComp  pointer to the feeder}
var
  apu,apv : single;      {temporary}
  bZ      : single;      {base impedance}
  cpu,cpv : complex;     {temporary}
  Curr    : complex;     {current}
  ft      : string;      {phase as string}
  ii,jj   : integer;     {index}
  pGridP  : TpGrid;      {parameters in polar form}
  pGridR  : TpGrid;      {pointer to the grid for parameters}
  Pow     : single;      {power}
  R2,R0   : single;      {neg.seq, zero seq. resistance}
  Rg      : single;      {earthing resistance}
  txt     : string;      {temporary}
  Vpp     : single;      {phase-phase voltage}
  Zt      : string;      {impedance as string}
  Rr,Xx,Zz,fii : single;
  X2,X0   : single;      {neg.seq, zero seq. reactance}
  Xg      : single;      {earthing reactance}
begin
  pGridR := @OhmRectGrid;   {grid to where parameters copied}
  pGridP := @OhmPolarGrid;  {grid for parameters in polar form}
  for ii := 0 to pGridR^.RowCount-1 do begin
    {read parameters one by one}
    pComp^.GetPar(Zindx[ii],apu);      {one impedance component}
    RemoveSpaces(apu,txt);             {format, and remove spaces, in routines.pas}
    pGridR^.Cells[1,ii] := txt;
  end;
  {display impedances also in polar form}
  for ii := 1 to 4 do begin
    RecToPolar(pGridR^.cells[1,2*ii], pGridR^.cells[1,2*ii+1], Zt,ft, Rr,Xx,Zz,fii);
    pGridP^.cells[1,2*(ii-1)] := Zt;
    pGridP^.cells[1,2*(ii-1)+1] := ft;
  end;
  {display base voltage, power, impedance}
  BaseToGrid(pComp, @kVEdit, @MVAEdit, @ZEdit, basekV, baseMVA, bZ);
  {display voltage and impedances in pu-form}
  VoltToPu;
  for ii := 2 to 9 do ImpedToPU(ii,@OhmRectGrid,@PURectGrid);
  {also in the polar grid, but phases as such}
  for ii := 0 to 3 do begin
    jj := 2*ii;              {only the magnitude}
    ImpedToPU(jj,@OhmPolarGrid,@PUPolarGrid);
    jj := 2*ii+1;
    PUPolarGrid.cells[1,jj] := OhmPolarGrid.cells[1,jj];
  end;
  {grids in the power sheet . . . . . . . . . .}
  CurrentGrid.cells[1,Vrow] := OhmRectGrid.cells[1,Vrow];  {copy voltage and phase as such}
  CurrentGrid.cells[1,Firow] := OhmRectGrid.cells[1,Firow];
  {three phase short circuit current}
  pComp^.GetPar(gFeed_V,Vpp);           {voltage}
  pComp^.GetPar(gFeed_R,Rr);            {resistance}
  pComp^.GetPar(gFeed_X,Xx);            {reactance}
  pComp^.GetPar(gFeed_R2,R2);           {neg.seq. resistance}
  pComp^.GetPar(gFeed_X2,X2);           {neg.seq. reactance}
  pComp^.GetPar(gFeed_R0,R0);           {zero.seq. resistance}
  pComp^.GetPar(gFeed_X0,X0);           {zero.seq. reactance}
  pComp^.GetPar(gFeed_Rg,Rg);           {earthing resistance}
  pComp^.GetPar(gFeed_Xg,Xg);           {earthing reactance}
  if (Rr > 0) or (Xx > 0) then begin    {reasonable impedance}
    {phase of voltage not considered in short circuit current, because ...
     ... the purpose is to get the impedances, I think  (???)}
    Curr := Cdiv(cplx(Vpp/sqrt(3),0),cplx(Rr,Xx));  {three-phase fault current}
    apu := Cabs(Curr);
    apv := Cangle(Curr)*180/pi;
    RemoveSpaces(apu,txt);                {format, and remove spaces, in routines.pas}
    CurrentGrid.cells[1,I3prow] := txt;   {display current in grid}
    RemoveSpaces(apv,txt);
    CurrentGrid.cells[1,f3prow] := txt;
    {three phase short circuit power}
    Pow := Cabs(Crmult(sqrt3*Vpp,Curr));  {power}
    RemoveSpaces(Pow,txt);
    PowerGrid.cells[1,P3row] := txt;
    {X/R for positive sequence}
    if (Rr > 0) then begin
      apu := Xx/Rr;
      RemoveSpaces(apu,txt);
      PowerGrid.cells[1,XRprow] := txt;
    end else begin
      PowerGrid.cells[1,XRprow] := '1e6';
    end;
  end else begin
    CurrentGrid.cells[1,I3prow] := '?';   {display current in grid}
    CurrentGrid.cells[1,f3prow] := '?';
  end;
  {line to ground fault current, WITH (???) the earthing impedance, if reasonable impedances}
  if (Rr > 0) or (Xx > 0) or (R2 > 0) or (X2 > 0) or (R0 > 0) or (X0 > 0) or
     (Rg > 0) or (Xg > 0) then begin
    cpu := Cadd(cplx(Rr,Xx),cplx(R2,X2));
    cpv := Cadd(cplx(R0,X0),cplx(3*Rg,3*Xg));
    cpu := Cadd(cpu,cpv);
    cpv := Cdiv(cplx(Vpp/sqrt(3),0),cpu);
    Curr := CRmult(3,cpv);
    apu := Cabs(Curr);
    apv := Cangle(Curr)*180/pi;
    RemoveSpaces(apu,txt);                {format, and remove spaces, in routines.pas}
    CurrentGrid.cells[1,I1prow] := txt;   {display current in grid}
    RemoveSpaces(apv,txt);
    CurrentGrid.cells[1,f1prow] := txt;
    {one phase short circuit power}
    Pow := Cabs(Crmult(Vpp/sqrt3,Curr));  {power, but sqrt3 ???}
    RemoveSpaces(Pow,txt);
    PowerGrid.cells[1,P1row] := txt;
    {X/R for zero sequence}
    if (R0 > 0) then begin
      apu := X0/R0;
      RemoveSpaces(apu,txt);
      PowerGrid.cells[1,XR0row] := txt;
    end else begin
      PowerGrid.cells[1,XR0row] := '1e6';
    end;
  end else begin
    CurrentGrid.cells[1,I1prow] := '?';   {display current in grid}
    CurrentGrid.cells[1,f1prow] := '?';
    PowerGrid.cells[1,P1row] := '?';
    PowerGrid.cells[1,XR0row] := '?';
  end;
  {display earthing impedance as such}
  CurrentGrid.cells[1,RgProw] := OhmRectGrid.cells[1,Rgrow];
  CurrentGrid.cells[1,XgProw] := OhmRectGrid.cells[1,Xgrow];
  PowerGrid.cells[1,ZgProw] := OhmPolarGrid.cells[1,Zgrow];
  PowerGrid.cells[1,fgProw] := OhmPolarGrid.cells[1,fgrow];
end;

procedure TFeederForm.AllParametersToComp;
{read parameters in the grid(s), transform to numerical form, write to component}
var
  apu : single;  {temporary}
  ii  : integer; {index}
begin
  for ii := 0 to OhmRectGrid.RowCount-1 do begin
     {impedances, rectang.form, ParametersToComp is in LineParam}
    ParametersToComp(pComp,OhmRectGrid.cells[1,ii],Zindx[ii],apu);
  end;
  {base variables to the comp.}
  pComp^.PutVPref(basekV,baseMVA);                    {save base power and voltage}
end;

procedure TFeederForm.FormDeactivate(Sender: TObject);
var
  bpu : boolean;  {temporary}
begin
  {hide the form, but not when Hint-button clicked, or when pu-calculator-button clicked}
//if (pHelp <> nil) then bpu := (not pHelp^.visible)
//  else bpu := true;
  if {(not puForm.visible) and bpu and} (not pSet^.Copy_Click) {and} {not hide, when copying}
     {(not UpdatePanel.visible)} then                              {or updating base variables}
    FeederForm.visible := false;
end;


procedure TFeederForm.FormHide(Sender: TObject);
{copy parameters to the component
 For impedances: only the rect.impedances in ohm/km}
var
  apu   : single;
  ii    : integer;
  RePro : TCompProc;     {procedure for operations after readings}
begin
  if (not appl_close) and (not cancel) then begin
    AllParametersToComp;
    unmark(longint(pSet));
    {some operation when parameters read}
    pComp^.GetRePro(RePro);              {get the procedure}
    RePro(longint(pComp));               {the operation after reading}
  end;
  cancel := false;
end;

procedure TFeederForm.CancelButClick(Sender: TObject);
begin
  cancel := true;
  FeederForm.visible := false;
  unmark(longint(pSet));       {must do also here, else does not unmark?}
end;

procedure TFeederForm.PutpComp(ipComp: longint);
{save the pointer to the component when creating the component in InitFeeder,
 and at mouse down in FeederGrid, both in skemproc.pas
 ipComp   pointer to the component, as integer}
var
  ix,iy : integer;
  lbl   : string;
begin
  pComp := TpComp(ipComp);
  pComp^.GetLabel(lbl,ix,iy);
  caption := lbl;             {show label in the caption of the parameter form}
end;

procedure BaseImpedance(var bZ: single; var erb : integer);
{calculate the base impedance from base power and voltage}
begin
  if (baseMVA > 0) and (basekV > 0) then begin
    bZ := basekV*basekV/baseMVA;
    erb := 0;
  end else begin
    bZ := 1;              {just some value}
    erb := 1;
  end;
end;

procedure TFeederForm.RorXtoPU(RX: single; row: integer; pPU: TpGrid);
{convert R or X (as single) to pu-form, write to PU-grid
 RX   resitance or reactance
 row  row index
 pPU  pointer to the pu-grid}
var
  bZ          : single;  {base impedance}
  erb         : integer; {error flags}
  puZ         : single;  {pu-impedance}
  txt         : string;
begin
  BaseImpedance(bZ, erb);
  {PU-impedance, but only if OK so far}
  if (erb = 0) then begin
    puZ := RX/bZ;
    RemoveSpaces(puZ,txt);             {format, and remove spaces, in routines.pas}
    pPU^.Cells[1,row] := txt;
  end;
end;

procedure TFeederForm.RorXtoOhm(RX: single; row: integer; pOhm: TpGrid);
{convert R or X (as single) from pu to Ohm, write to Ohm-grid
 RX   resitance or reactance in pu-form
 row  row index
 pOhm  pointer to the pu-grid}
var
  bZ          : single;  {base impedance}
  erb         : integer; {error flags}
  puZ         : single;  {pu-impedance}
  txt         : string;
begin
  BaseImpedance(bZ, erb);
  {Ohm-impedance, but only if OK so far}
  if (erb = 0) then begin
    puZ := RX*bZ;
    RemoveSpaces(puZ,txt);             {format, and remove spaces, in routines.pas}
    pOhm^.Cells[1,row] := txt;
  end;
end;

procedure TFeederForm.ImpedToOhm(row: integer; pPU, pOhm : TpGrid);
{read resistance or reactance in PU-grid, convert it to Ohm, write to Ohm-grid
 row   row index in the Ohm-grid
 pPU   pointer to the "from" grid
 pOhm  pointer to the "to" grid: rectangular or polar}
var
  apu,apv,apw : single;  {temporary}
  bZ          : single;  {base impedance}
  err,erb     : integer; {error flags}
  ipu         : integer; {temporary}
  puZ         : single;  {pu-impedance}
  RX          : single;  {reasistance or reactance}
  s1,s2,s3,s4 : string;  {temporary}
  txt         : string;
begin
  {read impedance as text, convert to numerical}
  txt := pPU^.cells[1,row];
  ValuesFromLine(txt, 1, false, ipu, RX , apu, apv, apw, s1,s2,s3,s4,err); {in routines.pas}
  {calculate base impedance (every time?), just in case, baseZ may not always be up to date?!}
  if (err = 0) then begin
    RorXtoOhm(RX, row, pOhm);
  end;
  {color in the grid indicates error in value}
  if (err = 0) then begin
    pPU^.color := clWhite;
  end else begin
    pPU^.color := clYellow;
  end;
end;

procedure TFeederForm.ImpedToPU(row: integer; pOhm, pPU : TpGrid);
{read resistance or reactance in Ohm-grid, convert it to PU-form, write to pu-grid
 row   row index in the Ohm-grid
 pOhm  pointer to the "from" grid: rectangular or polar
 pPU   pointer to the "to" grid}
var
  apu,apv,apw : single;  {temporary}
  bZ          : single;  {base impedance}
  err,erb     : integer; {error flags}
  ipu         : integer; {temporary}
  puZ         : single;  {pu-impedance}
  RX          : single;  {reasistance or reactance}
  s1,s2,s3,s4 : string;  {temporary}
  txt         : string;
begin
  {read impedance as text, convert to numerical}
  txt := pOhm^.cells[1,row];
  ValuesFromLine(txt, 1, false, ipu, RX , apu, apv, apw, s1,s2,s3,s4,err); {in routines.pas}
  {calculate base impedance (every time?), just in case, baseZ may not always be up to date?!}
  if (err = 0) then begin
    RorXtoPU(RX, row, pPU);
  end;
  {color in the grid indicates error in value}
  if (err = 0) then begin
    pOhm^.color := clWhite;
  end else begin
    pOhm^.color := clYellow;
  end;
end;

procedure TFeederForm.VoltToPu;
{read voltage in grid, convert to pu-form, write to pu-grid}
var
  apu,apv,apw : single;  {temporary}
  err,erb     : integer; {error flags}
  ipu         : integer; {temporary}
  puV         : single;  {pu-voltage}
  s1,s2,s3,s4 : string;  {temporary}
  txt         : string;
  Volt        : single;  {voltage}
begin
  txt := OhmRectGrid.cells[1,Vrow];    {voltage as text}
  ValuesFromLine(txt, 1, false, ipu, Volt , apu, apv, apw, s1,s2,s3,s4,err); {in routines.pas}
  if (basekV > 0) then begin
    if (err = 0) then begin
      puV := 0.001*Volt/basekV;
      RemoveSpaces(puV,txt);             {format, and remove spaces, in routines.pas}
      PURectGrid.Cells[1,Vrow] := txt;
      OhmRectGrid.color := clWhite;
      PURectGrid.Cells[1,Firow] := OhmRectGrid.cells[1,Firow];  {copy phase as such}
    end else begin
      OhmRectGrid.color := clYellow;
    end;
  end;
end;

procedure TFeederForm.PuToVolt;
{read pu-voltage in grid, convert to Volt, write to volt-ohm-grid}
var
  apu,apv,apw : single;  {temporary}
  err,erb     : integer; {error flags}
  ipu         : integer; {temporary}
  puV         : single;  {pu-voltage}
  s1,s2,s3,s4 : string;  {temporary}
  txt         : string;
  Volt        : single;  {voltage}
begin
  txt := PURectGrid.cells[1,Vrow];       {pu-voltage as text}
  ValuesFromLine(txt, 1, false, ipu, puV , apu, apv, apw, s1,s2,s3,s4,err); {in routines.pas}
  if (basekV > 0) then begin
    if (err = 0) then begin
      Volt := 1000*puV*basekV;
      RemoveSpaces(Volt,txt);             {format, and remove spaces, in routines.pas}
      OhmRectGrid.Cells[1,Vrow] := txt;
      PuRectGrid.color := clWhite;
      OhmRectGrid.Cells[1,Firow] := PURectGrid.cells[1,Firow];  {copy phase as such}
    end else begin
      PuRectGrid.color := clYellow;
    end;
  end;
end;

procedure TFeederForm.RectGridKeyUp(OhmOrPU: string);
{change rect. impedances to polar form when editing, and all variables either
from phys to pu-form or from pu to phys., depending on which grid
OhmOrPU  flag for the grid, 'ohm' or 'pu' }
var
  apu     : single;  {temporary}
  iz,ip   : integer; {indices for impedance, phase}
  pRect   : TpGrid;  {grid with rect.parameters, where editing}
  pRectOp : TpGrid;  {grid with rect.parameters, opposite with regard to pu or ohm with pRect}
  pPol    : TpGrid;  {grid with polar param, parallel with pRect}
  pPolOp  : TpGrid;  {grid with polar parameters, opposite with regard to pu or ohm with pRect}
  row     : integer; {row in grid}
  s1,s2   : string;  {temporary}
  txt,txx : string;  {temporary}
  Rr,Xx,Zz,fii : single;
begin
  {editing impedances?}
  if (OhmOrPu = 'ohm') then begin
    row := Rect_row;
    pRect := @OhmRectGrid;
    pPol := @OhmPolarGrid;
    pRectOp := @PURectGrid;
    pPolOp := @PUPolarGrid;
  end else begin
    row := RectPu_row; {row where editing}
    pRect := @PURectGrid;
    pPol := @PUPolarGrid;
    pRectOp := @OhmRectGrid;
    pPolOp := @OhmPolarGrid;
  end;
  if (row >= 2) then begin
    apu := row;
    if (row div 2) = (apu/2) then begin       {even index => resistance}
      s1 := pRect^.cells[1,row];
      s2 := pRect^.cells[1,row+1];
      iz := row-2;
      ip := row-1;
    end else begin                            {odd index => reactance}
      s1 := pRect^.cells[1,row-1];
      s2 := pRect^.cells[1,row];
      iz := row-3;
      ip := row-2;
    end;
    RecToPolar(s1,s2,txt,txx,Rr,Xx,Zz,fii);
    if (txt <> '?') and (txx <> '?') then begin     {reasonable values}
      pPol^.cells[1,iz] := txt;                     {impedance}
      pPol^.cells[1,ip] := txx;                     {phase}
      pRect^.color := clWhite;
    end else begin
      pRect^.color := clYellow;
    end;
    {param. from Ohm to pu or from pu to Ohm}
    if (OhmOrPu = 'ohm') then begin                 {physical units to pu}
      {rect. impedance to pu-form}
      ImpedToPU(row,pRect,pRectOp);
      {polar imped to pu-form}
      ImpedToPU(iz,pPol,pPolOp);                    {magnitude}
//    PUPolarGrid.cells[1,ip] := OhmPolarGrid.cells[1,ip];  {phase}
      pPolOp^.cells[1,ip] := pPol^.cells[1,ip];     {phase}
    end else begin                                  {pu to physical units}
      {rect. impedance to Ohm}
      ImpedToOhm(row,pRect,pRectOp);
      {polar imped to Ohm-form}
      ImpedToOhm(iz,pPol,pPolOp);                    {magnitude}
//    PUPolarGrid.cells[1,ip] := OhmPolarGrid.cells[1,ip];  {phase}
      pPolOp^.cells[1,ip] := pPol^.cells[1,ip];      {phase}
    end;
  end else begin                                     {voltage or phase}
    if (OhmOrPu = 'ohm') then begin
      VoltToPU;
    end else begin
      PuToVolt;
    end;
  end;
end;

procedure TFeederForm.OhmRectGridKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
{change rect. impedances to polar form when editing, and all variables to pu-form}
begin
  RectGridKeyUp('ohm');   {from Ohm to pu}
end;

procedure TFeederForm.PolarGridKeyUp(OhmOrPu: string);
{change polar impedances to rect. when editing, and to either Ohm or pu
 OhmOrPu   if 'ohm', work in ohms, if 'pu', work with per unit}
var
  apu     : single;  {temporary}
  ir,ix   : integer; {indices for resistance, reactance}
  magn    : boolean; {true, when magnitude (not phase)}
  pRect   : TpGrid;  {grid with rect.parameters}
  pRectOp : TpGrid;  {grid with rect.parameters, opposite with regard to pu or ohm with pRect}
  pPol    : TpGrid;  {grid with polar param, where editing, parallel with pRect}
  pPolOp  : TpGrid;  {grid with polar parameters, opposite with regard to pu or ohm with pRect}
  row     : integer; {row in grid}
  s1,s2   : string;  {temporary}
  txt,txx : string;  {temporary}
  Rr,Xx,Zz,fii : single;
begin
  if (OhmOrPu = 'ohm') then begin
    row := Polar_row;
    pRect := @OhmRectGrid;
    pPol := @OhmPolarGrid;
    pRectOp := @PURectGrid;
    pPolOp := @PUPolarGrid;
  end else begin
    row := PolPu_row;
    pRect := @PURectGrid;
    pPol := @PUPolarGrid;
    pRectOp := @OhmRectGrid;
    pPolOp := @OhmPolarGrid;
  end;
  apu := row;
  if (row div 2) = (apu/2) then begin       {even index => magnitude}
    s1 := pPol^.cells[1,row];               {magnitude}
    s2 := pPol^.cells[1,row+1];             {phase}
    ir := row+2;
    ix := row+3;
    magn := true;                           {editing magnitude}
  end else begin                            {odd index => phase}
    s1 := pPol^.cells[1,row-1];
    s2 := pPol^.cells[1,row];
    ir := row+1;
    ix := row+2;
    magn := false;                          {editing phase}
  end;
  PolarToRec(s1,s2,txt,txx, Rr,Xx,Zz,fii);
  if (txt <> '?') and (txx <> '?') then begin  {reasonable values}
    pRect^.cells[1,ir] := txt;                 {resistance}
    pRect^.cells[1,ix] := txx;                 {reactance}
    pPol^.color := clWhite;
  end else begin
    pPol^.color := clYellow;
  end;
  {grids with pu-notation}
  if (magn) then begin
    if (OhmOrPu = 'ohm') then begin
      ImpedToPU(row, pPol, pPolOp);              {convert magnitude to pu}
    end else begin
      ImpedToOhm(row,pPol,pPolOp);               {convert pu to magnitude (ohm)}
    end;
  end else begin                                 {editing phase}
    pPolOp^.cells[1,row] := pPol^.cells[1,row];  {copy phase as such}
  end;
  {rect.values to pu-form}
  if (OhmOrPu = 'ohm') then begin
    RorXtoPU(Rr, ir, pRectOp);
    RorXtoPU(Xx, ix, pRectOp);
  end else begin
    RorXtoOhm(Rr,ir,pRectOp);
    RorXtoOhm(Xx,ix,pRectOp);
  end;
end;

procedure TFeederForm.OhmPolarGridKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
{change polar impedances to rect. when editing}
var
  apu     : single;  {temporary}
  ir,ix   : integer; {indices for resistance, reactance}
  magn    : boolean; {true, when magnitude (not phase)}
  row     : integer; {row in grid}
  s1,s2   : string;  {temporary}
  txt,txx : string;  {temporary}
  Rr,Xx,Zz,fii : single;
begin
  PolarGridKeyUp('ohm');
end;

procedure TFeederForm.OhmRectGridSelectCell(Sender: TObject; Col,
  Row: Longint; var CanSelect: Boolean);
begin
  Rect_Row := row;
end;

procedure TFeederForm.OhmPolarGridSelectCell(Sender: TObject; Col,
  Row: Longint; var CanSelect: Boolean);
begin
  Polar_row := row;
end;



procedure TFeederForm.MVAEditKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
{update base impedance, ask which parameters to be updated}
begin
  BaseEditKeyUp(Key, @MVAEdit, @ZEdit, 'MVA', basekV, baseMVA,
                @UpDatePanel, @AVOhmBut, @PerUnitBut);          {in LineParam.pas}
end;

procedure TFeederForm.kVEditKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
{update base impedance, ask which parameters to be updated}
begin
  BaseEditKeyUp(Key, @kVEdit, @ZEdit, 'kV', basekV, baseMVA,
                @UpDatePanel, @AVOhmBut, @PerUnitBut);
end;

procedure TFeederForm.PerUnitButClick(Sender: TObject);
{update pu-values (when base changed)}
var
  ii,jj : integer;
begin
  {display voltage and impedances in pu-form}
  VoltToPu;
  for ii := 2 to 9 do ImpedToPU(ii,@OhmRectGrid,@PURectGrid);
  {also in the polar grid}
  for ii := 0 to 3 do begin
    jj := 2*ii;              {only the magnitude}
    ImpedToPU(jj,@OhmPolarGrid,@PUPolarGrid);
  end;
  UpdatePanel.visible := false;
end;

procedure TFeederForm.AVOhmButClick(Sender: TObject);
{update Ohm-values (when base changed)}
var
  ii,jj : integer;
begin
  {display voltage and impedances in pu-form}
  PuToVolt;
  for ii := 2 to 9 do ImpedToOhm(ii,@PuRectGrid,@OhmRectGrid);
  {also in the polar grid}
  for ii := 0 to 3 do begin
    jj := 2*ii;              {only the magnitude}
    ImpedToOhm(jj,@PuPolarGrid,@OhmPolarGrid);
  end;
  UpdatePanel.visible := false;
end;

procedure TFeederForm.UpdatePanelMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
{move the panel with the mouse}
const
  x0  : integer = 0;    {old coordinates}
  y0  : integer = 0;
begin
  if (ssLeft in Shift) then begin        {left button pressed}
    UpdatePanel.left := UpdatePanel.left+X-x0;
    UpdatePanel.top  := UpdatePanel.top +Y-y0;
  end else begin
    x0 := X;
    y0 := Y;
  end;
end;

procedure TFeederForm.CancelUpdateButClick(Sender: TObject);
{cancel the change in base values}
begin
  baseMVA := baseMVA_bu;
  MVAEdit.text := baseMVA_txt;
  basekV := basekV_bu;
  kVEdit.text := basekV_txt;
  ZEdit.text := baseZ_txt;
  UpdatePanel.visible := false;
end;

procedure TFeederForm.MVAEditEnter(Sender: TObject);
begin
  if (not UpdatePanel.visible) then begin
    baseMVA_bu := baseMVA;         {needed in case of cancel}
    baseMVA_txt := MVAEdit.text;
    basekV_bu := basekV;           {needed in case of cancel}
    basekV_txt := kVEdit.text;
    baseZ_txt := ZEdit.text;
  end;
end;

procedure TFeederForm.kVEditEnter(Sender: TObject);
begin
  if (not UpdatePanel.visible) then begin
    baseMVA_bu := baseMVA;         {needed in case of cancel}
    baseMVA_txt := MVAEdit.text;
    basekV_bu := basekV;           {needed in case of cancel}
    basekV_txt := kVEdit.text;
    baseZ_txt := ZEdit.text;
  end;  
end;

procedure TFeederForm.PuRectGridKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  RectGridKeyUp('pu');   {from pu to Ohm}
end;

procedure TFeederForm.PuPolarGridKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  PolarGridKeyUp('pu');
end;

procedure TFeederForm.PuRectGridSelectCell(Sender: TObject; Col,
  Row: Longint; var CanSelect: Boolean);
begin
  RectPu_row := row;
end;

procedure TFeederForm.PuPolarGridSelectCell(Sender: TObject; Col,
  Row: Longint; var CanSelect: Boolean);
begin
  PolPu_row := row;
end;

procedure TFeederForm.ZpFromI3(var I3,Vpp: single; var Zz: complex; var err : integer);
{calculate the pos.seq. impedance from three phase fault current
I3    magnitude of the 3-phase fault current
Vpp   phase to phase voltage
Zz    pos.seq. impedance
err   error flag (0 = no errors)}
var
  apu,apv,apw : single;  {temporary}
  C3          : complex; {current, as complex}
  erV,erf,erc : integer; {error flags}
  fii         : single;  {phase of current, in degrees}
//I3          : single;  {fault current}
  ipu         : integer; {temporary}
  s1,s2,s3,s4 : string;  {temporary}
//Vpp         : single;  {phase phase voltage}
  txt         : string;
//Zz          : complex; {impedance}
begin
  txt := CurrentGrid.cells[1,Vrow];       {voltage}
  ValuesFromLine(txt, 1, false, ipu, Vpp , apu, apv, apw, s1,s2,s3,s4,erV); {in routines.pas}
  txt := CurrentGrid.cells[1,I3prow];     {short circuit current}
  ValuesFromLine(txt, 1, false, ipu, I3 , apu, apv, apw, s1,s2,s3,s4,erc);  {in routines.pas}
  txt := CurrentGrid.cells[1,f3prow];     {phase of current}
  ValuesFromLine(txt, 1, false, ipu, fii , apu, apv, apw, s1,s2,s3,s4,erf); {in routines.pas}
  {continue, if reasonable values}
  if (erv = 0) and (erf = 0) and (erc = 0) and (I3 > 0) then begin
    apu := fii*pi/180;                    {phase of current in rad}
    C3 := cplx(I3*cos(apu),I3*sin(apu));  {current as complex}
    Zz :=Cdiv(cplx(Vpp/sqrt3,0),C3);      {impedance = voltage/current}
    if (abs(Zz.x) < 0.001) then txt := '0'
    else RemoveSpaces(Zz.x,txt);
    OhmRectGrid.cells[1,R1row] := txt;    {resistance}
    OhmRectGrid.cells[1,R2row] := txt;    {neg.seq. resistance = pos.seq. resistance}
    if (abs(Zz.y) < 0.001) then txt := '0'
    else RemoveSpaces(Zz.y,txt);
    OhmRectGrid.cells[1,X1row] := txt;    {reactance}
    OhmRectGrid.cells[1,X2row] := txt;    {neg.seq. reactance = pos.seq. reactance}
    CurrentGrid.color := clWhite;
    err := 0;
  end else begin
    CurrentGrid.color := clYellow;
    err := 1;
  end;
end;

procedure TFeederForm.Z0fromI1;
{calculate zero sequence impedance from line-earth fault current}
{what if result = negative impedance ???}
var
  apu,apv,apw : single;  {temporary}
  cpu         : complex;
  C1          : complex; {current, as complex}
  erV,erf,erc : integer; {error flags}
  erR,erX     : integer; {error flags}
  erRg,erXg   : integer; {error flags}
  fii         : single;  {phase of current, in degrees}
  I1          : single;  {fault current}
  ipu         : integer; {temporary}
  s1,s2,s3,s4 : string;  {temporary}
  Vpp         : single;  {phase phase voltage}
  txt         : string;
  X0,R0       : single;  {zero seq. impedance}
  Zp,Zg       : complex; {pos.seq.,zero seq., earthing impedance}
  Zz          : complex; {impedance}
begin
  {voltage and current}
  txt := CurrentGrid.cells[1,Vrow];        {voltage}
  ValuesFromLine(txt, 1, false, ipu, Vpp , apu, apv, apw, s1,s2,s3,s4,erV); {in routines.pas}
  txt := CurrentGrid.cells[1,I1prow];      {short circuit current}
  ValuesFromLine(txt, 1, false, ipu, I1 , apu, apv, apw, s1,s2,s3,s4,erc);  {in routines.pas}
  txt := CurrentGrid.cells[1,f1prow];      {phase of current}
  ValuesFromLine(txt, 1, false, ipu, fii , apu, apv, apw, s1,s2,s3,s4,erf); {in routines.pas}
  {known impedances, from the "main" grid}
  txt := OhmRectGrid.cells[1,R1row];       {pos.seq. resistance, from the "main" grid}
  ValuesFromLine(txt, 1, false, ipu, Zp.x , apu, apv, apw, s1,s2,s3,s4,erR); {in routines.pas}
  txt := OhmRectGrid.cells[1,X1row];       {pos.seq. reactance}
  ValuesFromLine(txt, 1, false, ipu, Zp.y , apu, apv, apw, s1,s2,s3,s4,erX); {in routines.pas}
  txt := OhmRectGrid.cells[1,Rgrow];       {earthing resistance, from the "main" grid}
  ValuesFromLine(txt, 1, false, ipu, Zg.x , apu, apv, apw, s1,s2,s3,s4,erRg); {in routines.pas}
  txt := OhmRectGrid.cells[1,Xgrow];       {earthing reactance}
  ValuesFromLine(txt, 1, false, ipu, Zg.y , apu, apv, apw, s1,s2,s3,s4,erXg); {in routines.pas}
  {continue, if reasonable values}
  if (erV = 0) and (erc = 0) and (erf = 0) and
     (erR = 0) and (erX = 0) and (erRg = 0) and (erXg = 0) and (I1 > 0) then begin
    {total impedance}
    apu := fii*pi/180;                    {phase of current in rad}
    C1 := cplx(I1*cos(apu),I1*sin(apu));  {current as complex}
    Zz :=Cdiv(cplx(Vpp*sqrt3,0),C1);      {total impedance = voltage/current}
    {solve zero seq. impedance}
    R0 := Zz.x-(2*Zp.x+3*Zg.x);           {zero seq. resistance, when R1 = R2}
    X0 := Zz.y-(2*Zp.y+3*Zg.y);           {zero seq. reactance}
    {display in main grid}
    if (abs(R0) < 0.001) then txt := '0'
    else RemoveSpaces(R0,txt);
    OhmRectGrid.cells[1,R0row] := txt;
    if (abs(X0) < 0.001) then txt := '0'
    else RemoveSpaces(X0,txt);
    OhmRectGrid.cells[1,X0row] := txt;
  end else begin
    {warning color, if error in this grid}
    if (erV <> 0) or (erc <> 0) or (erf <> 0) then begin
      CurrentGrid.color := clYellow;
    end;
  end;
end;

procedure TFeederForm.UpdateS3(I3,Vpp: single);
{update and display the 3-phase short circuit power, when current and voltage given
 I3   the 3-ph. short circuit current
 Vpp  the phase-phase voltage}
var
  S3  : single;  {the three phase short circuit power}
  txt : string;  {temporary}
begin
  S3 := sqrt3*I3*Vpp;              {power}
  RemoveSpaces(S3,txt);            {format}
  PowerGrid.cells[1,P3row] := txt; {display}
end;

procedure TFeederForm.UpdateXpRp(Zp : complex);
{update and display the pos.seq. ratio Xp/Rp
 Zp   the pos.seq. impedance}
var
  txt : string;  {temporary}
  XpR : single;  {ratio Xp/Rp}
begin
  if (Zp.x > 0) then begin
    XpR := Zp.y/Zp.x;
    RemoveSpaces(XpR,txt);
  end else begin
    txt := '1.e6';
  end;
  PowerGrid.cells[1,XRprow] := txt;
end;

procedure TFeederForm.CurrentGridKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
{update other grids to correspond this one}
var
  er3,er1 : integer; {error flag}
  I3      : single;  {magnitude of the 3-phase fault current}
  Vpp     : single;  {phase to phase voltage}
  Zp      : complex; {pos.seq. impedance}
begin
  if (Curr_row = Vrow) or (Curr_row = Firow) then begin              {voltage or phase}
    OhmRectGrid.cells[1,Curr_row] := CurrentGrid.cells[1,Curr_row];  {copy as such}
    ZpFromI3(I3,Vpp,Zp,er3);                                         {must recalculate impedances, etc}
    if (er3 = 0) then begin
      UpdateS3(I3,Vpp);                                              {update power in power grid}
      UpdateXpRp(Zp);                                                {update Xp/Rp}
    end;
    Z0FromI1;
  end else if (Curr_row = I3prow) then begin                         {LLL fault current row}
    ZpFromI3(I3,Vpp,Zp,er3);                                         {impedance from current}
    if (er3 = 0) then begin
      UpdateS3(I3,Vpp);                                              {update power in power grid}
      UpdateXpRp(Zp);                                                {update Xp/Rp}
    end;
    Z0FromI1;                                                        {must recalculate Z0}
  end else if (Curr_row = F3prow) then begin                         {LLL fault current phase}
    ZpFromI3(I3,Vpp,Zp,er3);                                         {impedance from current}
    if (er3 = 0) then UpdateXpRp(Zp);                                {update Xp/Rp}
    Z0FromI1;                                                        {must recalculate Z0}
  end else if (Curr_row = I1prow) then begin                         {Lg fault current row}
    Z0FromI1;
  end else if (Curr_row = F1prow) then begin                         {Lg fault current phase row}
    Z0FromI1;
  end else if (Curr_row = RgProw) then begin                         {earthing resistance row}
    OhmRectGrid.cells[1,Rgrow] := CurrentGrid.cells[1,RgProw];       {copy as such}
    Z0FromI1;                                                        {must recalculate Z0}
  end else if (Curr_row = XgProw) then begin                         {earthing reactance row}
    OhmRectGrid.cells[1,Xgrow] := CurrentGrid.cells[1,XgProw];       {copy as such}
    Z0FromI1;                                                        {must recalculate Z0}
  end else begin

  end;

end;

procedure TFeederForm.CurrentGridSelectCell(Sender: TObject; Col,
  Row: Longint; var CanSelect: Boolean);
begin
  Curr_row := row;
end;

procedure TFeederForm.SheetInUse;
{check/uncheck, set grids enabled/not enabled, according which seet is set in use }
var
  ohm : boolean;   {true, when OhmSheet active}
  pwr : boolean;   {true, when PowerSheet active}
  rat : boolean;   {true, when RatioSheet active}
begin
  {first, set flags for the status of the sheets}
  if (ParamPages.ActivePage = OhmSheet) then begin
    ohm := true;
    pwr := false;
    rat := false;
  end else if (ParamPages.ActivePage = PowerSheet) then begin
    ohm := false;
    pwr := true;
    rat := false;
  end else begin
    ohm := false;
    pwr := false;
    rat := true;
  end;
  {state of the check boxes, according to the status of the sheets}
  OhmCheckBox.checked := ohm;
  if (ohm) then OhmCheckBox.state := cbChecked
  else OhmCheckBox.state := cbUnchecked;
  PowerCheckBox.checked := pwr;
  if (pwr) then PowerCheckBox.state := cbChecked
  else PowerCheckBox.state := cbUnchecked;
  RatioCheckBox.checked := rat;
  if (rat) then RatioCheckBox.state := cbChecked
  else RatioCheckBox.state := cbUnchecked;
  {grids enabled or not}
  OhmRectGrid.enabled := ohm;
  OhmPolarGrid.enabled := ohm;
  PuRectGrid.enabled := ohm;
  PuPolarGrid.enabled := ohm;
  CurrentGrid.enabled := pwr;
  PowerGrid.enabled := pwr;
end;



procedure TFeederForm.OhmCheckBoxMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  SheetInUse;
end;

procedure TFeederForm.PowerCheckBoxMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  err   : integer;   {error flag}
  I3    : single;    {magnitude of the 3-p fault current}
  Vpp   : single;    {phase phase voltage}
  Zp    : complex;   {pos.seq. impedance}
begin
  SheetInUse;
  {the parameters of the power sheet define the impedances}
  ZpFromI3(I3,Vpp,Zp,err);
  Z0FromI1;
  {voltage and earthing impedance are (must be) the same on both sheets}
end;

procedure TFeederForm.RatioCheckBoxMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  SheetInUse;
end;

end.
