unit Find;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, Grids, Locate, Buttons;

type
  TFindForm = class(TForm)
    ImagePanel: TPanel;
    LocateImage: TImage;
    LocateGrid: TStringGrid;
    FilterBut: TSpeedButton;
    CopyBut: TSpeedButton;
    UndoBut: TSpeedButton;
    Amp1But: TSpeedButton;
    Amp2But: TSpeedButton;
    Amp3But: TSpeedButton;
    Amp4But: TSpeedButton;
    procedure FormCreate(Sender: TObject);
    procedure LocateGridSelectCell(Sender: TObject; Col, Row: Longint;
      var CanSelect: Boolean);
    procedure FormHide(Sender: TObject);
    procedure FilterButClick(Sender: TObject);
    procedure CopyButClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure UndoButClick(Sender: TObject);
    procedure LocateGridKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure LocateGridMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Amp2ButClick(Sender: TObject);
    procedure Amp3ButClick(Sender: TObject);
    procedure Amp4ButClick(Sender: TObject);
    procedure Amp1ButClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    select_l : boolean;  {a cell has been selected}
  end;

var
  FindForm: TFindForm;

implementation

uses Imagopas, Search;

{$R *.DFM}

procedure TFindForm.FormCreate(Sender: TObject);
var
  ll : longint;  {temporary}
begin
  FindForm.tag := longint(@LocateGrid); {pointer to the grid is saved in tag}
  ll := longint(@LocateImage);
  FindForm.hint := inttostr(ll);        {pointer to image is saved to hint !?}
  {pack also the pointers to the amp.buttons to the hint}
  {pointers unpacked in LocateComp of Skemadef.pas}
  ll := longint(@Amp1But);
  FindForm.hint := FindForm.hint+';'+inttostr(ll);
  ll := longint(@Amp2But);
  FindForm.hint := FindForm.hint+';'+inttostr(ll);
  ll := longint(@Amp3But);
  FindForm.hint := FindForm.hint+';'+inttostr(ll);
  ll := longint(@Amp4But);
  FindForm.hint := FindForm.hint+';'+inttostr(ll);
  select_l := false;
  {add flag that form created}
  Imagoo.ReadyEdit.text := Imagoo.ReadyEdit.text+'L';
end;

procedure TFindForm.LocateGridSelectCell(Sender: TObject; Col,
  Row: Longint; var CanSelect: Boolean);
begin
  SelectCell(@LocateGrid,Col,Row);
end;

procedure TFindForm.FormHide(Sender: TObject);
var
  wb : integer;
begin
  if (not appl_close) then begin
    {as if clicking the magnifying glass in the component menu in the main form..}
    {.. but only if in "locating"-mode, and the Locate-form is not visible}
    if (SetComp.Loc_Comp) then begin
      if (LocateForm.visible = false) then begin
        wb := SetComp.pBackgr^.width;
        SetComp.pBackgr^.Mouse_Down(FindForm,mbLeft,[],wb-45,1);
      end;
    {if listing open breakers, then as if clicking the BreakerBut in the main form}
    end else if (imagoo.BreakerBut.down) then begin
      if (LocateForm.visible = false) and (SearchForm.visible = false) then begin
        imagoo.BreakerBut.down := false;
      end;
    end;
    select_l := false;
    FindForm.CopyBut.enabled := false;
{   UndoBut.enabled := false;}
  end;
end;

procedure TFindForm.FilterButClick(Sender: TObject);
begin
  SelectFiltered(@LocateGrid,0,' ');   {in locate.pas}
end;

procedure TFindForm.CopyButClick(Sender: TObject);
begin
  LocateForm.CopyButClick(Sender);
  select_l := false;
  CopyBut.enabled := false;    {false, until a new component has been selected}
  UndoBut.enabled := true;     {undo of copy enabled}
end;

procedure TFindForm.FormActivate(Sender: TObject);
begin
  CopyBut.visible := SetComp.to_copy;
  UndoBut.visible := SetComp.to_copy;
end;

procedure TFindForm.UndoButClick(Sender: TObject);
begin
  LocateForm.UndoButClick(Sender);
end;

procedure TFindForm.LocateGridKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (not appl_close) then begin
    select_l := true;
    {allow copying only if cells selected in both grids}
    if (LocateForm.select_l) then FindForm.CopyBut.enabled := true;
  end;
end;

procedure TFindForm.LocateGridMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if (not appl_close) then begin
    select_l := true;
    {allow copying only if cells selected in both grids}
    if (LocateForm.select_l) then FindForm.CopyBut.enabled := true;
  end;
end;

procedure TFindForm.Amp1ButClick(Sender: TObject);
begin
  SelectFiltered(@LocateGrid,1,' ');
end;

procedure TFindForm.Amp2ButClick(Sender: TObject);
begin
  SelectFiltered(@LocateGrid,2,' ');
end;

procedure TFindForm.Amp3ButClick(Sender: TObject);
begin
  SelectFiltered(@LocateGrid,3,' ');
end;

procedure TFindForm.Amp4ButClick(Sender: TObject);
begin
  SelectFiltered(@LocateGrid,4,' ');
end;



end.
