unit LoadMultip;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Routines, Imagopas, Skemadef, Imagodef, Skemproc, Buttons;

type
  TLoadForm = class(TForm)
    LoadLabel: TLabel;
    ScalingEdit: TEdit;
    OKBut: TButton;
    CancelBut: TButton;
    Label1: TLabel;
    Scen0But: TSpeedButton;
    ScenABut: TSpeedButton;
    ScenBBut: TSpeedButton;
    ScenCBut: TSpeedButton;
    Scen0Edit: TEdit;
    ScenAEdit: TEdit;
    ScenBEdit: TEdit;
    ScenCEdit: TEdit;
    procedure OKButClick(Sender: TObject);
    procedure CancelButClick(Sender: TObject);
    procedure Scen0ButClick(Sender: TObject);
    procedure ScenAButClick(Sender: TObject);
    procedure ScenBButClick(Sender: TObject);
    procedure ScenCButClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ScalingEditChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

procedure ShowScenarioAndScalingFactors;
  
var
  LoadForm: TLoadForm;

implementation

uses scenarios;

{$R *.DFM}

const
  ScenInUse : integer = 0;

procedure ShowScenarioAndScalingFactors;
{show the scenario and scaling factors at the load component}
var
  err,erc : integer;  {error flag}
  jcomp   : integer;  {counts components}
  name    : string;   {name = type of the component}
  pComp   : TpComp;   {pointer to components}
begin
  {update displayed values at loads}
  pComp := nil;                                {initialize pointer to comp.}
  erc := 0;
  jcomp := 0;
  while (erc = 0) do begin                     {scan all components}
    SetComp.NextComp(pComp, erc,jcomp,false);  {pointer to next component}
    if (erc = 0) then begin                    {no errors, else no more components}
      pComp^.GetName(name);                    {name = type of the component}
      if (name = gLoadOr) or (name = gLoad) then begin   {some type of load}
//      ShowScalingFactor(pComp);              {show the multipliers, in Skemproc.pas}
        LoadOrSource(longint(pComp));          {show multipliers, scenario, change symbol, if..}
        {}                                     {in skemproc.pas}
      end;
    end;
  end;
end;

procedure TLoadForm.OKButClick(Sender: TObject);
{read the multiplier from the edit, save}
var
  err     : integer;  {error flag}
  kend    : integer;  {first non read char}
  st1     : string;   {temporary}
  val     : single;   {value of the multiplier}
begin
  NextValueFromLine(ScalingEdit.text, 1, kend,val, st1, err);  {in routines.pas}
  if (err = 0) then begin
    SetComp.Load_mult := val;
    LoadForm.visible := false;
    {update displayed values at loads}
    ShowScenarioAndScalingFactors;           {in this unit}
    {save descriptions for scenarios}
    SetComp.Scen_desc[0] := Scen0Edit.text;
    SetComp.Scen_desc[1] := ScenAEdit.text;
    SetComp.Scen_desc[2] := ScenBEdit.text;
    SetComp.Scen_desc[3] := ScenCEdit.text;
    ScalingEdit.color := clWhite;
  end else begin
    ScalingEdit.color := clYellow;
  end;

end;

procedure TLoadForm.CancelButClick(Sender: TObject);
begin
  {return initial scenario}
  if      (ScenInUse = 1)  then begin
    ScenABut.down := true;
    SetComp.Load_Scen := 'A';             {return the original scenario}
  end else if (ScenInUse = 2)  then begin
    ScenBBut.down := true;
    SetComp.Load_Scen := 'B';
  end else if (ScenInUse = 3)  then begin
    ScenCBut.down := true;
    SetComp.Load_Scen := 'C';
  end else begin
    Scen0But.down := true;
    SetComp.Load_Scen := 'N';
  end;
  {hide form}
  ScalingEdit.color := clWhite;
  LoadForm.visible := false;
  ShowScenarioAndScalingFactors;           {in this unit}
  ScenarioForm.ShowScenario;
end;

procedure TLoadForm.Scen0ButClick(Sender: TObject);
begin
  SetComp.Load_Scen := 'N';
  ShowScenarioAndScalingFactors;     {in this unit}
  ScenarioForm.ShowScenario;
end;

procedure TLoadForm.ScenAButClick(Sender: TObject);
begin
  SetComp.Load_Scen := 'A';
  ShowScenarioAndScalingFactors;
  ScenarioForm.ShowScenario;
end;

procedure TLoadForm.ScenBButClick(Sender: TObject);
begin
  SetComp.Load_Scen := 'B';
  ShowScenarioAndScalingFactors;
  ScenarioForm.ShowScenario;
end;

procedure TLoadForm.ScenCButClick(Sender: TObject);
begin
  SetComp.Load_Scen := 'C';
  ShowScenarioAndScalingFactors;
  ScenarioForm.ShowScenario;
end;

procedure TLoadForm.FormShow(Sender: TObject);
{save status}
begin
  if (Scen0But.down)  then ScenInUse := 0
  else if (ScenABut.down)  then ScenInUse := 1
  else if (ScenBBut.down)  then ScenInUse := 2
  else if (ScenCBut.down)  then ScenInUse := 3
  else ScenInUse := 0;
  ScalingEdit.color := clWhite;
end;

procedure TLoadForm.ScalingEditChange(Sender: TObject);
{indicate errors}
var
  err     : integer;  {error flag}
  kend    : integer;  {first non read char}
  st1     : string;   {temporary}
  val     : single;   {value of the multiplier}
begin
  NextValueFromLine(ScalingEdit.text, 1, kend,val, st1, err);  {in routines.pas}
  if (err = 0) then ScalingEdit.color := clWhite
  else ScalingEdit.color := clYellow;
end;

procedure TLoadForm.FormCreate(Sender: TObject);
begin
  {add flag that form created}
  Imagoo.ReadyEdit.text := Imagoo.ReadyEdit.text+'L';
end;

end.
