unit Notes;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Menus, Printers;

type
  TNotesForm = class(TForm)
    NoteMemo: TMemo;
    SaveDlg: TSaveDialog;
    NotesMenu: TMainMenu;
    FileMenu: TMenuItem;
    SaveItem: TMenuItem;
    ExitItem: TMenuItem;
    PrintDlg: TPrintDialog;
    PrintItem: TMenuItem;
    LineItem: TMenuItem;
    procedure FormResize(Sender: TObject);
    procedure SaveItemClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ExitItemClick(Sender: TObject);
    procedure PrintItemClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  NotesForm: TNotesForm;

implementation

uses matrix;

{$R *.DFM}

procedure TNotesForm.FormResize(Sender: TObject);
begin
  NoteMemo.width := ClientWidth;
  NoteMemo.height := ClientHeight;
end;

procedure TNotesForm.SaveItemClick(Sender: TObject);
{save the text in the notes-memo}
var
  ii,kk    : integer;
  Outfile  : TextFile;     {file where written}
begin
  if (SaveDlg.execute) then begin
    AssignFile(Outfile, SaveDlg.filename);    {open the given file,BUT ERRORS ?}
    rewrite(outfile);
    try
      kk := NotesForm.NoteMemo.lines.count;
      if (kk > 0) then begin
        for ii := 0 to kk-1 do writeln(Outfile,NotesForm.NoteMemo.lines[ii]);
      end;
    finally
      CloseFile(Outfile);
      SaveDlg.InitialDir := ExtractFileDir(SaveDlg.FileName); {save directory}      
    end;    
  end;
end;

procedure TNotesForm.FormCreate(Sender: TObject);
begin
  SaveDlg.InitialDir := MatrForm.NotesInitialDir;
end;

procedure TNotesForm.ExitItemClick(Sender: TObject);
begin
  NotesForm.visible := false;
end;

procedure TNotesForm.PrintItemClick(Sender: TObject);
{print the note-memo}
var
  line      : integer;
  PrintText : TextFile;  {for printing the text}
begin
  if PrintDlg.Execute then begin
    AssignPrn(PrintText);      {assign PrintText to the printer}
    Rewrite(PrintText);	       {create and open the output file}
    {assign the current Font setting to the Printer object's canvas}
    Printer.Canvas.Font := NoteMemo.Font;
    {write the contents of the Memo field to the printer object}
    for line := 0 to NoteMemo.Lines.Count - 1 do
      Writeln(PrintText,NoteMemo.Lines[line]);
    System.Close(PrintText);
  end;
end;

end.
