unit labelshow;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, imagodef, ExtCtrls, skemadef, imagopas, utildef, routines,
  skemproc, ComCtrls;

type
  TLabelForm = class(TForm)
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    CheckBox7: TCheckBox;
    CheckBox8: TCheckBox;
    CheckBox9: TCheckBox;
    CheckBox10: TCheckBox;
    LabelImage: TImage;
    ApplyBut: TButton;
    OKBut: TButton;
    CancelBut: TButton;
    FilterBox: TCheckBox;
    CheckBox11: TCheckBox;
    CheckBox12: TCheckBox;
    CheckBox13: TCheckBox;
    CheckBox14: TCheckBox;
    CheckBox15: TCheckBox;
    CheckBox16: TCheckBox;
    CheckBox17: TCheckBox;
    CheckBox18: TCheckBox;
    CheckBox19: TCheckBox;
    CheckBox20: TCheckBox;
    CheckBox21: TCheckBox;
    CheckBox22: TCheckBox;
    CheckBox23: TCheckBox;
    CheckBox24: TCheckBox;
    CheckBox25: TCheckBox;
    CheckBox26: TCheckBox;
    CheckBox27: TCheckBox;
    CheckBox28: TCheckBox;
    CheckBox29: TCheckBox;
    CheckBox30: TCheckBox;
    CheckBox31: TCheckBox;
    CheckBox32: TCheckBox;
    CheckBox33: TCheckBox;
    CheckBox34: TCheckBox;
    CheckBox35: TCheckBox;
    SetBut: TButton;
    ClearBut: TButton;
    HintMemo: TMemo;
    HintBut: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ApplyButClick(Sender: TObject);
    procedure OKButClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure CancelButClick(Sender: TObject);
    procedure SetButClick(Sender: TObject);
    procedure ClearButClick(Sender: TObject);
    procedure HintButClick(Sender: TObject);
    procedure FormClick(Sender: TObject);
    procedure HintMemoMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
    BoxList : TList;     {pointers to the check boxes}
  public
    { Public declarations }
  end;

var
  LabelForm: TLabelForm;

implementation

{$R *.DFM}

procedure TLabelForm.FormCreate(Sender: TObject);
var
  capt : string;     {caption}
  errc : integer;    {error flag}
  ii   : integer;
  ll   : longint;    {termporary}
  name : string;     {name = type of the model component}
  pBox : TpCheckBox;
  pMod : TpElComp;   {pointer to a model component}
  tw   : integer;    {text width}
begin
  {set the captions}
  CheckBox1.caption := gCap;      {Capacitor           }
  CheckBox2.caption := gImped;    {Impedance           }
  CheckBox3.caption := gGrImped;  {Grounding Impedance }
  CheckBox4.caption := gIsolImp;  {Isolating impedance }
  CheckBox5.caption := gFeed;     {Feeder              }
  CheckBox6.caption := gTrafoYY;  {Transformator       }
  CheckBox7.caption := gTrafoYD;  {Transformator Y D   }
  CheckBox8.caption := gTrafoDY;  {Transformator D Y   }
  CheckBox9.caption := gTrafoDD;  {Transformator D D   }
  CheckBox10.caption := gTrafo3W; {Three-winding transformer}
  CheckBox11.caption := gBus;     {bus}
  CheckBox12.caption := gLoad;    {Load}
  CheckBox13.caption := gGen;     {Generator}
  CheckBox14.caption := gSmot;    {Synch.Motor}
  CheckBox15.caption := gASmot;   {Asynchronous Motor or Generator}
  CheckBox16.caption := gBrkr;    {Breaker                        }
  CheckBox17.caption := gTrliS;   {Transmission line/km           }
  CheckBox18.caption := gCurrT;   {Current Transformer            }
  CheckBox19.caption := gSpecCT;  {Summing Current Transformer    }
  CheckBox20.caption := gSumCT;   {Sum Current Transformer        }
  CheckBox21.caption := gRelay;   {relay                          }
  CheckBox22.caption := gRelay_inv;   {relay (normal inverse)      }
  CheckBox23.caption := gRelay_vinv;  {relay (very inverse)       }
  CheckBox24.caption := gRelay_einv;  {relay (extremely inverse)  }
  CheckBox25.caption := grelay_Ltinv; {relay (long time inverse) }
  CheckBox26.caption := gmeasZ;   {Mho distance relay             }
  CheckBox27.caption := gPolyg;   {Polygonal distance relay       }
  CheckBox28.caption := gPQrel;   {PGQ Overcurrent relay          }
  CheckBox29.caption := gEMRel;   {Electromechanical relay        }
  CheckBox30.caption := gRCRel;   {Recloser relay                 }
  CheckBox31.caption := gUDRel;   {User defined relay             }
  CheckBox32.caption := gText;    {Text                           }
  CheckBox33.caption := gVolt;    {Voltmeter                      }
  CheckBox34.caption := gSymbol;  {breaker-2                      }
  CheckBox35.caption := gUnsymm;  {Unsymmetrical load             }
  {create a list for pointers, for easier use}
  BoxList := TList.create;        {for the pointers}
  BoxList.add(@CheckBox1);
  BoxList.add(@CheckBox2);
  BoxList.add(@CheckBox3);
  BoxList.add(@CheckBox4);
  BoxList.add(@CheckBox5);
  BoxList.add(@CheckBox6);
  BoxList.add(@CheckBox7);
  BoxList.add(@CheckBox8);
  BoxList.add(@CheckBox9);
  BoxList.add(@CheckBox10);
  BoxList.add(@CheckBox11);
  BoxList.add(@CheckBox12);
  BoxList.add(@CheckBox13);
  BoxList.add(@CheckBox14);
  BoxList.add(@CheckBox15);
  BoxList.add(@CheckBox16);
  BoxList.add(@CheckBox17);
  BoxList.add(@CheckBox18);
  BoxList.add(@CheckBox19);
  BoxList.add(@CheckBox20);
  BoxList.add(@CheckBox21);
  BoxList.add(@CheckBox22);
  BoxList.add(@CheckBox23);
  BoxList.add(@CheckBox24);
  BoxList.add(@CheckBox25);
  BoxList.add(@CheckBox26);
  BoxList.add(@CheckBox27);
  BoxList.add(@CheckBox28);
  BoxList.add(@CheckBox29);
  BoxList.add(@CheckBox30);
  BoxList.add(@CheckBox31);
  BoxList.add(@CheckBox32);
  BoxList.add(@CheckBox33);
  BoxList.add(@CheckBox34);
  BoxList.add(@CheckBox35);
  {set the width of the check box texts}
  for ii := 0 to BoxList.count-1 do begin
    pBox := BoxList.items[ii];
    {use an image to determine the width of the text (!?)}
    LabelImage.canvas.font.name := pBox^.font.name;
    LabelImage.canvas.font.size := pBox^.font.size;
    tw := LabelImage.canvas.textwidth(pBox^.caption);
    pBox^.width := tw+20;
    {set checked = labels shown}
    pBox^.checked := true; {labels shown, as a default}
  end;
  {find the model components with the same name as the caption for each check box}
  for ii := 0 to BoxList.count-1 do begin
    pBox := BoxList.items[ii];
    {pointers to hint (!?),clear initially}
    pBox^.hint := '';
    capt := pBox^.caption;
    {find the model component}
    errc := 0;                     {initialize error flag}
    pMod := nil;                   {initialize pointer to model component}
    while (errc = 0) do begin      {scan all components, stop at first error (!?)}
      SetComp.NextElco(pMod,errc); {first error should indicate: no more components}
      if (errc = 0) then begin     {next component found}
        pMod^.GetComNam(name);     {name (type) of the component}
        if (name = capt) then begin
          ll := longint(pMod);
          pBox^.hint := pBox^.hint+inttostr(ll)+';'; {save pointers to hint}
        end;
      end;
    end;
//showmessage(pBox^.hint);

  end;
  {position of the hint}
  HintMemo.top := 16;
  HintMemo.visible := false;
  LabelForm.height := OKBut.top+OKBut.height+32;
  {add flag that form created}
  Imagoo.ReadyEdit.text := Imagoo.ReadyEdit.text+'l';
end;

procedure TLabelForm.FormDestroy(Sender: TObject);
begin
  BoxList.free;
end;

procedure TLabelForm.ApplyButClick(Sender: TObject);
{change the settings for the display of the labels, show/not the labels}
var
  ii,jj : integer;    {index}
  line  : string;
  ll    : longint;    {temporary}
  pBox  : TpCheckBox;
  pElco : TpElComp;   {pointer to the model components}
  txt   : string;     {temporary}
begin
  for ii := 0 to BoxList.count-1 do begin
    {pointers to the check boxes in a list}
    pBox := BoxList.items[ii];
    line := pBox^.hint;
    {pointers to the model components packed to the hint}
    for jj := 1 to 4 do begin             {at most 4 pointers}
      ExtractParam(jj,';',line,txt);      {separated by a ';'. In routines.pas}
      if (length(txt) > 4) then begin     {some data}
        ll := strtoint(txt);              {pointer as integer}
        pElco := TpElComp(ll);            {pointer to the model component}
        pElco^.PutShowLab(pBox^.checked); {shown, if checked}
      end;
    end;
  end;
  {update the state (shown/not) of the labels on the screen}
  ShowLabelOrNot(@SetComp, not(Imagoo.HideLabelBut.down));   {show the labels, or not}
end;

procedure TLabelForm.OKButClick(Sender: TObject);
begin
  ApplyBut.click;
  HintMemo.visible := false;
  LabelForm.visible := false;
end;

procedure TLabelForm.FormShow(Sender: TObject);
{save the "check"-status of the boxes, for an eventual "cancel"}
var
  ii   : integer;
  pBox : TpCheckBox;
begin
  for ii := 0 to BoxList.count-1 do begin
    pBox := BoxList.items[ii];              {pointer to a check box}
    if (pBox^.checked) then pBox^.tag := 1  {save status to tag}
    else pBox^.tag := 0;
  end;
  {save status of filter box}
  if (FilterBox.checked) then FilterBox.tag := 1
  else FilterBox.tag := 0;
end;

procedure TLabelForm.CancelButClick(Sender: TObject);
{restore the original "checked"-status of the boxes, saved in the tag}
var
  ii  : integer;
  pBox : TpCheckBox;
begin
  for ii := 0 to BoxList.count-1 do begin
    pBox := BoxList.items[ii];        {pointer to a check box}
    pBox^.checked := (pBox^.tag = 1); {status saved in tag}
  end;
  {restore status of filter box}
  FilterBox.checked := (FilterBox.tag = 1);
  OKButclick(sender);                {update the state of the labels}
end;

procedure TLabelForm.SetButClick(Sender: TObject);
{set all boxes "checked"}
var
  ii  : integer;
  pBox : TpCheckBox;
begin
  for ii := 0 to BoxList.count-1 do begin
    pBox := BoxList.items[ii];   {pointer to a check box}
    pBox^.checked := true;       {checked}
  end;
end;

procedure TLabelForm.ClearButClick(Sender: TObject);
{set all boxes "not checked"}
var
  ii  : integer;
  pBox : TpCheckBox;
begin
  for ii := 0 to BoxList.count-1 do begin
    pBox := BoxList.items[ii];   {pointer to a check box}
    pBox^.checked := false;      {not checked}
  end;
end;

procedure TLabelForm.HintButClick(Sender: TObject);
begin
  HintMemo.visible := not HintMemo.visible;
end;

procedure TLabelForm.FormClick(Sender: TObject);
begin
  HintMemo.visible := false;
end;

procedure TLabelForm.HintMemoMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if (x < 20) and (y < 16) then HintMemo.visible := false;
end;

end.
