{parameter groups should be copied for relays, or should they? 9.4.07}
unit locate;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids,skemadef, routines, ExtCtrls, utildef, Buttons, distance, polygon,
  PQRelay,userdef, Imagodef,diagram, parametr, CTParam, skemproc, StdCtrls,
  relcurr;

type
  TLocateForm = class(TForm)
    LocateGrid: TStringGrid;
    ImagePanel: TPanel;
    LocateImage: TImage;
    FilterBut: TSpeedButton;
    CopyBut: TSpeedButton;
    UndoBut: TSpeedButton;
    SaveBut: TSpeedButton;
    SaveDlg: TSaveDialog;
    Amp1But: TSpeedButton;
    Amp2But: TSpeedButton;
    Amp3But: TSpeedButton;
    Amp4But: TSpeedButton;
    AutoBut: TButton;
    ManBut: TButton;
    procedure FormCreate(Sender: TObject);
    procedure LocateGridSelectCell(Sender: TObject; Col, Row: Longint;
      var CanSelect: Boolean);
    procedure FormHide(Sender: TObject);
    procedure FilterButClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure CopyButClick(Sender: TObject);
    procedure UndoButClick(Sender: TObject);
    procedure LocateGridKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure LocateGridMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormDestroy(Sender: TObject);
    procedure SaveButClick(Sender: TObject);
    procedure Amp1ButClick(Sender: TObject);
    procedure Amp2ButClick(Sender: TObject);
    procedure Amp3ButClick(Sender: TObject);
    procedure Amp4ButClick(Sender: TObject);
    procedure LocateGridDrawCell(Sender: TObject; Col, Row: Longint;
      Rect: TRect; State: TGridDrawState);
    procedure AutoButClick(Sender: TObject);
    procedure ManButClick(Sender: TObject);

  private
    { Private declarations }
//    descrP1_l  : string;        {description for undo when copying parameters}
//    descrP2_l  : string;
//    descrP3_l  : string;
//    descrP4_l  : string;
//    descrG1_l  : string;        {description for undo when copying parameters}
//    descrG2_l  : string;
//    descrG3_l  : string;
//    descrG4_l  : string;
//    descrQ1_l  : string;        {description for undo when copying parameters}
//    descrQ2_l  : string;
//    descrQ3_l  : string;
//    descrQ4_l  : string;
    nPar_l     : integer;      {no of parameters, for undo}
    pDescr_l   : TpStringList; {pointer to descriptions, for undo}
    pPar_l     : pSingle;      {pointer to parmeters, for undo}
    Pref_l     : single;       {reference power, for undo}
//  strpar_l   : string;       {string-parameters, for undo}
    UndoList_l : TList;        {for saving some data for "undo"}
    Vref_l     : single;       {reference voltage, for undo}
    descrP1_l  : array[0..gParSet] of string;  {for descriptions, needed for "undo"}
    descrP2_l  : array[0..gParSet] of string;
    descrP3_l  : array[0..gParSet] of string;
    descrG1_l  : array[0..gParSet] of string;
    descrG2_l  : array[0..gParSet] of string;
    descrG3_l  : array[0..gParSet] of string;
    descrQ1_l  : array[0..gParSet] of string;
    descrQ2_l  : array[0..gParSet] of string;
    descrQ3_l  : array[0..gParSet] of string;
    descrP4_l  : array[0..gParSet] of string;
    descrG4_l  : array[0..gParSet] of string;
    descrQ4_l  : array[0..gParSet] of string;
    ParStr_l   : TParStr;      {for saving string param. for undo, defined in Utildef.pas}
    StrPar_l   : array[0..gParSet] of string; {all string parameters in one string}
  public
    { Public declarations }
    select_l : boolean;        {true, when a cell has been selected}
    pAmp1But : TpSpeedBut;     {pointer to ampacity button 1}
//    procedure GetpAmp(var pA1{,pA2,pA3,pA4}: TpSpeedBut);
    procedure CopyParamGroups(pFrComp, pToComp: TpComp);
    procedure UndoParamGroups(pToComp: TpComp);
    procedure GetDescriptions(ig: integer;var P1,P2,P3,P4,G1,G2,G3,G4,Q1,Q2,Q3,Q4: string);
    procedure PutDescriptions(ig: integer;P1,P2,P3,P4,G1,G2,G3,G4,Q1,Q2,Q3,Q4: string);
  end;

procedure PointOnForm(ix,iy: integer);
procedure SquareOnComp(pLComp: TpComp);
procedure SelectCell(pGrid: TpGrid; Col, Row: Longint);
procedure SelectFiltered(pGrid: TpGrid; Iamp: integer; AorM: char);
procedure SortGrid(pGrid: TpGrid);

var
  LocateForm: TLocateForm;

implementation

uses Imagopas, Find, Search;

{$R *.DFM}

//var
//  pDummyComp: TpComp;       {mey be needed in "cancel"}

procedure TLocateForm.FormCreate(Sender: TObject);
var
  ii : integer;
  ll : longint;  {temporary}
begin
  LocateForm.tag := longint(@LocateGrid); {pointer to the grid is saved in tag}
  ll := longint(@LocateImage);
  LocateForm.hint := inttostr(ll); {pointer to image is saved to hint !?}
  {pack also the pointers to the amp.buttons to the hint}
  {pointers unpacked in LocateComp of Skemadef.pas}
  ll := longint(@Amp1But);
  LocateForm.hint := LocateForm.hint+';'+inttostr(ll);
  ll := longint(@Amp2But);
  LocateForm.hint := LocateForm.hint+';'+inttostr(ll);
  ll := longint(@Amp3But);
  LocateForm.hint := LocateForm.hint+';'+inttostr(ll);
  ll := longint(@Amp4But);
  LocateForm.hint := LocateForm.hint+';'+inttostr(ll);
  {pack also the buttons for auto/manual mode of relays}
  ll := longint(@AutoBut);
  LocateForm.hint := LocateForm.hint+';'+inttostr(ll);
  ll := longint(@ManBut);
  LocateForm.hint := LocateForm.hint+';'+inttostr(ll);
  nPar_l := 0;        {initialize var. for undoing copying of parameters}
  pPar_l := nil;
  for ii := 0 to gParSet do strpar_l[ii] := '';
  select_l := false;
  new(pDescr_l);
  pDescr_l^ := TStringList.Create; {create list for additional descriptions, for undo}
//  pDummyComp := nil;
  UndoList_l := TList.create;
  {add flag that form created}
  Imagoo.ReadyEdit.text := Imagoo.ReadyEdit.text+'L';
end;

procedure PointOnForm(ix,iy: integer);
{put a small image in the given position on the form
 ix,iy  left and top coordinates}
begin
  imagoo.NodeImage.left := ix-(imagoo.NodeImage.width div 2);
  imagoo.NodeImage.top := iy-(imagoo.NodeImage.height div 2);
  imagoo.NodeImage.visible := true;
end;

procedure SquareOnComp(pLComp: TpComp);
{move the marking square on the given component
 pLComp  pointer to the component}
const
  dmin = 220;            {not moved, if distance smaller}
  dx    : integer = 0;   {approximate distance to be moved in x direction}
  dy    : integer = 0;   {approximate distance to be moved in y direction}
  ix    : integer = 0;   {distance to be moded, when snapped to grid}
  iy    : integer = 0;   {distance to be moded, when snapped to grid}
var
  cx,cy  : integer;       {coordinates of the center}
  dxy    : TPoint;        {ix,iy combined}
  errc   : integer;       {error flag}
  jcomp  : integer;       {counts components}
  ll     : longint;       {temporary}
  pComp  : TpComp;        {pointer to a component}
  pDiagr : TpDiagramForm;  {pointer to the zoomed-out diagram}
  pSet   : TpCompSet;     {pointer to the common}
begin
  pLComp^.GetipSet(ll);
  pSet := TpCompSet(ll);
  cx := imagoo.width div 2;                {coordinates of the center of the schema}
  cy := imagoo.height div 2;
  dx := pLComp.left-cx;                    {distance to center, in x-direction}
  dy := pLComp.top-cy;
//if (abs(dx) > dmin) or (abs(dy) > dmin) then begin  {no small movements}
  if (pLComp^.left < 30) or (pLComp^.left > imagoo.width-30) or     {almost outside}
     (pLComp^.top  < 50) or (pLComp^.top  > imagoo.height-30) or
    ((pLComp^.left > pSet^.pBackgr^.left-8) and                     {or behind the menu}
     (pLComp^.left < pSet^.pBackgr^.left+pSet^.pBackgr^.width+8) and
     (pLComp^.top  > pSet^.pBackgr^.top-8) and
     (pLComp^.top  < pSet^.pBackgr^.top+pSet^.pBackgr^.height+8)) then begin
    ix := NearestGrid(dx,false);             {snap to grid}
    iy := NearestGrid(dy,false);
    pComp := nil;
    errc := 0;
    jcomp := 0;
    while (errc = 0) do begin                    {scan all components}
      pSet^.NextComp(pComp, errc,jcomp,false); {pointer to next component}
      if (errc = 0) then begin                   {no errors, no more components}
        pComp^.IncrCoord(-ix,-iy);               {update coordinates, but no painting yet}
      end;
    end;
    {update also the marking-position in the zoomed diagram}
    pDiagr := TpDiagramForm(pSet^.ipDiagram);
    dxy.x := -ix;  {pack in one variable}
    dxy.y := -iy;
    ll := longint(@dxy);
    pDiagr^.MarkerPosition(MainArrow,ll);
    {save also for undo}
    pSet^.move_ddx := -ix;
    pSet^.move_ddy := -iy;
    pSet^.SaveForUndo(MoveAll);
  end;
  Imagoo.square.left := pLComp.left;  {put the marker on the located comp}
  Imagoo.square.top := pLComp.top;
  Imagoo.square.visible := true;
  Imagoo.square.BringToFront;
  imagoo.invalidate;                  {paint the form}
end;

procedure SelectCell(pGrid: TpGrid; Col, Row: Longint);
{move the diagram so that the selected component is in the center,
 unless it is already near enough
 pGrid    pointer to the grid
 Col,Row  column and row in the grid}
var
  ll     : longint;       {temporary}
  pLComp : TpComp;        {pointer to the component to be located}
begin
if (not appl_close) then begin
  if (pGrid^.focused) then begin  {the red square must not appear, when breaker opened or closed}
    if (pGrid^.Cells[0,row] <> '') then begin
      ll := strtoint(pGrid^.Cells[0,row]);     {pointer to component as integer}
      pLComp := TpComp(ll);                    {pointer to the component}
      SquareOnComp(pLComp);                    {move the marking square on the component}
    end;
  end;
end;
end;

procedure TLocateForm.LocateGridSelectCell(Sender: TObject; Col,
  Row: Longint; var CanSelect: Boolean);
{move the diagram so that the selected component is in the center,
 unless it is already near enough}
begin
  SelectCell(@LocateGrid,Col,Row);
end;

procedure TLocateForm.FormHide(Sender: TObject);
var
  wb : integer;
begin
  if (not appl_close) then begin
    {as if clicking the magnifying glass in the component menu in the main form..}
    {.. but only if in "locating"-mode, and the Find-form is not visible}
    if (SetComp.Loc_Comp) then begin
      if (FindForm.visible = false) then begin
        wb := SetComp.pBackgr^.width;
        SetComp.pBackgr^.Mouse_Down(LocateForm,mbLeft,[],wb-45,1);
      end;
    {if listing open breakers, then as if clicking the BreakerBut in the main form}
    end else if (imagoo.BreakerBut.down) then begin
      if (FindForm.visible = false) and (SearchForm.visible = false) then begin
        imagoo.BreakerBut.down := false;
      end;
    end;
  select_l := false;
  FindForm.CopyBut.enabled := false;
  end;
  {hide the ampacity buttons}
  Amp1But.visible := false;
  Amp2But.visible := false;
  Amp3But.visible := false;
  Amp4But.visible := false;
  AutoBut.visible := false;
  ManBut.visible := false;
end;

procedure SelectFiltered(pGrid: TpGrid; Iamp: integer; AorM: char);
{remove all other components from the list, except for those having the "filter"
character as the last character in the label, or:
If transmission line, use ampacity limits instead of the filter, if
ampacity flag (iamp) > 0, or:
If relay, select those in manual or auto mode with respect to pram.group change
pGrid  pointer to the grid
Iamp   ampacity flag
AorM   auto or manual mode, for relays}
var
  ifree   : integer;  {first free row}
  irow    : integer;  {index}
  len     : integer;  {length of string}
  nfilt   : integer;  {number of filtered}
  nrows   : integer;  {no of rows}
  pComp   : TpComp;   {pointer to the component}
  rMod    : char;     {relay mode}
  stay    : boolean;  {flag for keeping the element}
  txt,txx : string;   {temporary}
begin
  nrows := pGrid^.RowCount;             {number of rows to local}
  if (nrows > 0) then begin
    {search and remove the entriew without the filter character}
    nfilt := 0;                         {initialize}
    for irow := 0 to nrows-1 do begin
      txt := pGrid^.cells[1,irow];      {label}
      txx := pGrid^.cells[0,irow];      {pointer}
      if (txt <> '') and (txx <> '') then begin          {probably a component listed}
        pComp := TpComp(strtoint(pGrid^.cells[0,irow])); {pointer to the component}
        if (Iamp <= 0) then begin                        {check filter, or ..}
          if (AorM <> 'A') and (AorM <> 'M') then begin  {not relay mode}
            stay := pComp^.IsFiltered;
          end else begin                                 {relay mode}
            RelayInAutoOrManMode(longint(pComp), rMod);  {mode of this relay}
            stay := (AorM = rMod);                       {correct mode}
          end;
        end else begin                                   {check ampacity (tr.line assumed)}
          stay := (pComp^.pImg_s^.tag = Iamp);           {ampacity flag saved in tag}
        end;
      end else begin                    {no component}
        stay := false;
      end;
      {clear, if not filtered}
      if (not stay) then begin
        pGrid^.Cells[0,irow] := '';
        pGrid^.Cells[1,irow] := '';
      end else begin
        inc(nfilt);
      end;
    end;
    {compress = remove empty rows}
    if (nfilt > 0) then begin
      ifree := 0;
      for irow := 0 to nrows-1 do begin {check all rows}
        txt := pGrid^.Cells[1,irow];
        if (length(txt) > 0) then begin    {there is text on the row}
          if (ifree <> irow) then begin
            pGrid^.Cells[1,ifree] := txt;
            pGrid^.Cells[0,ifree] := pGrid^.Cells[0,irow];
            pGrid^.Cells[1,irow] := '';
            pGrid^.Cells[0,irow] := '';
          end;
          inc(ifree);
        end;
      end;
      {set the number of rows}
      if (nfilt < 5) then pGrid^.RowCount := 5
      else pGrid^.RowCount := nfilt;
    end else begin      {no filtered}
      pGrid^.RowCount := 5;
    end;
  end;
end;

procedure SortGrid(pGrid: TpGrid);
{sort the entries in the grid alphabetical order (according to label)
 It is assumed that the column 1 contains the labels, and column 0 the
 pointers as integers}
var
  cnt     : integer;     {number of entries in the grid}
  GList   : TStringList; {temporary, for sorting}
  ii,jj   : integer;     {index}
  ipu     : integer;     {temporary}
  kk      : integer;
  len     : integer;     {length of line (string)}
  line    : string;      {label+pointer}
  sp      : integer;     {position of (last) space = separator between label and pointer}
  txt,txx : string;      {temporary}
begin
  {if more than one entry. Index starts at 0}
  if (pGrid^.rowcount > 1) and (length(pGrid^.cells[1,1]) > 0) then begin
    GList := TStringList.create;   {create list for sorting}
    {copy entries to list from grid}
    for ii := 0 to pGrid^.rowcount-1 do begin
      if (length(pGrid^.cells[0,ii]) > 0) then begin   {check pointer}
        txt := pGrid^.cells[1,ii]+' '+pGrid^.cells[0,ii];  {the label+pointer}
        Glist.add(txt);
      end else begin               {no entry, stop copying}
        break;
      end;
    end;
    {sort, and copy back}
    GList.sort;
    if (GList.count > 0) then begin
      for ii := 0 to GList.count-1 do begin
        {separate label and pointer}
        line := GList[ii];
        len := length(line);
        if (len > 0) then begin      {should be}
          {find separation between label and pointer = first space from the end}
          ipu := 0;
          for kk := 1 to len do begin
            jj := len-kk+1;
            if (line[jj] = ' ') then break else inc(ipu);  {count to get length of pointer}
          end;
          sp := len-ipu;     {location of space separating label and pointer}
          {copy label and pointer to separate strings}
          txt := '';
          txx := '';
          for kk := 1 to len do begin
            if (kk < sp) then txt := txt+line[kk]        {label}
            else if (kk > sp) then txx := txx+line[kk];  {pointer}
          end;
          pGrid^.cells[0,ii] := txx;  {pointer}
          pGrid^.cells[1,ii] := txt;  {label}
        end;
      end;
    end;
    GList.free;                    {finally, free the list}
  end;
end;

{ - - - - - - - - - - - - }
procedure TLocateForm.FilterButClick(Sender: TObject);
begin
  SelectFiltered(@LocateGrid,0,' ');
end;

procedure TLocateForm.FormActivate(Sender: TObject);
begin
  SaveBut.visible := SetComp.to_find;
  {CopyBut.visible := SetComp.to_copy; moved to findForm}
end;

procedure TLocateForm.GetDescriptions(ig: integer;var P1,P2,P3,P4,G1,G2,G3,G4,Q1,Q2,Q3,Q4: string);
{Get all descriptions of group ig}
begin
  if (ig >= 0) and (ig <= gParSet) then begin
    P1 := descrP1_l[ig];
    P2 := descrP2_l[ig];
    P3 := descrP3_l[ig];
    P4 := descrP4_l[ig];
    G1 := descrG1_l[ig];
    G2 := descrG2_l[ig];
    G3 := descrG3_l[ig];
    G4 := descrG4_l[ig];
    Q1 := descrQ1_l[ig];
    Q2 := descrQ2_l[ig];
    Q3 := descrQ3_l[ig];
    Q4 := descrQ4_l[ig];
  end else begin
    P1 := '';P2 := '';P3 := '';P4 := '';
    G1 := '';G2 := '';G3 := '';G4 := '';
    Q1 := '';Q2 := '';Q3 := '';Q4 := '';
  end;
end;

procedure TLocateForm.PutDescriptions(ig: integer;P1,P2,P3,P4,G1,G2,G3,G4,Q1,Q2,Q3,Q4: string);
{Put descriptions 1,2,3,4 of group ig}
begin
  if (ig >= 0) and (ig <= gParSet) then begin
    descrP1_l[ig] := P1;
    descrP2_l[ig] := P2;
    descrP3_l[ig] := P3;
    descrP4_l[ig] := P4;
    descrG1_l[ig] := G1;
    descrG2_l[ig] := G2;
    descrG3_l[ig] := G3;
    descrG4_l[ig] := G4;
    descrQ1_l[ig] := Q1;
    descrQ2_l[ig] := Q2;
    descrQ3_l[ig] := Q3;
    descrQ4_l[ig] := Q4;
  end;
end;

procedure TLocateForm.UndoParamGroups(pToComp: TpComp);
{undo the copying of the parameter groups = return the old values
 pToComp  pointer to the component where copied to}
var
  ii,jj    : integer;    {index}
  kk       : integer;    {index}
  mpar     : integer;    {number of "proper" parameters}
  name     : string;     {name = type of the comp.}
  pToGrup  : TpList;     {pointer to list of pointers to parameter groups}
  pToPar   : pSingle;    {pointer to the parameters}
  p1,p2,p3,p4,g1,g2,g3,g4,q1,q2,q3,q4 : string;  {temporary}
begin
  pToComp^.GetpList(pToGrup);
  pToComp^.GetName(name);
  mpar := RelayMainParamCount1(longint(pToComp)); {number of main ("proper") parameters}
  kk := 0;
  for ii := 1 to gParSet do begin             {all parameter groups}
    pToPar := pToGrup^.items[ii-1];           {pointer to the first parameter}
    for jj := 1 to mpar do begin              {all parameters in a group}
      pToPar^:= single(UndoList_l.items[kk]); {decode the camouflaged data}
      inc(pToPar);                            {pointer to next}
      inc(kk);
    end;
    {also the descriptions, or texts, but not [0], done elsewhere}
    GetDescriptions(ii,p1,p2,p3,p4,g1,g2,g3,g4,q1,q2,q3,q4);
    pToComp^.PutDescriptions123(ii ,p1,p2,p3,   g1,g2,g3,   q1,q2,q3);
    pToComp^.PutDescriptions4(ii,p4,g4,q4);
  end;
  {for user defined relays also the curves}
  if (name = gUDrel) then begin
    for ii := 1 to gParSet do begin         {all parameter sets}
      for jj := 1 to gReCurv do begin       {all char.curves in the relay}
        pToComp^.pParStr_s^[ii][jj] := ParStr_l[ii][jj];
      end;
    end;
  end;
end;

procedure TLocateForm.CopyParamGroups(pFrComp, pToComp: TpComp);
{copy the parameter groups of combined overcurrent relays
 pFrComp  pointer to the "from" component
 pToComp  pointer to the "to" component}
var
  apu      : single;     {temporary}
  ii,jj    : integer;    {indices}
  mpar     : integer;    {number of proper parameters}
  name     : string;     {name (type) of the component}
  pFrGrup  : TpList;     {pointer to list of pointers to parameter groups}
  pFrPar   : pSingle;    {pointer to param.in param.groups}
  pToGrup  : TpList;     {pointer to list of pointers to parameter groups}
  pToPar   : pSingle;    {pointer to param.in param.groups}
  g1,g2,g3,g4 : string;  {temporary}
  p1,p2,p3,p4 : string;  {temporary}
  q1,q2,q3,q4 : string;    {temporary}
begin
  pFrComp^.GetName(name);                 {name = type of the component}
  pFrComp^.GetpList(pFrGrup);
  pToComp^.GetpList(pToGrup);
  mpar := RelayMainParamCount1(longint(pFrComp)); {number of main ("proper") parameters}
  UndoList_l.clear;                       {clear list for new parameters}
  for ii := 1 to gParSet do begin         {all parameter groups}
    pFrPar := pFrGrup^.items[ii-1];       {pointer to the first parameter}
    pToPar := pToGrup^.items[ii-1];       {pointer to the first parameter}
    for jj := 1 to mpar do begin          {all parameters in a group}
      apu := pToPar^;                     {save old value for "undo"}
      UndoList_l.add(pSingle(apu));       {camouflage and save as pointer}
      pToPar^:= pFrPar^;                  {copy parameters}
      inc(pToPar);                        {pointer to next}
      inc(pFrPar);
    end;
    {also the descriptions to the grid for texts }
    {First, save for "undo"}
    pToComp^.GetDescriptions(ii,p1,p2,p3,p4,g1,g2,g3,g4,q1,q2,q3,q4);
    PutDescriptions(ii,p1,p2,p3,p4,g1,g2,g3,g4,q1,q2,q3,q4);
    {then copy}
    pFrComp^.GetDescriptions(ii,p1,p2,p3,p4,g1,g2,g3,g4,q1,q2,q3,q4);
    pToComp^.PutDescriptions123(ii ,p1,p2,p3,   g1,g2,g3,   q1,q2,q3);
    pToComp^.PutDescriptions4(ii,p4,g4,q4);
  end;
  {for user defined relays also the curves}
  if (name = gUDrel) then begin
    for ii := 1 to gParSet do begin         {all parameter sets}
      for jj := 1 to gReCurv do begin       {all char.curves in the relay}
        ParStr_l[ii][jj] := pToComp^.pParStr_s^[ii][jj];  {save for undo}
        pToComp^.pParStr_s^[ii][jj] := pFrComp^.pParStr_s^[ii][jj];
      end;
    end;
  end;
end;

procedure TLocateForm.CopyButClick(Sender: TObject);
{copy parameters of the selected component on the LocateForm to
 the selected component on the FindForm}
var
  apu,apv  : single;   {temporary}
  cnt      : integer;  {number of lines}
  corrow   : boolean;  {correct rows}
  d1,d2,d3 : string;   {descriptions}
  dp,dg,dq : string;   {descriptions}
  g1,g2,g3,g4 : string;    {temporary}
  ii,jj    : integer;  {index}
  ipu      : integer;  {temporary}
  isRel    : boolean;  {true, if component is a combined relay}
  ll,kk    : longint;  {temporary}
  len      : integer;  {length of string}
  line     : string;   {temporary}
  name     : string;   {name (type) of the component}
  npar     : integer;  {number of parameters}
  pCT      : TpComp;   {pointer to a current trafo}
  pFrComp  : TpComp;   {pointer to the component from which copied}
  pFrList  : TpList;   {pointer to the List}
  pPar     : pSingle;  {pointer for parameters}
  pSet     : TpCompSet;{pointer to the common}
  pToComp  : TpComp;   {pointer to the component to which copied}
  pToList  : TpList;   {pointer to the List}
  p1,p2,p3,p4 : string;    {temporary}
  q1,q2,q3,q4 : string;    {temporary}
  rowFr    : integer;  {index of "from" row}
  rowTo    : integer;  {index of "to" row}
  strpar   : string;   {string parameters in one string}
  txt      : string;   {temporary}
  tComp    : array[1..2] of string;   {pointer to component as text of integer}
  numb     : array[1..2] of boolean;  {pointers as strings contain only numbers}
begin
  rowFr := LocateGrid.row;           {row of "from" grid}
  rowTo := FindForm.LocateGrid.row;  {row of "to" grid}
  {rows reasonable}
  corrow := (rowFr >= 0) and (rowFr < LocateGrid.RowCount) and
            (rowTo >= 0) and (rowTo < FindForm.LocateGrid.RowCount);
  {pointers in column 0, as string of longint}
  numb[1] := true;                  {initialize = "only numbers"}
  numb[2] := true;
  if (corrow) then begin
    tComp[1] := LocateGrid.Cells[0,rowFr];          {pointer to "from" component}
    tComp[2] := FindForm.LocateGrid.Cells[0,rowTo]; {pointer to "to" component}
    {check that both reasonable}
    for ii := 1 to 2 do begin
      txt := tComp[ii];               {copy to local}
      len := length(txt);
      if (len > 0) then begin
        {check that only numbers}
        for jj := 1 to len do begin
          if (txt[jj] < '0') or (txt[jj] > '9') then begin {not a number}
            numb[ii] := false;
            break;
          end;
        end;
      end else begin       {no string, no numbers, no pointer}
        numb[1] := false;
        numb[2] := false;  {to be sure, actually one is enough}
      end;
    end;
  end else begin        {not reasonable rows}
    numb[1] := false;
    numb[2] := false;
  end;
  {continue only if reasonably looking pointers}
  if (numb[1] and numb[2]) then begin
    ll := strtoint(tComp[1]);
    pFrComp := TpComp(ll);               {pointer to "from" component}
    ll := strtoint(tComp[2]);
    pToComp := TpComp(ll);               {pointer to "to" component}
    if (pFrComp <> nil) and (pToComp <> nil) then begin
      {pointer to the common, needed below}  {moved up...}
      pToComp^.GetipSet(ll);
      pSet := TpCompSet(ll);              {pointer to the common}
      pSet^.pTo_Comp := pToComp;          {save pointer to common}
      pToComp^.GetName(name);            {name (type) of the component}
      pFrComp^.GetNpar(npar);            {number of parameters}
      {combined overcurrent relay, needed below}
      isRel := (name = gPQrel) or (name = gEMrel) or (name = gRCrel) or (name = gUDrel);
      {first, clear the previous parameters, saved for "undo"}
      if (pPar_l <> nil) then begin
        freemem(pPar_l,nPar_l*sizeof(single));  {release memory from previous case}
        pPar_l := nil;
      end;
      if (npar > 0) then begin
        getmem(pPar_l,nPar*sizeof(single));  {get memory for saving for "undo"}
        pPar := pPar_l;
        nPar_l := npar;
        for ii := 1 to npar do begin
          pToComp^.GetPar(ii,apv);
          pPar^ := apv;              {save for undo}
          inc(pPar);
          pFrComp^.Getpar(ii,apu);   {copy..}
          pToComp^.PutPar(ii,apu);   {..and paste}
        end;
      end;
//      {copy string param. to dummy, for "undo", but for relays only}
//      if (isRel) or (name = gMeasZ) or (name = gPolyg) then begin
//        for ii := 0 to gParSet do begin
//          pToComp^.GetStringPar(strpar,ii);      {string parameters in one string}
//          pDummyComp^.PutStringPar(strpar,ii);   {copy to dummy for "undo"}
//        end;
//      end else begin
      {for others, copy to local}
      pToComp^.GetStringPar(strpar_l[0],0);    {save for undo}
      {after these preparations, copy string parameters}
      for ii := 0 to gParSet do begin
        pFrComp^.GetStringPar(strpar,ii);      {string parameters in one string}
        pToComp^.PutStringPar(strpar,ii);      {copy to "to" component}
      end;
      {reference voltage and power (if exist)}
      pToComp^.GetVPref(Vref_l,Pref_l);   {save for undo}
      pFrComp^.GetVPref(apu,apv);
      pToComp^.PutVPref(apu,apv);
      {copy descriptions etc., save for undo first}
      pToComp^.GetDescrP(descrP1_l[0],descrP2_l[0],descrP3_l[0]);
      pToComp^.GetDescrG(descrG1_l[0],descrG2_l[0],descrG3_l[0]);
      pToComp^.GetDescrQ(descrQ1_l[0],descrQ2_l[0],descrQ3_l[0]);
      pToComp^.GetDescr4(descrP4_l[0],descrG4_l[0],descrQ4_l[0]);
      pFrComp^.GetDescrP(dp,d2,d3);       {copy all, in all cases (even if empty, or...}
      pToComp^.PutDescrP(7,dp,d2,d3);     {..results from calculations ..(?)}
      pFrComp^.GetDescrG(dg,d2,d3);
      pToComp^.PutDescrG(7,dg,d2,d3);
      pFrComp^.GetDescrQ(dq,d2,d3);
      pToComp^.PutDescrQ(7,dq,d2,d3);
      pFrComp^.GetDescr4(d1,d2,d3);
      pToComp^.PutDescr4(7,d1,d2,d3);
      {notes etc, if exist}
      if (pFrComp^.pDescr <> nil) and (pToComp^.pDescr <> nil) then begin
        cnt := pToComp^.DescrCount;                   {no of rows}
        {save first, for undo}
        pDescr_l.Clear;
        if (cnt > 0) then begin                       {there is something}
          for ii := 0 to cnt-1 do begin               {index starts from 0}
            pDescr_l^.add(pToComp^.GetDescrLine(ii)); {copy lines for saving}
          end;
        end;
        {next, copy to component}
        cnt := pFrComp^.DescrCount;                  {no of rows}
        pToComp^.ClearDescr;
        if (cnt > 0) then begin                      {there is something}
          for ii := 0 to cnt-1 do begin              {index starts from 0}
            pToComp^.AddDescrLine(pFrComp^.GetDescrLine(ii)); {copy lines to component}
          end;
        end;
      end;
      {list of pointers, especially for the special(summing) current transformer}
      pFrComp^.GetpList(pFrList);
      pToComp^.GetpList(pToList);
      if (pFrList <> nil) and (pToList <> nil) then begin
        {if a special current trafo, the first entry must be saved, not copied to}
        if (name = gSpecCT) then begin
          pCT := pToList^.Items[0];
          ipu := 1;
        end else begin
          pCT := nil; {save temporarily}
          ipu := 0;
        end;
        {for combined relays, the list is not copied, but the contents}
        cnt := pFrList^.count;                    {number of entries in list}
        if (not isRel) then begin
          pToList^.clear;
          if (pCT <> nil) then pToList^.add(pCT); {return the first entry for a special CT}
          if (cnt > ipu) then begin               {there (other) are elements}
            for ii := ipu to cnt-1 do begin
              pToList^.add(pFrList^.items[ii]);   {copy the entries}
            end;
          end;
        end else begin                            {combined overcurrent relay}
          {copy parameter groups of combined overcurrent relays . . . . . . . . . . . .}
          CopyParamGroups(pFrComp, pToComp);
        end;
      end;
      {if tr.line, damage curve of to-comp not shown}
      if (name = gTrLiS) then pToComp^.PutPar(gTrLiS_InUse,0);
      {if parameters of the "to" component shown, update (!?)}
      if (pToComp = pSet^.pActComp) or
         (Dist.GetActRel = pToComp) or (Poly.GetActRel = pToComp) or
         (PQRelay.GetActPQ = pToComp) or (Userdef.GetpActComp = pToComp) then begin
        pToComp^.Mouse_Down(pToComp^,mbLeft,[],0,0);
        pToComp^.Mouse_Up  (pToComp^,mbLeft,[],0,0);
      end;
      {if graphs shown, update}
      if (RelayCharact.visible) then begin
        if (RelayCharact.GetpRelDraw = pToComp) then begin
          Relay_Show(pToComp,'real'); {in Skemproc.pas}
        end;
      end;
      {update picture of some components}
      if (name = gTrafo3W) then Trafo3Wpicture(longint(pToComp))
      else if (name = gCurrT) or (name = gSpecCT) then UpdateCTsymbol(pToComp, nil)
      else if (name = gText) then begin
        line := dp+';'+dg+';'+dq;
        TextToImage(pToComp^.pImg_s,line);
      end;
    end;
  end;
end;

procedure TLocateForm.UndoButClick(Sender: TObject);
{undo copying of parameters}
var
  cnt    : integer;   {no of rows}
  ii     : integer;   {index}
  line   : string;    {temporary}
  name   : string;    {name = type of the component}
  pPar   : pSingle;   {pointer to the parameters}
  strpar : string;    {string parameters in one string}
begin
  if (SetComp.pTo_Comp <> nil) {and (pPar_l <> nil)} {and (nPar_l > 0)} then begin
    SetComp.pTo_Comp^.GetName(name);     {name = type of the component}
    if (pPar_l <> nil) and (nPar_l > 0) then begin
      pPar := pPar_l;    {copy to local}
      for ii := 1 to nPar_l do begin
        SetComp.pTo_Comp^.PutPar(ii,pPar^);
        inc(pPar);
      end;
    end;
    {return also the string parameters (if any)}
    SetComp.pTo_Comp^.PutStringPar(strpar_l[0],0);
    {return reference values}
    SetComp.pTo_Comp^.PutVPref(Vref_l,Pref_l);
    {return the descriptions}
    SetComp.pTo_Comp^.PutDescrP(7,descrP1_l[0],descrP2_l[0],descrP3_l[0]);
    SetComp.pTo_Comp^.PutDescrG(7,descrG1_l[0],descrG2_l[0],descrG3_l[0]);
    SetComp.pTo_Comp^.PutDescrQ(7,descrQ1_l[0],descrQ2_l[0],descrQ3_l[0]);
    SetComp.pTo_Comp^.PutDescr4(7,descrP4_l[0],descrG4_l[0],descrQ4_l[0]);
    {return notes}
    if (SetComp.pTo_Comp^.pDescr <> nil) and (pDescr_l <> nil) then begin
      cnt := pDescr_l^.count;                      {no of rows}
      SetComp.pTo_Comp^.ClearDescr;
      if (cnt > 0) then begin                      {there is something}
        for ii := 0 to cnt-1 do begin              {index starts from 0}
          SetComp.pTo_Comp^.AddDescrLine(pDescr_l^[ii]);    {copy lines}
        end;
      end;
    end;
    {return parameter groups, if combined overcurrent relay}
    if (name = gPQrel) or (name = gEMrel) or (name = gRCrel) or (name = gUDrel) then
      UndoParamGroups(SetComp.pTo_Comp);
    {return string parameters}
    for ii := 0 to gParSet do begin
      SetComp.pTo_Comp^.PutStringPar(Strpar_l[ii],ii);   {copy to "to" component}
    end;
    {if parameters of the "to" component shown, update (!?)}
    if (SetComp.pTo_Comp = SetComp.pActComp) or
       (Dist.GetActRel = SetComp.pTo_Comp) or (Poly.GetActRel = SetComp.pTo_Comp) or
       (PQRelay.GetActPQ = SetComp.pTo_Comp) or (Userdef.GetpActComp = SetComp.pTo_Comp) then begin
      SetComp.pTo_Comp^.Mouse_Down(SetComp.pTo_Comp^,mbLeft,[],0,0);
      SetComp.pTo_Comp^.Mouse_Up  (SetComp.pTo_Comp^,mbLeft,[],0,0);
    end;
    {if graphs shown, update}
    if (RelayCharact.visible) then begin
      if (RelayCharact.GetpRelDraw = SetComp.pTo_Comp) then begin
        Relay_Show(SetComp.pTo_Comp,'real'); {in Skemproc.pas}
      end;
    end;
    {update picture of some components}
    if (name = gTrafo3W) then Trafo3Wpicture(longint(SetComp.pTo_Comp))
    else if (name = gCurrT) or (name = gSpecCT) then UpdateCTsymbol(SetComp.pTo_Comp, nil)
    else if (name = gText) then begin
      line := descrP1_l[0]+';'+descrG1_l[0]+';'+descrQ1_l[0];
      TextToImage(SetComp.pTo_Comp^.pImg_s,line);
    end;
  end;
end;

procedure TLocateForm.LocateGridKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (not appl_close) then begin
    select_l := true;
    {allow copying only if cells selected in both grids}
    if (FindForm.select_l) then FindForm.CopyBut.enabled := true;
  end;
end;

procedure TLocateForm.LocateGridMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if (not appl_close) then begin
    select_l := true;
    {allow copying only if cells selected in both grids}
    if (FindForm.select_l) then FindForm.CopyBut.enabled := true;
  end;
end;

procedure TLocateForm.FormDestroy(Sender: TObject);
var
  ll   : longint;
  pSet : TpCompSet;
begin
  if (pDescr_l <> nil) then begin
    pDescr_l^.free;
    dispose(pDescr_l);
    pDescr_l := nil;
  end;
  if (pPar_l <> nil) then begin
    freemem(pPar_l,nPar_l*sizeof(single));  {release memory from previous case}
    pPar_l := nil;
  end;
  UndoList_l.free;
//  if (pDummyComp <>nil) then begin
//    pDummyComp^.GetipSet(ll);
//    pSet := TpCompSet(ll);
//    pSet^.ReallyDeleteComp(pDummyComp);
//  end;
end;

procedure TLocateForm.SaveButClick(Sender: TObject);
{write the listed components on BOTH lists to file}
var
  ii        : integer;      {index}
  ll        : longint;      {temporary}
  lst       : integer;      {index}
  Outfile   : TextFile;     {file where written}
  pComp     : TpComp;       {pointer to a component}
  pForm     : TpForm;       {pointer to the form with the grids}
  pGrid     : TpGrid;       {pointer to a grid with component labels}
  row       : integer;      {no of rows}
  row1,row2 : integer;      {number of rows in the grids}
  txt       : string;       {temporary}
begin
  {write entries to file}
  if (SaveDlg.execute) then begin
    AssignFile(Outfile, SaveDlg.filename);      {open the given file}
    rewrite(outfile);
    for lst := 1 to 2 do begin                  {both lists}
      {first, components on "this" list}
      if (lst = 1) then pGrid := @LocateGrid else pGrid := @FindForm.LocateGrid;
      if (lst = 1) then pForm := @LocateForm else pForm := @FindForm;
      row := pGrid^.RowCount;
      if (row > 0) then begin
        if (lst = 2) and (pForm^.visible) then writeln(outfile,'/components on the second list');
        for ii := 0 to row-1 do begin
          {write to file, if not empty}
          if (pGrid^.cells[1,ii] <> '') then begin
            {pointer in column 0, as longint}
            txt := pGrid^.cells[0,ii];
            if (txt <> '') and (txt[1] >= '0') and (txt[1] <= '9') then begin
              {seems to be a pointer}
              ll := strtoint(txt);
              if (ll <> 0) then begin
                pComp := TpComp(ll);                  {pointer to the component from integer}
                {add a slash '/' in front of a closed breaker}
                if (pComp^.hint = 'wire') or (pComp^.hint = gSymbol) then {closed breaker!}
                  txt := '/' else txt := '';
                Writeln(outfile,txt+pGrid^.Cells[1,ii]);
              end;
            end;
          end;
        end;
      end;
    end;
    CloseFile(Outfile);
  end
end;

procedure TLocateForm.Amp1ButClick(Sender: TObject);
begin
  SelectFiltered(@LocateGrid,1,' ');
end;

procedure TLocateForm.Amp2ButClick(Sender: TObject);
begin
  SelectFiltered(@LocateGrid,2,' ');
end;

procedure TLocateForm.Amp3ButClick(Sender: TObject);
begin
  SelectFiltered(@LocateGrid,3,' ');
end;

procedure TLocateForm.Amp4ButClick(Sender: TObject);
begin
  SelectFiltered(@LocateGrid,4,' ');
end;

procedure TLocateForm.LocateGridDrawCell(Sender: TObject; Col,
  Row: Longint; Rect: TRect; State: TGridDrawState);
begin
{  if (row = 1) and (col = 1) then showmessage('draw');}
end;

procedure TLocateForm.AutoButClick(Sender: TObject);
begin
  SelectFiltered(@LocateGrid, 0, 'A');
end;

procedure TLocateForm.ManButClick(Sender: TObject);
begin
  SelectFiltered(@LocateGrid, 0, 'M');
end;

end.
