unit Mutual;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, skemadef, routines, utildef, Grids, ExtCtrls ;

type
  TMutualDataForm = class(TForm)
    Mutual12Grid: TStringGrid;
    Mutual13Grid: TStringGrid;
    Mutual23Grid: TStringGrid;
    Mutual14Grid: TStringGrid;
    Mutual24Grid: TStringGrid;
    Mutual34Grid: TStringGrid;
    Mutual45Grid: TStringGrid;
    Mutual15Grid: TStringGrid;
    Mutual25Grid: TStringGrid;
    Mutual35Grid: TStringGrid;
    Mutual16Grid: TStringGrid;
    Mutual26Grid: TStringGrid;
    Mutual36Grid: TStringGrid;
    Mutual46Grid: TStringGrid;
    Mutual56Grid: TStringGrid;
    Mutual17Grid: TStringGrid;
    Mutual27Grid: TStringGrid;
    Mutual37Grid: TStringGrid;
    Mutual47Grid: TStringGrid;
    Mutual57Grid: TStringGrid;
    Mutual67Grid: TStringGrid;
    Mutual18Grid: TStringGrid;
    Mutual28Grid: TStringGrid;
    Mutual38Grid: TStringGrid;
    Mutual48Grid: TStringGrid;
    Mutual58Grid: TStringGrid;
    Mutual68Grid: TStringGrid;
    Mutual78Grid: TStringGrid;
    Mutual1Panel: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Mutual2Panel: TPanel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Mutual3Panel: TPanel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Mutual4Panel: TPanel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Mutual5Panel: TPanel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Mutual6Panel: TPanel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Mutual7Panel: TPanel;
    Label19: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    FromGroup: TRadioGroup;
    ToGroup: TRadioGroup;
    ShowBut: TButton;
    CopyBut: TButton;
    CancelBut: TButton;
    OKBut: TButton;
    procedure FormHide(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormActivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
//  procedure NumberEditKeyUp(Sender: TObject; var Key: Word;
//    Shift: TShiftState);
    procedure ShowButClick(Sender: TObject);
    procedure CopyButClick(Sender: TObject);
    procedure CancelButClick(Sender: TObject);
    procedure SetFormSize{(nlin: integer)};
    procedure SetNline(nlin: integer);
    procedure OKButClick(Sender: TObject);
  private
    { Private declarations }
    cancel : boolean;          {cancel-button clicked}
    nline  : integer;          {number of lines}
    pComp  : TpComp;           {pointer to the component}
    pSet   : TpCompSet;        {pointer to the common}
    pGrid  : array[1..(gMutuLine*(gMutuLine-1) div 2)] of TpGrid;  {pointers to param.grids}
    {the grids are numbered as
      1  2  4   7  11
         3  5   8   .
            6   9   .
               10   etc}
    pPanel : array[1..gMutuLine-1] of TpPanel;  {panels for labels }
  public
    { Public declarations }
    procedure ParametersToGrid(ipComp: longint);
  end;

var
  MutualDataForm: TMutualDataForm;

implementation
uses
  imagopas, skemproc, mutupar;
{$R *.DFM}

procedure TMutualDataForm.ParametersToGrid(ipComp: longint);
{read parameters from component, put to grid(s)
 ipComp  pointer to the component as integer}
const
  nmin = 2;            {min.number of lines}
  nmax = gMutualMax;   {max.number of lines}
var
  ii,jj   : integer; {indices}
  ip      : integer; {index of the parameter}
  ipu     : integer; {temporary}
  kk      : integer; {index}
  ll      : longint; {temporary}
  mm      : integer; {index}
  ngrids  : integer; {number of visible grids}
  par     : single;  {parameter}
  txt,txx : string;  {temporary}
begin
  pComp := TpComp(ipComp);
  pComp^.Getipset(ll);
  pSet := TpCompSet(ll);
  pComp^.GetPar(1,par);    {first parameter = number of tr.lines}
  ipu := round(par);
//  {number of lines must be between nmin and nmax}
//  if (ipu < nmin) then nline := nmin
//  else if (ipu <= nmax) then nline := ipu
//  else nline := nmax;
//  NumberEdit.text := inttostr(nline);  {display number of lines}
  {the "proper" parameters: length, resistance, reactance for each pair}
  kk := 0;                             {index for the line pair = for the grid}
  for ii := 0 to gMutuLine-2 do begin
    for jj := 0 to ii do begin
      inc(kk);
      for mm := 1 to 3 do begin          {three parameters}
        ip := (kk-1)*3+mm+1;             {index of the parameter (first param = no of lines)}
        pComp^.GetPar(ip,par);           {parameter from the component}
        txt := ManyChars(par,true);      {parameter to string, in routines.pas}
        txx := spaceless(txt);           {remove spaces}
        pGrid[kk]^.cells[0,mm] := txx;   {parameter to grid}
      end;
    end;
  end;
  {show data grids only for the given number of connected lines}
  SetFormSize{(nline)};
end;

procedure TMutualDataForm.SetFormSize{(nlin: integer)};
{show data grids only for the given number of connected lines
 and set the form size accordingly
 nline  number of mutually connected lines}
var
  ii     : integer; {inddx}
  ngrids : integer; {number of visible grids}
begin
  for ii := 1 to high(pGrid) do pGrid[ii]^.visible := false;  {hide initially}
  ngrids := nline*(nline-1) div 2;    {number of visible grids}
  for ii := 1 to ngrids do pGrid[ii]^.visible := true;
  {show label panels only for the given number of connected lines}
  for ii := 1 to high(pPanel) do pPanel[ii]^.visible := false;
  for ii := 1 to nline-1 do pPanel[ii]^.visible := true;
  {set size of form accordingly}
  width := pGrid[ngrids]^.left+pGrid[ngrids]^.width+32;
  if (nline = 2) then begin
    showBut.visible := false;
//    height := LinesLabel.top+LinesLabel.height+32;
  end else begin
    ShowBut.visible := true;
//    height := pGrid[ngrids]^.top+pGrid[ngrids]^.height+50;
  end;
  height := pGrid[ngrids]^.top+pGrid[ngrids]^.height+50;
end;

procedure TMutualDataForm.SetNline(nlin: integer);
begin
  nline := nlin;
end;

procedure TMutualDataForm.FormHide(Sender: TObject);
{copy parameters to the component, unmark, (etc)}
var
  apu   : single;
  ii,jj : integer;   {indices}
  ip    : integer; {index of the parameter}
  kk,mm : integer;   {indices}
  kstrt : integer;   {start studying of the parameters at character number kstrt of line}
  kend  : integer;   {last studied character}
  line  : string;    {the text line with the numbers (in)}
  par   : single;    {the numeric value (out)}
  str   : string;    {the parameter as text (out), as it is on the line}
  errc  : integer;   {error code (defined in chckfloat), = 0, if no errors}
//RePro : TCompProc; {procedure for operations after readings}
begin
  if (not appl_close) and (not cancel) then begin
//  line := NumberEdit.text;                              {number of lines as string}
//  kstrt := 1;
//  NextValueFromLine(line, kstrt, kend, par, str, errc); {convert to number}
//  if (errc = 0) then pComp^.putPar(1,par);              {save to component}
    {save the "proper" parameters: length, resistance, reactance for each pair}
    {...better/simpler in some other way...}
    kk := 0;                               {index for the line pair = for the grid}
    for ii := 0 to gMutuLine-2 do begin    {all parameters (even those not visible)!?}
      for jj := 0 to ii do begin
        inc(kk);
        for mm := 1 to 3 do begin          {three parameters}
          ip := (kk-1)*3+mm+1;             {index of the parameter (first param = no of lines)}
          line := pGrid[kk]^.cells[0,mm];  {parameter as text}
          kstrt := 1;
          NextValueFromLine(line, kstrt, kend, par, str, errc); {convert to number, in Routines.pas}
          if (errc = 0) then pComp^.PutPar(ip,par);  {save, if no errors (some Warning??)}
        end;
      end;
    end;
    unmark(longint(pSet));
    {some operation when parameters read}
//  pComp^.GetRePro(RePro);              {get the procedure}
//  RePro(longint(pComp));               {the operation after reading = set height :=}
  end;
  cancel := false;
  FromGroup.visible := false;
  ToGroup.visible := false;
  CopyBut.visible := false;
end;

procedure TMutualDataForm.FormDeactivate(Sender: TObject);
{hide the form, unless help visible or copying
 Parameters saved to component in FormHide}
var
  bpu : boolean;  {temporary}
begin
  if (not LineDataForm.visible) then begin     {line data can be displayed at the same time}
    {hide the form, but not when Hint-button clicked}
  { if (pHelp <> nil) then bpu := (not pHelp^.visible)
    else} bpu := true;
    if (bpu and (not pSet^.Copy_Click)) then   {not hide, when copying}
      MutualDataForm.visible := false;
  end;
end;

procedure TMutualDataForm.FormShow(Sender: TObject);
begin
  ActiveControl := nil;        {focus to main form, for the case of delete-key pressed}
//NumberEdit.color := clWhite; {may be yellow, if there was an error}
end;

procedure TMutualDataForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  {eventual "delete component" must be handled here, because form (?) has focus}
  {see more in FormShow of LineParam.pas}
  if (pComp <> nil) then begin
    if (pSet^.pActComp <> nil) then begin     {some component active}
      if (key = 46) then begin                {delete-key}
        pSet^.FormKeyDown(Key, Shift);        {delete the component}
      end;
    end;
  end;
end;

procedure TMutualDataForm.FormActivate(Sender: TObject);
begin
  ActiveControl := nil;    {delete-key must delete the component initially}
end;

procedure TMutualDataForm.FormCreate(Sender: TObject);
{pointers to grids for data
 Only half of the array needed}
var
  ii  : integer;
begin
  {initialize (useful?)}
  for ii := 1 to high(pGrid) do begin
    pGrid[ii] := nil;
  end;
  cancel := false;
  {pointers to gris into array}
  pGrid[ 1] := @Mutual12Grid;
  pGrid[ 2] := @Mutual13Grid;
  pGrid[ 3] := @Mutual23Grid;
  pGrid[ 4] := @Mutual14Grid;
  pGrid[ 5] := @Mutual24Grid;
  pGrid[ 6] := @Mutual34Grid;
  pGrid[ 7] := @Mutual15Grid;
  pGrid[ 8] := @Mutual25Grid;
  pGrid[ 9] := @Mutual35Grid;
  pGrid[10] := @Mutual45Grid;
  pGrid[11] := @Mutual16Grid;
  pGrid[12] := @Mutual26Grid;
  pGrid[13] := @Mutual36Grid;
  pGrid[14] := @Mutual46Grid;
  pGrid[15] := @Mutual56Grid;
  pGrid[16] := @Mutual17Grid;
  pGrid[17] := @Mutual27Grid;
  pGrid[18] := @Mutual37Grid;
  pGrid[19] := @Mutual47Grid;
  pGrid[20] := @Mutual57Grid;
  pGrid[21] := @Mutual67Grid;
  pGrid[22] := @Mutual18Grid;
  pGrid[23] := @Mutual28Grid;
  pGrid[24] := @Mutual38Grid;
  pGrid[25] := @Mutual48Grid;
  pGrid[26] := @Mutual58Grid;
  pGrid[27] := @Mutual68Grid;
  pGrid[28] := @Mutual78Grid;
  {captions}
  Mutual12Grid.cells[0,0] := ' 1 - 2 ';
  Mutual13Grid.cells[0,0] := ' 1 - 3 ';
  Mutual23Grid.cells[0,0] := ' 2 - 3 ';
  Mutual14Grid.cells[0,0] := ' 1 - 4 ';
  Mutual24Grid.cells[0,0] := ' 2 - 4 ';
  Mutual34Grid.cells[0,0] := ' 3 - 4 ';
  Mutual45Grid.cells[0,0] := ' 4 - 5 ';
  Mutual15Grid.cells[0,0] := ' 1 - 5 ';
  Mutual25Grid.cells[0,0] := ' 2 - 5 ';
  Mutual35Grid.cells[0,0] := ' 3 - 5 ';
  Mutual16Grid.cells[0,0] := ' 1 - 6 ';
  Mutual26Grid.cells[0,0] := ' 2 - 6 ';
  Mutual36Grid.cells[0,0] := ' 3 - 6 ';
  Mutual46Grid.cells[0,0] := ' 4 - 6 ';
  Mutual56Grid.cells[0,0] := ' 5 - 6 ';
  Mutual17Grid.cells[0,0] := ' 1 - 7 ';
  Mutual27Grid.cells[0,0] := ' 2 - 7 ';
  Mutual37Grid.cells[0,0] := ' 3 - 7 ';
  Mutual47Grid.cells[0,0] := ' 4 - 7 ';
  Mutual57Grid.cells[0,0] := ' 5 - 7 ';
  Mutual67Grid.cells[0,0] := ' 6 - 7 ';
  Mutual18Grid.cells[0,0] := ' 1 - 8 ';
  Mutual28Grid.cells[0,0] := ' 2 - 8 ';
  Mutual38Grid.cells[0,0] := ' 3 - 8 ';
  Mutual48Grid.cells[0,0] := ' 4 - 8 ';
  Mutual58Grid.cells[0,0] := ' 5 - 8 ';
  Mutual68Grid.cells[0,0] := ' 6 - 8 ';
  Mutual78Grid.cells[0,0] := ' 7 - 8 ';
  {pointers to panels into array}
  pPanel[1] := @Mutual1Panel;
  pPanel[2] := @Mutual2Panel;
  pPanel[3] := @Mutual3Panel;
  pPanel[4] := @Mutual4Panel;
  pPanel[5] := @Mutual5Panel;
  pPanel[6] := @Mutual6Panel;
  pPanel[7] := @Mutual7Panel;
  {add flag that form created}
  Imagoo.ReadyEdit.text := Imagoo.ReadyEdit.text+'M';  
end;
(*
procedure TMutualDataForm.NumberEditKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
{show the data grids (etc) only for the given number of connected lines}
{size changed also in FormHide}
var
  errc  : integer;   {error code (defined in chckfloat), = 0, if no errors}
  ipu   : integer;   {temporary}
  kstrt : integer;   {start studying of the parameters at character number kstrt of line}
  kend  : integer;   {last studied character}
  line  : string;    {the text line with the numbers (in)}
  par   : single;    {the numeric value (out)}
  str   : string;    {the parameter as text (out), as it is on the line}
begin
  line := NumberEdit.text;                              {number of lines as string}
  kstrt := 1;
  NextValueFromLine(line, kstrt, kend, par, str, errc); {convert to number}
  if (errc = 0) then begin                              {continue only if no errors}
    ipu := round(par);        {to integer}
    if (ipu < 2) then begin
      NumberEdit.color := clYellow;
    end else if (ipu <= gMutualMax) then begin            {= gMutuLine, in Utildef.pas}
      nline := ipu;
      SetFormSize{(nline)};
      pComp^.height := (nline-1)*32+8{2};       {set the size of the component}
      NumberEdit.color := clWhite;
    end else begin
      NumberEdit.color := clYellow;
    end;
  end else begin
    NumberEdit.color := clYellow;
  end;
end;
*)
procedure TMutualDataForm.ShowButClick(Sender: TObject);
begin
  FromGroup.visible := not FromGroup.visible;
  ToGroup.visible := FromGroup.visible;
  CopyBut.visible := FromGroup.visible;
end;

procedure TMutualDataForm.CopyButClick(Sender: TObject);
{copy parameters from selected "from"-table to selected "to"-table}
var
  iFra,iTo : integer; {indices}
  nGrids   : integer; {number of data grids visible}
begin
  if (FromGroup.itemindex <> ToGroup.itemindex) then begin
    iFra := FromGroup.itemindex+1;
    iTo := ToGroup.itemindex+1;
    pGrid[iTo]^.cells[0,1] := pGrid[iFra]^.cells[0,1];
    pGrid[iTo]^.cells[0,2] := pGrid[iFra]^.cells[0,2];
    pGrid[iTo]^.cells[0,3] := pGrid[iFra]^.cells[0,3];
    {select next to-group}
    nGrids := nline*(nline-1) div 2;       {number of data grids visible}
    if (ToGroup.itemindex < nGrids-1) then
      ToGroup.itemindex := ToGroup.itemindex+1;
  end;
end;

procedure TMutualDataForm.CancelButClick(Sender: TObject);
begin
  cancel := true;
  MutualDataForm.visible := false;
  unmark(longint(pSet));       {must do also here, else does not unmark?}
end;

procedure TMutualDataForm.OKButClick(Sender: TObject);
begin
  MutualDataForm.visible := false;
  unmark(longint(pSet));       {must do also here, else does not unmark?}
end;

end.
