unit parametr;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, skemadef, utildef, routines, StdCtrls, Imagopas, ExtCtrls, Imagodef,
  Buttons, nodes, Compdef, Elplex, TapChanger;

{type for telling from where (some) parameters are read}
type
  TFromWhere = (fromGrid,fromComp);

type
  TGridForm = class(TForm)
    ParamGrid: TStringGrid;
    OKBut: TButton;
    CancelBut: TButton;
    HintBut: TButton;
    TrafoPanel: TPanel;
    TrafoImage: TImage;
    TrafoYYY: TImage;
    TrafoYYD: TImage;
    TrafoYYYsw: TImage;
    TrafoYYDsw: TImage;
    TrafoYYYr: TImage;
    TrafoYYDr: TImage;
    TrafoYYYrs: TImage;
    TrafoYYDrs: TImage;
    TrafoYYYu: TImage;
    TrafoYYDu: TImage;
    TrafoYYYus: TImage;
    TrafoYYDus: TImage;
    TrafoYYYl: TImage;
    TrafoYYDl: TImage;
    TrafoYYYls: TImage;
    TrafoYYDls: TImage;
    PhasePanel: TPanel;
    PhaseImage: TImage;
    AVOBut: TSpeedButton;
    PUBut: TSpeedButton;
    ShowCurveBut: TSpeedButton;
    ImpedGrid: TStringGrid;
    AmpGrid: TStringGrid;
    AmpBut: TSpeedButton;
    AmpLabel: TLabel;
    CurveBut: TSpeedButton;
    ZperCentBut: TSpeedButton;
    CurveGrid: TStringGrid;
    ImpedPanel: TPanel;
    PhaseRadioBut: TRadioButton;
    R1RadioBut: TRadioButton;
    ZeroPanel: TPanel;
    R0RadioBut: TRadioButton;
    Phase0RadioBut: TRadioButton;
    RatioRadioBut: TRadioButton;
    ShowImpedPanel: TPanel;
    ZTLabel: TLabel;
    OhmZtLabel: TLabel;
    R1Label: TLabel;
    OhmR1Label: TLabel;
    X1Label: TLabel;
    OhmX1Label: TLabel;
    R0Label: TLabel;
    OhmR0Label: TLabel;
    X0Label: TLabel;
    OhmX0Label: TLabel;
    BasePanel: TPanel;
    BaseGrid: TStringGrid;
    BaseZLabel: TLabel;
    BaseOhmLabel: TLabel;
    AVORadioBut: TRadioButton;
    PURadioBut: TRadioButton;
    OhmRadioBut: TRadioButton;
    PerCentRadioBut: TRadioButton;
    AvopuBut: TSpeedButton;
    TLabel: TLabel;
    BaseZtLabel: TLabel;
    TrafoBaseGrid: TStringGrid;
    procedure FormCreate(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure OKButClick(Sender: TObject);
    procedure CancelButClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure HintButClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure TrafoImageMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ParamGridSelectCell(Sender: TObject; Col, Row: Longint;
      var CanSelect: Boolean);
    procedure ParamGridTopLeftChanged(Sender: TObject);
    procedure PhaseImageMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure AVOButClick(Sender: TObject);
    procedure PUButClick(Sender: TObject);
    procedure BaseGridKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure BaseGridSelectCell(Sender: TObject; Col, Row: Longint;
      var CanSelect: Boolean);
    procedure AmpButClick(Sender: TObject);
    procedure ZperCentButClick(Sender: TObject);
    procedure ParamGridKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ImpedGridKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ImpedGridSelectCell(Sender: TObject; Col, Row: Longint;
      var CanSelect: Boolean);
    procedure ImpedGridMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure AmpGridKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure AmpGridSelectCell(Sender: TObject; Col, Row: Longint;
      var CanSelect: Boolean);
    procedure ImpedGridDrawCell(Sender: TObject; Col, Row: Longint;
      Rect: TRect; State: TGridDrawState);
    procedure R1RadioButClick(Sender: TObject);
    procedure PhaseRadioButClick(Sender: TObject);
    procedure R0RadioButClick(Sender: TObject);
    procedure Phase0RadioButClick(Sender: TObject);
    procedure RatioRadioButClick(Sender: TObject);
    procedure GetRatio(XorR: char; var q01 : single; var er1: integer);
    procedure BaseGridEnter(Sender: TObject);
    procedure BaseGridExit(Sender: TObject);
    procedure AvopuButClick(Sender: TObject);
    procedure TrafoBaseGridKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure TrafoBaseGridSelectCell(Sender: TObject; Col, Row: Longint;
      var CanSelect: Boolean);
    procedure TrafoBaseGridEnter(Sender: TObject);
    procedure TrafoBaseGridExit(Sender: TObject);
  private
    { Private declarations }
    actcol   : integer;   {the active (selected) column}
    actrow   : integer;   {the active (selected) row}
    ampcol   : integer;   {the active (selected column in the ampacity grid}
    baserow  : integer;   {active row in the trafo base grid}
    F1rect   : TRect;     {rectangle around phase cell in imped.grid}
    F0rect   : TRect;     {rectangle around phase cell in imped.grid}
    improw   : integer;   {the active (selected) row in the impedance grid}
    r01rect  : TRect;     {rectangle around phase cell in imped.grid}
    R0rect   : TRect;     {rectangle around resist. cell in imped.grid}
    R1rect   : TRect;     {rectangle around phase cell in imped.grid}
    x01rect  : TRect;     {rectangle around phase cell in imped.grid}
    Z0col    : integer;   {the active (selected) column in the Z0-subgrid}
    Z0rect   : TRect;     {rectangle around resist. cell in imped.grid}
  public
    { Public declarations }
    procedure SetHeights;
    procedure SetWidths;
    procedure ChangeOfBase(row: integer);
    procedure VisibleAndHeight;
    procedure ShowBaseZ;
    procedure PUfromAVOpar;
    procedure PUfromAVO(par : single; ii : integer);
    procedure AVOfromPU(pupar : single; ii : integer; var pavo: single);
    procedure ShowTrafoBase;
    procedure ShowImpedancesInTrafoBase(RR,XX : single; Zrow,frow,Rrow: integer);
    procedure ImpedancesInTrafoBase(wherePar:TfromWhere;var R1,X1,R0,X0: single; var err : integer);
    procedure UpdateRandXinMainGrid(OneOrZero: char; Zz,Rr,Xx: single);
    procedure ShowAmpacity;
    procedure Adjust3WPanels;
    function  theVArow: integer;
    procedure UpdateResistance(Zz: single; OneOrZero: char; var Rr,fii : single; var er : integer);
    procedure UpdatePhase(Zz: single; OneOrZero: char; var Rr,fii: single; var er: integer);
    procedure ResistanceFromPhase(fii: single; OneOrZero: char; var Rr,Zz: single; var er : integer);
    procedure PhaseFromResistance(Rr : single; OneOrZero: char; var Zz: single; var er: integer);
    procedure GetTrafoBaseFromComp(var V1n,VAn,ZTr: single);
    procedure TrafoBaseChange(OneOrZero: char);
    function  EditingImpedRow(OneOrZero: char; par: single): boolean;
    procedure GetZ0(var Z0,R0,X0 : single; var ert : integer);
    procedure ZeroParFromPosPar(ZorR,XorR: char; z01, Z1,R1,X1: single; var Z0,R0,X0: single;
                            var er1,er2,er3: integer);
    procedure UpdateZeroPerOne(RorF: char; R1,X1: single; var er: integer);
    procedure getZRX(Zrow,Rrow: integer; var Zz,Rr,Xx: single; var er1,er2,er3: integer);
    procedure ShowInOhms(OneOrZero,XorR: char; txt: string);
  end;

var
  GridForm: TGridForm;

procedure TrafoParamShow(ipComp: longint); far; {show parameters of 3w-trafo}
procedure HideParameters(ipComp: longint); far; {hide the parameter form}
procedure Trafo3wStart  (ipComp: longint); far; {show default parameters of 3w-trafo}
procedure Trafo3wPicture(ipComp: longint); far; {select picture for the trafo}
procedure PutpCompToGrid(ipComp: longint);
procedure PutNparToGrid(np: integer);

implementation

{$R *.DFM}

const
  baseMVA     : single = 1;        {base power for pu}
  basekV      : single = 1;        {base voltage for pu}
  baseZ       : single = 1;        {base impedance}
  baseTrVA    : single = 1;        {base power for imped.in trafo base (VA)}
  baseTrV1    : single = 1;        {base voltage for imped.in trafo base (Volt)}
  baseTrZ     : single = 1;        {transformer base impedance}
  baserow     : integer = 0;
  CancelClick : boolean = false;   {cancel-button clicked}
  is2WTrafo   : boolean = false;   {true, when the component is two-winding trafo}
  is3WTrafo   : boolean = false;   {true, when the component is three-winding trafo}
  pHelp       : TpMemo = nil;      {pointer to the help-memo}
  DefRows = 20;                    {default number of rows}
  TypeRow = 11;                    {row for parameter defining the type of a 3w transformer}
  PhaseRow = 12;                   {row for parameter defining phase shift of 3w YYD-trafo}
  Rg3row = 20;                     {grounding resistance for winding 3}
  Xg3row = 21;                     {grounding reactance for winding 3}
  Zr13row = 23;                    {Z0/Z1 for windings 1-3}
  Zr23row = 24;                    {Z0/Z1 for windings 2-3}
  {rows for the 2-w trafo}
  DamagRow = 18;                   {row for "caption"}
  NameRow  = 22;                   {name of the damage curve}
  LightGray = $00E8E8E8;
  {rows in the impedance grid}
  V1row = 0;
  VArow = 1;
  Z1row = 0;
  R1row = 1;
  firow = 2;
  nurow = 3;  {not used}
  Z0row = 4;
  R0row = 5;
  f0row = 6;
  x01row = 7;
  r01row = 8;
//  ImpedCapt = 'Z (%) in trafo Base:';  {normal caption of the impedance label}
var
  nbas        : integer;  {number of "basic" parameters}
  npar        : integer;  {number of parameters}
  pComp       : TpComp;   {pointer to the component, value set in ..
                          {PutpCompToGrid for "general" components, and ...}
                          {.. in Trafo3wStart, TrafoParamShow for 3w-transformers}
  pGrid       : TpGrid;   {pointer to the grid with the parameters}
  pPhaseImage : TpImage;  {pointer to image for selecting the phase shift}
  pPhasePanel : TpPanel;  {pointer to the panel for selecting phase shift}
  pTrafoPanel : TpPanel;  {pointer  to the panel for selecting the trafo type}
  pTrafoImage : TpImage;  {pointer to the image for selecting the trafo type}

procedure PutpCompToGrid(ipComp: longint);
{called in TComp.Mouse_Down of skemadef.pas}
begin
  pComp := TpComp(ipComp);
end;

procedure PutNparToGrid(np: integer);
{called in TComp.Mouse_Down of skemadef.pas
 Mouse_down called also when component created!}
begin
  npar := np;
end;

procedure TrafoParamNames;
{write the names of the parameters in the grid}
begin
  {parameter names to the grid}
  pGrid^.Cells[0,1] := 'V1';
  pGrid^.Cells[0,2] := 'V2';
  pGrid^.Cells[0,3] := 'V3';
  pGrid^.Cells[0,4] := 'X12';
  pGrid^.Cells[0,5] := 'X13';
  pGrid^.Cells[0,6] := 'X23';
  pGrid^.Cells[0,7] := 'R1';
  pGrid^.Cells[0,8] := 'R2';
  pGrid^.Cells[0,9] := 'R3';
  pGrid^.Cells[0,10] := 'VA';
  pGrid^.Cells[0,11] := 'type';
  pGrid^.Cells[0,12] := 'phase shift';
  pGrid^.Cells[0,13] := 'Vs1';
  pGrid^.Cells[0,14] := 'Vs2';
  pGrid^.Cells[0,15] := 'Vs3';
  pGrid^.Cells[0,16] := 'Rg1';
  pGrid^.Cells[0,17] := 'Xg1';
  pGrid^.Cells[0,18] := 'Rg2';
  pGrid^.Cells[0,19] := 'Xg2';
  pGrid^.Cells[0,20] := 'Rg3';
  pGrid^.Cells[0,21] := 'Xg3';
  pGrid^.Cells[0,22] := 'Z0/Z1(1-2)';
  pGrid^.Cells[0,23] := 'Z0/Z1(1-3)';
  pGrid^.Cells[0,24] := 'Z0/Z1(2-3)';
  {put the image for the trafo type in place}
  pTrafoPanel^.left := pGrid^.DefaultColWidth+pGrid.GridLineWidth+1;
  pTrafoPanel^.top := pGrid^.top+(pGrid^.DefaultRowHeight+pGrid^.GridLineWidth)*TypeRow+1;
  pTrafoPanel^.visible := true;
  pTrafoPanel^.BringToFront;
  {put the image for the trafo phase shift}
  pPhasePanel^.left := pGrid^.DefaultColWidth+pGrid.GridLineWidth+1;
  pPhasePanel^.top := pGrid^.top+(pGrid^.DefaultRowHeight+pGrid^.GridLineWidth)*PhaseRow+1;
  pPhasePanel^.visible := true;
  pPhasePanel^.BringToFront;
end;

procedure DefaultTrafoParameters;
{write the default values of the parameters in the grid}
begin
  {parameter names to the grid}
  pGrid^.Cells[1,1] := '100';
  pGrid^.Cells[1,2] := '100';
  pGrid^.Cells[1,3] := '100';
  pGrid^.Cells[1,4] := '1';
  pGrid^.Cells[1,5] := '1';
  pGrid^.Cells[1,6] := '1';
  pGrid^.Cells[1,7] := '0.1';
  pGrid^.Cells[1,8] := '0.1';
  pGrid^.Cells[1,9] := '0.1';
  pGrid^.Cells[1,10] := '1000';
  pGrid^.Cells[1,11] := '1';
  pGrid^.Cells[1,12] := '0';
  pGrid^.Cells[1,13] := '100';
  pGrid^.Cells[1,14] := '100';
  pGrid^.Cells[1,15] := '100';
  pGrid^.Cells[1,16] := '1e6';
  pGrid^.Cells[1,17] := '1e6';
  pGrid^.Cells[1,18] := '1e6';
  pGrid^.Cells[1,19] := '1e6';
  pGrid^.Cells[1,10] := '1e6';
  pGrid^.Cells[1,21] := '1e6';
  pGrid^.Cells[1,22] := '1';
  pGrid^.Cells[1,23] := '1';
  pGrid^.Cells[1,24] := '1';
end;

function Is123Trafo(pComp: TpComp): boolean;
{true, when the nodes of the 3w trafo are 1,2,3 in counter-clockwise,
 that is, when the name is Trafo3w..., and not Trafo3c...
 pComp  pointer to the trafo}
var
  name : string;       {name of the model component}
  pMod : TpElComp;     {pointer to the model component}
begin
  pComp^.GetpMod(pMod);
  name := pMod^.name;
  Is123Trafo := (name[7] = 'w');
end;

function IsDownTrafo(pComp: TpComp): boolean;
{true, when a 3w trafo is a "down" trafo= node 1 topmost
 that is, when the name is Trafo3*_d_...
 pComp  pointer to the trafo}
var
  name : string;       {name of the model component}
  pMod : TpElComp;     {pointer to the model component}
begin
  pComp^.GetpMod(pMod);
  name := pMod^.name;
  IsDownTrafo := (name[9] = 'd');
end;

function IsRightTrafo(pComp: TpComp): boolean;
{true, when a 3w trafo is a "right" trafo= node 1 leftmost
 that is, when the name is Trafo3*_r_...
 pComp  pointer to the trafo}
var
  name : string;       {name of the model component}
  pMod : TpElComp;     {pointer to the model component}
begin
  pComp^.GetpMod(pMod);
  name := pMod^.name;
  IsRightTrafo := (name[9] = 'r');
end;

function IsUpTrafo(pComp: TpComp): boolean;
{true, when a 3w trafo is an "up" trafo= node 1 lowest
 that is, when the name is Trafo3*_u_...
 pComp  pointer to the trafo}
var
  name : string;       {name of the model component}
  pMod : TpElComp;     {pointer to the model component}
begin
  pComp^.GetpMod(pMod);
  name := pMod^.name;
  IsUpTrafo := (name[9] = 'u');
end;

function IsLeftTrafo(pComp: TpComp): boolean;
{true, when a 3w trafo is a "left" trafo= node 1 on the right
 that is, when the name is Trafo3*_l_...
 pComp  pointer to the trafo}
var
  name : string;       {name of the model component}
  pMod : TpElComp;     {pointer to the model component}
begin
  pComp^.GetpMod(pMod);
  name := pMod^.name;
  IsLeftTrafo := (name[9] = 'l');
end;

procedure WriteYYYorYYD(Toile: TCanvas; YorD: char);
{write YYY and YYD on the image for selecting the trafo type
 Use bold, colored font for the selected type, else gray, normal font
 canvas  the canvas on which written
 YorD    type: 'Y' or 'D', for the bold font}
begin
  Toile.Font.name := 'arial';
  Toile.font.size := 8;
  {first, write the YYY}
  if (YorD = 'Y') then begin
    Toile.Font.Style := [fsBold];
    Toile.font.Color := clBlue;
  end else begin
    Toile.Font.Style := [];
    Toile.font.Color := clGray;
  end;
  Toile.TextOut(2,0,'YYY');
  {next, write the YYD}
  if (YorD = 'Y') then begin
    Toile.Font.Style := [];
    Toile.font.Color := clGray;
  end else begin
    Toile.Font.Style := [fsBold];
    Toile.font.Color := clBlue;
  end;
  Toile.TextOut(pGrid^.DefaultColWidth div 2,0,'YYD');
end;

procedure WritePlusOrMinus30(Toile: TCanvas; PorM: char);
{write -30 and +30 on the image for selecting the trafo phase shift
 Use bold, colored font for the selected type, else gray, normal font
 canvas  the canvas on which written
 PorM    type: '+' or '-', for the bold font}
begin
  Toile.Font.name := 'arial';
  Toile.font.size := 8;
  {first, write the -30}
  if (PorM = '-') then begin
    Toile.Font.Style := [fsBold];
    Toile.font.Color := clBlue;
  end else begin
    Toile.Font.Style := [];
    Toile.font.Color := clGray;
  end;
  Toile.TextOut(2,0,'-30');
  {next, write the +30}
  if (PorM = '-') then begin
    Toile.Font.Style := [];
    Toile.font.Color := clGray;
  end else begin
    Toile.Font.Style := [fsBold];
    Toile.font.Color := clBlue;
  end;
  Toile.TextOut(pGrid^.DefaultColWidth div 2,0,'+30');
end;

procedure ShowOrNotPhaseShift;
{if YYY-trafo, hide and disable selection of phase
 else show and enable selection of phase}
begin
  {disable selection of phase shift, if YYY-trafo}
  if (pGrid^.cells[1,TypeRow] <> '2') then begin   {YYY-trafo}
    pPhaseImage^.picture := nil;
    pPhaseImage^.enabled := false;
  end else begin                                  {YYD-trafo}
    {show trafo phase shift}
    pPhaseImage^.picture := nil;
    if (pGrid^.cells[1,PhaseRow] = '0') then begin  {-30 deg.}
      WritePlusOrMinus30(pPhaseImage^.canvas,'-');
    end else begin                                  {+30 deg.}
      WritePlusOrMinus30(pPhaseImage^.canvas,'+');
    end;
    pPhaseImage^.enabled := true;
  end;
end;


procedure Trafo3wStart(ipComp: longint);
{show the default parameters, when the component is created}
var
  apu,apv : single;    {temporary}
  apw,apx : single;    {temporary}
  errc    : integer;   {error flag}
  ii      : integer;   {index}
  ipu     : integer;   {temporary}
  line    : string;    {temporary}
  ll      : longint;   {temporary}
  pSet    : TpCompSet; {pointer to the common}
  st1,st2 : string;    {temporary}
  st3,st4 : string;    {temporary}
begin
  GridForm.caption := '3-wind. trafo';
  pComp := TpComp(ipComp);            {pointer to the trafo}
  pComp^.GetipSet(ll);
  pSet := TpCompSet(ll);              {pointer to the common}
  pComp^.GetMemIntSing(13);           {memory for temporarily saving zero seq. impedances}
  {only when creating manually, not when undeleting}
  if (not pSet^.un_del) and (pSet^.create_comp) then begin
    pComp^.GetNpar(npar);             {number of parameters}
    pGrid^.RowCount := npar+1;
    TrafoParamNames;                  {parameter names to the grid}
    DefaultTrafoParameters;           {default values to the grid}
    {save the default parameters (so that "cancel" does not reset them}
    if (pGrid^.RowCount > npar) and (npar > 0) then begin
      for ii:=1 to npar do begin
        line := pGrid^.Cells[1,ii];
        ValuesFromLine(line,1,false,ipu, apu,apv,apw,apx,st1,st2,st3,st4,errc); {one parameter a time}
        if (errc <> 0) then begin
          pComp^.putpar(ii,1);        {error, save just some value}
        end else begin
          pComp^.putpar(ii,apu);      {save the parameter to the component}
        end;
      end;
      {show trafo type in the grid for the parameters}
      pTrafoImage^.picture := nil;
      if (pGrid^.cells[1,TypeRow] = '1') then begin  {YYY-transformer}
        WriteYYYorYYD(pTrafoImage^.canvas,'Y');
      end else begin                                 {YYD}
        WriteYYYorYYD(pTrafoImage^.canvas,'D');
      end;
      {show trafo phase shift in the grid for the parameters}
      ShowOrNotPhaseShift;

//      pPhaseImage^.picture := nil;
//      if (pGrid^.cells[1,PhaseRow] = '0') then begin  {-30 deg.}
//        WritePlusOrMinus30(pPhaseImage^.canvas,'-');
//      end else begin                                  {+30 deg.}
//        WritePlusOrMinus30(pTrafoImage^.canvas,'+');
//      end;
    end;
    GridForm.ParamGridTopLeftChanged(nil);  {TrafoImage on the right place}
    GridForm.visible := true;
  end;
end;

procedure YYDpicture(pTrafo: TpComp);
{get "normal" or "swapped" picture of a 3winding YYD trafo
 pTrafo   pointer to the trafo}
begin
  if (Is123Trafo(pTrafo)) then begin
    if (IsDownTrafo(pTrafo)) then
      pTrafo^.picture := GridForm.TrafoYYD.picture
    else if (IsRightTrafo(pTrafo)) then
      pTrafo^.picture := GridForm.TrafoYYDr.picture
    else if (IsUpTrafo(pTrafo)) then
      pTrafo^.picture := GridForm.TrafoYYDu.picture
    else if (IsLeftTrafo(pTrafo)) then
      pTrafo^.picture := GridForm.TrafoYYDl.picture;
  end else begin
    if (IsDownTrafo(pTrafo)) then
      pTrafo^.picture := GridForm.TrafoYYDsw.picture  {"swapped"}
    else if (IsRightTrafo(pTrafo)) then
      pTrafo^.picture := GridForm.TrafoYYDrs.picture
    else if (IsUpTrafo(pTrafo)) then
      pTrafo^.picture := GridForm.TrafoYYDus.picture
    else if (IsLeftTrafo(pTrafo)) then
      pTrafo^.picture := GridForm.TrafoYYDls.picture;
  end;
end;

procedure YYYpicture(pTrafo: TpComp);
{get "normal" or "swapped" picture of a 3winding YYY trafo
 pTrafo   pointer to the trafo}
begin
  if (Is123Trafo(pTrafo)) then begin
    if (IsDownTrafo(pTrafo)) then
      pTrafo^.picture := GridForm.TrafoYYY.picture
    else if (IsRightTrafo(pTrafo)) then
      pTrafo^.picture := GridForm.TrafoYYYr.picture
    else if (IsUpTrafo(pTrafo)) then
      pTrafo^.picture := GridForm.TrafoYYYu.picture
    else if (IsLeftTrafo(pTrafo)) then
      pTrafo^.picture := GridForm.TrafoYYYl.picture;
  end else begin
    if (IsDownTrafo(pTrafo)) then
      pTrafo^.picture := GridForm.TrafoYYYsw.picture  {"swapped"}
    else if (IsRightTrafo(pTrafo)) then
      pTrafo^.picture := GridForm.TrafoYYYrs.picture
    else if (IsUpTrafo(pTrafo)) then
      pTrafo^.picture := GridForm.TrafoYYYus.picture
    else if (IsLeftTrafo(pTrafo)) then
      pTrafo^.picture := GridForm.TrafoYYYls.picture;
  end;
end;

procedure Trafo3wPicture(ipComp: longint);
{select picture for the trafo}
var
  apu    : single;
  pTrafo : TpComp;
begin
  pTrafo := TpComp(ipComp);
  pTrafo^.GetPar(g3W_type,apu);
  if (apu = 2) then begin           {YYD-trafo}
    YYDpicture(pTrafo);
  end else begin                    {YYY-trafo}
    YYYpicture(pTrafo);
  end;
end;

procedure TrafoParamShow(ipComp: longint);
{show the parameters of a three-winding transformer}
var
  apu   : single;    {temporary}
  ii    : integer;   {index}
  ix,iy : integer;   {coordinates}
  lbl   : string;    {label}
  ll    : longint;   {temporary}
  pForm : TpForm;    {pointer to the form with the parameters}
  pSet  : TpCompSet; {pointer to the common}
  txt   : string;    {temporary}
{V1=10,V2=1,V3=1,X12=1,X13=1,X23=1,R1=0.1,R2=0.1,R3=0.1,VA=1,c2=1,c3=1,
 Rg1=0,Xg1=0,Rg2=0,Xg2=0,Rg3=0,Xg3=0,Vs1=0,Vs2=0,Vs3=0}
begin
  pComp := TpComp(ipComp);    {pointer to the trafo}
  pComp^.GetipSet(ll);        {pointer to the common, as integer}
  pSet := TpCompSet(ll);      {pointer to the common}
  {show parameter window only if allowed}
  if (pSet^.p3wBox^.checked) then begin
    pComp^.GetNpar(npar);       {number of parameters}
    pGrid^.RowCount := npar+1;
    pComp^.GetLabel(lbl,ix,iy); {label of the component}
    TrafoParamNames;            {parameter names to the grid}
    {parameter values to the grid}
    for ii:= 1 to npar do begin
      pComp^.Getpar(ii,apu);          {get value of parameter i}
      RemoveSpaces(apu,txt);          {format, and remove spaces, in routines.pas}
      pGrid^.Cells[1,ii] := txt;      {parameter to grid. NOTE changes below !!}
    end;
    {clear grounding impedance, if YYD}
    if (pGrid^.cells[1,TypeRow] <> '1') then begin
      pGrid^.cells[1,Rg3Row] := 'xxx';
      pGrid^.cells[1,Xg3Row] := 'xxx';
      pGrid^.cells[1,Zr13Row] := 'xxx';
      pGrid^.cells[1,Zr23Row] := 'xxx';
    end;
    ShowOrNotPhaseShift;  {hide selection of phase shift, if YYY-trafo, else show}
    {show trafo type}
    pTrafoImage^.picture := nil;
    if (pGrid^.cells[1,TypeRow] = '1') then begin  {YYY-transformer}
      WriteYYYorYYD(pTrafoImage^.canvas,'Y');
    end else begin                                 {YYD}
      WriteYYYorYYD(pTrafoImage^.canvas,'D');
    end;
    GridForm.ParamGridTopLeftChanged(nil);  {TrafoImage on the right place}
    GridForm.caption := lbl;                {label as caption}
    GridForm.visible := true;
    GridForm.ActiveControl := nil;          {focus to main form, for the case of delete-key pressed}
  end;
end;

procedure HideParameters(ipComp: longint);
{hide the parameter form (for a 3-w trafo...)}
var
  name : string;
begin
  GridForm.visible := false;
  {determine picture of the trafo}
  pComp^.GetName(name);
  if (name = gTrafo3W) then Trafo3wPicture(ipComp);
end;

procedure TGridForm.FormCreate(Sender: TObject);
var
  ipu : integer;
begin
  width := 140;
  pGrid := @ParamGrid;
  pGrid^.cells[1,0] := 'A, V, Ohm';   {basic units}
  pGrid^.cells[2,0] := 'per unit';    {per unit convention}
  BaseGrid.cells[0,0] := 'base MVA';
  BaseGrid.cells[0,1] := 'base kV';
  pTrafoPanel := @TrafoPanel;
  pTrafoImage := @TrafoImage;
  pPhasePanel := @PhasePanel;
  pPhaseImage := @PhaseImage;
  {prepare image for selecting the trafo type}
  TrafoPanel.width := ParamGrid.DefaultColWidth;
  TrafoPanel.height := ParamGrid.DefaultRowHeight;
  TrafoImage.width := TrafoPanel.width-4;
  TrafoImage.height := TrafoPanel.height-4;
  TrafoImage.left := 2;
  TrafoImage.top := 2;
  WriteYYYorYYD(TrafoImage.Canvas,'Y');
  {prepare image for selecting the phase shift}
  PhasePanel.width := ParamGrid.DefaultColWidth;
  PhasePanel.height := ParamGrid.DefaultRowHeight;
  PhaseImage.width := PhasePanel.width-4;
  PhaseImage.height := PhasePanel.height-4;
  PhaseImage.left := 2;
  PhaseImage.top := 2;
  WritePlusOrMinus30(PhaseImage.Canvas,'-');
  {pointers to the grid and form}
  SetComp.pParForm := @GridForm;
  SetComp.pParGrid := @ParamGrid;
  {texts for the ampacity grid}
  AmpGrid.cells[0,0] := '  A1';
  AmpGrid.cells[1,0] := '  A2';
  AmpGrid.cells[2,0] := '  A3';
  AmpGrid.cells[3,0] := '  A4';
  {position}
  top := Imagoo.top+64;
  left := Imagoo.left+4;
  {rectangles in the imped.grid}
  F1Rect := ImpedGrid.CellRect(1,firow);
  R1Rect := ImpedGrid.CellRect(1,R1row);
  F0Rect := ImpedGrid.CellRect(1,f0row);
  R0Rect := ImpedGrid.CellRect(1,R0row);
  r01Rect := ImpedGrid.CellRect(1,r01row);
  x01Rect := ImpedGrid.CellRect(1,x01row);
  Z0Rect := ImpedGrid.CellRect(1,Z0row);  
end;

procedure TGridForm.FormDeactivate(Sender: TObject);
{move the parameters to the component, unless cancel, or..}
var
  apu,apv : single;    {temporary}
  apw,apx : single;    {temporary}
  copy    : boolean;   {copying}
  errc    : integer;   {error flag}
  ii      : integer;   {index}
  inHelp  : boolean;   {true, when hint-memo clicked}
  ipu     : integer;   {temporary}
  kend    : integer;   {first non-read char.}
  line    : string;    {one parameter as text}
  ll      : longint;   {temporary}
  oldval  : single;    {old parameter value}
  pSet    : TpCompSet; {pointer to the common}
  RePro   : TCompProc; {procedure performed after reading param.}
  st1,st2 : string;    {temporary}
  st3,st4 : string;    {temporary}
  strpar  : string;    {string parameters as one line}
  val     : single;    {parameter value}
  xy,xysc : Tpoint;    {mouse coordinates}
begin
  {but not if closing the application}
  if (not appl_close) then begin
    inHelp := false;     {initialize}
    {help-memo clicked?}
    if (pHelp <> nil) then begin
      if (pHelp^.visible) then begin
        GetCursorPos(xysc);        {mouse position in screen coordinates}
        xy := Imagoo.ScreentoClient(xysc);  {position in coord. of imagoo-form}
        if (xy.x >= pHelp^.left) and (xy.x <= pHelp^.left+pHelp^.width) and
           (xy.y >= pHelp^.top ) and (xy.y <= pHelp^.top+pHelp^.height) then
           inHelp := true
        else inHelp := false;
      end else begin
        inHelp := false;
      end;
    end else begin
      inHelp := false;
    end;
    {parameters not accepted, if Cancel-button or Hint-button clicked}
    if (not CancelClick) and (not inHelp) then begin
      if (pComp <> nil) then begin
        pComp^.GetipSet(ll);
        pSet := TpCompSet(ll);    {pointer to the common}
        if (not pComp^.delete_s) then begin
          if (pGrid^.RowCount > npar) and (npar > 0) then begin
            strpar := '';
            for ii:=1 to npar do begin
              line := pGrid^.Cells[1,ii];
//            ValuesFromLine(line,1,true,ipu, apu,apv,apw,apx,st1,st2,st3,st4,errc); {one parameter a time}
              NextValueFromLine(line, 1, kend,val, st1, errc);
              {first, is it a string parameter?, an improbable value used as flag}
              pComp^.GetPar(ii,apu);
              if (apu = improbg) then begin {an "improbable" value as a flag}
                  AddStringPar('T'+st1, strpar);
              end else begin
                if (errc <> 0) then begin
                  pSet^.err_cs := 1;
                end else begin
                  pComp^.getpar(ii,oldval);        {get the old value, for comparisons}
                  pComp^.putpar(ii,val);           {save the parameter to the component}
                  if (oldval <> val) then pSet^.IsChanged := true; {flag the change}
                end;
              end;
            end;
            pComp^.PutStringPar(strpar,0);       {save all string parameters}
          end;
          pComp^.PutVPref(basekV,baseMVA);       {save base power and voltage}
          AmpageLimits(pComp,AmpCheckIf(pSet));  {check ampage limits, if..}
          {.}                                    {AmpageLimits, AmpCheckIf in in Elplex.pas }
          {must rewrite trafo tap (in TapChanger.pas), if it has been calculated}
          if (pSet^.appl_op = 12) or (pSet^.appl_op = 13) then ShowTap(pComp);
          {additional operations}
          try
            pComp^.GetRePro(RePro);  {get procedure}
            RePro(longint(pComp));   {do smth. after reading param}
          finally
          end;
        end;
        copy := pSet^.Copy_Click;   {copying}
      end else begin
        copy := false;              {actually not possible?}
      end;
      if (not copy) then GridForm.visible := false; {no hide, because act comp copied}
    end;
  end;
end;

procedure TGridForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  ll      : longint;   {temporary}
  pSet    : TpCompSet; {pointer to the common}
begin
  {eventual "delete component" must be handled here, because form has focus}
  if (pComp <> nil) then begin
    pComp^.GetipSet(ll);
    pSet := TpCompSet(ll);                    {pointer to the common}
    if (pSet^.pActComp <> nil) then begin     {some component active}
      if (key = 46) then begin                {delete-key}
        pSet^.FormKeyDown(Key, Shift);        {delete the component}
        GridForm.visible := false;   {hide the form, when deleting component}
      end;
    end;
  end;
end;

procedure TGridForm.OKButClick(Sender: TObject);
begin
  GridForm.visible := false;
  if (pHelp <> nil) then pHelp^.visible := false;
end;

procedure TGridForm.CancelButClick(Sender: TObject);
var
  apu  : single;
  name : string;  {name = type of the component}
begin
  CancelClick := true;
  GridForm.visible := false;
  if (pHelp <> nil) then pHelp^.visible := false;
  {check the image of a 3-w transformer}
  pComp^.GetName(name);
  if (name = gTrafo3W) then begin    {is a 3-w trafo}
    pComp^.GetPar(g3w_type,apu);     {type of the trafo}
    if (apu = 1) then begin
      pComp^.picture := GridForm.TrafoYYY.picture;
    end else begin
      pComp^.picture := GridForm.TrafoYYD.picture;
    end;
  end;
end;

procedure TGridForm.FormActivate(Sender: TObject);
begin
{  CancelClick := false;}
end;

procedure TGridForm.HintButClick(Sender: TObject);
{display the help-memo (hint-memo)}
var
{ pHelp : TpMemo;     {pointer to the help-memo}
  pMod  : TpElComp;   {pointer to the model component}
begin
  if (pComp <> nil) then begin
    pComp^.GetpMod(pMod);
    pMod^.GetpHelp(pHelp);
    if (pHelp <> nil) then begin
      pHelp.top := 200;
      pHelp.left := 100;
      pHelp.width := 380;
      pHelp.height := 430;
      pHelp.visible := true;
    end;
  end;
end;

procedure TGridForm.FormShow(Sender: TObject);
{show parameters, set size, etc.
NOTE: The parameters are moved to the grid in TComp.Mouse_Down of skemadef.pas,
      BUT the parameters of 3-w transformers are moved in TrafoParamShow of this unit}
var
  apu,apv  : single;    {temporary}
  err      : integer;   {error flag}
  fii      : single;    {phase of impedance, in degrees}
  ii       : integer;   {index}
  ipu      : integer;   {temporary}
  lbl      : string;    {label}
  R1,R0    : single;    {pos.,zero seq. resistance, in ohms}
  txt      : string;    {temporary}
  V1n      : single;    {nominal primary voltage}
  VAn      : single;    {nominal apparent power}
  X1,X0    : single;    {pos.,zero seq. reactance, inohms}
  Zb       : single;    {base impedance from base variables of the trafo}
begin
  CancelClick := false;
  is2WTrafo := isTrafo(pComp) and not(pComp^.hint = gTrafo3W);  {true, when component is a 2-w trafo, in nodes.pas}
  is3WTrafo := (pComp^.hint = gTrafo3W);   {ture, when 3-winding trafo}
  {if 3w trafo, impedances cannot be given in percent of trafo base}
  if (is3WTrafo) then begin
    ZperCentBut.down := false;
    ZperCentButClick(Sender);
  end;
  {base values of voltage and power}
  pComp^.GetVPRef(apu,apv);         {base power and voltage BUT MVA and kV, or VA and V??}
  RemoveSpaces(apu,txt);            {format, and remove spaces, in routines.pas}
  BaseGrid.cells[1,1] := txt;
  basekV := apu;
  RemoveSpaces(apv,txt);            {format, and remove spaces, in routines.pas}
  BaseGrid.cells[1,0] := txt;
  baseMVA := apv;
  baseZ := basekV*basekV/baseMVA;
  ShowBaseZ;
  {show only basic parameters = parameters originally defined on the main form}
  {the other parameters are displayed in other tables (grids)}
  {first, reset the row heights}
  for ii := 1 to npar do begin
    pGrid^.rowHeights[ii] := pGrid^.DefaultRowHeight; {hide or show the rows}
  end;
  {next, hide the rows for "nonbasic" parameters}
  pComp^.GetnBasPar(nbas);
  if (nbas < npar) then begin
    for ii := nbas+1 to npar do begin
      pGrid^.rowHeights[ii] := 0;      {hide or show the rows}
    end;
  end;
  {texts in grids}
//  ImpedGrid.cells[0,0] := ' V1 (V)';
//  ImpedGrid.cells[0,1] := ' VAn (VA)';
  ImpedGrid.cells[0,Z1row] := '|Z1| (%)';
  ImpedGrid.cells[0,R1row] := '|R1| (%)';
  ImpedGrid.cells[0,firow] := ' 1 ()';
  ImpedGrid.cells[0,Z0row] := '|Z0| (%)';
  ImpedGrid.cells[0,R0row] := '|R0| (%)';
  ImpedGrid.cells[0,f0row] := ' 0 ()';
  ImpedGrid.cells[0,x01row]:= 'X0/X1';
  ImpedGrid.cells[0,r01row]:= 'R0/R1';
  TrafoBaseGrid.cells[0,0] := ' V1 (V)';
  TrafoBaseGrid.cells[0,1] := ' VAn (VA)';
  {show the zero seq. impedance, if zero sec. row selected}

  {set buttons etc visible, according to comp.type, and the height of the form}
  VisibleAndHeight;
  SetWidths;
  SetHeights;
  pGrid^.color := clWhite;
  {show label, if 2-w trafo (for 3-w, label shown in TrafoParamShow !?)}
  pComp^.GetLabel(lbl,ii,ipu);
  Caption := lbl;
  {show parameters in pu-form}
  PUfromAVOpar;
  {for a 2-w transformer, show the impedance etc. in "pu" using the trafo base values}
  if (is2WTrafo) then begin
    GetTrafoBaseFromComp(V1n,VAn,Zb);
    baseTRV1 := V1n;                                {save to local}
    baseTrVA := VAn;
    baseTrZ := Zb;
    ShowTrafoBase;
    ImpedancesInTrafoBase(fromComp,R1,X1,R0,X0,err); {show impedances}
    ShowAmpacity;                                    {show ampacity limits in amp.grid}
//  ImpedGrid.cells[1,V1row] := pGrid^.cells[1,gTrafo_V1]; {used also as trafo base voltage}
//  ImpedGrid.cells[1,VArow] := pGrid^.cells[1,theVArow];  {used also as trafo base power}
    TrafoBaseGrid.cells[1,V1row] := pGrid^.cells[1,gTrafo_V1]; {used also as trafo base voltage}
    TrafoBaseGrid.cells[1,VArow] := pGrid^.cells[1,theVArow];  {used also as trafo base power}
    {show also the ratio of zero seq. and pos.seq. impedances}
    if (R1 > 0) then apu := R0/R1 else apu := 1;
    RemoveSpaces(apu,txt);                        {format}
    ImpedGrid.cells[1,r01row] := txt;
    if (X1 > 0) then apu := X0/X1 else apu := 1;
    RemoveSpaces(apu,txt);                        {format}
    ImpedGrid.cells[1,x01row] := txt;
    ImpedGrid.color := clWhite;                   {reset color, no errors now}
  end;
  {initialize row and column}
  pGrid^.row := 1;
  pGrid^.col := 1;
  actrow := 1;
  actcol := 1;
  ampcol := 0;
  improw := 0;
  baserow := 0;
  Z0col := 1;
//  ActiveControl := nil; {focus to main form, for the case of delete-key pressed, see LineParam}
    {does not work here, must be in TComp.mouse_down of Skemadef.pas ??!!}
end;

procedure TGridForm.ShowAmpacity;
{show the ampacity limits for 2-w trafos}
var
  ii : integer;
begin
  for ii := 0 to 3 do begin
    {copy from main grid, where the limits are hidden}
    AmpGrid.cells[ii,1] := pGrid^.cells[1,gTrafo_A1+ii];
  end;
end;

procedure TGridForm.ShowImpedancesInTrafoBase(RR,XX : single; Zrow,frow,Rrow: integer);
{show the impedances in the impedance grid in % using the trafo base
 RR  resistance
 XX  reactance
 Zrow  row for the impedance
 Rrow  row for the resistance
 frow  row for the "phase" angle}
var
  apu,apv : single;   {temporary}
  txt,txx : string;   {temporary}
  ZZ      : complex;  {impedance}
begin
  ZZ := cplx(RR,XX);
  apu := Cabs(ZZ)*100/baseTrZ;               {magnitude in trafo base}
  RemoveSpaces(apu,txt);                     {format}
  apv := Cangle(ZZ)*180/pi;                  {phase}
  RemoveSpaces(apv,txx);
  ImpedGrid.cells[1,Zrow] := txt;            {impedance to grid}
  ImpedGrid.cells[1,frow] := txx;            {phase to grid}
  apu := RR*100/baseTrZ;                     {resistance}
  RemoveSpaces(apu,txt);
  ImpedGrid.cells[1,Rrow] := txt;            {resistance to grid}
end;

procedure TGridForm.ImpedancesInTrafoBase(wherePar:TfromWhere;
                var R1,X1,R0,X0: single; var err : integer);
{show the impedances of a 2-w trafo in the impedance grid
 using the base values from the "normal" trafo parameters V1 and VAn
 wherePar   tells where the parameters are read from: component or the (main) grid
 R1,X1      pos.seq. resistance, reactance in ohms
 R0,X0      zero seq. resistance, reactance
 err        total error from reading parameters, = 0, if no errors}
var
  apu,apv  : single;    {temporary}
  apw      : single;    {temporary}
  cpu      : complex;   {temporary}
  er1,er2  : integer;   {error flag}
  er3,er4  : integer;   {error flag}
  ipu      : integer;   {temporary}
  s1,s2    : string;    {temporary}
  s3,s4    : string;    {temporary}
  txt,txx  : string;    {temporary}
  Z0,Z1    : complex;   {impedances}
begin
  if (wherePar = fromComp) then begin   {read base par directly from the component}
    pComp^.GetPar(gTrafo_R1,R1);
    pComp^.GetPar(gTrafo_X ,X1);
    pComp^.GetPar(gTrafo_R0,R0);
    pComp^.GetPar(gTrafo_X0,X0);
    er1 :=0; er2 := 0; er3 := 0; er4 := 0;
  end else if (wherePar = fromGrid) then begin  {from grid for parameters}
    txt := pGrid^.cells[1,gTrafo_R1];           {resistance}
    ValuesFromLine(txt, 1, false, ipu, R1, apu, apv, apw, s1,s2,s3,s4,er1);
    txt := pGrid^.cells[1,gTrafo_X];            {reactance}
    ValuesFromLine(txt, 1, false, ipu, X1, apu, apv, apw, s1,s2,s3,s4,er2);
    txt := pGrid^.cells[1,gTrafo_R0];           {resistance}
    ValuesFromLine(txt, 1, false, ipu, R0, apu, apv, apw, s1,s2,s3,s4,er3);
    txt := pGrid^.cells[1,gTrafo_X0];            {reactance}
    ValuesFromLine(txt, 1, false, ipu, X0, apu, apv, apw, s1,s2,s3,s4,er4);
  end else begin                                {error case}
    er1 := 1; er2 := 1; er3 := 1; er4 := 1;
    R1 := 1;X1 := 1;R0 := 1;X0 := 1;            {just some values}
  end;
  {calculate impedances in trafo base, as magnitude and phase}
  if (er1 = 0) and (er2 = 0) then begin         {resistance and reactance correct}
    ShowImpedancesInTrafoBase(R1,X1,Z1row,firow,R1row);
  end;
  {zero seq. impedance}
  if (er3 = 0) and (er4 = 0) then begin
    ShowImpedancesInTrafoBase(R0,X0,Z0row,f0row,R0row);
  end;
  {ratio of resistances}
  if (er1 = 0) and (er3 = 0) then begin
    if (R1 > 0) and (R0 > 0) then begin
      apu := R0/R1;
      RemoveSpaces(apu,txt);  {format}
    end else begin
      txt := '1';
    end;
    ImpedGrid.cells[1,r01row] := txt;
  end;
  {ratio of reactances}
  if (er2 = 0) and (er4 = 0) then begin
    if (X1 > 0) and (X0 > 0) then begin
      apu := X0/X1;
      RemoveSpaces(apu,txt);  {format}
    end else begin
      txt := '1';
    end;
    ImpedGrid.cells[1,x01row] := txt;
  end;
  err := er1+er2+er3+er4;
end;

procedure TGridForm.GetTrafoBaseFromComp(var V1n,VAn,Ztr: single);
{get the base power and voltage of the transformer itself as parameters of the comp.
 (this may be different from the "general" base values used for pu-values)
 V1n   nominal primary voltage
 VAn   nominal apparent power
 Ztr   base impedance of the trafo}
var
  name  : string;    {name = type of the component}
  V1r   : single;    {raw and checked primary voltage of trafo}
  VAnr  : single;    {raw and checked nominal power}
begin
  pComp^.GetName(name);                 {name = type of the trafo}
  pComp^.GetPar(gTrafo_V1,V1r);         {primary voltage}
  if (V1r < 1) then V1n := 1 else V1n := V1r;
  {different indices for different transformers}
  if (name = gTrafoYY) then begin
    pComp^.GetPar(gYY_VAn,VAnr);
  end else if (name = gTrafoYD) then begin
    pComp^.GetPar(gYD_VAn,VAnr);
  end else if (name = gTrafoDY) then begin
    pComp^.GetPar(gDY_VAn,VAnr);
  end else if (name = gTrafoDD) then begin
    pComp^.GetPar(gDD_VAn,VAnr);
  end else begin                   {error case}
    VAnr := 1e6;                   {just some value}
  end;
  if (VAnr < 1) then VAn := 1 else VAn := VAnr;
  Ztr := V1n*V1n/VAn;              {base impedance}
end;


procedure TGridForm.ShowTrafoBase;
{show the base impedance of the transformer itself
 (this may be different from the "general" base impedance used for pu-values)}
var
  txt  : string;    {temporary}
begin
  RemoveSpaces(baseTrZ,txt);             {format}
  BaseZtlabel.caption := ' = '+txt;
  OhmZtLabel.left := BaseZtLabel.left+BaseZtLabel.width+2;
end;

procedure TGridForm.FormHide(Sender: TObject);
var
  ii : integer;
  ll : longint;
begin
  if (not appl_close) then begin
    if (pHelp <> nil) then pHelp^.visible := false;
    pHelp := nil;
    pComp^.GetipSet(ll);
    unmark(ll);
    {hide the panels for nonnumerical parameters}
    pTrafoPanel^.visible := false;
    pPhasePanel^.visible := false;
    {clear the grid}
    for ii := 1 to pGrid^.RowCount do begin
      pGrid^.Cells[0,ii] := '';
//    pGrid^.Cells[1,ii] := '';
    end;

  end;
end;

procedure TGridForm.VisibleAndHeight;
{set the buttons etc. visible, adjust form height}
var
  ipu : integer;
begin
  {more buttons, tables etc. visible for 2-winding trafos}
  CurveBut.visible := is2wTrafo;
  ShowCurveBut.visible := {is2wTrafo}false;
  AmpBut.visible := is2wTrafo;

  ZperCentBut.visible := is2wTrafo;


  ImpedGrid.visible := is2wTrafo and ZperCentBut.down;
  ImpedPanel.visible := ImpedGrid.visible;
  AmpLabel.visible := is2wTrafo and AmpBut.down;
  AmpGrid.visible := is2wTrafo and AmpBut.down;
  {pu and/or physical units?}
  PUButClick(nil);
  AVOButClick(nil);
  {set the size of the form}
  if (is2wTrafo) then SetHeights
  else {3wtrafo} GridForm.height := OKBut.top+OKBut.height+40;
end;

procedure TGridForm.TrafoImageMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{select the type of the transformer  YYY or YYD}
var
  apu : single;  {temporary}
  txt : string;  {temporary}
begin
  TrafoImage.picture := nil;
  if (X < TrafoImage.width div 2) then begin       {YYY}
    {if type is changed, get some (old) values for the grounding impedance, etc}
    if (pGrid^.cells[1,TypeRow] <> '1') then begin {old type was not YYY}
      pComp^.Getpar(Rg3Row+1,apu);                 {get value of grounding resistance}
      RemoveSpaces(apu,txt);                       {format, and remove spaces, in routines.pas}
      pGrid^.Cells[1,Rg3Row] := txt;               {parameter to grid}
      pComp^.Getpar(Xg3Row+1,apu);                 {get value of grounding reactance}
      RemoveSpaces(apu,txt);                       {format, and remove spaces, in routines.pas}
      pGrid^.Cells[1,Xg3Row] := txt;               {parameter to grid}
      pComp^.Getpar(Zr13Row+1,apu);                {get value of Z0/Z1}
      RemoveSpaces(apu,txt);                       {format, and remove spaces, in routines.pas}
      pGrid^.Cells[1,Zr13Row] := txt;              {parameter to grid}
      pComp^.Getpar(Zr23Row+1,apu);                {get value of Z0/Z1}
      RemoveSpaces(apu,txt);                       {format, and remove spaces, in routines.pas}
      pGrid^.Cells[1,Zr23Row] := txt;              {parameter to grid}
    end;
    WriteYYYorYYD(TrafoImage.canvas,'Y');
    pGrid^.cells[1,TypeRow] := '1';
    YYYpicture(pComp);
//  pComp^.picture := TrafoYYY.picture;
  end else begin                                {YYD}
    WriteYYYorYYD(TrafoImage.canvas,'D');
    pGrid^.cells[1,TypeRow] := '2';
    YYDpicture(pComp);
//  pComp^.picture := TrafoYYD.picture;
    {clear grounding impedance}
    pGrid^.cells[1,Rg3Row] := 'xxx';
    pGrid^.cells[1,Xg3Row] := 'xxx';
    pGrid^.cells[1,Zr13Row] := 'xxx';
    pGrid^.cells[1,Zr23Row] := 'xxx';
  end;
  {show or not the selection of the phase shift}
  ShowOrNotPhaseShift;
end;

procedure TGridForm.PhaseImageMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{select the phase shift of the YYD transformer, + or - 30 degrees}
begin
  PhaseImage.picture := nil;
  if (X < PhaseImage.width div 2) then begin       {-30 degr.}
    WritePlusorMinus30(PhaseImage.canvas,'-');
    pGrid^.cells[1,PhaseRow] := '0';
  end else begin                                {YYD}
    WritePlusOrMinus30(PhaseImage.canvas,'+');
    pGrid^.cells[1,PhaseRow] := '1';
  end;
end;



procedure TGridForm.ParamGridSelectCell(Sender: TObject; Col, Row: Longint;
  var CanSelect: Boolean);
{grounding impedance not needed for a YYD-transformer}
{hidden cells cannot be edited}
var
  apu  : single;  {temporary}
  ipu  : integer; {temporary}
  nbas : integer; {number of basic parameters}
  name : string;  {name = type of the component}
begin
  actrow := row;
  actcol := col;
  pComp^.GetName(name);
  pComp^.GetnBasPar(nbas);
  {3w-transformer, row for grounding impedance or ratio Z0/Z1}
  if (name = gTrafo3W) and (col = 1) and
     ((row = Rg3row) or (row = Xg3row) or (row = Zr13Row) or (row = Zr23row)) then begin
    pComp^.GetPar(g3w_type,apu);
    if {(apu <> 1) or} (pGrid^.cells[1,TypeRow] <> '1') then begin  {not YYY-trafo}
      pGrid^.options := pGrid^.options-[goEditing,goAlwaysShowEditor];
      {this does not help, if the contents of cell has recently been edited ??!!}
    end else begin
      pGrid^.options := pGrid^.options+[goEditing,goAlwaysShowEditor];
    end;
  {hidden cells cannot be edited}
  end else if (row > nbas) then begin
    pGrid^.options := pGrid^.options-[goEditing,goAlwaysShowEditor];
  end else begin
    {if PU or AVO-column is hidden, it cannot be edited}
    if ((not PUBut.down ) and (col = 2)) or
       ((not AVOBut.down) and (col = 1)) then begin
      pGrid^.options := pGrid^.options-[goEditing,goAlwaysShowEditor];
    end else begin
      pGrid^.options := pGrid^.options+[goEditing,goAlwaysShowEditor];
    end;
  end;
//{display zero seq. impedances when selecting (editing) Z0/Z1}
//ZeroSeqGrid(row);
end;

procedure TGridForm.ParamGridTopLeftChanged(Sender: TObject);
{when scrolling the data of 3w-trafo, move the image for the selection of the type}
var
  name : string; {name = type of the component}
begin
  pComp^.GetName(name);
  {3w-transformer}
  if (name = gTrafo3W) then begin
    pTrafoPanel^.top := pGrid^.top+(pGrid^.DefaultRowHeight+pGrid^.GridLineWidth)*
                        (TypeRow-ParamGrid.TopRow+1)+1;
    pPhasePanel^.top := pGrid^.top+(pGrid^.DefaultRowHeight+pGrid^.GridLineWidth)*
                        (PhaseRow-ParamGrid.TopRow+1)+1;
    {hide the panels, if higher than the grid}
    pTrafoPanel^.visible := (pTrafoPanel^.top > ParamGrid.top+ParamGrid.DefaultRowHeight+1);
    pPhasePanel^.visible := (pPhasePanel^.top > ParamGrid.top+ParamGrid.DefaultRowHeight+1);
  end;
//{move the small grid for Z0, if visible}
//if (is2wTrafo and X0R0Grid.visible) then ZeroSeqGrid(pGrid^.row);
end;

procedure TGridForm.SetWidths;
{set the width of the grid and the form, depending on the widths of the columns}
const
  wscw = 20;  {width with scroll}
  nscw = 4;   {width without scroll}
var
  ii      : integer;
  ipu,ipv : integer;
begin
  {adjust width, depends on is the scroll bar visible}
  if ({pGrid^.RowCount}nbas > DefRows) then
   ipu := wscw                          {with scroll bar}
  else ipu := nscw;                     {no scroll bar}
  {total width of the columns}
  ipv := 0;
  for ii := 0 to pGrid^.ColCount-1 do ipv := ipv+pGrid^.ColWidths[ii];
  pGrid^.width := ipv+pGrid^.GridLineWidth+ipu;

  {width of the form depends on what is visible}
  if (is2wTrafo) then begin               {2-winding trafo, more grids etc visible}
    if (AmpBut.down) then                 {must be wider, because AmpGrid visbile}
      GridForm.width := AmpGrid.width+8
    else if (ZperCentBut.down) then       {must have room for radio buttons}
      GridForm.width := Impedgrid.width+ImpedPanel.width+7
    else
      GridForm.width := pGrid^.width+10;
  end {3-w trafo} else begin              {3w trafo, only the main grid}
    GridForm.width := pGrid^.width+8;
  end;
end;

procedure TGridForm.AVOButClick(Sender: TObject);
begin
  if (AVOBut.down) then begin
    ParamGrid.ColWidths[1] := 64;

  end else begin
    ParamGrid.ColWidths[1] := 0;

  end;
  SetWidths;
  SetHeights;
  {for 3w-trafos, adjust the size of the panels for selecting the trafo type and phase shift}
  Adjust3WPanels;  
end;

procedure TGridForm.Adjust3WPanels;
{set the widht of the panels for the trafo type and phase shift, for
 a 3-winding trafo}
begin
  if (is3WTrafo) then begin
    if (AvoBut.down) and (PUBut.down) then begin
      TrafoPanel.width := 2*ParamGrid.DefaultColWidth+2;
      PhasePanel.width := 2*ParamGrid.DefaultColWidth+2;
    end else begin
      TrafoPanel.width := ParamGrid.DefaultColWidth;
      PhasePanel.width := ParamGrid.DefaultColWidth;
    end;
  end;
end;

procedure TGridForm.PUButClick(Sender: TObject);
begin
  if (PUBut.down) then begin
    ParamGrid.ColWidths[2] := 64;

  end else begin
    ParamGrid.ColWidths[2] := 0;

  end;
//  BaseGrid.visible := PUBut.down;
//  BaseZlabel.visible := PUBut.down;
//  BaseOhmLabel.visible := PUBut.down;
  BasePanel.visible := PUBut.down;
  SetWidths;
  SetHeights;
  {for 3w-trafos, adjust the size of the panels for selecting the trafo type and phase shift}
  Adjust3WPanels;
end;

procedure TGridForm.ShowBaseZ;
{show the calculated base impedance
 baseZ  the base impedance}
var
  txt : string;  {temporary}
begin
  txt := ManyChars(baseZ,false);
  BaseOhmLabel.caption := txt+' W';
end;

procedure TGridForm.ChangeOfBase(row: integer);
{read new base value, recalculate the impedances
 row   row index of the new value as text in a grid, 0 = MVA, 1 = kV}
var
  apu,apv : single;  {temporary}
  apw,apx : single;  {temporary}
  bvar    : single;  {base variable (power or voltage)}
  err     : integer; {error flag}
  ii      : integer; {index}
  ipu     : integer; {temporary}
  nbas    : integer; {number of basic variables}
  pavo    : single;  {parameter in physical units}
  pupar   : single;  {parameter in pu-form}
  R0,R1   : single;  {resistances}
  s1,s2   : string;  {temporary}
  s3,s4   : string;  {temporary}
  txt     : string;  {temporary}
  X0,X1   : single;  {reactance}
begin
  {convert string to single}
  txt := BaseGrid.cells[1,row];
  ValuesFromLine(txt, 1, false, ipu, bvar, apu, apv, apw, s1,s2,s3,s4,err);
  if (err = 0) then begin        {no errors}
    if (row = 0) then begin
      if (bvar >= 0.99e-6) then     {must not be too small}
        baseMVA := bvar             {save base power as single}
      else baseMVA := 1e-6;
    end else if (row = 1) then begin
      if (bvar >= 0.99e-3) then     {must not be too small}
        basekV := bvar              {save base power as single}
      else basekV := 1e-3;
    end else begin                  {error case}
      {error, no changes...}
    end;
    BaseGrid.color := clWhite;
    baseZ := basekV*basekV/baseMVA;
    ShowBaseZ;
    {update the parameters in physical units or in pu in the grid, depending on
     the radio buttons}
    pComp^.GetnBasPar(nbas);
    if (nbas > 0) then begin
      if (PURadioBut.checked) then begin {keep present PU values, update A,V,Ohm}
        for ii := 1 to nbas do begin
          txt := pGrid^.cells[2,ii];     {parameter in pu-form, as text}
          ValuesFromLine(txt, 1, false, ipu, pupar, apu, apv, apw, s1,s2,s3,s4,err);
          if (err = 0) then begin        {no errors}
            AVOfromPU(pupar,ii,pavo);    {change to physical units}
          end;
        end;
        {update also the values in the %Z-grid (impedance grid)}
        ImpedancesInTrafoBase(fromGrid, R1, X1, R0, X0, err);
      end else begin                     {keep present A,V,Ohm values, update PU}
        for ii := 1 to nbas do begin
          txt := pGrid^.cells[1,ii];     {parameter in physical-form, as text}
          ValuesFromLine(txt, 1, false, ipu, pavo, apu, apv, apw, s1,s2,s3,s4,err);
          if (err = 0) then begin        {no errors}
            PUfromAVO(pavo,ii);          {change to per units}
          end;
        end;
      end;
    end;
  end else begin
    BaseGrid.color := clYellow;
  end;
end;

procedure TGridForm.AVOfromPU(pupar : single; ii : integer; var pavo: single);
{convert a parameter in per-units to physical units, write to grid
 pupar  the pu-value of the parameter
 ii     index = row of the parameter
 pavo   the parameter in physical units}
var
  par     : single;  {parameter in physical units}
  txt,txx : string;  {temporary}
begin
  if (ii > 0) and (ii < pGrid^.RowCount) then begin
    txt := pGrid^.cells[0,ii]; {name of the parameter}
    if (length(txt) >= 1) then begin
      {the first character tells the type of the parameter, mostly}
      if (txt[1] = 'V') then begin
        {might also be (apparent) power}
        if (length(txt) >= 2) and (txt[2] = 'A') then begin   {VA = apparent power}
          par := pupar*(baseMVA*1e6);
        end else begin                        {voltage}
          par := pupar*(basekV*1000);
        end;
      end else if (txt[1] = 'A') or (txt[1] = 'I') then begin   {current}
        par := pupar*(1000*baseMVA)/basekV*sqrt(3);
      end else if (txt[1] = 'X') or (txt[1] = 'R') or (txt[1] = 'Z') then begin {impedance}
        par := pupar*baseZ;
      end else if (txt[1] = 'P') then begin   {power}
        par := pupar*(1e6*baseMVA);
      end else begin                          {cannot be converted to pu}
        par := pupar;
      end;
    end else begin                  {no name, error}
      par := pupar;
    end;
    {write to the grid}
    RemoveSpaces(par,txx);          {format, and remove spaces, in routines.pas}
    pGrid^.Cells[1,ii] := txx;      {parameter to grid}
    pavo := par;
  end else begin
    pavo := pupar;                  {error case, just some value}
  end;
end;

procedure TGridForm.PUfromAVO(par : single; ii : integer);
{convert a parameter in physical units to the pu-notation, write to grid
 par  the value of the parameter
 ii   index = row of the parameter}
var
  pupar   : single;  {parameter in pu-form}
  txt,txx : string;  {temporary}
begin
  if (ii > 0) and (ii < pGrid^.RowCount) then begin
    txt := pGrid^.cells[0,ii]; {name of the parameter}
    if (length(txt) >= 1) then begin
      {the first character tells the type of the parameter, mostly}
      if (txt[1] = 'V') then begin
        {might also be (apparent) power}
        if (length(txt) >= 2) and (txt[2] = 'A') then begin   {VA = apparent power}
          pupar := par/(baseMVA*1e6);
        end else begin                        {voltage}
          pupar := par/(basekV*1000);
        end;
      end else if (txt[1] = 'A') or (txt[1] = 'I') then begin   {current}
        pupar := par*basekV*sqrt(3)/(1000*baseMVA);
      end else if (txt[1] = 'X') or (txt[1] = 'R') or (txt[1] = 'Z') then begin {impedance}
        pupar := par/baseZ;
      end else if (txt[1] = 'P') then begin   {power}
        pupar := par/(1e6*baseMVA);
      end else begin                          {cannot be converted to pu}
        pupar := par;
      end;
    end else begin                            {no name, error}
      pupar := par;
    end;
    {write to the grid}
    RemoveSpaces(pupar,txx);        {format, and remove spaces, in routines.pas}
    pGrid^.Cells[2,ii] := txx;      {parameter to grid}
  end;
end;

procedure TGridForm.PUfromAVOpar;
{convert the component parameters from physical units to pu-notation, write to grid}
var
  ii    : integer;  {index}
  nbas  : integer;  {number of "basic" parameters
  {}                {(shown in the grid, determined in the hint of the original image)}
  par   : single;   {parameter}
begin
  pComp^.GetnBasPar(nbas);
  if (nbas > 0) then begin       {should be ?}
    for ii := 1 to nbas do begin
      pComp^.GetPar(ii,par);     {directly from component? or should be taken taken from grid?}
      PUfromAVO(par, ii);        {change the parameter to pu-form, and write to the grid}
    end;
  end;
end;

procedure TGridForm.BaseGridKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  ChangeOfBase(baserow);
end;

procedure TGridForm.BaseGridSelectCell(Sender: TObject; Col, Row: Longint;
  var CanSelect: Boolean);
begin
  baserow := row;
end;

procedure TGridForm.AmpButClick(Sender: TObject);
begin
  AmpGrid.visible := AmpBut.down;
  AmpLabel.visible := AmpBut.down;
  SetWidths;
  SetHeights;
end;

procedure TGridForm.ZperCentButClick(Sender: TObject);
begin
  ShowImpedPanel.top := AVOBut.top+AVOBut.height+4;
  ShowImpedPanel.left := 1;
  ImpedGrid.left := 1;
  ImpedGrid.top := ShowImpedPanel.top+ShowImpedPanel.height+4;
  ImpedPanel.left := ImpedGrid.left+ImpedGrid.width;
  ImpedPanel.top := ImpedGrid.top+ImpedGrid.DefaultRowHeight+1;
  ZeroPanel.top := ImpedGrid.top+ImpedGrid.height-ZeroPanel.height;
  ZeroPanel.left := ImpedPanel.left;
  ShowImpedPanel.visible := ZperCentBut.down;
  ImpedGrid.visible := ZperCentBut.down;
  ImpedPanel.visible := ImpedGrid.visible;
  ZeroPanel.visible := ImpedGrid.visible;
  ParamGrid.visible := not ZperCentBut.down;
  if (ZperCentBut.down) then begin
//  BaseGrid.visible := false;
    BasePanel.visible := false;
  end else begin
//  BaseGrid.visible := PUBut.down;
    BasePanel.visible := PUBut.down;
  end;
  AVOBut.visible := not ZperCentBut.down;
  PUBut.visible := not ZperCentBut.down;
  AvopuBut.left := 1;
  AvopuBut.visible := ZperCentBut.down;
  SetWidths;
  SetHeights;
end;

procedure TGridForm.SetHeights;
{set the height of the form for the parameters depending on the
 grids etc that are shown}
var
  nexty : integer; {top of the next component}
begin
  nexty := ParamGrid.top+ParamGrid.height+4;
  if (PUBut.down) then begin
    BasePanel.top := nexty;
    nexty := nexty+BasePanel.height+4;
//    BaseGrid.top := nexty;
//    nexty := nexty+BaseGrid.height+4;
//    BaseZLabel.top := nexty;
//    BaseOhmLabel.top := nexty;
//    nexty := nexty+BaseZLabel.height+4;
  end;
  OKBut.top := nexty;
  CancelBut.top := OKBut.top;
  HintBut.top := OKBut.top;
  AmpBut.top := OKBut.top;
  nexty := nexty+OKBut.height+4;
  if (AmpBut.down) and (is2wTrafo) then begin
    AmpLabel.top := nexty;
    nexty := nexty+AmpLabel.height+4;
    AmpGrid.top := nexty;
    nexty := nexty+AmpGrid.height+4;
  end;
  ShowCurveBut.top := nexty;
  nexty := nexty+ShowCurveBut.height+4;
  GridForm.height := nexty+40;
end;

function TGridForm.theVArow: integer;
{get the index of the row for the nominal apparent power of a 2-w transformer
 theVArow  the row index}
var
  name : string;
begin
  pComp^.GetName(name);
  if      (name = gTrafoYY) then theVArow := gYY_VAn
  else if (name = gTrafoYD) then theVArow := gYD_VAn
  else if (name = gTrafoDY) then theVArow := gDY_VAn
  else if (name = gTrafoDD) then theVArow := gDD_VAn
  else theVArow := 1;    {error case, just some value ?!}
end;


procedure TGridForm.ParamGridKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
{convert to physical units from pu, or to pu from physical,
 update other grids, for some parameters, some components}
var
  apu,apv : single;   {temporary}
  apw     : single;   {temporary}
  err,ert : integer;  {error flag}
  ipu     : integer;  {temporary}
  name    : string;   {name = type of the component}
  nbas    : integer;  {number of basic parameters}
  par     : single;   {the parameter}
  pavo    : single;   {parameter in physical units, if par in pu}
  R1,R0   : single;   {pos.,zero seq. resistance, in ohms}
  s1,s2   : string;   {temporary}
  s3,s4   : string;   {temporary}
  txt     : string;   {temporary}
  X1,X0   : single;   {pos..zero seq. reactance}
begin
  pComp^.GetnbasPar(nbas);  {number of basic parameters}
  {only basic parameters can be converted}
  if (actrow > 0) and (actrow <= nbas) and (actcol > 0) and (actcol <= 2) then begin
    txt := pGrid^.cells[actcol,actrow];    {the parameter being edited}
    ValuesFromLine(txt, 1, false, ipu, par, apu, apv, apw, s1,s2,s3,s4,err);
    if (err = 0) then begin                {no errors}
      if (actcol = 1) then begin           {editing physical units}
        PUfromAVO(par,actrow);             {change to pu}
        pavo := par;
      end else if (actcol = 2) then begin  {editing per units}
        AVOfromPU(par,actrow,pavo);        {change to physical units}
      end else begin
       {error, do nothing}
      end;
      {for 2w-trafos, update displayed trafo base values, if changed here}
      if (is2wTrafo) then begin
        pComp^.GetName(name);       {name = type of the component}
        if (actrow = gTrafo_V1) or  {prim.voltage = base voltage}
           {nominal power = base power, different index for different transformers}
          ((name = gTrafoYY) and (actrow = gYY_VAn)) or
          ((name = gTrafoYD) and (actrow = gYD_VAn)) or
          ((name = gTrafoDY) and (actrow = gDY_VAn)) or
          ((name = gTrafoDD) and (actrow = gDD_VAn)) then begin
          {update trafo base, and impedances in % of trafo base}
          if (actrow = gTrafo_V1) then begin            {editing voltage}
            if (par > 0) and (baseTrVA > 0) then begin  {reasonable values}
              baseTrV1 := par;
              baseTrZ := par*par/baseTrVA;
              ShowTrafoBase;
//            ImpedGrid.cells[1,V1row] := pGrid^.cells[1,actrow]; {copy V1 to imped.grid}
              TrafoBaseGrid.cells[1,V1row] := pGrid^.cells[1,actrow]; {copy V1 to imped.grid}
            end else begin
              {color as warning??}
            end;
          end else begin                                {editing apparent power}
            if (par > 0) and (baseTrV1 > 0) then begin  {reasonable values}
              baseTrVA := par;
              baseTrZ := baseTrV1*baseTrV1/par;
              ShowTrafoBase;
//            ImpedGrid.cells[1,VArow] := pGrid^.cells[1,actrow]; {copy VA to imped.grid}
              TrafoBaseGrid.cells[1,VArow] := pGrid^.cells[1,actrow]; {copy VA to imped.grid}
            end else begin
              {color as warning??}
            end;
          end;
//        ShowTrafoBase(fromGrid);
          ImpedancesInTrafoBase(fromGrid,R1,X1,R0,X0,ert);
        end;
        {impedances}
        if (actrow = gTrafo_R1) or (actrow = gTrafo_X ) or
           (actrow = gTrafo_R0) or (actrow = gTrafo_X0) then
          ImpedancesInTrafoBase(fromGrid,R1,X1,R0,X0,ert);
      end;
      pGrid^.color := clWhite;
    end else begin
      pGrid^.color := clYellow;
    end;
  end;
end;

procedure TGridForm.ShowInOhms(OneOrZero,XorR: char; txt: string);
{show resistance or reactance in ohms in the impedance grid
 OneOrZero   show as pos.seq, if '1', and as zero seq. if '0'
 XorR        show as X if 'X', and as R if 'R'
 txt         the string (text) to be shown}
begin
  if (XorR = 'R') then begin
    if (OneOrZero = '1') then begin
      R1Label.caption := 'R = '+txt;
      OhmR1Label.left := R1Label.left+R1Label.width+2;
    end else begin
      R0Label.caption := 'R0 = '+txt;
      OhmR0Label.left := R0Label.left+R0Label.width+2;
    end;
  end else begin
    if (OneOrZero = '1') then begin
      X1Label.caption := 'X = '+txt;
      OhmX1Label.left := X1Label.left+X1Label.width+2;
    end else begin
      X0Label.caption := 'X0 = '+txt;
      OhmX0Label.left := X0Label.left+X0Label.width+2;
    end;
  end;
end;

procedure TGridForm.UpdateRandXinMainGrid(OneOrZero: char; Zz,Rr,Xx: single);
{update resistance and reactance in the main grid, when impedance and resistance
 are given in the Impedance-subgrid, in percent of Trafo base impedance
 Update also the R and X in the showImpedPanel
 OneOrZero  pos(1) or zero(0) seq.
 Zz   impedance in percent
 Rr   resistance in percent
 Xx   reactance in percent (if known). If Xx < 0, reactance is calculated}
var
  apu     : single;   {temporary}
  err     : integer;  {error flag}
  Ro      : single;   {resistance in trafo base, in ohms}
  Rpu     : single;   {resistance in per unit}
  Rrow    : integer;  {row for resistance in the main grid}
  txt     : string;   {temporary}
  Xo      : single;   {reactance in ohms}
  Xp      : single;   {reactance in per cent (of trafo base impedance)}
  Xpu     : single;   {reactance in per unit}
  Xrow    : integer;  {row for reactance}
begin
  if (OneOrZero = '1') then begin      {pos.seq.}
    Rrow := gTrafo_R1;
    Xrow := gTrafo_X;
  end else begin                       {zero seq.}
    Rrow := gTrafo_R0;
    Xrow := gTrafo_X0;
  end;
  Ro := Rr*baseTrZ*0.01;               {resistance in ohms}
  Rpu := Ro/baseZ;                     {resistance in pu}
  RemoveSpaces(Ro,txt);                {format}
  pGrid^.cells[1,Rrow] := txt;         {display in grid}
  {show also in the panel above  imped grid}
  ShowInOhms(OneOrZero,'R',txt);
(*
  if (OneOrZero = '1') then begin
    R1Label.caption := 'R = '+txt;
    OhmR1Label.left := R1Label.left+R1Label.width+2;
  end else begin
    R0Label.caption := 'R0 = '+txt;
    OhmR0Label.left := R0Label.left+R0Label.width+2;
  end;
*)
  {per unit resistance}
  RemoveSpaces(Rpu,txt);               {format}
  pGrid^.cells[2,Rrow] := txt;         {display in grid}
  {reactance, calculate, if input > 0, else use input}
  if (Xx < 0) then begin
    apu := Zz*Zz-Rr*Rr;                {reactance in trafo base}
    if (apu >= 0) then begin           {should be, checked above}
      Xp := sqrt(apu);
      err := 0;
    end else begin
      Xp := 0.01;                      {just some value, not used}
      err := 1;
    end;
  end else begin                       {reactance given as input}
    Xp := Xx;
    err := 0;
  end;
  {show, if no errors}
  if (err = 0) then begin
    Xo := Xp*baseTrZ*0.01;             {reactance in ohms}
    Xpu := Xo/baseZ;                   {pu-reactance}
    RemoveSpaces(Xo,txt);              {format}
    pGrid^.cells[1,Xrow] := txt;       {display in grid}
    {show also in the panel above the imped.grid}
    ShowInOhms(OneOrZero,'X',txt);
(*
    if (OneOrZero = '1') then begin
      X1Label.caption := 'X = '+txt;
      OhmX1Label.left := X1Label.left+X1Label.width+2;
    end else begin
      X0Label.caption := 'X0 = '+txt;
      OhmX0Label.left := X0Label.left+X0Label.width+2;
    end;
*)    
    RemoveSpaces(Xpu,txt);             {format}
    pGrid^.cells[2,Xrow] := txt;       {display in grid}
  end;
end;

procedure TGridForm.UpdateResistance(Zz: single; OneOrZero: char; var Rr,fii : single; var er : integer);
{update the resistance in the impedance grid, when the impedance changes, and
 the phase shift is fixed
 Zz   the magnitude of the impedance
 OneOrZero   flag for pos.seq (1) or zero seq (0)
 Rr   the updated resistance
 fii  the "phase" of the impedance (in degrees)
 er   error flag}
var
  apu,apv : single;   {temporary}
  apw     : single;   {temporary}
  er1     : integer;  {error flag}
//fii     : single;   {phase angle of impedance}
  frow    : integer;  {row for phase}
  ipu     : integer;  {temporary}
  Rrow    : integer;  {row for resistance}
  s1,s2   : string;   {temporary}
  s3,s4   : string;   {temporary}
  txt     : string;   {temporary}
begin
  if (OneOrZero = '1') then begin        {pos.seq.}
    frow := firow;
    Rrow := R1row;
  end else begin                         {zero seq.}
    frow := f0row;
    Rrow := R0row;
  end;
  txt := ImpedGrid.cells[1,frow];        {phase of impedance as text}
  ValuesFromLine(txt, 1, false, ipu, fii, apu, apv, apw, s1,s2,s3,s4,er1);
  if (er1 = 0) then begin
    Rr := Zz*cos(fii*pi/180);            {resistance}
    RemoveSpaces(Rr,txt);                {format}
    ImpedGrid.cells[1,Rrow] := txt;      {display in grid}
    ImpedGrid.color := clWhite;
    er := 0;                             {no error for resistance}
  end else begin
    ImpedGrid.color := clYellow;
    Rr := 1;                             {just some value}
    er := 1;                             {some error in resistance}
  end;
end;

procedure TGridForm.UpdatePhase(Zz: single; OneOrZero: char; var Rr, fii: single; var er: integer);
{update the "phase angle" of the impedance (arc tan R/X), when the magnitude of the impedance
 changes, but the resistive component is fixed
 Zz  the magnitude of the impedance
 OneOrZero  flag for pos.seq (1) or zero seq. (0)
 Rr  the resistance
 er  error flag}
var
  apu,apv : single;   {temporary}
  apw     : single;   {temporary}
  cpu     : complex;  {temporary}
  er1     : integer;  {error flag}
//fii     : single;   {phase angle of impedance}
  frow    : integer;  {row for phase}
  ipu     : integer;  {temporary}
  Rrow    : integer;  {row for resistance}
  s1,s2   : string;   {temporary}
  s3,s4   : string;   {temporary}
  txt     : string;   {temporary}
begin
  if (OneOrZero = '1') then begin        {pos.seq.}
    frow := firow;
    Rrow := R1row;
  end else begin                         {zero seq.}
    frow := f0row;
    Rrow := R0row;
  end;
  txt := ImpedGrid.cells[1,Rrow];        {resistance of impedance as text}
  ValuesFromLine(txt, 1, false, ipu, Rr, apu, apv, apw, s1,s2,s3,s4,er1);
  if (er1 = 0) then begin
    apu := Zz*Zz-Rr*Rr;                  {reactance squared}
    if (apu >= 0) then begin
      apv := sqrt(apu);                  {reactance}
      cpu := cplx(Rr,apv);               {impedance}
      fii := Cangle(cpu)*180/pi;         {angle in degrees}
      RemoveSpaces(fii,txt);             {format}
      ImpedGrid.cells[1,frow] := txt;
      ImpedGrid.color := clWhite;
      er := 0;                           {no error in resistance}
    end else begin                       {error case}
      ImpedGrid.color := clYellow;
      fii := 0;                           {just some value}
      er := 1;                           {some error in resistance}
    end;
  end else begin                         {error}
    er := 1;                             {error in resistance}
    fii := 0;                            {just some value}
    Rr := 1;                             {just some value}
    ImpedGrid.color := clYellow;
  end;
end;

procedure TGridForm.ResistanceFromPhase(fii: single; OneOrZero: char;
                                    var Rr,Zz: single; var er : integer);
{update resistance in the impedance grid, when phase is changed
 fii  phase
 OneOrZero  pos(1) or zero (0) seq.
 Rr   resistance
 Zz   the impedance
 er   error flag}
var
  apu,apv : single;   {temporary}
  apw     : single;   {temporary}
  ipu     : integer;  {temporary}
  Rrow    : integer;  {row for resistance}
  s1,s2   : string;   {temporary}
  s3,s4   : string;   {temporary}
  txt     : string;   {temporary}
  Zrow    : integer;  {row for impedance}
begin
  if (OneOrZero = '1') then begin        {pos.seq.}
    Zrow := Z1row;
    Rrow := R1row;
  end else begin                         {zero seq.}
    Zrow := Z0row;
    Rrow := R0row;
  end;
  txt := ImpedGrid.cells[1,Zrow];        {magnitude of impedance as text}
  ValuesFromLine(txt, 1, false, ipu, Zz, apu, apv, apw, s1,s2,s3,s4,er);
  if (er = 0) then begin
    Rr := Zz*cos(fii*pi/180);            {resistance}
    RemoveSpaces(Rr,txt);                {format}
    ImpedGrid.cells[1,Rrow] := txt;      {display in grid}
    ImpedGrid.color := clWhite;
  end else begin
    ImpedGrid.color := clYellow;         {indicate an error}
  end;
end;

procedure TGridForm.PhaseFromResistance(Rr : single; OneOrZero: char; var Zz: single; var er: integer);
{update the impedance-phase in the impedance grid, when the resistance is changed
 Rr  the resistance
 OneOrZero  pos (1) or zero (0) sequence
 Zz  the impedance
 er  error flag}
var
  apu,apv : single;   {temporary}
  apw     : single;   {temporary}
  cpu     : complex;  {temporary}
  er1,er2 : integer;  {error flag}
  frow    : integer;  {row for phase}
  ipu     : integer;  {temporary}
  s1,s2   : string;   {temporary}
  s3,s4   : string;   {temporary}
  txt     : string;   {temporary}
  Zrow    : integer;  {row for the impedance}
begin
  if (OneOrZero = '1') then begin        {pos.seq.}
    frow := firow;
    Zrow := Z1row;
  end else begin                         {zero seq.}
    frow := f0row;
    Zrow := Z0row;
  end;
  txt := ImpedGrid.cells[1,Zrow];        {magnitude of impedance as text}
  ValuesFromLine(txt, 1, false, ipu, Zz, apu, apv, apw, s1,s2,s3,s4,er1);
  if (er1 = 0) then begin
    if (Zz >= Rr) then begin             {reasonable resistance}
      apu := sqrt(Zz*Zz-Rr*Rr);
      cpu := cplx(Rr,apu);               {impedance as complex}
      apu := Cangle(cpu)*180/pi;         {phase angle in degrees}
      RemoveSpaces(apu,txt);             {format}
      ImpedGrid.cells[1,frow] := txt;    {show in grid}
      ImpedGrid.color := clWhite;
      er2 := 0;
    end else begin
      ImpedGrid.color := clYellow;
      er2 := 1;
    end;
  end else begin
    ImpedGrid.color := clYellow;
    er2 := 0;
  end;
  er := er1+er2;                         {total error}
end;

procedure TGridForm.getZRX(Zrow,Rrow: integer; var Zz,Rr,Xx: single; var er1,er2,er3: integer);
{get impedance, resistance from the impedance grid, calculate reactance
 Zrow   row for impedance (pos or zero seq)
 Rrow   row for resistance
 Zz,Rr,Xx  impedance, resistance reactance
 er1,er2,er3   error flags}
var
  apu,apv : single;   {temporary}
  apw     : single;   {temporary}
  ipu     : integer;  {temporary}
  s1,s2   : string;   {temporary}
  s3,s4   : string;   {temporary}
  txt     : string;   {temporary}
begin
  txt := ImpedGrid.cells[1,Zrow];
  ValuesFromLine(txt, 1, false, ipu, Zz, apu, apv, apw, s1,s2,s3,s4,er1);
  txt := ImpedGrid.cells[1,Rrow];
  ValuesFromLine(txt, 1, false, ipu, Rr, apu, apv, apw, s1,s2,s3,s4,er2);
  if (er1 = 0) and (er2 = 0) then begin
    if (Zz >= Rr) then begin               {reasonable resistance}
      Xx := sqrt(Zz*Zz-Rr*Rr);
      er3 := 0;
    end else begin
      Xx := 0.01;                          {just some value}
      er3 := 1;
    end;
  end else begin
    Xx := 0.01;
    er3 := 1;
  end;
end;

procedure TGridForm.TrafoBaseChange(OneOrZero: char);
{update the impedances in the main grid, when the base variables in the
 impedance grid change
 OneOrZero   pos. (1) or zero (0) sequence}
var
  apu,apv : single;   {temporary}
  apw     : single;   {temporary}
  er1,er2 : integer;  {error flag}
  ipu     : integer;  {temporary}
  s1,s2   : string;   {temporary}
  s3,s4   : string;   {temporary}
  Rr      : single;   {resistance, in % of trafo base}
  Rro,Rrp : single;   {resistance in ohms, in per unit}
  Rrow    : integer;  {row of resistance}
  TR,TX   : integer;  {row of R,X in the main grid}
  txt     : string;   {temporary}
  Xx      : single;   {reactance in %}
  Xxo     : single;   {reactance in ohms}
  Xxp     : single;   {reactance in per unit}
  Zz      : single;   {zero, pos. sequence impedance}
  Zrow    : integer;  {row of impedance}
begin
  {get row indices, for pos. or zero seq. impedances}
  if (OneOrZero = '1') then begin       {pos.sequence}
    Rrow := R1row;
    Zrow := Z1row;
    TR := gTrafo_R1;
    TX := gTrafo_X;
  end else begin                        {zero seq.}
    Rrow := R0row;
    Zrow := Z0row;
    TR := gTrafo_R0;
    TX := gTrafo_X0;
  end;
  {get impedance, resistance, calculate reactance}
  txt := ImpedGrid.cells[1,Zrow];
  ValuesFromLine(txt, 1, false, ipu, Zz, apu, apv, apw, s1,s2,s3,s4,er1);
  txt := ImpedGrid.cells[1,Rrow];
  ValuesFromLine(txt, 1, false, ipu, Rr, apu, apv, apw, s1,s2,s3,s4,er2);
  if (er1 = 0) and (er2 = 0) then begin
    if (Zz >= Rr) then begin               {reasonable resistance}
      Xx := sqrt(Zz*Zz-Rr*Rr);
      Xxo := Xx*baseTrZ*0.01;              {reactance in ohms}
      Rro := Rr*baseTrZ*0.01;              {resistance in ohms}
      RemoveSpaces(Rro,txt);               {format}
      pGrid^.cells[1,TR] := txt;           {resistance in ohms in the main grid}
      ShowInOhms(OneOrZero,'R',txt);       {show also in the impedance grid}
      RemoveSpaces(Xxo,txt);
      pGrid^.cells[1,TX] := txt;           {reactance in ohms in the main grid}
      ShowInOhms(OneOrZero,'X',txt);       {show also in the impedance grid}
      ImpedGrid.color := clWhite;
      {impedances in per unit, in the main table}
      Xxp := Xxo/baseZ;
      RemoveSpaces(Xxp,txt);
      pGrid^.cells[2,TX] := txt;           {reactance in per unit in the main grid}
      Rrp := Rro/baseZ;
      RemoveSpaces(Rrp,txt);               {format}
      pGrid^.cells[2,TR] := txt;           {resistance in per unit in the main grid}
    end else begin
      ImpedGrid.color := clYellow;
    end;
  end else begin
    ImpedGrid.color := clYellow;
  end;
end;

procedure TGridForm.GetZ0(var Z0,R0,X0 : single; var ert : integer);
{get the zero seq. impedance + components from the impedance grid
Z0  magnitude of impedance
R0  resistance
X0  reactance
ert total error}
var
  apu,apv : single;     {temporary}
  apw     : single;     {temporary}
  er1,er2 : integer;    {error flag}
  er3     : integer;    {error flag}
  ipu     : integer;    {temporary}
  s1,s2   : string;     {temporary}
  s3,s4   : string;     {temporary}
  txt     : string;     {temporary}
begin
  txt := ImpedGrid.cells[1,R0row];
  ValuesFromLine(txt, 1, false, ipu, R0, apu, apv, apw, s1,s2,s3,s4,er1);
  txt := ImpedGrid.cells[1,Z0row];
  ValuesFromLine(txt, 1, false, ipu, Z0, apu, apv, apw, s1,s2,s3,s4,er2);
  if (er1 = 0) and (er2 = 0) then begin
    if (Z0 >= R0) then begin
      X0 := sqrt(Z0*Z0-R0*R0);
      er3 := 0;
    end else begin
      X0 := 0.01;   {just some value (should not be needed)}
      er3 := 1;
    end;
  end else begin
    er3 := 1;
    X0 := 0.01;
  end;
  ert := er1+er2+er3;
end;

procedure TGridForm.GetRatio(XorR: char; var q01 : single; var er1: integer);
{get the ratio X0/X1 or R0/R1 from the impedance grid
 XorR   if 'X' then X0/X1, if 'R', then R0/R1
 q01    the ratio
 er1    error flag}
var
  apu,apv : single;     {temporary}
  apw     : single;     {temporary}
  ipu     : integer;    {temporary}
  s1,s2   : string;     {temporary}
  s3,s4   : string;     {temporary}
  txt     : string;     {temporary}
begin
  if (XorR = 'X') then
    txt := ImpedGrid.cells[1,x01row]             {ratio X0/X1 as text}
  else
    txt := ImpedGrid.cells[1,r01row];            {ratio R0/R1 as text}
  ValuesFromLine(txt, 1, false, ipu, q01, apu, apv, apw, s1,s2,s3,s4,er1);
end;

procedure TGridForm.ZeroParFromPosPar(ZorR,XorR: char; z01, Z1,R1,X1: single; var Z0,R0,X0: single;
                                  var er1,er2,er3: integer);
{update Z0, R0, X0 in the impedance grid from Z1 or R1 in the impedance grid
 ZorR   'Z' = editing Z, 'R' = editing R (if editing R, update X0 and R0, else only X0)
 XorR   if 'X' then z01 = X0/X1, if = 'R', then z01 = R0/R1, else not given
 z01    X0/X1 or R0/R1, or not known
 Z1     pos.seq. impedance (%)
 R1     pos.seq. resistance (%)
 X1     pos.seq. reactance (%)
 er1,er2,er3  error flags}
var
  apu,apv : single;     {temporary}
  apw     : single;     {temporary}
  cpu     : complex;    {temporary}
  fi0     : single;     {zero seq. phase}
  ipu     : integer;    {temporary}
  r01     : single;     {R0/R1}
  s1,s2   : string;     {temporary}
  s3,s4   : string;     {temporary}
  txt     : string;     {temporary}
  x01     : single;     {X0/X1}
begin
  {Z1 or R1 edited, (and R1 or Z1 known) r0/r1 and x0/x1 fixed,
   calculate R0 and X0, update Z0}
  if (XorR = 'R') then begin            {R0/R1 given, read X0/X1}
    r01 := z01;
    er1 := 0;
    GetRatio('X', x01, er2);
  end else if (XorR = 'X') then begin   {X0/X1 given, read R0/R1}
    x01 := z01;
    er2 := 0;
    GetRatio('R', r01, er1);
  end else begin                        {read both}
    GetRatio('X', x01, er2);
    GetRatio('R', r01, er1);
  end;
  if (er1 = 0) and (er2 = 0) then begin
    X0 := x01*X1;             {zero seq.reactance, in %}
    R0 := r01*R1;             {zero seq.resistance, in %}
    Z0 := sqrt(X0*X0+R0*R0);
    RemoveSpaces(Z0,txt);   {format}
    ImpedGrid.cells[1,Z0row] := txt;
    {update also zero seq. phase}
    cpu := cplx(R0,X0);
    fi0 := Cangle(cpu)*180/pi;     {zero seq. impedance phase}
    RemoveSpaces(fi0,txt);  {format}
    ImpedGrid.cells[1,f0row] := txt;
    {update R0 if editing Z1 and (pos.seq.) phase selected, or editing R1 }
    if ((PhaseradioBut.checked) and (ZorR = 'Z')) or (ZorR = 'R') then begin
      txt := ImpedGrid.cells[1,r01row];    {r0/r1 as text}
      ValuesFromLine(txt, 1, false, ipu, r01, apu, apv, apw, s1,s2,s3,s4,er3);
      if (er3 = 0) then begin
        R0 := r01*R1;           {zero seq.resistance, in %}
        RemoveSpaces(R0,txt);   {format}
        ImpedGrid.cells[1,R0row] := txt;
      end;
    end else begin
      er3 := 0;                 {must have a value}
    end;
  end;
end;

procedure TGridForm.UpdateZeroPerOne(RorF: char; R1,X1: single; var er: integer);
{update R0/R1 and X0/X1 in the impedance grid, when pos seq. resistance
 and reactance given (in %)
 RorF  if 'R', then pos.seq. radio but.for resistance checked,
       if 'F', then pos.seq. radio but for phase checked
 R1  pos.seq. resistance
 X1  pos.seq. reactance
 er  error flag}
var
  apu : single;  {temporary}
  R0  : single;  {zero seq. resistance}
  X0  : single;  {zero seq. reactance}
  Z0  : single;  {zero seq. impedance}
  txt : string;  {temporary}
begin
  GetZ0(Z0,R0,X0,er);             {read from imped.grid}
  if (er = 0) then begin
    if (X1 > 0) then apu := X0/X1 else apu := 1;
    RemoveSpaces(apu,txt);     {format}
    ImpedGrid.cells[1,x01row] := txt;
    if (RorF = 'F') then begin
      if (R1 > 0) then apu := R0/R1 else apu := 1;
      RemoveSpaces(apu,txt);     {format}
      ImpedGrid.cells[1,r01row] := txt;
    end;
  end;
end;

function TGridForm.EditingImpedRow(OneOrZero: char; par: single): boolean;
{update other rows in the imped.grid and in the main grid, when some
 "component" of the impedance edited
 OneOrZero   pos(1) or zero (0) sequence
 par         the value of the edited parameter (the impedance "component")}
var
  apu,apv : single;     {temporary}
  apw     : single;     {temporary}
  cpu     : complex;    {temporary}
  er1,er2 : integer;    {error flag}
  ere,er3 : integer;    {error flag}
  fii     : single;     {"phase" of the impedance, in degrees}
  fi0     : single;     {zero seq. phase}
  frow    : integer;    {index for phase row}
  imped   : boolean;    {true, if some row in this proc.}
  ipu     : integer;    {temporary}
  pRBut   : TpRadioBut; {pointer to the radio button for resistance}
  pfBut   : TpRadioBut; {pointer to the radio button for phase}
  r01     : single;     {R0/R1}
  R0      : single;     {zero seq. resistance}
  RorF    : char;       {radio but or phase but checked}
  Rr      : single;     {resistance}
  Rrow    : single;     {row for resistance}
  s1,s2   : string;     {temporary}
  s3,s4   : string;     {temporary}
  txt     : string;     {temporary}
  Xx      : single;     {reactance}
  X0      : single;     {zero seq. reactance}
  x01     : single;     {X0/X1}
  Zrow    : integer;    {index for impedance row}
  Zz      : single;     {impedance}
  Z0      : single;     {zero seq. impedance}
begin
  {indices etc depending on sequence}
  if (OneOrZero = '1') then begin       {pos seq.}
    frow := firow;
    Rrow := R1row;
    Zrow := Z1row;
    pRBut := @R1RadioBut;
    pfBut := @PhaseRadioBut;
  end else begin                      {zero seq.}
    frow := f0row;
    Rrow := R0row;
    Zrow := Z0row;
    pRBut := @R0RadioBut;
    pfBut := @Phase0RadioBut;
  end;
  imped := false;                            {initialize}
  {is some "component" of the impedance being edited}
  if (improw = Zrow) then begin              {editing impedance}
    {calculate resistance, or phase, this grid, but only if no errors in impedance}
    if (pfBut^.checked) then begin           {phase fixed, calc. resistance}
      UpdateResistance(par,OneOrZero,Rr,fii,ere);
    end else if (pRbut^.checked) then begin  {resistance fixed, calc. phase}
      UpdatePhase(par,OneOrZero,Rr,fii,ere);
    end else begin
      ere := 1;       {error case (not possible}
    end;
    if (ere = 0) then Xx := par*sin(fii*pi/180) else Xx := 0.01;  {if error, just some value}
    {if pos.seq, must update some zero seq. parameters}
    if (OneOrZero = '1') and (ere = 0) then begin
      {if 0/1 ratio selected (in zero seq.), must update zero seq. impedance, resistance, and phase}
      if (RatioRadioBut.checked) then begin
        ZeroParFromPosPar('Z',' ',1,par,Rr,Xx, Z0,R0,X0,er1,er2,er3);
        {update zero seq. R0 and X0 in the main grid (if no errors)}
        if (er1+er2+er3 = 0) then UpdateRandXinMainGrid('0',Z0,R0,-1);
      end else begin
        {R or phase selected (in zero seq.), update ratio}
        if (R1RadioBut.checked) then RorF := 'R' else RorF := 'F';
        UpdateZeroPerOne(RorF, Rr,Xx, er1);
        er2 := 0; er3 := 0;
      end;
//    {update zero seq. R0 and X0 in the main grid (if no errors)} {not here!}
//    if (er1+er2+er3 = 0) then UpdateRandXinMainGrid('0',Z0,R0);
    end;
    {impedance, resistance, reactance in the main grid, but only if no errors}
    if (ere = 0) then begin
      UpdateRandXinMainGrid(OneOrZero,par,Rr,-1);
    end;
    imped := true;
  {editing phase of impedance}
  end else if (improw = frow) and (pfBut^.checked) then begin
    {resistance, this grid}
    ResistanceFromPhase(par,OneOrZero,Rr,Zz,er1);
    {update impedance also in the main grid}
    if (er1 = 0) then UpdateRandXinMainGrid(OneOrZero,Zz,Rr,-1);
    imped := true;
  {editing resistance}
  end else if (improw = Rrow) and (pRBut^.checked) then begin
    {calculate imped.phase in this grid}
    PhaseFromResistance(par,OneOrZero, Zz,er1);
    {move impedances to the main grid}
    if (er1 = 0) then UpdateRandXinMainGrid(OneOrZero,Zz,par,-1);
    imped := true;
    {if editing pos.seq. (R1), then must update some zero seq.parameters}
    if (OneOrZero = '1') and (er1 = 0) and (Zz >= par) then begin
      Xx := sqrt(Zz*Zz-par*par);
      if (RatioRadioBut.checked) then begin
        {if 0/1 ratio selected (in zero seq.),
         must update zero seq. impedance, resistance, and phase}
        {R1 edited, Z1, x0/x1 and r0/r1 fixed, calculate x1, and then Z0, R0, fii0}
        ZeroParFromPosPar('R',' ',1,Zz,par,Xx,Z0,R0,X0, er1,er2,er3);
        {update zero seq. R0 and X0 in the main grid (if no errors)}
        if (er1+er2+er3 = 0) then UpdateRandXinMainGrid('0',Z0,R0,-1);
      end else begin
       {R or phase selected (in zero seq.), update ratio R0/R1, and X0/X1}
        UpdateZeroPerOne('F',par,Xx, er1);
      end;
    end;
  end;
  EditingImpedRow := imped;
end;

procedure TGridForm.ImpedGridKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
{update related resistances/reactances etc. in this and in the main grid}
{ERROR cases?, alarm with color, or ..??}
var
  apu,apv : single;   {temporary}
  apw     : single;   {temporary}
  chr     : char;     {temporary}
  cpu     : complex;  {temporary}
  err,er1 : integer;  {error flag}
  er2,er3 : integer;  {error flag}
  erx,ere : integer;  {error flag}
  fii     : single;   {phase angle of impedance}
  ipu     : integer;  {temporary}
  par     : single;   {the parameter}
  r01     : single;   {ratio R0/R1}
  R1,R1o  : single;   {resistance in trafo base, in ohms}
  R1p,R0p : single;   {resistance in per unit}
  R0o,R0  : single;   {zero seq. resistance in ohms, in %}
  s1,s2   : string;   {temporary}
  s3,s4   : string;   {temporary}
  txt     : string;   {temporary}
  x01     : single;   {ratio X0/X1}
  X0,X1   : single;   {reactance in %}
  X1o,X0o : single;   {reactance in ohms}
  X1p,X0p : single;   {reactance in per unit}
  Z0,Z1   : single;   {zero, pos. sequence impedance}
  Z0ohm   : single;   {zero seq. impedance in ohms}
begin
  txt := ImpedGrid.cells[1,improw];            {parameter as text}
  ValuesFromLine(txt, 1, false, ipu, par, apu, apv, apw, s1,s2,s3,s4,err);
  if (err = 0) then begin
    {trafo base impedance is changed}
(*
    if (improw = V1row) or (improw = VArow) then begin
      if (par > 0) then begin                    {reasonable parameter}
        {update the local trafo bases}
        if (improw = V1row) then baseTrV1 := par {changing the trafo base voltage}
        else baseTrVA := par;
        baseTrZ := baseTrV1*baseTrV1/baseTrVA;   {new base impedance}
        ShowTrafoBase;
        {update the impedances here or in the main grid, depending on selection}
        if (PerCentRadioBut.checked) then begin  {%Z has priority, change Ohm-values}
          TrafoBaseChange('1');                  {pos.seq}
          TrafoBaseChange('0');                  {zero seq.}
        end else begin                           {Ohm values have priority, change %Z}
          ImpedancesInTrafoBase(fromGrid, R1,X1,R0,X0, err);
        end;
        ImpedGrid.color := clWhite;
        {copy the base to the main grid as pri.voltage or nominal power}
        if (improw = V1row) then begin
          pGrid^.cells[1,gTrafo_V1] := ImpedGrid.cells[1,V1row]; {copy voltage}
          apu := par*0.001/basekV;              {in pu-notation}
          RemoveSpaces(apu,txt);                {format}
          pGrid^.cells[2,gTrafo_V1] := txt;
        end else begin
          {nominal apparent power, index depends on transformer type}
          ipu := theVArow;
          pGrid^.cells[1,ipu] := ImpedGrid.cells[1,VArow]; {copy apparent power}
          apu := 1.e-6*par/baseMVA;             {in pu-notation}
          RemoveSpaces(apu,txt);                {format}
          pGrid^.cells[2,ipu] := txt;
        end;
      end else begin
        ImpedGrid.color := clYellow;             {warning}
      end;
*)
      {editing Z1, R1 or phase 1 (pos.seq.}
    if EditingImpedRow('1', par) then begin
      {nothing more, all was done in the function of the if-statement above}
      {editing zero seq. Z, R or phase}
    end else if EditingImpedRow('0', par) then begin
      {nothing more, all was done in the function above}
      {editing the ratio of impedance}
    end else if ((improw = x01row) or (improw = r01row)) and
                 (RatioRadioBut.checked) then begin
      {get pos.seq. impedance and components}
      getZRX(Z1row,R1row, Z1,R1,X1, er1,er2,er3);
      if (er1+er2+er3 = 0) then begin
        if (improw = x01row) then
          ZeroParFromPosPar('R','X',par,Z1,R1,X1,Z0,R0,X0, er1,er2,er3)
        else if (improw = r01row) then
          ZeroParFromPosPar('R','R',par,Z1,R1,X1,Z0,R0,X0, er1,er2,er3);
        {update zero seq. impedances in the main grid}
        if (er1+er2+er3 = 0) then begin
          UpdateRandXinMainGrid('0',Z0,R0,X0);
        end;
      end else begin
        {}
      end;
    end else begin                           {error case}
      {do nothing}
    end;
  end else begin
    {warning color, unless row not used}
    if (improw <> nurow) then ImpedGrid.color := clYellow;             {because of some error}
  end;
end;

procedure TGridForm.ImpedGridSelectCell(Sender: TObject; Col, Row: Longint;
  var CanSelect: Boolean);
begin
  improw := row;      {save the row index}
//  {indicate the variable to be edited, maybe} {ONLY when editing! after all}
//  if (row = firow) then PhaseRadioBut.checked := true
//  else if (row = R1row) then R1RadioBut.checked := true;
  {editing of the phase or R or... rows is possible, only when selected with the
   radio buttons}
  if (row = R1row) then begin            {row for pos.seq. resistance}
    if (R1RadioBut.checked) then
      ImpedGrid.options := ImpedGrid.options+[goEditing,goAlwaysShowEditor]
    else
      ImpedGrid.options := ImpedGrid.options-[goEditing,goAlwaysShowEditor];
  end else if (row = firow) then begin
    if (PhaseRadioBut.checked) then
      ImpedGrid.options := ImpedGrid.options+[goEditing,goAlwaysShowEditor]
    else
      ImpedGrid.options := ImpedGrid.options-[goEditing,goAlwaysShowEditor];
  end else if (row = R0row) then begin
    if (R0RadioBut.checked) then
      ImpedGrid.options := ImpedGrid.options+[goEditing,goAlwaysShowEditor]
    else
      ImpedGrid.options := ImpedGrid.options-[goEditing,goAlwaysShowEditor];
  end else if (row = f0row) then begin
    if (Phase0RadioBut.checked) then
      ImpedGrid.options := ImpedGrid.options+[goEditing,goAlwaysShowEditor]
    else
      ImpedGrid.options := ImpedGrid.options-[goEditing,goAlwaysShowEditor];
  end else if (row = x01row) or (row = r01row) then begin
    if (RatioRadioBut.checked) then
      ImpedGrid.options := ImpedGrid.options+[goEditing,goAlwaysShowEditor]
    else
      ImpedGrid.options := ImpedGrid.options-[goEditing,goAlwaysShowEditor];
  end else if (row = nurow) then begin  {"not used" row}
      ImpedGrid.options := ImpedGrid.options-[goEditing,goAlwaysShowEditor];
  end else begin           {other rows can be edited}
    ImpedGrid.options := ImpedGrid.options+[goEditing,goAlwaysShowEditor]
  end;
//  {change color of "priority"}
//  if (row = V1row) or (row = VArow) then begin
//    OhmRadioBut.font.color := clRed;
//    PerCentRadioBut.font.color := clRed;
//  end else begin
//    OhmRadioBut.font.color := clBlue;
//    PerCentRadioBut.font.color := clBlue;
//  end;
end;

procedure TGridForm.ImpedGridMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{indicate the variable to be edited, possibly} {NOT so!}
var
  ipu : integer;
begin
//  ipu := y div(ImpedGrid.defaultRowHeight+ImpedGrid.GridLineWidth); {row}
//  if (ipu = firow) then PhaseRadioBut.checked := true
//  else if (ipu = R1row) then R1RadioBut.checked := true;
end;

procedure TGridForm.AmpGridKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
{check and copy the parameters in the main grid}
var
  Amp     : single;   {ampacity}
  apu,apv : single;   {temporary}
  apw     : single;   {temporary}
  err     : integer;  {error flag}
  ipu     : integer;  {temporary}
  s1,s2   : string;   {temporary}
  s3,s4   : string;   {temporary}
  txt     : string;   {temporary}
begin
  txt := AmpGrid.cells[AmpCol,1];            {ampacity limit, in amperes}
  ValuesFromLine(txt, 1, false, ipu, Amp, apu, apv, apw, s1,s2,s3,s4,err);
  if (err = 0) then begin
    pGrid^.cells[1,gTrafo_A1+AmpCol] := txt; {copy to main grid}
    AmpGrid.color := clWhite;
  end else begin
    AmpGrid.color := clYellow;
  end;
end;

procedure TGridForm.AmpGridSelectCell(Sender: TObject; Col, Row: Longint;
  var CanSelect: Boolean);
begin
  ampcol := col;        {save active (selected) column}
end;

procedure TGridForm.ImpedGridDrawCell(Sender: TObject; Col, Row: Longint;
  Rect: TRect; State: TGridDrawState);
var
  txt  : string;  {temporary}
begin
  {oikeastaan ei tarvita joka kerta, vain kun muutos??}
  {grey out the cells that cannot be edited, because of the radio buttons}
  if (col = 1) then begin       {data only on col.1}
    if ((row = R1row)  and    (PhaseRadioBut.checked )) or
       ((row = firow)  and    (R1RadioBut.checked    )) or
       ((row = R0row)  and not(R0RadioBut.checked    )) or
       ((row = f0row)  and not(Phase0RadioBut.checked)) or
       ((row = x01row) and not(RatioRadioBut.checked )) or
       ((row = r01row) and not(RatioRadioBut.checked )) or
       ((row = Z0row)  and    (RatioRadioBut.checked )) or
        (row = nurow)  then begin
      ImpedGrid.canvas.pen.color := clBtnFace;
      ImpedGrid.canvas.brush.color := clBtnFace;
      ImpedGrid.canvas.rectangle(rect.left,rect.top,rect.right,rect.bottom);
//    {copy the resistance or phase or .. from the cell}
//    txt := ImpedGrid.cells[1,row];
//    ImpedGrid.canvas.font.name := 'arial';
//    ImpedGrid.canvas.font.size := 8;
//    ImpedGrid.canvas.font.color := clBlack;
//    ImpedGrid.canvas.font.style := [];
//    ImpedGrid.canvas.TextOut(4+rect.left,rect.top+2,txt);
    end else begin


    end;
  end;
end;

procedure TGridForm.R1RadioButClick(Sender: TObject);
begin
  ImpedGridDrawCell(Sender,1,firow,F1Rect,[]);           {grey out the unselected cell}
  ImpedGrid.cells[1,R1row] := ImpedGrid.cells[1,R1row];  {copy, to return the white}
end;

procedure TGridForm.PhaseRadioButClick(Sender: TObject);
begin
  ImpedGridDrawCell(Sender,1,R1row,R1Rect,[]);           {grey out the unselected cell}
  ImpedGrid.cells[1,firow] := ImpedGrid.cells[1,firow];  {copy, to return the white}
end;

procedure TGridForm.R0RadioButClick(Sender: TObject);
begin
  ImpedGridDrawCell(Sender,1,f0row,F0Rect,[]);           {grey out the unselected cell}
  ImpedGridDrawCell(Sender,1,r01row,r01Rect,[]);
  ImpedGridDrawCell(Sender,1,x01row,x01Rect,[]);
  ImpedGrid.cells[1,R0row] := ImpedGrid.cells[1,R0row];  {copy, to return the white}
  ImpedGrid.cells[1,Z0row] := ImpedGrid.cells[1,Z0row];  {copy, to return the white}
end;

procedure TGridForm.Phase0RadioButClick(Sender: TObject);
begin
  ImpedGridDrawCell(Sender,1,R0row,R0Rect,[]);           {grey out the unselected cell}
  ImpedGridDrawCell(Sender,1,r01row,r01Rect,[]);
  ImpedGridDrawCell(Sender,1,x01row,x01Rect,[]);
  ImpedGrid.cells[1,f0row] := ImpedGrid.cells[1,f0row];  {copy, to return the white}
  ImpedGrid.cells[1,Z0row] := ImpedGrid.cells[1,Z0row];
end;

procedure TGridForm.RatioRadioButClick(Sender: TObject);
begin
  ImpedGridDrawCell(Sender,1,R0row,R0Rect,[]);           {grey out the unselected cell}
  ImpedGridDrawCell(Sender,1,f0row,F0Rect,[]);
  ImpedGridDrawCell(Sender,1,Z0row,Z0Rect,[]);
  ImpedGrid.cells[1,r01row] := ImpedGrid.cells[1,r01row];  {copy, to return the white}
  ImpedGrid.cells[1,x01row] := ImpedGrid.cells[1,x01row];
end;

procedure TGridForm.BaseGridEnter(Sender: TObject);
begin
  AVORadioBut.font.color := clRed;
  PURadioBut.font.color := clRed;
end;

procedure TGridForm.BaseGridExit(Sender: TObject);
begin
  AVORadioBut.font.color := clBlue;
  PURadioBut.font.color := clBlue;
end;

procedure TGridForm.AvopuButClick(Sender: TObject);
begin
  ZperCentButClick(sender);
end;

procedure TGridForm.TrafoBaseGridKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
{update trafo base impedance, and trafo impedances}
var
  apu,apv : single;   {temporary}
  apw     : single;   {temporary}
  err     : integer;  {error flag}
  ipu     : integer;  {temporary}
  par     : single;   {the parameter}
  R1      : single;   {resistance in trafo base, in ohms}
  R0      : single;   {zero seq. resistance in ohms, in %}
  s1,s2   : string;   {temporary}
  s3,s4   : string;   {temporary}
  txt     : string;   {temporary}
  X0,X1   : single;   {reactance in %}
begin
  txt := TrafoBaseGrid.cells[1,baserow];            {parameter as text}
  ValuesFromLine(txt, 1, false, ipu, par, apu, apv, apw, s1,s2,s3,s4,err);
  if (err = 0) then begin
    {trafo base impedance is changed}
    if (par > 0) then begin                    {reasonable parameter}
      {update the local trafo bases}
      if (baserow = V1row) then baseTrV1 := par {changing the trafo base voltage}
      else baseTrVA := par;
      baseTrZ := baseTrV1*baseTrV1/baseTrVA;   {new base impedance}
      ShowTrafoBase;
      {update the impedances here or in the main grid, depending on selection}
      if (PerCentRadioBut.checked) then begin  {%Z has priority, change Ohm-values}
        TrafoBaseChange('1');                  {pos.seq}
        TrafoBaseChange('0');                  {zero seq.}
      end else begin                           {Ohm values have priority, change %Z}
        ImpedancesInTrafoBase(fromGrid, R1,X1,R0,X0, err);
      end;
      TrafoBaseGrid.color := clWhite;
      {copy the base to the main grid as pri.voltage or nominal power}
      if (baserow = V1row) then begin
        pGrid^.cells[1,gTrafo_V1] := TrafoBaseGrid.cells[1,V1row]; {copy voltage}
        apu := par*0.001/basekV;              {in pu-notation}
        RemoveSpaces(apu,txt);                {format}
        pGrid^.cells[2,gTrafo_V1] := txt;
      end else begin
        {nominal apparent power, index depends on transformer type}
        ipu := theVArow;
        pGrid^.cells[1,ipu] := TrafoBaseGrid.cells[1,VArow]; {copy apparent power}
        apu := 1.e-6*par/baseMVA;             {in pu-notation}
        RemoveSpaces(apu,txt);                {format}
        pGrid^.cells[2,ipu] := txt;
      end;
    end else begin
      TrafoBaseGrid.color := clYellow;             {warning}
    end;
  end else begin
    TrafoBaseGrid.color := clYellow;
  end;
end;


procedure TGridForm.TrafoBaseGridSelectCell(Sender: TObject; Col,
  Row: Longint; var CanSelect: Boolean);
begin
  baserow := row;      {save row for key up}
end;

procedure TGridForm.TrafoBaseGridEnter(Sender: TObject);
begin
  OhmRadioBut.font.color := clRed;
  PerCentRadioBut.font.color := clRed;
end;

procedure TGridForm.TrafoBaseGridExit(Sender: TObject);
begin
  OhmRadioBut.font.color := clBlue;
  PerCentRadioBut.font.color := clBlue;
end;

end.
