{ <> }
unit RelCalc;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, StdCtrls, Menus, ExtCtrls, skemadef, routines, EMTP, compdef, utildef;

type
  TRelayCalcForm = class(TForm)
    MeasureBut: TSpeedButton;
    ReferenceBut: TSpeedButton;
    MeasureEdit: TEdit;
    ReferenceEdit: TEdit;
    CurrentLabel: TLabel;
    CurrentEdit: TEdit;
    FaultLabel: TLabel;
    FaultEdit: TEdit;
    CalcBut: TButton;
    TestEdit: TEdit;
    MeasureLabel: TLabel;
    MeasCurrEdit: TEdit;
    CalcLabel: TLabel;
    CoordLabel: TLabel;
    CoordImg: TImage;
    ImpedanceBox: TGroupBox;
    rZaLabel: TLabel;
    rjEdit: TLabel;
    ResEdit: TEdit;
    ReactEdit: TEdit;
    MethodBox: TGroupBox;
    InitBut: TSpeedButton;
    MeasureBox: TComboBox;
    CTmeasLabel: TLabel;
    ReferenceBox: TComboBox;
    CTrefLabel: TLabel;
    ClearBut: TButton;
    RefreshBut: TButton;
    FaultBox: TComboBox;
    FaultLineLabel: TLabel;
    MaxLabel: TLabel;
    TopMenu: TMainMenu;
    FileIndex: TMenuItem;
    ExitItem: TMenuItem;
    OptionsItem: TMenuItem;
    InitialStateItem: TMenuItem;
    ImpedanceItem: TMenuItem;
    TempEdit: TEdit;
    MultiBut: TButton;
    FaultTypeBox: TGroupBox;
    LLLImg: TImage;
    LLImg: TImage;
    LEImg: TImage;
    LLEImg: TImage;
    ThreePhaseBut: TRadioButton;
    LineLineBut: TRadioButton;
    LineEarthBut: TRadioButton;
    LLEBut: TRadioButton;
    SequenceBox: TGroupBox;
    PosSeqBut: TRadioButton;
    NegSeqBut: TRadioButton;
    ZeroSeqBut: TRadioButton;
    PhaseABut: TRadioButton;
    MaxAbcBut: TRadioButton;
    Fault2Box: TComboBox;
    MutualLineLabel: TLabel;
    LineBox: TGroupBox;
    Sect1But: TSpeedButton;
    Sect2But: TSpeedButton;
    Sect3But: TSpeedButton;
    Sect4But: TSpeedButton;
    Sect5But: TSpeedButton;
    Sect6But: TSpeedButton;
    Sect7But: TSpeedButton;
    Sect8But: TSpeedButton;
    OrLineLabel: TLabel;
    FaultShape2: TShape;
    BusShape: TShape;
    BusBox: TGroupBox;
    UpstreamBusBut: TSpeedButton;
    UpstreamBusLabel: TLabel;
    DownstreamBusLabel: TLabel;
    DownstreamBusBut: TSpeedButton;
    UpstreamBusEdit: TEdit;
    DownstreamBusEdit: TEdit;
    LinesBut: TButton;
    LinesCalcBut: TButton;
    MultiZBut: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure CalcButClick(Sender: TObject);
    procedure CurrentEditChange(Sender: TObject);
    procedure ResEditEnter(Sender: TObject);
    procedure ReactEditEnter(Sender: TObject);
    procedure Z012ButClick(Sender: TObject);
    procedure SuppButClick(Sender: TObject);
    procedure IECButClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure MeasureBoxChange(Sender: TObject);
    procedure ReferenceBoxChange(Sender: TObject);
    procedure ClearButClick(Sender: TObject);
    procedure RefreshButClick(Sender: TObject);
    procedure FaultBoxChange(Sender: TObject);
    procedure ExitItemClick(Sender: TObject);
    procedure InitialStateItemClick(Sender: TObject);
    procedure ImpedanceItemClick(Sender: TObject);
    procedure MultiButClick(Sender: TObject);
    procedure ThreePhaseButClick(Sender: TObject);
    procedure LineLineButClick(Sender: TObject);
    procedure LineEarthButClick(Sender: TObject);
    procedure LLEButClick(Sender: TObject);
    procedure Fault2BoxChange(Sender: TObject);
    procedure Sect1ButClick(Sender: TObject);
    procedure Sect2ButClick(Sender: TObject);
    procedure Sect3ButClick(Sender: TObject);
    procedure Sect4ButClick(Sender: TObject);
    procedure Sect5ButClick(Sender: TObject);
    procedure Sect6ButClick(Sender: TObject);
    procedure Sect7ButClick(Sender: TObject);
    procedure Sect8ButClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure LinesButClick(Sender: TObject);
    procedure LinesCalcButClick(Sender: TObject);
    procedure MultiZButClick(Sender: TObject);
  private
    { Private declarations }
    BusList_r    : TList;          {list of all buses}
    Calculate_r  : boolean;        {calculation in progress (calc.button clicked)}
    ConnLines_r  : TList;          {lines connected to a given node, either directly or through other lines}
    ConnDown_r   : TList;          {downstream nodes of lines in ConnList_r}
    ConnList_r   : TList;          {list of lines connected to given (upstream) bus}
    ConnRev_r    : TList;          {if <> nil) connected line line is reversed = connected node = downstream node}
    ConnUp_r     : TList;          {upstream nodes of lines in ConnList_r}
    CurrUp_r     : single;         {upstream "current"}
    CurrDown_r   : single;         {downstream "current"}
    ShortCurr_r  : complex;        {short circuit current, calculated and set in SolveNet of Elplex.pas}
    fm_r,fp_r    : single;         {neg, pos function value}
    Iline_r      : integer;        {index of line, when lines with mutual impedances}
    Imeasi_r     : single;         {imag comp. of prefault current in meas.CT (but when IEC?)}
    Imeasr_r     : single;         {real comp. of prefault current in meas.CT}
    Irefi_r      : single;         {imag comp. of prefault current in ref.CT (but when IEC?)}
    Irefr_r      : single;         {real comp. of prefault current in ref.CT}
    LineData_r   : TList;          {list for line data}
    LineInd_r    : integer;        {index of line, when searching for line}
    LineList_r   : TList;          {list of pointers to tr.lines}
    LineVolt_r   : TList;          {list of pointers to objects for voltages}
    LinkDown_r   : TList;          {downstream nodes of lines in LinkList_r. Network nodes, down wrt buses....}
    {..}                           {..saved as pointers in the list (for simplicity !?)}
    LinkFound_r  : boolean;        {true, when found link of lines from upstr.bus to downstr. bus}
    LinkList_r   : TList;          {list of lines connecting upstr. and downstr. buses }
    LinkRev_r    : TList;          {flags for "reversed" lines in LinkList_r. nil = not reversed}
    LinkUp_r     : TList;          {upstream nodes of lines in LinkList_r. Network nodes, up wrt buses..}
    {..}                           {..saved as pointers in the list (for simplicity !?)}
    LinkVolt_r   : TList;          {list of objects with node voltages}
    Sections_r   : TList;          {list of line sections}
    MutualList_r : TList;          {list of pointers to tr.lines with mutual impedances}
    Unconn_r     : TList;          {temporary list of unconnected nodes of lines with one connected node}
    nNodes_r     : integer;        {total number of (different) nodes of lines connected to given node}
    pDownstr_r   : TpComp;         {pointer to downstream bus}
    pMeasCT_r    : TpComp;         {pointer to measurement current trafo}
    pRefCT_r     : TpComp;         {pointer to reference current trafo}
    pTrLine_r    : TpComp;         {tr.line where fault is}
    pUpstr_r     : TpComp;         {pointer to upstream bus (fault between upstr. and downstr. buses)}
    pFault_r     : TpComp;         {pointer to the fault}
    revers_r     : boolean;        {true, when "reversed" line: fault near CT, when s = 1}
    SetCur_r     : single;         {target current of reference CT}
    Vdw_r        : complex;        {downstream prefault voltage at tr.line where fault}
    Vup_r        : complex;        {upstream ...}
    xm_r         : single;         {x giving negative function value (x = s = relative pos of fault}
    xp_r         : single;         {x giving positive function value}
    xmin_r,xmax_r: single;         {min, max relative pos middle node in tr.line}
    Ztot_r       : complex;        {total impedance of lines connecting the buses}
  public
    { Public declarations }
    procedure SetMeasureCT(ipComp: longint);
    procedure SetReferenceCT(ipComp: longint);
    procedure GetMeasureCT(var ipComp: longint);
    procedure GetReferenceCT(var ipComp: longint);
    procedure SetUpstreamBus(ipComp: longint);
    procedure SetDownstreamBus(ipComp: longint);
    procedure SetTrLine(ipComp: longint; IDline: integer);
    procedure UpdateLineID(IDline: integer);
    function  GetTrLine: longint;
    function  GetIline: integer;
    procedure SetFault(ipComp: longint);
    function  GetFault: longint;
    procedure ClearRelayForm;
    procedure IncreaseFaultImpedance;
    procedure CalculateCurrents(xx: single; var Ira,Ima,xm,xp,fm,fp,ff: single; var MorP : string);
    procedure ShowMeasuredCurrent;
    procedure GetPrefaultRefCTCurrent(var Ir,Ii: single);
    procedure GetPrefaultMeasCTCurrent(var Ir,Ii: single);
    procedure SequenceCurrent(Ia,Ib,Ic: complex; var Iseq: complex);
    procedure GetCTphaseCurr(pComp: TpComp; var Ia,Ib,Ic: complex);
    function  GetPrefVoltage: complex;
    procedure GetLinePar(pComp: TpComp; par: string; var val : single);
    procedure PutMiddlePar(pComp: TpComp; val : single);
    procedure PutFaultOnMutualImpedanceLine(LineID: integer);
    procedure UpdateConnListIf(pComp: TpComp; upnode,j1,j2: integer; pList,pUp,pDown,pRev: TpList);
    procedure AddToConnListIf(upnode: integer; pList, pUp,pDown,pRev: TpList; var added: boolean);
    procedure ListsOfLinesAndBuses;
    procedure ShowLink(found: boolean);
    procedure FindLinesBetweenBuses;
    procedure PrefaultState;
    procedure ReadFaultImpedance;
    procedure IterateFaultPosition;
    procedure FaultDirection(var fdir: string; var fx,fy : integer);
    procedure PutFaultOnNode(px,py : integer);
    procedure InitializeCalculations;
    procedure GetSetCurrent(var SetCur: single; var er: integer);
    procedure PrefaultLineVoltages;
    procedure SavePrefaultLineVoltages;
    procedure LineDataCreate;
    procedure LineDataFree;
    procedure SectionsFree;
    procedure GetPrefaultLineVoltages(ii : integer);
    procedure NodesOfLine(jj: integer; var j1,j2,j3 : integer);
    procedure LineVoltCreate;
    procedure LineVoltFree;
    procedure CopyMutualLineVoltages(pComp: TpComp; Vup,Vdw: array of complex);
    procedure ClearMutualLineVoltageArrays;
    procedure GetUpDownNodes(pComp: TpComp; pUp,pDown: pInteger; var m1,m2: integer);
    procedure GetLineImpedance(pTrLine: TpComp; var Zline: complex);
    procedure FindFaultImpedance(lz : complex);
    procedure SearchFaultImpedance;
    procedure FindLineSections;
    procedure CreateSection(pComp: TpComp; cu,cd, n1,n2: integer; iLine: integer);
    procedure CheckLineSections(iList: longint);
    procedure FindNodeIndices;
    procedure FindConnectedLines(nodeUp,nodeDown: integer; var down: boolean);
    procedure FindLinkBetweenBuses;
    procedure FindUpDownIndices(var iup,idw: integer);
    procedure CalculateFictiveCurrents(Eup: single; iup,idw: integer);
    function  Calculating: boolean;
    procedure PutShortCurrent(Curr: complex);
    function  GetShortCurrent: complex;
  end;

procedure NoFaultInRelayForm(ipComp: longint); far;

var
  RelayCalcForm: TRelayCalcForm;

implementation

uses Imagopas, elplex, skemproc, LoadFlow, GenVolt, TapChanger, Imagodef,
  AllShort, nodes, Cmatmul, matmul;

{$R *.DFM}

{define object for tr.line data}
type
  TpLineData = ^TLineData;     {define pointer type first !}
  TLineData = class(TObject)
private
  pComp_l  : TpComp;    {pointer to the component (line)}
  Vup_l    : complex;   {prefault voltage at upstream node (upstr. of line)}
  Vdw_l    : complex;   {prefault voltage at downstream node}
end;

{define object for saving node voltages of lines with mutual impedances}
type
  TpLineVolt = ^TLineVolt;
  TLineVolt = class(TObject)
private
  {voltages at upstr. and downstr. nodes. GMutualMax defined in Utildef.pas}
  pComp_n  : TpComp;
  Vuparr_n : array [0..gMutualMax] of complex;  {voltages at upstream nodes}
  Vdwarr_n : array [0..gMutualMax] of complex;
end;

{define object for transmission lines and sections of tr.lines.
 Line: "simple" line with only two nodes
 Section: "simple" line with three nodes, or component of several lines with mutual impedances}
type
  TpLineSection = ^TLineSection;
  TLineSection = class(TObject)
private
  cpUp_c     : integer;  {upstream (wrt buses, network) connecting point (within component)}
  cpDown_c   : integer;  {downstream conn.point}
  pComp_c    : TpComp;   {pointer to the line}
  upstr_c    : integer;  {upstream node (in the network)}
  downstr_c  : integer;  {downstream node}
  faultUp_c  : boolean;  {fault connected to the upstr. node (wrt the component), when searching...}
  iLine_c    : integer;  {index of line, for lines with mutual impedances}
  included_c : boolean;  {temporary, included in link, when collecting}
  inList_c   : boolean;  {flag: is in list of connected lines, when searching for connections}
  inLink_c   : boolean;  {line belongs to the link between buses}
  {nodes of lines are indexed in order of appearance}
  iUp_c      : integer;  {index of upstream node}
  iDown_c    : integer;  {index of downstream node}
  new_c      : boolean;  {flag, when adding to list of connected lines}
  unconn_c   : string;   {flag for node that is not yet connected, 'up', or 'down'}
  Curr_c     : single;   {"current" in line, when searching for connected lines}
  Vup_c      : single;   {upstream voltage}
  Vdown_c    : single;   {downstream voltage}
end;



{position of the fault: upstream node of the line, middle node of the line,
 or downstream node of the line.}
type
  TFaultNode = (up, middle, down);
const
  FaultNode: TFaultNode = middle;       {initialize as middle}

function  TRelayCalcForm.Calculating: boolean;
begin
  Calculating := Calculate_r;
end;

procedure TRelayCalcForm.PutShortCurrent(Curr: complex);
{save the short current. Needed for correcting the CT result, if
 fault connected to the CT, see SumCurr of Skemadef.pas
 Called in SolveNet of Elplex.pas}
begin
  ShortCurr_r := curr;
end;

function  TRelayCalcForm.GetShortCurrent: complex;
{called in SumCurr of Skemadef.pas}
begin
  GetShortCurrent := ShortCurr_r;
end;

procedure TRelayCalcForm.FormHide(Sender: TObject);
begin
  if (not appl_close) and (not SetComp.shut_down) then begin
    Imagoo.RelayCalcItem.checked := false;
    ClearRelayForm;
  end;
end;

procedure TRelayCalcForm.SetMeasureCT(ipComp: longint);
{save the pointer etc. of the clicked CT to be used as the measurement CT
 ipComp  pointer to the CT as integer
 Called in ShowCurrPhasors of CurrPhas}
var
  ix,iy : integer;  {coordinates}
  lbl   : string;   {label of the component}
  pComp : TpComp;   {pointer to the CT}
begin
  pComp := TpComp(ipComp);
  if (pComp <> nil) then begin
    pComp^.GetLabel(lbl,ix,iy);
    MeasureEdit.text := lbl;
    MeasureLabel.caption := 'current at '+lbl;
    MeasureBut.down := false;
    MeasCurrEdit.text := '';
    {reset label font = indication that CT no more selected, but only if CT still exists}
    if (pMeasCT_r <> nil) and (SetComp.pCompList.indexof(pMeasCT_r) >= 0) then begin
      pMeasCT_r^.pLabel_s^.font.color := clGreen;
      pMeasCT_r^.pLabel_s^.font.style := [];
      pMeasCT_r^.pLabel_s^.font.size := 8;
    end;
    {set font = indication that CT selected }
    pComp^.pLabel_s^.font.color := clBlue;
    pComp^.pLabel_s^.font.style := [fsBold];
    pComp^.pLabel_s^.font.size := 10;
  end;
  pMeasCT_r := pComp;
end;

procedure TRelayCalcForm.SetReferenceCT(ipComp: longint);
{save the pointer etc. of the clicked CT to be used as the reference CT
 ipComp  pointer to the CT as integer
 Called in ShowCurrPhasors of CurrPhas}
var
  ix,iy : integer;  {coordinates}
  lbl   : string;   {label of the component}
  pComp : TpComp;   {pointer to the CT}
begin
  pComp := TpComp(ipComp);
  if (pComp <> nil) then begin
    pComp^.GetLabel(lbl,ix,iy);
    ReferenceEdit.text := lbl;
    ReferenceBut.down := false;
    {reset label font = indication that CT no more selected}
    if (pRefCT_r <> nil) and (SetComp.pCompList.indexof(pRefCT_r) >= 0) then begin
      pRefCT_r^.pLabel_s^.font.color := clGreen;
      pRefCT_r^.pLabel_s^.font.style := [];
      pRefCT_r^.pLabel_s^.font.size := 8;
    end;
    {set font = indication that CT selected }
    pComp^.pLabel_s^.font.color := clGreen;
    pComp^.pLabel_s^.font.style := [fsBold];
    pComp^.pLabel_s^.font.size := 10;
  end;
  pRefCT_r := pComp;
end;

procedure TRelayCalcForm.GetMeasureCT(var ipComp: longint);
begin
  ipComp := longint(pMeasCT_r);
end;

procedure TRelayCalcForm.GetReferenceCT(var ipComp: longint);
begin
  ipComp := longint(pRefCT_r);
end;

function TRelayCalcForm.GetFault: longint;
begin
  GetFault := longint(pFault_r);
end;

procedure TRelayCalcForm.SetUpstreamBus(ipComp: longint);
{save the pointer (etc) of the clicked bus as the upstream bus.
 (The fault is between the upstream and downstream buses)
 Called in ShowVoltPhasors of voltphas.pas}
var
  ix,iy : integer;  {coordinates}
  lbl   : string;   {label of the component}
  pComp : TpComp;   {pointer to the bus}
begin
  pComp := TpComp(ipComp);
  if (pComp <> nil) then begin        {pointer to the bus}
    pComp^.GetLabel(lbl,ix,iy);
    UpstreamBusEdit.text := lbl;
    UpstreamBusBut.down := false;
    pUpstr_r := pComp;
  end;
end;

procedure TRelayCalcForm.SetDownstreamBus(ipComp: longint);
{save the pointer (etc) of the clicked bus as the upstream bus.
 (The fault is between the upstream and downstream buses)
 Called in ShowVoltPhasors of voltphas.pas}
var
  ix,iy : integer;  {coordinates}
  lbl   : string;   {label of the component}
  pComp : TpComp;   {pointer to the bus}
begin
  pComp := TpComp(ipComp);
  if (pComp <> nil) then begin        {pointer to the bus}
    pComp^.GetLabel(lbl,ix,iy);
    DownstreamBusEdit.text := lbl;
    DownstreamBusBut.down := false;
    pDownstr_r := pComp;
  end;
end;

procedure TRelayCalcForm.SetFault(ipComp: longint);
{set the pointer to the fault
 ipComp  pointer to the fault, as integer
 Called in ToRelayCalc of Skemproc.pas, after clicking (moving) a fault}
begin
  pFault_r := TpComp(ipComp);
end;

procedure TRelayCalcForm.SetTrLine(ipComp: longint; IDLine: integer);
{save the data of the transmission line, where  the fault is
 called in ToRelayCalc of Skemproc.pas}
var
  jx,jy : integer; {coordinates}
  lbl   : string;  {label of the line}
  pComp : TpComp;  {pointer to the line}
begin
  pComp := TpComp(ipComp);
  if (pComp <> nil) then begin             {line found}
    pComp^.GetLabel(lbl,jx,jy);            {label (name) of the component}
    RelayCalcForm.FaultEdit.text := lbl;
    pTrLine_r := pComp;
    Iline_r := IDLine;                     {index of line}
  end else begin
    RelayCalcForm.FaultEdit.text := '??';  {line not found}
    pTrLine_r := nil;
  end;
end;

procedure TRelayCalcForm.UpdateLineID(IDline: integer);
{when a new line is selected with buttons in the component "lines with mutual impedances",
 the identifier of the line must be updated}
begin
  Iline_r := IDline;
end;

function TRelayCalcForm.GetTrLine: longint;
{get the pointer to the tr.line where the fault is
 ipComp  pointer to the line, as integer}
begin
  GetTrLine := longint(pTrLine_r);
end;

function TRelayCalcForm.GetIline: integer;
{get the index of the line, if lines with mutual impedance}
begin
  GetIline := ILine_r;
end;

procedure TRelayCalcForm.GetLinePar(pComp: TpComp; par: string; var val : single);
{get the value of the given parameter for a transmission line, or for tr.line with
 (zero seq.) mutual impedance
 pComp  pointer to the line
 par    type of the parameter:
        'middle' = relative position of the middle node
        'length' = length of line
        'RpL'    = resistance/length
        'XpL'    = reactance/length
 val    value of the parameter}
var
  fpar : integer;   {index of first (usual) parameter of the line with mutual impedances}
  ipar : integer;   {index of parameter}
  name : string;    {name = type of the component}
begin
  if (pComp <> nil) then begin
    if (isTLine(pComp)) then begin               {ordinary transmission line}
      if (par = 'middle') then                 {relative position of the middle node}
        ipar := gTrLiS_s1
      else if (par = 'length') then            {length of line}
        ipar := gTrLiS_len
      else if (par = 'RpL') then               {resistance/length}
        ipar := gTrLiS_R
      else if (par = 'XpL') then               {reactance/length}
        ipar := gTrLiS_X
      else
        ipar := 1;                             {error, just some value (?)}
      pComp^.getPar(ipar,val);
    end else begin                               {other, probably line with mutual impedance}
      pComp^.GetName(name);                      {name = type of the component}
      if (name = gMutual) then begin             {line(s) with mutual impedances}
        fpar := gMutuStrt+(Iline_r-1)*gMutuNpar;
        if (par = 'middle') then                 {relative position of the middle node}
          ipar := gMutuStrt-1
        else if (par = 'length') then            {length of line}
          ipar := fpar
        else if (par = 'RpL') then               {resistance/length}
          ipar := fpar+1
        else if (par = 'XpL') then               {reactance/length}
          ipar := fpar+2
        else
          ipar := 1;                             {error, just some value (?)}
        pComp^.getPar(ipar,val);
      end;
    end;
  end else begin                                 {error}
    val := 1;                                    {just some value}  
  end;
end;

procedure TRelayCalcForm.PutMiddlePar(pComp: TpComp; val : single);
{put the relative position of the middle node for a transmission line, or for tr.line with
 (zero seq.) mutual impedance
 pComp  pointer to the line
 val    value of the parameter}
var
  name : string;    {name = type of the component}
begin
  if (pComp <> nil) then begin
    if (isTLine(pComp)) then begin               {ordinary transmission line}
      pComp^.putPar(gTrLiS_s1,val);
    end else begin                               {other, probably line with mutual impedance}
      pComp^.GetName(name);                      {name = type of the component}
      if (name = gMutual) then begin             {line(s) with mutual impedances}
        pComp^.putPar(gMutuStrt-1,val);
      end;
    end;
  end;
end;

function TRelayCalcForm.GetPrefVoltage: complex;
{get the prefault voltage at the location of the fault =
 somewhere along the transmission line. Calculate it as weighed
 average of the voltages at the endpoints
 Called in AllShort and Elplex.pas}
var
  cpu,cpv,cpw : complex;   {temporary}
  s1          : single;    {relative location of the midpoint (fault)}
begin
  {voltage in the node, where the fault is}
  if (FaultNode = middle) then begin
    {get relative position of the midpoint. Not the original (mostly),
     but the one that was set in the iterations}
    GetLinePar(pTrLine_r, 'middle', s1);
    {voltage as weighed average of the voltages at the endpoints}
    cpu := CRmult(1-s1,Vup_r);
    cpv := CRmult(s1,Vdw_r);
    cpw := Cadd(cpu,cpv);
    GetPrefVoltage := cpw;
  end else if (FaultNode = up) then begin  {upstream node ( = upstream for the component)}
    GetPrefVoltage := Vup_r;
  end else if (FaultNode = down) then begin {downstream node}
    GetPrefVoltage := Vdw_r;
  end;
end;

procedure TRelayCalcForm.ClearMutualLineVoltageArrays;
{initialize = clear the arrays needed for saving (temporarily) the voltages of lines
 with mutual impedances
 Called in ResultsToComp of Elplex.pas}
var
  ii,jj : integer;     {index}
  pLV   : TpLineVolt;  {pointer to object for saving the voltages}
begin
  {clear arrays}
  if (LineVolt_r.count > 0) then begin
    for ii := 0 to LineVolt_r.count-1 do begin
      pLV := LineVolt_r[ii];
      pLV^.pComp_n := nil;
      for jj := 0 to gMutualMax do begin
        pLV^.VupArr_n[jj] := cplx(0,0);
        pLV^.VdwArr_n[jj] := cplx(0,0);
      end;
    end;
  end;
end;

procedure TRelayCalcForm.CopyMutualLineVoltages(pComp: TpComp; Vup,Vdw: array of complex);
{copy the voltages of the lines of the mutual impedance-component to "local" array,
 if the some of the lines of the component is in the link between the buses.
 The copying is done at every solution of the net. The voltages must thus be
 saved to more permanent way after the prefault calculation, in ...
 Called in MutualRes of Elplex.pas
 NOTE: the arrays must be cleared before this procedure is called for the first line
       Clearing is done in ClearMutualLineVoltageArrays called in ResultsToComp of Elplex.pas
 pComp     pointer to the line-component
 Vup, Vdw  arrays where the voltages are collected, done in Mutualres of Elplex.pas}
var
  apu    : single;      {temporary}
  ii,jj  : integer;     {index}
  indx   : integer;     {index of component in link, if it is there}
  inList : boolean;     {component in list}
  nl     : integer;     {number of lines in this component}
  pLV    : TpLineVolt;  {pointer to object for saving the voltages}
begin
  {first, check is this component in the link between the buses}
  indx := LinkList_r.IndexOf(pComp);
  if (indx >= 0) then begin                     {is in the list}
    {is the voltages of this line already saved = is the line in this list}
    inList := false;
    pComp^.GetPar(1,apu);                       {parameters are single's}
    nl := round(apu);                           {number of lines in this component}
    if (LineVolt_r.count > 0) then begin        {objects exist (created in ..)}
      for ii := 0 to LineVolt_r.count-1 do begin
        pLV := LineVolt_r[ii];
        if (pLV^.pComp_n <> nil) then begin
          if (pLV^.pComp_n = pComp) then begin
            inList := true;                     {component in list, voltages saved}
            break;
          end;
        end else begin                          {first free object}
          if (not inList) then begin            {should not be, else cannot be here!?}
            for jj := 1 to nl do begin          {all lines of the component}
              pLV^.pComp_n := pComp;            {add (copy) component to list}
              pLV^.VupArr_n[jj] := Vup[jj];     {copy voltages here.., later, moved on..}
              pLV^.VdwArr_n[jj] := Vdw[jj];
            end;
            break;
          end;
        end;
      end;
    end;
  end;
end;

procedure TRelayCalcForm.FormCreate(Sender: TObject);
begin
  pMeasCT_r := nil;         {pointer to measurement current trafo}
  pRefCT_r  := nil;         {pointer to reference current trafo}
  pFault_r := nil;
  pTrLine_r := nil;
  pUpstr_r := nil;
  pDownstr_r := nil;
  Irefi_r := 0;             {prefault current in ref.CT}
  Irefr_r := 0;
  Imeasi_r := 0;
  Imeasr_r := 0;
  Calculate_r := false;
  {add flag that form created}
  Imagoo.ReadyEdit.text := Imagoo.ReadyEdit.text+'R';
  TempEdit.text := floattostr(gssmax);
  {create lists for tr.lines}
  LineData_r := TList.create;
  LineList_r := TList.create;
  LineVolt_r := TList.create;
  MutualList_r := TList.create;
  ConnList_r := TList.create;
  ConnUp_r := TList.create;
  ConnDown_r := TList.create;
  ConnRev_r := TList.create;
  LinkList_r := TList.create;
  LinkUp_r := TList.create;
  LinkDown_r := TList.create;
  LinkRev_r := TList.create;
  LinkVolt_r := TList.create;
  BusList_r := TList.create;
  Sections_r := TList.create;
  ConnLines_r := TList.create;
  Unconn_r := TList.create;
  {hide buttons etc. that are not needed any more}
  height := BusShape.top+height-ClientHeight;
end;

procedure TRelayCalcForm.GetLineImpedance(pTrLine: TpComp; var Zline: complex);
{get the impedance of the given line. Neglect the capacitance(s)
 pTrLine  pointer to the line
 Zline    the impedance}
const
  Zmin = 0.001;      {minimum impedance}
var
  apu,apv : single;  {temporary}
  len     : single;  {length of the line}
  Rline   : single;  {resistance}
  Xline   : single;  {reactance}
begin
  GetLinePar(pTrLine, 'length', len);
  GetLinePar(pTrLine, 'RpL', apu);
  GetLinePar(pTrLine, 'XpL', apv);
  Rline := apu*len;                        {resistance of line}
  Xline := apv*len;                        {reactance of line}
  if (Xline > Zmin) or (Rline > Zmin) then begin
    Zline := cplx(Rline,Xline);            {line impedance}
  end else begin
    Zline := cplx(0,Zmin);
  end;
end;

procedure TRelayCalcForm.FindFaultImpedance(lz : complex);
{if the set current is too small, a solution is not found for the fault position.
 In that case, the fault impedance is increased until a solution is found.
 The fault impedance is set eqal to the impedance of the line(s) multiplied by
 some unknown multiplier. The unknown multiplier is solved iteratively.
 lz  the impedance of the line(s).}
const
  niter = 20;         {max. no of iterations}
var
  ff      : single;   {function value}
  fm,fp   : single;   {neg,pos function value. Function = abs.value of current at... }
  {.}                 {...the ref CT minus current setting (in the current edit)}
  ii      : integer;  {index}
  Ima,Ira : single;   {abs.value of measured current, ref.current}
  iter    : integer;  {index for iterations}
  MorP    : string;   {fm or fp changed}
  xm,xp   : single;   {brackets for unknown for neg, pos function value}
  xx      : single;   {unknown = multiplier for line impedance}
begin
  fp := fp_r;                              {pos. function should be the same as before}
  xp := 0;                                 {no additional impedance at pos.function}
  {find the other bracket. Increase impedance, until function negative}
  xx := 0.5;                               {initial guess}
  xm := -1;                                {initialize, negative as a flag}
  for ii := 1 to 20 do begin
    xx := 2*xx;
    SetComp.fault_imped := Crmult(xx,lz);  {xx times original line impedance}
    {calculate function value}
    CalculateCurrents(xx,Ira,Ima,xm,xp,fm,fp,ff,MorP);
    if (xm > 0) then break;                {other bracket found}
  end;
  {continue only, if both brackets found}
  if (xm > 0) then begin
    {find the root = impedance where the reference current = set current (target)}
    for iter :=1 to niter do begin
      xx := 0.5*(xp+xm);
      SetComp.fault_imped := Crmult(xx,lz);  {xx times original line impedance}
      {calculate new function value = short circuit calculation}
      CalculateCurrents(xx,Ira,Ima,xm,xp,fm,fp,ff,MorP);
      testEdit.text := inttostr(iter);
      testEdit.refresh;
    end;
    ShowMeasuredCurrent;     {current at the measurement CT}
    {show currents at the ref. and meas CT, in diagram}
    ShowCurrRes(pRefCT_r,imagoo.ShowCurrBut.caption);          {show the desired phase of the current, in Elplex.pas}
    ShowCurrRes(pMeasCT_r,imagoo.ShowCurrBut.caption);
  end else begin
    {..bracket not found. What now? ...}
  end;
end;

procedure TRelayCalcForm.IncreaseFaultImpedance;
{If end of zone not found, the search may be continued by increasing the fault
 impedance.
 "End of zone not found" = fault is at the far end of the line, but the
  current measured by the reference CT is still larger than the Current Setting.
 In that case, increase the fault impedance until the current measured by the
 reference CT is equal to the Current Setting.
 For this searh, the (old) positive function value fp_r must be known (obtained with
 xp_r = nearly 1 (i.e. relative fault position) in normal case, or = nearly 0,
 if transmission line reversed}
var
  fz0     : complex;  {old fault impedance}
  lz      : complex;  {line impedance}
  rPos    : single;   {original relative position of the middle node of the tr.line}
begin
  {line exists, pos. bracket found = solution searched but not found}
  if (pTrLine_r <> nil) and (fp_r > 0) and (xp_r > 0) then begin
    {save the original relative position of node in tr.line}
    GetLinePar(pTrLine_r, 'middle', rPos);
    {get impedance of the line, where the fault is}
    GetLineImpedance(pTrLine_r,lz);
    fz0 := SetComp.fault_imped;         {save present fault impedance}
    {set the (relative) position of the fault to end of the line}
    if (revers_r) then PutMiddlePar(pTrLine_r, gssmin)  {reversed line, put to the start of the line}
    else PutMiddlePar(pTrLine_r, gssmax);               {gssmin, max defined in imagodef.pas}
    {find the fault impedance that gives the set current}
    FindFaultImpedance(lz);
    {return the original relative position of node in tr.line}
    PutMiddlePar(pTrLine_r, rPos);
  end else begin    {transmission line not defined}
    {??}
  end;
end;

procedure TRelayCalcForm.ShowMeasuredCurrent;
{show the current at the measurement CT using the measure edit}
var
  apu      : single;
  Ia,Ib,Ic : complex;   {phase currents}
  Js       : complex;   {imag., real component of the measured current}
begin
  if (ThreePhaseBut.checked) then begin     {three-phase fault}
    pMeasCT_r^.GetVar(gCurr_Ir,Js.x);       {real part of current at ref.current trafo}
    pMeasCT_r^.GetVar(gCurr_Ii,Js.y);
  end else begin                            {asymm.fault}
    GetCTphaseCurr(pMeasCT_r,Ia,Ib,Ic);
    SequenceCurrent(Ia,Ib,Ic,Js);           {select sequence current}
  end;
  apu := Cabs(Js);                        {measured current}
  {show current}
  MeasCurrEdit.text := TenChar(apu);        {in Emtp.pas}
end;

procedure TRelayCalcForm.GetPrefaultRefCTCurrent(var Ir,Ii: single);
{get the prefault current at reference current transformer. Needed when asymm.fault,
 in AsymmFault of AllShort.pas}
begin
  Ir := Irefr_r;
  Ii := Irefi_r;
end;

procedure TRelayCalcForm.GetPrefaultMeasCTCurrent(var Ir,Ii: single);
{get the prefault current at reference current transformer. Needed when asymm.fault,
 in AsymmFault of AllShort.pas}
begin
  Ir := Imeasr_r;
  Ii := Imeasi_r;
end;

procedure TRelayCalcForm.GetCTphaseCurr(pComp: TpComp; var Ia,Ib,Ic: complex);
{Get the phase currents of a current transformer
 pComp     pointer to the CT
 Ia,Ib,Ic  the phase currents}
var
  nv : integer;  {number of variables}
begin
  if (pComp <> nil) then begin
    pRefCT_r^.GetNvar(nv);               {number of variables in current trafo (for one phase)}
    {currents of reference CT}
    pComp^.GetVar(gCurr_Ir,Ia.x);
    pComp^.GetVar(gCurr_Ii,Ia.y);
    pComp^.GetVar(gCurr_Ir+nv,Ib.x);
    pComp^.GetVar(gCurr_Ii+nv,Ib.y);
    pComp^.GetVar(gCurr_Ir+2*nv,Ic.x);
    pComp^.GetVar(gCurr_Ii+2*nv,Ic.y);
  end else begin
    Ia := cplx(0,0); Ib := cplx(0,0); Ic := cplx(0,0);
  end;
end;

procedure TRelayCalcForm.SequenceCurrent(Ia,Ib,Ic: complex; var Iseq: complex);
{calculate the sequence current (pos,neg or zero) according to the sequence buttons
 Ia,Ib,Ic  phase currents
 Iseq      the selected sequence current}
var
  aa,ab,ac : single;    {abs.value of current}
  Ip,Im,Iz : complex;   {sequence currents}
begin
  PhaseToSeq(Ia,Ib,Ic,Ip,Im,Iz);
  {select sequence current}
  if (PosSeqBut.checked) then begin           {positive sequence}
    Iseq := Ip;
  end else if (NegSeqBut.checked) then begin  {negative sequence}
    Iseq := Im;
  end else if (ZeroSeqBut.checked) then begin {zero sequence}
    Iseq := Crmult(3.0,Iz);
  end else if (PhaseABut.checked) then begin  {phase a}
    ISeq := Ia;
  end else if (MaxAbcBut.checked) then begin  {largest phase current}
    aa := Cabs(Ia);
    ab := Cabs(Ib);
    ac := Cabs(Ic);
    if (aa > ab) then begin
      if (aa > ac) then Iseq := Ia else Iseq := Ic;
    end else begin
      if (ab > ac) then Iseq := Ib else Iseq := Ic;
    end;
  end else begin                              {error, se pos.seq.  }
    Iseq := Ip;
  end;
end;

procedure TRelayCalcForm.CalculateCurrents(xx: single; var Ira,Ima,xm,xp,fm,fp,ff: single;
                                           var MorP : string);
{solve the net (with fault), and calculate the function value
 function = current at reference CT - "target" current of refere ce CT
 xx   the present guess for the unknown (may refer to different variables...
 Ira  abs. value of reference current
 Ima  abs. value of measured current
 xm,xp   values of unknown for neg, pos function values
 fm,fp   neg. and pos. function values
 ff      function value at this calculation
 MorP    'p' = positive value of function updated, 'm' = neg.value updated}
var
  apu      : single;    {temporary}
  cpu      : complex;   {temporary}
  fault    : string;    {type of fault}
  Ii ,Ir   : single;    {imag.,real components of reference current}
  Imi,Imr  : single;    {imag., real components of reference current}
  ma,mb,mc : complex;   {phase currents of measurement CT}
  mp,mn,mz : complex;   {sequence currents of measurement}
  nv       : integer;   {number of variables}
  ra,rb,rc : complex;   {phase currents of reference CT}
  rp,rn,rz : complex;   {sequence currents of reference CT}
begin
  {check fault type}
  if (ThreePhaseBut.checked) then fault := 'LLL'
  else if (LineLineBut.checked) then fault := 'LL'
  else if (LineEarthBut.checked) then fault := 'LE'
  else if (LLEBut.checked) then fault := 'LLE'
  else fault := 'LLL';
  {put the reference and measurement CT's, needed when asymmetric faults (AsymmFaults, below)}
  AllShortForm.PutRefAndMeasCT(pRefCT_r,pMeasCT_r);
  {only superposition available (no more IEC-calculation)}
//if (SuppBut.checked) then begin     {superposition}
  SetComp.Appl_Type := SuperpOne;
  if (fault = 'LLL') then begin                         {3-phase = LLL fault}
    SolveNet(imagopas.ipSetG,InitBut.down, Superpos);   {3-phase fault}
  end else begin                                        {asymm.fault}
    AllShortForm.AsymmFaults(ipSetg,fault, Superpos);   {in AllShort.pas}
  end;
//end else begin                      {IEC-calculation}
//  SetComp.Appl_Type := std;
//  SolveNet(imagopas.ipSetG, false, IECFault);        {3-phase fault, IEC-calculation}
//end;
  {if three phase fault, get the currents as such}
  if (fault = 'LLL') then begin
    pRefCT_r^.GetVar(gCurr_Ir,Ir);        {real part of current at ref.current trafo}
    pRefCT_r^.GetVar(gCurr_Ii,Ii);
    pMeasCT_r^.GetVar(gCurr_Ir,Imr);      {real part of current at measurement current trafo}
    pMeasCT_r^.GetVar(gCurr_Ii,Imi);
  end else begin
    {...but if asymm.fault, need phase or sequence currents }
    AllShortForm.GetCTcurr(ma,mb,mc,ra,rb,rc);
    {put to current transformers ....(not good...?!)}
    pRefCT_r^.GetNvar(nv);               {number of variables in current trafo (for one phase)}
    {currents of reference CT}
    pRefCT_r^.PutVar(gCurr_Ir,ra.x);
    pRefCT_r^.PutVar(gCurr_Ii,ra.y);
    pRefCT_r^.PutVar(gCurr_Ir+nv,rb.x);
    pRefCT_r^.PutVar(gCurr_Ii+nv,rb.y);
    pRefCT_r^.PutVar(gCurr_Ir+2*nv,rc.x);
    pRefCT_r^.PutVar(gCurr_Ii+2*nv,rc.y);
    pRefCT_r^.ShowResults;               {display currents}
    {currents of measurement CT}
    pMeasCT_r^.PutVar(gCurr_Ir,ma.x);
    pMeasCT_r^.PutVar(gCurr_Ii,ma.y);
    pMeasCT_r^.PutVar(gCurr_Ir+nv,mb.x);
    pMeasCT_r^.PutVar(gCurr_Ii+nv,mb.y);
    pMeasCT_r^.PutVar(gCurr_Ir+2*nv,mc.x);
    pMeasCT_r^.PutVar(gCurr_Ii+2*nv,mc.y);
    pMeasCT_r^.ShowResults;
    {measurement sequence current, according to selected seq.}
    SequenceCurrent(ma,mb,mc,cpu);
    Imr := cpu.x;
    Imi := cpu.y;
    {reference sequence current, according to selected seq.}
    SequenceCurrent(ra,rb,rc,cpu);
    Ir := cpu.x;
    Ii := cpu.y;
  end;
  Ima := sqrt(Imr*Imr+Imi*Imi);       {abs.value of measured current}
  Ira := sqrt(Ir*Ir+Ii*Ii);           {abs.value of ref.current}
  apu := Ira-SetCur_r;                {function value}
  ff := apu;
  if (apu >= 0) then begin            {bracket with positive function value found}
    xp := xx;
    fp := apu;
    MorP := 'p';                      {pos. value of function changed}
  end else if (apu < 0) then begin
    xm := xx;
    fm := apu;
    MorP := 'm';                      {neg. value of function changed}
  end;
  AllShortForm.PutRefAndMeasCT(nil,nil); {reset pointers to ref. and meas. CT, as a flag}
end;

procedure TRelayCalcForm.PrefaultLineVoltages;
{get the prefault voltage at the ends of the transmission line, where the fault is
 (After the calculation of the prefault state, of course...!!)}
begin
  if (isTLine(pTrLine_r)) then begin                      {"ordinary" transmission line}
    pTrLine_r^.GetVar(gTrLiS_V1r,Vup_r.x);                {real comp. of upstream voltage}
    pTrLine_r^.GetVar(gTrLiS_V1i,Vup_r.y);
    pTrLine_r^.GetVar(gTrLiS_V2r,Vdw_r.x);                {real comp. of downstream voltage}
    pTrLine_r^.GetVar(gTrLiS_V2i,Vdw_r.y);
  end else begin                                          {tr.ine with mutual impedance}
    Vup_r.x := pTrLine_r^.var3_s;                         {saved in elplex.pas}
    Vup_r.y := pTrLine_r^.var4_s;
    Vdw_r.x := pTrLine_r^.var5_s;
    Vdw_r.y := pTrLine_r^.var6_s;
  end;
end;

procedure TRelayCalcForm.SavePrefaultLineVoltages;
{after solving the net, must save the voltages at the ends of the tr.lines
 between the upstream and downstream buses, as prefault voltages
 The voltages are put Var3_s...Var6_s in elplex for simple lines, and
 in CopyMutualLineVoltages for lines-comp. with mutual impedances}
var
  apu     : single;     {temporary}
  er1,er2 : integer;    {error flags}
  ii,jj   : integer;    {index}
  j1,j2   : integer;    {up- and downstr. connecting points (nodes)}
  j3      : integer;    {middle connecting point(node). Hardly needed}
  kk      : integer;    {index}
  m1,m2   : integer;
  nl      : integer;    {number of lines}
  n1,n2   : integer;    {nodes}
  pComp   : TpComp;     {pointer to a line}
  pLDat   : TpLineData; {pointer to object for saving the data}
  pLVolt  : TpLineVolt; {pointer to object for saving the voltages}
  rev     : boolean;    {reversed line (upstr. and downstr of the line <> up and down for buses}
  Vfound  : boolean;    {voltages found}
  Vdw     : complex;    {downstr. voltage (down for the line)}
  Vup     : complex;    {upstr. voltage}
begin
  if (LinkList_r.count > 0) then begin
    for ii := 0 to LinkList_r.count-1 do begin
      pComp := LinkList_r[ii];
      {"simple" line, voltages saved in var3_s etc}
      if (isTLine(pComp)) then begin
        Vup.x := pComp^.Var3_s;
        Vup.y := pComp^.Var4_s;
        Vdw.x := pComp^.Var5_s;
        Vdw.y := pComp^.Var6_s;
        Vfound := true;
      end else begin                    {line with mutual impedance}
        {several lines and thus, nodes in one component}
        GetUpDownNodes(pComp,LinkUp_r[ii],LinkDown_r[ii], m1,m2);
        rev := (LinkRev_r[ii] <> nil);  {non-nil pointer used as flag for reversed line}
        {must find to which line these nodes belong}
        pComp^.getPar(1,apu);
        nl := round(apu);               {number of lines in this component}
        Vup := cplx(0,0);
        Vdw := cplx(0,0);
        {find the component in the list for lines with mutual imp.}
        Vfound := false;
        if (LineVolt_r.count > 0) then begin
          for kk := 0 to LineVolt_r.count-1 do begin       {all objects saving line voltages}
            pLVolt := LineVolt_r[kk];
            if (pLVolt.pComp_n = pComp) then begin         {component (with several lines) found?}
              {must still find the line in this component that has the same nodes}
              for jj := 1 to nl do begin
                NodesOfLine(jj, j1,j2,j3);                 {get nodes}
                pComp^.getNode(j1,n1,er1);                 {upstream node of this line}
                pComp^.GetNode(j2,n2,er2);
                if (er1 = 0) and (er2 = 0) then begin
                  if ((n1 = m1) and (n2 = m2)) or          {given nodes, not reversed}
                     ((n1 = m2) and (n2 = m1)) then begin
                    Vup := pLVolt^.Vuparr_n[jj];           {upstr.voltage}
                    Vdw := pLVolt^.Vdwarr_n[jj];
                    Vfound := true;
                    break;
                  end;
                end;
              end;
              if (Vfound) then break;
            end;
          end;
        end;
      end;
      {save data to a separate object for data}
      if (Vfound) then begin
        pLdat := LineData_r[ii];          {object for saving data}
        pLdat^.Vup_l := Vup;
        pLdat^.Vdw_l := Vdw;
      end else begin
        {?}
      end;
    end;
  end;
end;

procedure TRelayCalcForm.GetPrefaultLineVoltages(ii : integer);
{get the prefault voltages at the ends of the line under study,
 index ii in LinkList_r}
var
  pLD  : TpLineData;  {pointer to object with the data}
begin
  if (ii >= 0) and (ii < LineData_r.count) then begin  {reasonable index}
    pLD := LineData_r[ii];
    Vup_r := pLD^.Vup_l;
    Vdw_r := pLD^.Vdw_l;
  end;
end;

procedure TRelayCalcForm.PrefaultState;
{calculate the prefault state, for superposition, either a "simple" calculation,
 or something more advanced (load flow etc)}
var
  success      : boolean;  {load flow succesful}
begin
  if (not InitBut.down) then begin                      {no precalculated initial state}
    SolveNet(imagopas.ipSetG,false, normal);            {initial state}
    SetComp.SavePrefaultVoltages('parz');               {especially needed when all faults}
    {save initial state, but IN A Different WAY, I think??!!}
  end else begin
    {prefault state from load flow or voltage calculation}
    {must (perhaps?) recalculate, because of the third node in the tr.line where fault ...??!!}
    {Is this always necessary ??!! Maybe it is, saving of prefault voltages below}
    if      (SetComp.List_Probl = AdjustVolt) then begin
      SolveNetWithGivenOutputVoltages(ipSetG, SetComp.List_Probl);  {solve with given output voltages}
    end else if (SetComp.List_Probl = SolvingLoadFlow) then begin
      LoadFlowCalculation(ipSetG, SetComp.List_Probl, success);     {load flow}
    end else if (SetComp.List_Probl = TapLoad) then begin
      LoadTapCalculation(ipSetG, 1, success);                       {load flow with tap changers}
    end else if (SetComp.List_Probl = TapVolt) then begin
      LoadTapCalculation(ipSetG, 2, success)                       {output voltages with tap changers}
    end else begin
      SolveNetWithGivenOutputVoltages(ipSetG, SetComp.List_Probl);
    end;
  end;
  {prefault currents at reference and measurement CT:s. Needed, if asymm. fault}
  pRefCT_r^.GetVar(gCurr_Ir,Irefr_r);                   {real part of current at ref.current trafo}
  pRefCT_r^.GetVar(gCurr_Ii,Irefi_r);
  pMeasCT_r^.GetVar(gCurr_Ir,Imeasr_r);                 {real part of current at ref.current trafo}
  pMeasCT_r^.GetVar(gCurr_Ii,Imeasi_r);
end;

procedure TRelayCalcForm.ReadFaultImpedance;
{read the (optional) fault impedance.
(But always or only, when (nonzero) impedance selected - - - -???}
var
  err,erx      : integer;  {error flags for impedance}
  ipu          : integer;  {temporary}
  Rf,Xf        : single;   {fault impedance}
  str,stx      : string;   {resistance, reactance as string}
  txt          : string;   {temporary}
begin
  {read fault impedance}
  txt := ResEdit.text;                             {resistance, as text}
  NextValueFromLine(txt, 1, ipu, Rf, str, err);    {resistance}
  txt := ReactEdit.text;                           {reactance, as text}
  NextValueFromLine(txt, 1, ipu, Xf, stx, erx);    {reactance}
  {put values to "common"}
  if (err = 0) and (erx = 0) then begin
    SetComp.fault_Z := str+' + j '+stx;              {fault impedance as string, needed in report}
    SetComp.fault_imped := cplx(Rf,Xf);              {fault impedance}
  end else begin                                     {error(s), set some values}
    SetComp.fault_Z := '0 + j0';
    SetComp.fault_imped := cplx(0,0);
    if (err <> 0) then ResEdit.color := clYellow;
    if (erx <> 0) then ReactEdit.color := clYellow;
  end;
end;

procedure TRelayCalcForm.IterateFaultPosition;
{iterate the fault position in a transmission line, until the current in the
 reference CT has the given value}
const
  niter = 20;     {max. number of iterations}
var
  ff           : single;   {function value}
  Iabs         : single;   {abs.value of current at ref.CT}
  Ima          : single;   {abs.value of measured current}
  iter         : integer;  {iteration counter}
  MorP         : string;   {fm or fp changed}
  xx           : single;   {unknown = relative position of middle node}
begin
  {iterate}
  for iter:=1 to niter do begin
    xx := 0.5*(xp_r+xm_r);              {bisection....}
    (*
    apu := fm_r-fp_r;                   {...or regula falsi }
    if (abs(apu) > 1.e-6) then begin
      xx := (fm_r*xp_r-fp_r*xm_r)/apu; {new guess for position of fault}
    end else begin
      xx := 0.5*(xp_r+xm_r);           {NOT so ?!}
    end;
    *)
    {calculate new function value = short circuit calculation}
    PutMiddlePar(pTrLine_r, xx);
//  Imagoo.ShortCircTimerTimer(nil);     {SKIP all preparations !??? Check!!!}
    CalculateCurrents(xx,Iabs,Ima,xm_r,xp_r,fm_r,fp_r,ff,MorP);
//showmessage(floattostr(xx)+'  '+floattostr(Iabs));
    testEdit.text := inttostr(iter);
    testEdit.refresh;
  end;
TempEdit.text := floattostr(xx)+'  '+floattostr(fm_r)+'  '+floattostr(fp_r);
end;

procedure TRelayCalcForm.InitializeCalculations;
{initializations for the calculations}
begin
  MultiBut.visible := false;
  xmin_r := gssmin;          {defined in imagodef.pas}
  xmax_r := gssmax;          {... when relcalc.pas is compiled, gssmax may be changed to an inreasonable value ??!!}
  {read fault impedance. [Should it be zero, if impedance option not selected ...???] }
  ReadFaultImpedance;
  {some initializations}
  TestEdit.text := '';                                      {clear messages initially}
  MeasCurrEdit.text := '';                                  {clear measured current value initially}
end;

procedure TRelayCalcForm.CalcButClick(Sender: TObject);
{Find the position of the fault on the transmission line (pTrLine) so that
 the current measured at the reference CT (pRefCT, on one end of the transmission
 line pTrLine) is equal (so equal as possible..) to the value given in CurrentEdit.
 When the fault position is found, read the current at the measurement point
 (pMeasCT). The position of the fault is given by the parameter s = relative position
 0 < s < 1 on the line}
const
  niter = 20;     {max. number of iterations}
var
  apu,apv      : single;   {temporary}
  apw          : single;   {temporary}
  curr         : single;   {the calculated current at the reference point}
  er           : integer;  {error flag}
  fx           : single;   {function value}
  ibrc         : integer;  {index for founding brackets}
  Iabs         : single;   {abs.value of current at ref.CT}
  Ifar         : single;   {measured current, when fault at far end of line}
  Ima          : single;   {abs.value of measured current}
  Imr,Imi      : single;   {measured current}
  Inear        : single;   {measured current, when fault at near end of line}
  ipu          : integer;  {temporary}
  Ipa          : single;   {abs.value of prefault current}
  Ipangle      : single;   {phase angle of prefault current}
  Ipr,Ipi      : single;   {prefault current}
  Ir,Ii        : single;   {real, react. currents}
  Irnear,Irfar : single;   {reference current, when fault _nominally_ at near end (near CT), far end}
  iter         : integer;  {iteration counter}
  Iup,Idwn     : single;   {measured current, when fault upstream, downstream}
  Jr,Ji        : single;   {measured currents}
  MorP         : string;   {fm or fp changed}
  rPos         : single;   {relative position of the middle node of the tr.line}
  s1,s2        : string;   {temporary}
  s3,s4        : string;   {temporary}
  success      : boolean;  {load flow succesful}
  txt          : string;   {temporary}
  upnode       : integer;  {upstream node}
  xx           : single;   {unknown = relative position of middle node}
begin
  InitializeCalculations;                                   {some preparations}
  FaultNode := middle;                                      {middle node in this calculation}
  {calculate only if all components known}
  if (pMeasCT_r <> nil) and (pRefCT_r <> nil) and (pTrLine_r <> nil) and
     (SetComp.pCompList.indexof(pMeasCT_r) >= 0) and          {measurement CT exists}
     (SetComp.pCompList.indexof(pRefCT_r)  >= 0) and          {reference CT exists}
     (SetComp.pCompList.indexof(pTrLine_r) >= 0) then begin   {transmission line exists}
    {calculate initial state, if superpos.method, and not yet calculated}
//  if (SuppBut.checked) then begin
    PrefaultState;                                        {solve once more}
    PrefaultLineVoltages;                                 {voltages at ends of the line}
//  end else begin
//    Imagoo.NodeButClick(nil);                             {determine nodes (necessary?)}
//  end;
{?} SetComp.Appl_Op := 18;
    {save the relative length-parameter during the calculations, return later}
    GetLinePar(pTrLine_r, 'middle', rPos);
    {read target current, if reasonable}
    if (CurrentEdit.color <> clYellow) then begin           {yellow = error flag}
      {reserve space for current transformers, if not LLL-fault (reserves in SolveNet)}
      if (not ThreePhaseBut.checked) then begin
        SetComp.GetMemForCurrTrAndRelays;
      end;
      GetSetCurrent(SetCur_r, er);     {read the set(point of the) current}
      if (er = 0) then begin           {numerical value found}
        {initialize brackets to unreasonable values}
        xm_r := -1; xp_r := -1;
        fm_r := 0; fp_r := 0;
        Inear := 0;
        Ifar := 0;
        Irnear := 0;                          {to keep the compiler happy...}
        Irfar := 0;
        {first, find the "brackets" of the root}
        for ibrc := 1 to 2 do begin
          if (ibrc = 1) then xx := xmin_r else xx := xmax_r;
          {relative position of the middle node = fault}
          PutMiddlePar(pTrLine_r, xx);
          {solve short circuit current}
          CalculateCurrents(xx,Iabs,Ima,xm_r,xp_r,fm_r,fp_r,fx,MorP);
          {save the currents}
          if (ibrc = 1) then Inear := Ima else Ifar := Ima;     {measured}
          if (ibrc = 1) then Irnear := Iabs else Irfar := Iabs; {reference}
        end;
        {line may be wrong way around. Reference current larger, when fault at _nominally_ far end}
        revers_r := Irfar > Irnear;
        if (revers_r) then begin
          Iup := Ifar;
          Idwn := Inear;
        end else begin
          Iup := Inear;
          Idwn := Ifar;
        end;
        {special or normal case? }
        if (Iup <= Idwn) then begin             {special case, currents bechave in an unusual way}
          MeasCurrEdit.text := TenChar(Idwn);   {Display larger current, TenChar in Emtp.pas}
          TestEdit.text := 'Warning: Current increases in '+MeasureEdit.text+' and decreases in '+
                            ReferenceEdit.text;
          MaxLabel.visible := true;
        end else begin
          MaxLabel.visible := false;
          {normal case, continue normally. Brackets found?}
          if (xm_r > 0) and (xp_r > 0) then begin
            {solve fault position, iterate}
            IterateFaultPosition;
            {current at measurement curr.trafo}
            ShowMeasuredCurrent;
            {show current at ref. and meas. CT, in diagram}
            ShowCurrRes(pRefCT_r,imagoo.ShowCurrBut.caption);          {show the desired phase of the current, in Elplex.pas}
            ShowCurrRes(pMeasCT_r,imagoo.ShowCurrBut.caption);
(*
            pMeasCT_r^.GetVar(gCurr_Ir,Jr);         {real part of current at ref.current trafo}
            pMeasCT_r^.GetVar(gCurr_Ii,Ji);
            apu := sqrt(Jr*Jr+Ji*Ji);             {measured current}
            {show current}
            MeasCurrEdit.text := TenChar(apu);     {in Emtp.pas}
*)
          end else begin                          {no solution}
            {give warning for improper value}
            if (xm_r < 0) then begin                {did not find current > set current}
              TestEdit.text := 'End of zone not found (Ikz > Isz). Try multi Z-button (or next zone)';
              MultiBut.visible := true;
            end else begin
              TestEdit.text := 'current setting too large';
            end;
          end;
        end;
        {release memory for current transformers (if not LLL-fault)}
        if (not ThreePhaseBut.checked) then begin
          if (SetComp.nCurrTr > 0) and (SetComp.ppCurrTr <> nil) then
            SetComp.FreeMemForCurrTrAndRelays;
        end;
      end else begin                   {no numerical value, error}
        TestEdit.text := 'input error';
      end;
    end else begin                     {no numerical value}
      TestEdit.text := 'input error';
    end;
    {return the original relative position of node in tr.line}
    PutMiddlePar(pTrLine_r, rPos);
  end else begin       {some component(s) not defined}
    TestEdit.text := 'not complete input';
  end;

end;

procedure TRelayCalcForm.CurrentEditChange(Sender: TObject);
{check, is the text a numerical value}
var
  apu,apv : single;   {temporary}
  apw     : single;   {temporary}
  er      : integer;  {error flag}
  ipu     : integer;  {temporary}
  s1,s2   : string;   {temporary}
  s3,s4   : string;   {temporary}
  SetCur  : single;   {current parameter}
  txt     : string;   {temporary}
begin
  GetSetCurrent(SetCur, er);              {read the current from the edit component}
  if (er = 0) then begin
    CurrentEdit.color := clWhite;
    TestEdit.text := floattostr(SetCur);  {testing..}
  end else begin
    {not a proper numerical value}
    CurrentEdit.color := clYellow;
  end;
end;

procedure TRelayCalcForm.GetSetCurrent(var SetCur: single; var er: integer);
{read the set current from the edit
 SetCur  the set current
 er      error flag}
var
  apu,apv : single;   {temporary}
  apw     : single;   {temporary}
  ipu     : integer;  {temporary}
  s1,s2   : string;   {temporary}
  s3,s4   : string;   {temporary}
  txt     : string;   {temporary}
begin
  txt := CurrentEdit.text;
  {convert text to numerical value (in Routines.pas)}
  ValuesFromLine(txt, 1, false, ipu, SetCur, apu, apv, apw, s1,s2,s3,s4,er);
end;

procedure TRelayCalcForm.ResEditEnter(Sender: TObject);
begin
  ResEdit.color := clWhite;
end;

procedure TRelayCalcForm.ReactEditEnter(Sender: TObject);
begin
  ReactEdit.color := clWhite;
end;

procedure TRelayCalcForm.Z012ButClick(Sender: TObject);
begin
  InitBut.enabled := false;
//FaultsEnabled(false);     {not possible to select fault type}
end;

procedure TRelayCalcForm.SuppButClick(Sender: TObject);
begin
  InitBut.enabled := true;
//FaultsEnabled(false);     {not possible to select fault type}
end;

procedure TRelayCalcForm.IECButClick(Sender: TObject);
begin
  InitBut.enabled := false;
//FaultsEnabled(false);     {not possible to select fault type}
end;

procedure TRelayCalcForm.FormShow(Sender: TObject);
{find short circuit, and to which line it is connected, if any}
{and add current transformers to the combo boxes for measurement and reference}
begin
  RefreshButClick(sender);
  Calculate_r := false;
end;

procedure TRelayCalcForm.MeasureBoxChange(Sender: TObject);
{get the selected CT (label and pointer)}
var
  indx  : integer;  {index}
  pComp : TpComp;   {pointer to the CT}
begin
  indx := MeasureBox.Items.IndexOf(MeasureBox.text);  {index of the selected label}
  if (indx >= 0) then begin
    pComp := TpComp(MeasureBox.Items.Objects[indx]);  {get the pointer, stored as TObject}
    SetMeasureCT(longint(pComp));
  end;
end;

procedure TRelayCalcForm.ReferenceBoxChange(Sender: TObject);
{get the selected CT (label and pointer)}
var
  indx  : integer;  {index}
  pComp : TpComp;   {pointer to the CT}
begin
  indx := ReferenceBox.Items.IndexOf(ReferenceBox.text);  {index of the selected label}
  if (indx >= 0) then begin
    pComp := TpComp(ReferenceBox.Items.Objects[indx]);    {get the pointer, stored as TObject}
    SetReferenceCT(longint(pComp));
  end;
end;

procedure TRelayCalcForm.ClearRelayForm;
{clear lists of current trafos, etc}
begin
  ReferenceBox.clear;
  ReferenceBox.text := '';
  ReferenceEdit.text := '';
  MeasureBox.clear;
  MeasureBox.text := '';
  MeasureEdit.text := '';
  FaultBox.clear;
  Fault2Box.clear;
  if (pMeasCT_r <> nil) then begin
    pMeasCT_r^.pLabel_s^.font.style := [];      {access violation?}
    pMeasCT_r^.pLabel_s^.font.size := 8;
  end;
  if (pRefCT_r <> nil) then begin
    pRefCT_r^.pLabel_s^.font.style := [];
    pRefCT_r^.pLabel_s^.font.size := 8;
  end;
  pRefCT_r := nil;
  pMeasCT_r := nil;
  pUpstr_r := nil;
  pDownstr_r := nil;
  UpstreamBusEdit.text := '';
  DownstreamBusEdit.text := '';
  LineDataFree;
  LineVoltFree;
  SectionsFree;
  BusList_r.clear;
  ConnDown_r.clear;
  ConnList_r.clear;
  ConnRev_r.clear;
  ConnUp_r.clear;
  LineData_r.clear;
  LineList_r.clear;
  LineVolt_r.clear;
  LinkDown_r.clear;
  LinkList_r.clear;
  LinkRev_r.clear;
  LinkUp_r.clear;
  LinkVolt_r.clear;
  MutualList_r.clear;
  Sections_r.clear;
  ConnLines_r.clear;
  Unconn_r.clear;
  Calculate_r := false;
end;

procedure TRelayCalcForm.ClearButClick(Sender: TObject);
begin
  ClearRelayForm;
end;

procedure TRelayCalcForm.RefreshButClick(Sender: TObject);
var
  err   : integer; {error flag}
  ix,iy : integer; {coordinates}
  jcomp : integer; {counter}
  lbl   : string;  {label (name) of a component}
  name  : string;  {name = type of the component}
  pComp : TpComp;  {pointer to a component}
  pSet  : TpCompSet;
  pShort: TpComp;  {pointer to the short}
begin
  pSet := TpCompSet(imagopas.ipSetG);         {pointer to the common}
  {check all components to find the short and current trafos}
  MeasureBox.clear;
  ReferenceBox.clear;
  FaultBox.clear;
  Fault2Box.clear;
  pComp := nil;
  err := 0;
  jcomp := 0;
  pShort := nil;                            {initialize}
  while (err = 0) do begin                  {scan all components}
    pSet^.NextComp(pComp, err,jcomp,false); {pointer to next component}
    if (err = 0) then begin                 {no errors, no more components}
      pComp^.GetName(name);                 {get name (type) of the comp.}
      if (name = gShort) then begin         {short circuit}
        pShort := pComp;
      end else if (name = gCurrT) then begin {current transformer}
        pComp^.GetLabel(lbl,ix,iy);
        MeasureBox.Items.AddObject(lbl, TObject(pComp));
        ReferenceBox.Items.AddObject(lbl, TObject(pComp));
      end else if (name = gTrLiS) then begin {transmission line}
        pComp^.GetLabel(lbl,ix,iy);
        FaultBox.Items.AddObject(lbl, TObject(pComp));
      end else if (name = gMutual) then begin {transmission lines with mutual impedances}
        pComp^.GetLabel(lbl,ix,iy);
        Fault2Box.Items.AddObject(lbl, TObject(pComp));
      end;
    end;
  end;
  {if short found, check is it connected to the middle node of a transmission line}
  if (pShort <> nil) then begin
    ToRelayCalc(longint(pShort));   {in skemproc.pas}
  end else begin
    pFault_r := nil;
    FaultEdit.text := '??';
  end;
end;

procedure TRelayCalcForm.FaultDirection(var fdir: string; var fx,fy : integer);
{find the direction (orientation, up, down, right, left) of the fault
 fdir   the direction as text
 fx,fy  coordinates (left,top) of the fault }
var
  nx,ny : integer;  {coordinates of the first node of the fault}
begin
  fx := pFault_r^.left;                               {present coordinates of the fault}
  fy := pFault_r^.top;
  {coordinates of first node}
  pFault_r^.GetNxy(1,nx,ny);                          {coordinates of the node of the fault}
  {deduce the direction (orientation) of the fault component}
  if (ny = fy) and (nx > fx) then fdir := 'down'                      {downwards}
  else if (ny > fy) and (nx = fx+pFault_r^.width) then fdir := 'left' {to the left}
  else if (ny > fy) and (nx = fx) then fdir := 'right'                {to the right}
  else if (ny = fy+pFault_r^.height) and (nx > fx) then fdir := 'up'  {upwards}
  else fdir := 'unknown';                                             {error, should not be possible}
end;

procedure TRelayCalcForm.PutFaultOnNode(px,py : integer);
{put the fault so that its node coincides with the given node (given coordinates)
 Exact position of the fault depends on the orientation of the fault
   (up, down, left, right)
px,py coordinates of the node }
var
  fdir  : string;   {direction of the fault}
  fx,fy : integer;  {old position of the fault, for the orientation}
  ix,iy : integer;  {new, (possibly) approximate position of fault}
  xn,yn : integer;  {new position of the fault}
begin
  {deduce the direction (orientation) of the fault}
  FaultDirection(fdir, fx,fy);
  if (fdir = 'down') then begin
    ix := px-16;
    iy := py;
  end else if (fdir = 'up') then begin
    ix := px-16;
    iy := py-32;
  end else if (fdir = 'right') then begin
    ix := px;
    iy := py-16;
  end else if (fdir = 'left') then begin
    ix := px-32;
    iy := py-16;
  end else begin       {error, do not move}
    ix := fx;
    iy := fy;
  end;
  pFault_r^.MoveSnap(false,ix,iy,fx,fy,xn,yn); {move and snap to grid}
end;

procedure TRelayCalcForm.PutFaultOnMutualImpedanceLine(LineID: integer);
{put the fault on the selected tr.line (with mutual impedance). Exact position
 depends on the orientation of the fault and the line
 LineID  the index of the selected line in the mutual impedance line-component}
var
  fdir  : string;   {direction (orientation) of the fault}
  fx,fy : integer;  {old position of the fault, for the orientation}
  ix,iy : integer;  {new, (possibly) approximate position of fault}
  ldir  : string;   {direction (orientation) of the line}
  lx,ly : integer;  {position of the line}
  mx,my : integer;  {coordinates of the first node of the line}
  nx,ny : integer;  {coordinates of the first node of the fault}
  xn,yn : integer;  {new position of the fault}
begin
  if (pTrLine_r <> nil) and (pFault_r <> nil) then begin
    {Exact position of the fault depends on orientation (direction) of the fault and the line}
    {position of the line}
    lx := pTrLine_r^.left;
    ly := pTrLine_r^.top;
    {deduce the direction (orientation) of the fault}
    FaultDirection(fdir, fx,fy);
    {deduce the direction (orientation) of the tr.line-component}
    {coordinates of first node}
    pTrLine_r^.GetNxy(1,mx,my);                         {coordinates of the first node of the line}
    if (mx > lx) and (my = ly) then ldir := 'down'
    else if (mx = lx) and (my > ly) then ldir := 'right'
    else if (mx > lx) and (my = ly+pTrLine_r^.height) then ldir :='up'
    else if (mx = lx+pTrLine_r^.width) and (my > ly) then ldir := 'left'
    else ldir := 'unknown';
    {put the fault on the line}
    ix := fx; iy := fy;                        {initialize, to keep compiler happy}
    if (ldir = 'down') or (ldir = 'up') then begin              {nominal current direction = down or up}
      if (fdir = 'down') then begin            {fault current downwards}
        ix := lx-(pFault_r^.width div 2)+(lineID-1)*32;
        iy := ly+(pFault_r^.height div 2);
      end else if (fdir = 'up') then begin     {fault current upwards}
        ix := lx-(pFault_r^.width div 2)+(lineID-1)*32;
        iy := ly-(pFault_r^.height div 2);
      end else if (fdir = 'right') then begin  {fault current to the right}
        ix := lx+(lineID-1)*32;
        iy := ly;
      end else if (fdir = 'left') then begin   {fault current to the left}
        ix := lx-16+(lineID-1)*32;
        iy := ly;
      end else begin                           {error...?}
        ix := fx; iy := fy;
      end;
      pFault_r^.MoveSnap(false,ix,iy,fx,fy,xn,yn); {move and snap to grid}
    end else if (ldir = 'left') or (ldir = 'right') then begin     {nominal current direction = left or right}
      if (fdir = 'down') then begin            {fault current down}
        ix := lx;
        iy := ly+(lineID-1)*32;
      end else if (fdir = 'up') then begin     {fault current up}
        ix := lx;
        iy := ly-16+(lineID-1)*32;
      end else if (fdir = 'right') then begin  {fault current to the right}
        ix := lx+16;
        iy := ly-16+(lineID-1)*32;
      end else if (fdir = 'left') then begin   {fault current to the left}
        ix := lx-16;
        iy := ly-16+(lineID-1)*32;
      end else begin                           {error...?}
        ix := fx; iy := fy;
      end;
      pFault_r^.MoveSnap(false,ix,iy,fx,fy,xn,yn); {move and snap to grid}
    end else begin                             {something else = error}
      {error...?}
    end;
  end;
end;

procedure TRelayCalcForm.Fault2BoxChange(Sender: TObject);
{move the fault to the selected tr.line (with mutual impedances)}
var
  apu    : single;
  fx,fy  : integer;  {old coordinates of the fault}
  indx   : integer;  {index}
  lbut   : integer;  {"index" of button for selecting the line}
  lineID : integer;
  lines  : integer;  {number of connected lines in this component}
  lx,ly  : integer;  {coordinates of the tr.line}
  nx,ny  : integer;  {coordinates of the node of the fault}
  pComp  : TpComp;   {pointer to the tr.line}
  xn,yn  : integer;  {new position}
begin
  LineBox.visible := true;                                {show buttons for selcting line}
  pComp := nil;
  if (pFault_r <> nil) then begin
    indx := Fault2Box.Items.IndexOf(Fault2Box.text);      {index of the selected label}
    if (indx >= 0) then begin
      FaultBox.text := '';                                {box for "ordinary" lines not selected}
      pComp := TpComp(Fault2Box.Items.Objects[indx]);     {get the pointer, stored as TObject}
//    SetTrLine(longint(pComp),1);                        {tr.line where the fault will be} {MOVED below}
      {must check the buttons}
      pComp^.GetPar(1,apu);                               {number of lines in this mutual-lines-component}
      lines := round(apu);                                {number of lines in this component}
      {"index" of button for selecting the line}
      if      (Sect1But.down) then lbut := 1 else if (Sect2But.down) then lbut := 2
      else if (Sect3But.down) then lbut := 3 else if (Sect4But.down) then lbut := 4
      else if (Sect5But.down) then lbut := 5 else if (Sect6But.down) then lbut := 6
      else if (Sect7But.down) then lbut := 7 else if (Sect8But.down) then lbut := 8
      else lbut := 1;
      {compare with the number of lines}
      if (lbut <= lines) then begin                     {reasonable button}
        lineID := lbut;
      end else begin                                    {button refers to line that does not exist}
        lineID := 1;
        Sect1But.down := true;                          {line 1 in case of an error}
      end;
      SetTrLine(longint(pComp),LineID);                 {tr.line where the fault will be}
      {move fault to the selected line}
      PutFaultOnMutualImpedanceLine(lineID);
      TestEdit.text := '';
      pFault_r^.BringToFront;
    end else begin                                      {error, ??}
      {?}
    end;
  end else begin   {no fault}
    TestEdit.text := 'no fault!?';
    FaultEdit.text := '??';
  end;
  {set the number of visible buttons according to the number of lines}
  if (pComp <> nil) then begin
    pComp^.GetPar(1,apu);                 {number of lines in this mutual-lines-component}
    lines := round(apu);
    Sect1But.visible := true;
    Sect2But.visible := true;             {there should always be at least two lines}
    Sect3But.visible := (lines >= 3);
    Sect4But.visible := (lines >= 4);
    Sect5But.visible := (lines >= 5);
    Sect6But.visible := (lines >= 6);
    Sect7But.visible := (lines >= 7);
    Sect8But.visible := (lines >= 8);
  end;
end;

procedure TRelayCalcForm.FaultBoxChange(Sender: TObject);
{move the fault to the selected line}
var
  fx,fy : integer;  {old coordinates of the fault}
  indx  : integer;  {index}
  lx,ly : integer;  {coordinates of the tr.line}
  nx,ny : integer;  {coordinates of the node of the fault}
  pComp : TpComp;   {pointer to the tr.line}
  xn,yn : integer;  {new position}
begin
  if (pFault_r <> nil) then begin
    indx := FaultBox.Items.IndexOf(FaultBox.text);      {index of the selected label}
    if (indx >= 0) then begin
      Fault2Box.text := '';                             {box for "mutual" lines not selected}
      LineBox.visible := false;                         {hide buttons for selecting mutual lines}
      pComp := TpComp(FaultBox.Items.Objects[indx]);    {get the pointer, stored as TObject}
      SetTrLine(longint(pComp),1);                      {tr.line where the fault is. Index (1) not needed here}
      {move the fault to the line}
      lx := pComp^.left;
      ly := pComp^.top;
      {Exact position of the fault depends on orientation of the fault (and line)}
      fx := pFault_r^.left;                               {present coordinates of the fault}
      fy := pFault_r^.top;
      pFault_r^.GetNxy(1,nx,ny);                          {coordinates of the node of the fault}
      {deduce the orientation of the fault component}
      if (ny = fy) and (nx > fx) then begin                                   {downwards}
        pFault_r^.MoveSnap(false,lx,ly+(pFault_r^.height div 2),fx,fy,xn,yn); {move and snap to grid}
      end else if (ny > fy) and (nx = fx+pFault_r^.width) then begin          {to the left}
        pFault_r^.MoveSnap(false,lx-(pFault_r^.width div 2),ly-7,fx,fy,xn,yn);
      end else if (ny > fy) and (nx = fx) then begin                          {to the right}
        pFault_r^.MoveSnap(false,lx+(pFault_r^.width div 2),ly-7,fx,fy,xn,yn);
      end else if (ny = fy+pFault_r^.height) and (nx > fx) then begin         {upwards}
        pFault_r^.MoveSnap(false,lx-7,ly-(pFault_r^.height div 2),fx,fy,xn,yn);
      end else begin                                    {error, should not be possible}

      end;
      TestEdit.text := '';

    end;
  end else begin   {no fault}
    TestEdit.text := 'no fault!?';
    FaultEdit.text := '??';
  end;
end;

procedure NoFaultInRelayForm(ipComp: longint);
begin
  RelayCalcForm.pFault_r := nil;
end;

procedure TRelayCalcForm.ExitItemClick(Sender: TObject);
begin
  RelayCalcForm.visible := false;
end;

procedure TRelayCalcForm.InitialStateItemClick(Sender: TObject);
begin
  InitialStateItem.checked := not InitialStateItem.checked;
  MethodBox.visible := InitialStateItem.checked;
end;

procedure TRelayCalcForm.ImpedanceItemClick(Sender: TObject);
begin
  ImpedanceItem.checked := not ImpedanceItem.checked;
  ImpedanceBox.visible := ImpedanceItem.checked;
  {reset impedance to zero, if hidden}
  if (not ImpedanceItem.checked) then begin
    ResEdit.text := '0';
    ReactEdit.text := '0';
  end;
end;


procedure TRelayCalcForm.MultiButClick(Sender: TObject);
{increase fault impedance, until current at desired value}
begin
  {reserve space for current transformers, if not LLL-fault (reserves in SolveNet)}
  if (not ThreePhaseBut.checked) then begin
    SetComp.GetMemForCurrTrAndRelays;
  end;
  IncreaseFaultImpedance;
  {release memory for current transformers (if not LLL-fault)}
  if (not ThreePhaseBut.checked) then begin
    if (SetComp.nCurrTr > 0) and (SetComp.ppCurrTr <> nil) then
      SetComp.FreeMemForCurrTrAndRelays;
  end;
end;

procedure TRelayCalcForm.ThreePhaseButClick(Sender: TObject);
begin
  SequenceBox.visible := false;
end;

procedure TRelayCalcForm.LineLineButClick(Sender: TObject);
begin
  SequenceBox.visible := true;
end;

procedure TRelayCalcForm.LineEarthButClick(Sender: TObject);
begin
  SequenceBox.visible := true;
end;

procedure TRelayCalcForm.LLEButClick(Sender: TObject);
begin
  SequenceBox.visible := true;
end;



procedure TRelayCalcForm.Sect1ButClick(Sender: TObject);
begin
  {move fault to the selected line}
  PutFaultOnMutualImpedanceLine(1);
  UpdateLineID(1);
end;

procedure TRelayCalcForm.Sect2ButClick(Sender: TObject);
begin
  {move fault to the selected line}
  PutFaultOnMutualImpedanceLine(2);
  UpdateLineID(2);
end;

procedure TRelayCalcForm.Sect3ButClick(Sender: TObject);
begin
  {move fault to the selected line}
  PutFaultOnMutualImpedanceLine(3);
  UpdateLineID(3);
end;

procedure TRelayCalcForm.Sect4ButClick(Sender: TObject);
begin
  {move fault to the selected line}
  PutFaultOnMutualImpedanceLine(4);
  UpdateLineID(4);
end;

procedure TRelayCalcForm.Sect5ButClick(Sender: TObject);
begin
  {move fault to the selected line}
  PutFaultOnMutualImpedanceLine(5);
  UpdateLineID(5);
end;

procedure TRelayCalcForm.Sect6ButClick(Sender: TObject);
begin
  {move fault to the selected line}
  PutFaultOnMutualImpedanceLine(6);
  UpdateLineID(6);
end;

procedure TRelayCalcForm.Sect7ButClick(Sender: TObject);
begin
  {move fault to the selected line}
  PutFaultOnMutualImpedanceLine(7);
  UpdateLineID(7);
end;

procedure TRelayCalcForm.Sect8ButClick(Sender: TObject);
begin
  {move fault to the selected line}
  PutFaultOnMutualImpedanceLine(8);
  UpdateLineID(8);
end;

procedure TRelayCalcForm.LineDataCreate;
{create the objects for data of the lines between the buses
 The data is added later...}
var
  ii    : integer;     {index}
  pLDat : TpLineData;  {pointer to an object with data}
begin
  LineData_r.clear;
  if (LinkList_r.count > 0) then begin
    for ii := 0 to LinkList_r.count-1 do begin
      {create the object for saving the data. Object destroyed in ...}
      new(pLdat);                     {reserve space for the object}
      pLdat^ := TLineData.Create;     {create the object}
      LineData_r.add(pLdat);
    end;
  end;
end;

procedure TRelayCalcForm.LineDataFree;
{free the objects in the list LineData_r, but not the list itself}
var
  ii  : integer;
  pLD : TpLineData;
begin
  if (LineData_r.count > 0) then begin
    for ii := 0 to LineData_r.count-1 do begin
      pLD := LineData_r[ii];
      pLD.free;
      dispose(pLD);
    end;
  end;
  LineData_r.clear;
end;

procedure TRelayCalcForm.SectionsFree;
{free the objects in the list Sections_r, but not the list itself}
var
  ii  : integer;
  pLS : TpLineSection;
begin
  if (Sections_r.count > 0) then begin
    for ii := 0 to Sections_r.count-1 do begin
      pLS := Sections_r[ii];
      pLS.free;
      dispose(pLS);
    end;
  end;
  Sections_r.clear;
end;

procedure TRelayCalcForm.LineVoltCreate;
{create the objects for voltages of the lines (with mutual imp.) between the buses
 The data is added later...
 (Actually, probably more objects are created than needed)}
var
  ii     : integer;     {index}
  pLVolt : TpLineVolt;  {pointer to an object with data}
begin
  LineVolt_r.clear;
  if (LinkList_r.count > 0) then begin
    for ii := 0 to LinkList_r.count-1 do begin
      {create the object for saving the data. Object destroyed in ...}
      new(pLVolt);                     {reserve space for the object}
      pLVolt^ := TLineVolt.Create;     {create the object}
      LineVolt_r.add(pLVolt);
    end;
  end;
end;

procedure TRelayCalcForm.LineVoltFree;
{free the objects in the list LineData_r, but not the list itself}
var
  ii  : integer;
  pLV : TpLineVolt;
begin
  if (LineVolt_r.count > 0) then begin
    for ii := 0 to LineVolt_r.count-1 do begin
      pLV := LineVolt_r[ii];
      pLV.free;
      dispose(pLV);
    end;
  end;
  LineVolt_r.clear;
end;

procedure TRelayCalcForm.FormDestroy(Sender: TObject);
{free the lists etc}
begin
  LineList_r.free;
  MutualList_r.free;
  ConnList_r.free;
  ConnUp_r.free;
  ConnDown_r.free;
  ConnRev_r.free;
  LinkList_r.free;
  LinkUp_r.free;
  LinkDown_r.free;
  LinkRev_r.free;
  BusList_r.free;
  {linedata may contain objects}
  LineDataFree;     {free the objects}
  LineData_r.free;  {free the list}
  LineVoltFree;
  LineVolt_r.free;
  {sections may contain objects}
  SectionsFree;
  Sections_r.free;
  ConnLines_r.free;
  Unconn_r.free;
end;

procedure TRelayCalcForm.GetUpDownNodes(pComp: TpComp; pUp,pDown: pInteger; var m1,m2: integer);
{the connection points (component nodes, "local" nodes) are saved as integer pointers
 (so that TList can be used). Extract the connecting points, and get the
 corresponding network nodes
 pComp     pointer to the component
 pUp,pDown connecting points (as integer pointers) Upstr, and Downstr. wrt the buses
 m1,m2     correspoinding network nodes}
var
  er1,er2  : integer;  {error flags}
  ipu,ipv  : integer;  {temporary}
begin
  ipu := integer(pUp);               {conn.points saved as pointers, convert back}
  ipv := integer(pDown);
  pComp^.getNode(ipu,m1,er1);
  pComp^.getNode(ipv,m2,er2);
end;

procedure TRelayCalcForm.UpdateConnListIf(pComp: TpComp; upnode,j1,j2: integer;
                                          pList, pUp, pDown,pRev: TpList);
{add component to list of connected components, if node = given node
 AND comp. not yet in the list (MORE conditions needed...!!!!!!
 TComp   pointer to the component (line);
 upnode  given node (of bus)
 j1,j2   indices for nodes of line (1 and 2 for simple line, 1+k*5 and 2+k*5 for lines
         with mutual impedance
 pList   pointer to list to be updated
 pUp,pDown  lists of upstream and downstream nodes
 pRev    flags for reversed lines: if <> nil, downstream node of line is connected to upnode}
var
  ern     : integer;  {error flag}
  ii      : integer;
  iList   : integer;  {index in the list}
  inList  : boolean;  {component and nodes are in the list}
  ipu,ipv : integer;  {temporary}
  m1,m2   : integer;  {nodes}
  n1,n2   : integer;  {nodes}
  pLine   : TpComp;   {pointer to a line in the list}
begin
  {check, is this component and its nodes already in the list. Must also check...
   ...nodes, because component (line with mutual imp.) may be several times in the list}
  pComp^.getNode(j1,n1,ern);                {upstream node of this line}
  pComp^.GetNode(j2,n2,ern);
  inList := false;
  if (pList^.count > 0) then begin
    for ii := 0 to pList^.count-1 do begin
      pLine := pList^[ii];
      GetUpDownNodes(pLine, pUp^[ii],pDown^[ii], m1,m2);
      {component and nodes in the lists?}
      if (pLine = pComp) and
         (((m1 = n1) and (m2 = n2)) or
          ((m2 = n1) and (m1 = n2))) then begin
        inList := true;
        break;
      end;
    end;
  end;
  if (not inList) then begin                  {add only, if component and nodes not in lists}
    {connected = same node}
    if (n1 = upnode) then begin               {first node connected to bus?}
      pList^.add(pComp);                      {add to list of lines connected to bus}
      pUp^.add(pInteger(j1));                 {first node connected to given node}
      pDown^.add(pInteger(j2));               {second node away from the given node}
      pRev^.add(nil);                         {flag: not reversed}
    end else if (n2 = upnode)  then begin
      pList^.add(pComp);
      pUp^.add(pInteger(j2));                 {first node connected to given node}
      pDown^.add(pInteger(j1));               {second node away from the given node}
      pRev^.add(pComp);                       {flag: reversed}
    end;
  end;
end;

procedure TRelayCalcForm.NodesOfLine(jj: integer; var j1,j2,j3 : integer);
{get the up- and downstream connection points (nodes) of the line jj of the line-component..
 .. containing several lines with mutual impedances
 jj     the line within the component
 j1,j2  up- and downstr. connecting points (nodes)}
begin
  j1 := (jj-1)*gMutu_nOne+1;               {gMutu_nOne nodes for one line, imagodef.pas}
  j2 := j1+1;
  j3 := j2+1;
end;

procedure TRelayCalcForm.AddToConnListIf(upnode: integer; pList, pUp,pDown,pRev: TpList; var added: boolean);
{scan all simple lines and lines with mutual impedance and check is any connected
 to the given node. Connected: same node
 upnode  the given node
 pList      List where to be added
 pUp,pDown  upstream and downstream nodes
 pRev       flags for reversed lines (downstream node of line connected to the given node
 added      true, if a line added to list}
var
  apu    : single;  {temporary}
  ii,jj  : integer; {indices}
  j1,j2  : integer; {indices}
  j3     : integer; {middle connecting point(node). Hardly needed}
  mLines : integer; {number of lines in the comp. with mutual impedances}
  oldcnt : integer; {elements in pList^ when entering}
  pComp  : TpComp;  {pointer to a component (a line)}
begin
  oldcnt := pList^.count;                       {number of elements in list when entering}
  {first, check list of normal lines}
  if (LineList_r.count > 0) then begin
    for ii := 0 to LineList_r.count-1 do begin
      pComp := LineList_r[ii];                  {pointer to a line}
      {connected to the given node}
      UpdateConnListIf(pComp, upnode, 1, 2, pList, pUp,pDown,pRev);
    end;
  end;
  {next, check lines with mutual impedaces}
  if (MutualList_r.count > 0) then begin
    for ii := 0 to MutualList_r.count-1 do begin
      pComp := MutualList_r[ii];
      pComp^.getPar(1,apu);                      {number of lines}
      mLines := round(apu);
      {check all lines of this component}
      for jj := 1 to mLines do begin
        {get up- and downstream nodes of this line among all nodes}
        NodesOfLine(jj, j1,j2,j3);
        {update list, if component connected}
        UpdateConnListIf(pComp, upnode, j1, j2, pList,pUp,pDown,pRev);
      end;
    end;
  end;
  added := pList^.count > oldcnt;
end;

procedure TRelayCalcForm.ListsOfLinesAndBuses;
{construct lists of lines, separate lists for "simple" and lines with mutual impedances,
 and bus nodes (not the buses themselves)}
var
  err,ern : integer;  {error flag}
  ipu     : integer;  {temporary}
  jcomp   : integer;  {counts components}
  name    : string;   {name = type of the component}
  pComp   : TpComp;   {pointer to a component}
begin
  LineList_r.clear;
  MutualList_r.clear;
  BusList_r.clear;
  {scan all components, check types. Initialize first}
  pComp := nil;
  err := 0;
  jcomp := 0;
  {then scan}
  while (err = 0) do begin                    {scan all components}
    SetComp.NextComp(pComp, err,jcomp,false); {pointer to next component}
    if (err = 0) then begin                   {no errors, no more components}
      pComp^.GetName(name);                   {get name (type) of the comp.}
      if (name = gTrliS) then begin           {transmission line?}
        LineList_r.add(pComp);                {add to list of simple lines}
      end else if (name = gMutual) then begin
        MutualList_r.add(pComp);              {add to list of lines with mutual impedances}
      end else if (name = gBus) then begin
        pComp^.GetNode(1,ipu,ern);
        BusList_r.add(pInteger(ipu));         {save node camouflaged as pointer (..??!!..)}
      end;
    end;
  end;
end;

procedure TRelayCalcForm.ShowLink(found: boolean);
{show the labels of lines in the link, if found}
var
  ii    : integer;  {index}
  ix,iy : integer;  {coordinates}
  lbl   : string;   {label (name) of the component}
  pComp : TpComp;   {pointer to a component}
begin
  if (Found) then begin
    for ii := 0 to LinkList_r.count-1 do begin
      pComp := LinkList_r[ii];
      pComp^.GetLabel(lbl,ix,iy);
      showmessage(lbl);
    end;
  end else begin
    showmessage('link not found');
  end;
end;

procedure TRelayCalcForm.LinesButClick(Sender: TObject);
{determine the tr.lines that are between the upstream and downstream buses.
 Include "simple" lines and lines with mutual impedances}
begin
  FindLinesBetweenBuses;     {find the chain of lines between the buses}

end;

procedure TRelayCalcForm.FindLinesBetweenBuses;
{determine the tr.lines that are between the upstream and downstream buses.
 Include "simple" lines and lines with mutual impedances}
var
  apu       : single;   {temporary}
  bpu       : boolean;  {temporary}
  ChainEnd  : boolean;  {chain of lines (link) ends at some other component (or just ends)}
  downnode  : integer;  {node of downstream bus}
  ern       : integer;  {error flag}
  iBus      : integer;  {index}
  ii,jj     : integer;  {index}
  iLine     : integer;  {index of lines}
  iLink     : integer;  {index of elements in link}
  ipu,ipv   : integer;  {temporary}
  ix,iy     : integer;
  j1,j2     : integer;  {indices}
  LastNode  : integer;  {last node in link, so far}
  lbl       : string;   {label of component}
  mLines    : integer;  {number of lines in one mutual impedance-component}
  maxLink   : integer;  {max.number of lines in the link}
  m1,m2     : integer;  {nodes}
  newNode   : integer;  {node of line added to list}
  n1,n2     : integer;  {nodes}
  pAdded    : TpComp;   {pointer to line added to list}
  pComp     : TpComp;   {pointer to a component}
  pLine     : TpComp;   {pointer to a line}
  upnode    : integer;  {node of the upstream bus}
begin
  {upstream buses defined and exist?}
  if (pUpstr_r <> nil) and (pDownstr_r <> nil)    and
     (pUpstr_r <> pDownstr_r)                     and        {not the same bus}
     (SetComp.pCompList.indexof(pUpstr_r) >= 0)   and        {upstr. bus exists}
     (SetComp.pCompList.indexof(pDownstr_r) >= 0) then begin {downstr.bus exists}
     {determine nodes IF NOT already done, check!!!, add!!!, change (if..)!!!}
    Imagoo.NodeButClick(nil);                                {determine nodes (necessary?)}
    {construct lists of lines and bus nodes...}
    {..Separate lists for "simple" and lines with mutual impedances}
    ListsOfLinesAndBuses;
    {find lines that are connected to the upstream bus}
    pUpstr_r^.GetNode(1,upnode,ern);              {node of the upstream bus}
    pDownstr_r^.GetNode(1,downnode,ern);          {node of the downstream bus, needed later}
    ConnList_r.clear;                             {clear list initially}
    ConnUp_r.clear;                               {clear list for upstream nodes}
    ConnDown_r.clear;
    ConnRev_r.clear;
    {add lines to list of connected lines, if line is connected to the given node = bus}
    AddToConnListIf(upnode, @ConnList_r,@ConnUp_r,@ConnDown_r,@ConnRev_r,bpu);
    {search for lines that connect upstream and downstream buses. Lines in series}
    LinkFound_r := false;                                     {initialize, link not yet found}
    if (ConnList_r.count > 0) then begin                    {some line connected to upstream bus?}
      for iLine := 0 to ConnList_r.count-1 do begin         {check lines connected to upstr. node, until..}
        ChainEnd := false;                                  {end of this chain not yet found}
        LinkList_r.clear;                                   {clear initially}
        LinkUp_r.clear;                                     {clear upstream nodes}
        LinkDown_r.clear;
        LinkRev_r.clear;
        {initialize node-flags-indices, but not those that are connected to the upstr.bus}
        pComp := ConnList_r[iLine];
        GetUpDownNodes(pComp,ConnUp_r[iLine],ConnDown_r[iLine], m1,m2);
        {check, is this line connected directly to downstream bus}
        if (m2 = downnode) then begin
          LinkList_r.add(pComp);                            {link found..}
          LinkUp_r.add(ConnUp_r[iLine]);
          LinkDown_r.add(ConnDown_r[iLine]);
          LinkRev_r.add(ConnRev_r[iLine]);                  {flag for possibly reversed line}
          LinkFound_r := true;
          break;                                            {..stop search}
        end else begin
          LinkList_r.add(pComp);                            {add as first possible line...may be cleared later}
          LinkUp_r.add(ConnUp_r[iLine]);
          LinkDown_r.add(ConnDown_r[iLine]);
          LinkRev_r.add(ConnRev_r[iLine]);                  {flag for reversed line, first line}
          {try to build the link (series of lines) to the downstream bus}
          {repeat until no more lines connected in series}
          maxLink := LineList_r.count+8*MutualList_r.count; {max. number of lines in link (very large...)}
          {maybe "while" could be better...}
          for iLink := 1 to maxLink do begin
            pLine := LinkList_r.Last;                       {pointer to last (so far) line in the link}
            GetUpDownNodes(pLine,LinkUp_r.Last,LinkDown_r.Last, ipu,LastNode);
            {search (and add) for line connected to the last node....}
            {.....add lines to list, if connected}
            AddToConnListIf(LastNode, @LinkList_r,@LinkUp_r,@LinkDown_r,@LinkRev_r,bpu);
            {if new line added, check, is it connected to some bus}
            if (bpu) then begin
              pAdded := LinkList_r.Last;                 {line added last to list}
              GetUpDownNodes(pAdded,LinkUp_r.Last,LinkDown_r.Last,ipu,NewNode);
              if (BusList_r.count > 0) then begin        {should /must be}
                for iBus := 0 to BusList_r.count-1 do begin  {check all buses}
                  {node number (ID) camouflaged as pointer, change back to integer}
                  if (newNode = integer(BusList_r[iBus])) then begin   {new node is some bus}
                    if (newNode = DownNode) then begin     {new node = downstream bus?}
                      LinkFound_r := true;                 {link (chain of lines) from upstr.bus to downstr bus found}
                    end;
                    ChainEnd := true;
                    break;
                  end else begin                           {not bus at the end of the added line, continue}
                    {..}
                  end;
                end;
              end else begin                             {error, should not happen !?}
                {..}
              end;
            end else begin                               {no lines added, end of search in this branch}
              ChainEnd := true;                          {no more lines to be added, stop seach}
              break;
            end;
            if (ChainEnd) then break;                    {this chain of lines checked}
          end;
        end;
        if (LinkFound_r) then begin

          break;
        end;
      end;
    end;
  end else begin
      showmessage('buses ?');
  end;
end;


procedure TRelayCalcForm.LinesCalcButClick(Sender: TObject);
{find the fault position so that the current at the reference CT equals the
 given current}
var
  brack    : boolean;  {true, when brackets found}
  ConnDown : boolean;  {true, if up- and downstr. buses connected}
  downnode : integer;  {downstream bus}
  er       : integer;  {error flag}
  ern,erp  : integer;  {error flag}
  f1st     : single;   {first function value}
  ff       : single;   {function value}
  flast    : single;   {last function value}
  fm,fp    : single;   {negative, positive function value}
  iCalc    : integer;  {index}
  ii       : integer;  {index}
  iLine    : integer;  {index}
  ipu,ipv  : integer;  {temporary}
  Ira,Ima  : single;   {reference, measured current}
  iStrt    : integer;  {start index for calculations}
  ix,iy    : integer;  {coordinates}
  kLine    : integer;  {index of line, where the solution is (maybe...)}
  lbl      : string;   {label}
  lz       : complex;  {impedance of one line}
  m1,m2    : integer;  {nodes}
  mn       : integer;  {node}
  MorP     : string;   {fm or fp changed}
  mx,my    : integer;  {coordinates of the node in the line}
  nx,ny    : integer;  {coordinates of node}
  n1x,n1y  : integer;  {coordinates of first node}
  n2x,n2y  : integer;  {coordinates of second node}
  pLine    : TpComp;   {pointer to aline}
  pSect    : TpLineSection; {pointer to a line(section) as object}
  upnode   : integer;  {node of upstream bus}
  xm,xp    : single;   {relative position of fault on line for neg, and pos function}
  xx       : single;   {relative position of fault}
begin
{?}SetComp.Appl_Op := 18;
  Imagoo.SolvedProb.picture := nil;
  Calculate_r := true;
  {calculate only, if lines between given buses found, and fault exists}
//LinesButClick(sender);                                   {find the lines connecting the upstr. and downstr.buses}
(**)
{...test...Find connections differently, using fictive currents}
  {determine nodes IF NOT already done, check!!!, add!!!, change (if..)!!!}
  Imagoo.NodeButClick(nil);                                {determine nodes (necessary?)}
  {..Separate lists for "simple" and lines with mutual impedances}
  {?necessary?}ListsOfLinesAndBuses;
  FindLineSections;
  pUpstr_r^.GetNode(1,upnode,ern);              {node of the upstream bus}
  pDownstr_r^.GetNode(1,downnode,ern);
  FindConnectedLines(upnode,downnode,ConnDown);
//CheckLineSections(longint(@ConnLines_r));
  if (ConnDown) and (ConnLines_r.count > 0) then begin
    FindNodeIndices;
  end;
  FindLinkBetweenBuses;
//CheckLineSections(longint(@Sections_r));
{...endtest...}
(**)
  GetSetCurrent(SetCur_r, er);                             {read the set(point of the) current}
  fm := 1; fp := -1;                                       {initialize function values to unreasonable val.}
  f1st := 0; flast := 0;
  if (LinkFound_r) and (pFault_r <> nil) and (er = 0) then begin    {line(s) and fault and set point for current}
    InitializeCalculations;             {clear, set some values...}
    {calculate only if all components known, and current given}
    if (pMeasCT_r <> nil) and (pRefCT_r <> nil)     and
       (SetComp.pCompList.indexof(pMeasCT_r)  >= 0) and    {measurement CT exists}
       (SetComp.pCompList.indexof(pRefCT_r)   >= 0) and    {reference CT exists}
       (SetComp.pCompList.indexof(pUpstr_r)   >= 0) and    {upstream bus exists}
       (SetComp.pCompList.indexof(pDownstr_r) >= 0) and
       (CurrentEdit.color <> clYellow) and                 {yellow = error flag}
       (LinkList_r.count > 0) then begin                   {lines in the list}
      {start processing...}
      LineDataCreate;                                      {create objects for data of the lines}
      LineVoltCreate;
      {calculate initial state, if superpos.method, and not yet calculated}
//    if (SuppBut.checked) then begin
        PrefaultState;
        SavePrefaultLineVoltages;                          {save voltages to a separate list}
//    end else begin
//        Imagoo.NodeButClick(nil);                          {determine nodes (necessary?)}
//    end;
{?}   SetComp.Appl_Op := 18;
      {reserve space for current transformers, if not LLL-fault (reserves in SolveNet)}
      if (not ThreePhaseBut.checked) then begin
        SetComp.GetMemForCurrTrAndRelays;
      end;
      {find the line where the fault should be, i.e. where function value changes sign}
      n1x := 0; n1y := 0; n2x := 0; n2y := 0;              {initialize, to keep the compiler happy}
      MorP := 'm';                                         {initialize, just some value}
      xm := -1; xp := -1;                                  {initialize to unreasonable values}
      brack := false;                                      {initialize, brackets not yet found}
      kLine := -1;                                         {initialize: line not yet found}
      Ztot_r := cplx(0,0);                                 {initialize total impedance....}
      {..}                                                 {... Needed if set current too small}
      for iLine := 0 to LinkList_r.count-1 do begin
        LineInd_r := iLine;                              {maybe needed when correcting, in SumCurr of Skemadef.pas}
        pTrLine_r := LinkList_r[iLine];
        GetLineImpedance(pTrLine_r,lz);                  {impedance of one line}
        Ztot_r := Cadd(Ztot_r,lz);                       {add, to get the total impedance}
        GetPrefaultLineVoltages(iLine);                  {..needed for superpos...}
        pLine := pTrLine_r;                              {pointer to line between buses}
        GetUpDownNodes(pLine,LinkUp_r[iLine],LinkDown_r[iLine], m1,m2);  {m1=up, m2= down, wrt. buses}
        {both nodes for the first component, else only the downstream node}
        if (iLine = 0) then iStrt := 1 else iStrt := 2;
        for iCalc := iStrt to 2 do begin                 {both ends of the first line}
          {get coordinates of both ends. Only one needed here, but both, when iterating, below}
          ipu := integer(LinkUp_r[iLine]);               {connection point = node of component}
          ipv := integer(LinkDown_r[iLine]);
          pLine^.GetNxy(ipu,n1x,n1y);
          pLine^.GetNxy(ipv,n2x,n2y);
{?}       ern := 0;        {BUT if some error ???}
          {upstream node (wrt buses) for first node of first line, else downstream}
          if (iCalc = 1) then begin                     {nodes at the upstream end of the line}
            nx := n1x; ny := n1y;
            mn := m1;
          end else begin
            nx := n2x; ny := n2y;
            mn := m2;
          end;
          pLine^.Int3_s := mn;                          {save node, where fault connected}
          {put fault on node, calculate}
          if (ern = 0) then begin
            PutFaultOnNode(nx,ny);                       {put the fault on the given node}
            pFault_r^.PutNode(1,mn,erp);                 {set node number (ID) accordingly}
            {calculate currents, when fault at one end of line (xx not used...yet)}
            {first, fault in upstream node wrt buses, then in downstr. node wrt buses...}
            {.. But for the line this may be upstr. or downstr. node}
            if (iCalc = 1) then begin                    {upstr.node wrt buses}
              if (LinkRev_r[iLine] = nil) then           {nil = line not reversed wrt. buses}
                FaultNode := up else FaultNode := down;
            end else begin                               {downstr. node wrt buses}
              if (LinkRev_r[iLine] = nil) then           {nil = line not reversed wrt. buses}
                FaultNode := down else FaultNode := up;
            end;
            {update xm or xp, when moving to next line (in series) That is, ...}
            {..the downstream (wrt buses) node of previous line becomes upstrean node of present line}
            if (iLine > 0) then begin
              if (MorP = 'm') then begin                 {negative function value changed in previous line}
                if (LinkRev_r[iLine] = nil) then xm := xmin_r else xm := xmax_r;
                xp := -1;                                {not yet defined, for this line}
              end else begin                             {positive function value changed}
                if (LinkRev_r[iLine] = nil) then xp := xmin_r else xp := xmax_r;
                xm := -1;                                {not yet defined for this line}
              end;
            end;
            {must give some value to xx, needed later, when iterating, not yet}
            if (iCalc = 1) then begin                    {first node of first line}
              if (LinkRev_r[iLine] = nil) then xx := xmin_r else xx := xmax_r;
            end else begin                               {second node}
              if (LinkRev_r[iLine] = nil) then xx := xmax_r else xx := xmin_r;
            end;
            {next, carry out the calculations}
            CalculateCurrents(xx, Ira,Ima,xm,xp,fm,fp,ff,MorP);
            if (iCalc = 1) and (iLine = 0) then f1st := ff;   {save first function value}
            if (iLine = LinkList_r.count-1) then flast := ff; {save last function value (if possible)}
            {solution in this line?}
            if (fm <= 0) and (fp >= 0) then begin
              kLine := iLine;
              brack := true;
              pLine^.int3_s := -10;                      {reset}
              break;                                     {actually, this is last round in any case...}
            end;
          end else begin                                 {something wrong with the nodes}
              {..}
          end;
        end;                                             {both ends of first line calculated}
        {jump out of loop, if brackets found, go to iterations}
        if (brack) then break;
      end;
      {iterate, if found line, where the solution is}
      if (kLine >= 0) then begin
        mx := (n1x+n2x) div 2;                         {coordinates of node in the middle}
        my := (n1y+n2y) div 2;
        PutFaultOnNode(mx,my);                         {put the fault on the given node}
        {determine nodes, if node must be added in the middle of a "simple" line}
{IF..}  Imagoo.NodeButClick(nil);
{Fault node ID ? must think....}
//      pFault_r^.PutNode(1,{mn}18,erp);               {set node number (ID) accordingly}
        FaultNode := middle;                           {fault is now in the middle node}
        {solve fault position, iterate}
{WHAT if the solution is between 0.999 and 1, or 0 and 0.001?...??}
        xm_r := xm; xp_r := xp;                        {copy brackets}
        fm_r := fm; fp_r := fp;
        IterateFaultPosition;
        {current at measurement curr.trafo}
        ShowMeasuredCurrent;
        {show current at ref. and meas. CT, in diagram}
        ShowCurrRes(pRefCT_r,imagoo.ShowCurrBut.caption);  {show the desired phase of the current, in Elplex.pas}
        ShowCurrRes(pMeasCT_r,imagoo.ShowCurrBut.caption);
      end else begin                                   {solution cannot be found}
        if (f1st < flast) then begin
        {no solution, because current increases when distance to relay increases (= some error)}
          TestEdit.text := 'Warning: Current increases in '+MeasureEdit.text+' and decreases in '+
                            ReferenceEdit.text;
          MeasCurrEdit.text := TenChar(Ima);   {Display larger current, TenChar in Emtp.pas}
        end else if (flast < 0) then begin
        {no solution, because set current too large}
           TestEdit.text := 'current setting too large';
        end else if (flast > 0) then begin
        {no solution, because set current too small = end of zone not found}
           TestEdit.text := 'End of zone not found (Ikz > Isz). Try multi Zlines-button (or next zone)';
           fp_r := fp;                                   {save for iteration with fault impedance}
        end else begin
        {some other reason (error?)}
          TestEdit.text := 'No solution, reason unknown';
        end;
      end;
      {end of calculations, free reserved space etc}
      LineDataFree;
      {release memory for current transformers (if not LLL-fault)}
      if (not ThreePhaseBut.checked) then begin
        if (SetComp.nCurrTr > 0) and (SetComp.ppCurrTr <> nil) then
          SetComp.FreeMemForCurrTrAndRelays;
      end;
    end else begin                           {buses or CT's or .. missing}
      if (SetComp.pCompList.indexof(pMeasCT_r)  <  0) then showmessage('measurement CT??');
      if (SetComp.pCompList.indexof(pRefCT_r)   <  0) then showmessage('reference CT??');
      if (SetComp.pCompList.indexof(pUpstr_r)   <  0) then showmessage('upstream bus?');
      if (SetComp.pCompList.indexof(pDownstr_r) <  0) then showmessage('downstream bus??');
      if (CurrentEdit.color = clYellow) then showmessage('Current setting??'); {yellow = error flag}
      if (LinkList_r.count <= 0) then showmessage('lines between buses??');    {lines in the list}
    end;
  end else begin                             {no link or fault or current}
    if (not LinkFound_r) then begin          {no link of lines between the buses}
      showmessage('No transmission line(s) between given buses !');
    end else if (pFault_r = nil) then begin  {no fault in the diagram}
      showmessage('No fault!');
    end else if (er <> 0) then begin         {some error in the set current}
      showmessage('Error in Current setting');
    end else begin                           {else - should not be possible}
      showmessage('some error?');
    end;
  end;
  Calculate_r := false;
end;

procedure TRelayCalcForm.SearchFaultImpedance;
{If end of zone not found, the search may be continued by increasing the fault
 impedance.
 "End of zone not found" = fault is at the far end of the line(s), but the
  current measured by the reference CT is still larger than the Current Setting.
 In that case, increase the fault impedance until the current measured by the
 reference CT is equal to the Current Setting.
 For this searh, the (old) positive function value fp_r must be known (obtained when
 the fault is the far end of the last line = at the downstream bus.
 The search is done by setting the fault impedance to some multiple of the line impedance}
begin
{ }
end;

procedure TRelayCalcForm.MultiZButClick(Sender: TObject);
{increase fault impedance, until current at desired value}
begin
{?} SetComp.Appl_Op := 18;
  Imagoo.SolvedProb.picture := nil;
  Calculate_r := true;
  {reserve space for current transformers, if not LLL-fault (reserves in SolveNet)}
  if (not ThreePhaseBut.checked) then begin
    SetComp.GetMemForCurrTrAndRelays;
  end;
//SearchFaultImpedance;
  FindFaultImpedance(Ztot_r);
  {release memory for current transformers (if not LLL-fault)}
  if (not ThreePhaseBut.checked) then begin
    if (SetComp.nCurrTr > 0) and (SetComp.ppCurrTr <> nil) then
      SetComp.FreeMemForCurrTrAndRelays;
  end;
  Calculate_r := false;
end;

procedure TRelayCalcForm.CreateSection(pComp: TpComp; cu,cd, n1,n2: integer; iLine: integer);
{create the object for a line section, and add it to the list of line sections
 pComp  pointer to the component
 cu,cd  upstream, downstream (wrt component) conn. point (within the component)
 n1,n2  upstream and downstream nodes (up,down wrt the component)
 iLine  index of line, if component with lines with mutual impedances, else -1}
var
  pLsect : TpLineSection; {pointer to a (new) line section}
begin
  new(pLsect);                        {reserve space for the object}
  pLsect^ := TLineSection.Create;     {create the object}
  pLsect^.pComp_c := pComp;
  pLsect^.upstr_c := n1;              {upstream node}
  pLsect^.downstr_c := n2;
  pLsect^.cpUp_c := cu;               {upstr. conn.point}
  pLsect^.cpDown_c := cd;
  pLsect^.iLine_c := iLine;           {line section, if lines with mutual imped., else -1}
  Sections_r.add(pLsect);             {add to list of sections}
end;

procedure TRelayCalcForm.FindNodeIndices;
{the lines are collected in a list as objects. The up- and downstream nodes
 are indexed in the order of appearance. The indices are saved in the abovementioned
 objects. Each index corresponds to a (unique) node. That is, if two lines have a
 common node (are connected) then the nodes of both lines have the same index (of course?)}
var
  foundup : boolean;        {upstr.node found among nodes of other lines}
  founddw : boolean;        {downstr.node found}
  ii      : integer;
  iLsect  : integer;        {index}
  pList   : TpList;         {pointer to the list}
  pLsect  : TpLineSection;  {pointer to the line section under study}
  pOther  : TpLineSection;  {pointer to a section in the list}
begin
  pList := @ConnLines_r;                       {use local variable}
  if (pList^.count > 0) then begin             {there are lines in the list}
    nNodes_r := 0;                             {initialize}
    {find node indices for all lines in the list}
    for iLsect := 0 to pList^.count-1 do begin
      pLsect := pList^[iLsect];
      {if first line section, the node indices must be 1 and 2}
      if (iLsect = 0) then begin
        pLsect^.iUp_c := 1;
        pLsect^.iDown_c := 2;
        nNodes_r := 2;
      end else begin
        {not first, must check previous nodes}
        {check, is/are the node/s already indexed}
        foundup := false;                          {initialize}
        founddw := false;
        {check all previous sections}
        for ii := 0 to iLsect-1 do begin
          pOther := pList^[ii];                    {pointer to a section, for comparison}
          if (pOther <> pLsect) then begin         {should be, but check just to be sure}
            {first, check the upstream node}
            if (pLsect^.upstr_c = pOther^.upstr_c) then begin   {same as upstr. node of another line}
              pLsect^.iUp_c := pOther^.iUp_c;      {copy index}
              foundup := true;
            end else if (pLsect^.upstr_c = pOther^.downstr_c) then begin
              {same as downstr. node of another line}
              pLsect^.iUp_c := pOther^.iDown_c;     {copy index}
              foundup := true;
            end;
            {next, check the downstream node}
            if (pLsect^.downstr_c = pOther^.upstr_c) then begin   {same as upstr. node of another line}
              pLsect^.iDown_c := pOther^.iUp_c;     {copy index}
              founddw := true;
            end else if (pLsect^.downstr_c = pOther^.downstr_c) then begin
              {same as downstr. node of another line}
              pLsect^.iDown_c := pOther^.iDown_c;   {copy index}
              founddw := true;
            end;
          end;
        end;
        {if node(s) not found, must increase index}
        if (not foundup) then begin                 {upstream node not found among "old" nodes}
          inc(nNodes_r);
          pLsect^.iUp_c := nNodes_r;
        end;
        if (not founddw) then begin                 {downstream node not found}
          inc(nNodes_r);
          pLsect^.iDown_c := nNodes_r;
        end;
      end;
    end;
  end;
end;

procedure TRelayCalcForm.FindLineSections;
{construct list of lines and/or line sections
 Section: if "simple" line has three nodes, or
          a section of lines-component with mutual impedances}
var
  apu    : single;        {temporary}
  ern    : integer;       {error flag}
  err    : integer;       {error flag}
  jcomp  : integer;       {counter}
  jj     : integer;       {index}
  j1,j2  : integer;       {connection points (local nodes)}
  j3     : integer;       {connection point}
  name   : string;        {name = type of the component}
  n1,n2  : integer;       {nodes}
  n3     : integer;       {node}
  nLines : integer;       {number of lines in comp. with mutual impedances}
  nnod   : integer;       {number of nodes}
  pComp  : TpComp;        {pointer to a component}
begin
  SectionsFree;                               {release possible old sections}
  {scan all components, find lines}
  pComp := nil;
  err := 0;
  jcomp := 0;
  while (err = 0) do begin                    {scan all components}
    SetComp.NextComp(pComp, err,jcomp,false); {pointer to next component}
    if (err = 0) then begin                   {no errors, no more components}
      pComp^.GetName(name);                   {get name (type) of the comp.}
      if (name = gTrLiS) then begin           {"simple" line}
        {normally two nodes, but may have three connection points = nodes}
        pComp^.GetNnod(nnod);
        pComp^.GetNode(1,n1,ern);             {upstream (wrt component) node (in network)}
        pComp^.GetNode(2,n2,ern);             {downstream node}
        {assume: always only two nodes in use (third may be connected, but not to a line}
        CreateSection(pComp,1,2, n1,n2,-1);   {create obj. for section, add to list}
      end else if (name = gMutual) then begin {lines with mutual impedance}
        pComp^.getPar(1,apu);                 {number of lines}
        nLines := round(apu);
        {check all lines of this component}
        for jj := 1 to nLines do begin
          {get up- and downstream and middle nodes of this line among all nodes}
          NodesOfLine(jj, j1,j2,j3);
          pComp^.GetNode(j1,n1,ern);
          pComp^.GetNode(j2,n2,ern);
          pComp^.GetNode(j3,n3,ern);
          {assume: always only one section..., two is not probable}
          CreateSection(pComp,j1,j2, n1,n2,jj);     {object from upstr.node to downstr. node}
        end;
      end;
    end;
  end;
end;

procedure TRelayCalcForm.CheckLineSections(iList: longint);
{show data of line sections, for check}
var
  ii     : integer;       {index}
  ix,iy  : integer;       {coordinates}
  lbl    : string;        {label (name) of the component}
  n1,n2  : integer;       {nodes}
  pList  : TpList;        {pointer to a list}
  pLsect : TpLineSection; {pointer to a (new) line section}
begin
  pList := TpList(iList);
  if (pList^.count > 0) then begin
    for ii := 0 to pList^.count-1 do begin
      pLsect := pList^[ii];
      pLsect^.pComp_c^.getLabel(lbl,ix,iy); {label of the component}
      n1 := pLsect^.upstr_c;                {upstr.node}
      n2 := pLsect^.downstr_c;              {downstr.node}
      showmessage(lbl+'  '+inttostr(n1)+'  '+inttostr(n2));
    end;
  end;
end;

procedure TRelayCalcForm.FindConnectedLines(nodeUp,nodeDown: integer; var down: boolean);
{find lines that are connected to the given upstream node either directly or through
 other lines
 Check, are the lines connected also to the downstream node
 nodeUp   (network) upstream node to which lines connected
 nodeDown check, are the lines connected to this downstream node, set...
 ..down to true, if connected}
var
  firstF  : boolean;        {found line connected to the first (given) node}
  iconn   : integer;        {index for connected lines}
  ii      : integer;        {index}
  itry    : integer;        {index}
  iunc    : integer;        {index}
  lineF   : boolean;        {found connected line}
  ll      : longint;        {temporary}
  nConn   : integer;        {number of connected lines, so far}
  nLines  : integer;        {number of lines}
  ntry    : integer;        {max.no of searches}
  nunc    : integer;        {unconnected node}
  nup,ndw : integer;        {upstr, downstr nodes of an unconnected line}
  pConn   : TpLineSection;  {pointer to a connected line}
  pLine   : TpLineSection;  {pointer to a line (section)}
  unconn  : integer;        {unconnected node of a connected line}
begin
  down := false;            {initialize}
  ConnLines_r.clear;
  if (Sections_r.count > 0) then begin     {there are lines (sections)}
    {clear indices and flags}
    for ii := 0 to Sections_r.count-1 do begin
      pLine := Sections_r[ii];
      pLine^.iUp_c := -1;
      pLine^.iDown_c := -1;
      pLine^.new_c := false;
      pLine^.inList_c := false;
      pLine^.unconn_c := '';
    end;
    {start searching}
    nLines := Sections_r.count;               {no of lines to local}
    ntry := 2*nLines;                         {max. no of searches (actually = nLines !?)}
    {first, find lines directly connected to the given node}
    firstF := false;                           {initialize flag}
    Unconn_r.clear;
    for ii := 0 to nLines-1 do begin
      pLine := Sections_r[ii];
      {is it connected to the given node}
      if (pLine^.upstr_c = nodeUp) then begin {upstream node connected to given node}
        ConnLines_r.add(pLine);
        firstF := true;
        pLine^.new_c := true;                 {this line newly added}
        pLine^.inList_c := true;              {this line is now in the list}
        pLine^.unconn_c := 'down';            {downstream node not connected, so far}
      end else if (pLine^.downstr_c = nodeUp) then begin
        ConnLines_r.add(pLine);
        firstF := true;
        pLine^.new_c := true;
        pLine^.inList_c := true;
        pLine^.unconn_c := 'up';
      end;
    end;
    {continue only if some line(s) connected to the given node}
    if (firstF) then begin
      {search for lines connected to the previously connected lines, until no more lines found}
       lineF := false;                          {initialize flag}
       for itry := 1 to ntry do begin           {why not "while" ?}
         nConn := ConnLines_r.count;            {number of connected lines, in this phase}
         for ii := 0 to nLines-1 do begin       {scan the list of lines}
           pLine := Sections_r[ii];             {pointer to a line}
           if (not pLine^.inList_c) then begin  {check only lines that are not yet connected}
             {check connection of unconnected nodes of connected lines}
             nup := pLine^.upstr_c;             {upstr.node of unconnected line}
             ndw := pLine^.downstr_c;           {downstr node of unconnected line}
             {compare with unconnected nodes of newly connected lines}
             for iconn := 0 to nConn-1 do begin {should start from old nConn.. (maybe later...)}
               pConn := ConnLines_r[iconn];
               if (pConn^.new_c) then begin               {newly connected line}
                 {select the unconnected node of the connected line}
                 if (pConn^.unconn_c = 'up') then         {upstream node not connected}
                   nunc := pConn^.upstr_c
                 else if (pConn^.unconn_c = 'down') then  {downstream node not connected}
                   nunc := pConn^.downstr_c
                 else nunc := -10;                        {error}
                 {compare with the nodes of the line under study}
                 if (pLine^.upstr_c = nunc) then begin    {upstream node connected to given node}
                   ConnLines_r.add(pLine);
                   lineF := true;
                   pLine^.new_c := true;                  {this line newly added}
                   pLine^.inList_c := true;               {this line is now in the list}
                   pLine^.unconn_c := 'down';             {downstream node not connected, so far}
                   break;                                 {connection to one line suffices}
                 end else if (pLine^.downstr_c = nunc) then begin
                   ConnLines_r.add(pLine);
                   lineF := true;
                   pLine^.new_c := true;
                   pLine^.inList_c := true;
                   pLine^.unconn_c := 'up';
                   break;
                 end;
               end;
             end;
           end;
         end;
         {clear old new-flags}
         for iconn := 0 to nConn-1 do begin
           pConn := ConnLines_r[iconn];
           pConn^.new_c := false;
         end;
         if (not lineF) then break;           {no more connected lines found}
       end;
       {check, is some line connected to the downstream node}
       if (ConnLines_r.count > 0) then begin  {there are lines}
         for ii := 0 to ConnLines_r.count-1 do begin
           pLine := ConnLines_r[ii];
           if (pLine^.upstr_c = nodeDown) or
              (pLine^.downstr_c = nodeDown) then begin
             down := true;
             break;
           end;
         end;
       end;
    end else begin
      {no lines connected to the given node, do nothing}
    end;
  end;
end;

procedure TRelayCalcForm.FindUpDownIndices(var iup,idw: integer);
{find the indices of the nodes that are connected the upstream and downstream buses
 iup, idown  the indices}
var
  ern     : integer;       {error flag}
  ii      : integer;       {index}
  nup,ndw : integer;       {network node of the up- and downstream buses}
  pLine   : TpLineSection; {pointer to a line}
begin
  {get indices of up- and downstream nodes}
  pUpstr_r^.GetNode(1,nup,ern);         {node of the upstream bus}
  pDownstr_r^.GetNode(1,ndw,ern);       {node of the downstream bus, needed later}
  {find corresponding indices}
  iup := -1; idw := -1;                 {initialize, as flags}
  for ii := 0 to ConnLines_r.count-1 do begin
    pLine := ConnLines_r[ii];           {pointer to a line-object}
    if (iup < 0) then begin             {index for upnode not yet found}
      if (pLine^.upstr_c = nup) then iup := pLine^.iup_c
      else if (pLine^.downstr_c = nup) then iup := pLine^.idown_c;
    end;
    if (idw < 0) then begin             {index for downnode not yet found}
      if (pLine^.upstr_c = ndw) then idw := pLine^.iup_c
      else if (pLine^.downstr_c = ndw) then idw := pLine^.idown_c;
    end;
    {break loop, if both indices found}
    if (iup >= 0) and (idw >= 0) then break;
  end;
end;

procedure TRelayCalcForm.CalculateFictiveCurrents(Eup: single; iup,idw: integer);
{calculate fictive currents in the lines connected to the up- and downstream buses
 in order to deduce, how the buses are connected: one chain of lines, or parallel
 paths
 Eup      upstream (fictive) voltage;
 iup, idw indices of the nodes of the upstr. and downstr. buses}
var
  apu     : single;        {temporary}
  dodd    : single;        {flag for permutations}
  ii      : integer;       {index}
  ju,jd   : integer;       {indices of up- and downstr. nodes of a line}
  nn      : integer;       {dimension = number of unknowns}
  paa,pbb : pSingle;       {coefficient matrix, right hand side}
  pii     : pInteger;      {index array}
  pLine   : TpLineSection; {pointer to a line}
  pww     : pSingle;       {working space}
  sngl    : integer;       {flag for singular}
  tout    : single;        {test output}
  Vup,Vdw : single;        {upstr. and downstr. "voltages" of lines}
begin
  {get memory for the equations}
  nn := nNodes_r+2;                     {number of nodes + currents in and out}
  nn := nNodes_r+2;
  getmem(paa,nn*nn*Sizeof(single));     {for admittance matrix}
  getmem(pww,nn*Sizeof(single));        {for working space}
  getmem(pbb,nn*Sizeof(single));        {for right hand side}
  getmem(pii,nn*Sizeof(integer));       {for index array}
  ClearREq(nn, paa, pww, pbb, pii);     {clear the matrices and vectors initially}
  {construct the equations for the nodes}
  for ii := 0 to ConnLines_r.count-1 do begin
    pLine := ConnLines_r[ii];
    ju := pLine^.iup_c;                 {upstream index}
    jd := pLine^.idown_c;               {downstream index}
    getmat(paa,ju,ju,nn,nn,apu);
    apu := apu+1;
    putmat(paa,ju,ju,nn,nn,apu);
    getmat(paa,ju,jd,nn,nn,apu);
    apu := apu-1;
    putmat(paa,ju,jd,nn,nn,apu);
    getmat(paa,jd,jd,nn,nn,apu);
    apu := apu+1;
    putmat(paa,jd,jd,nn,nn,apu);
    getmat(paa,jd,ju,nn,nn,apu);
    apu := apu-1;
    putmat(paa,jd,ju,nn,nn,apu);
  end;
  {add the input and output currents to the up- and downstr. buses}
  getmat(paa,nn-1,iup,nn,nn,apu);
  apu := apu+1;
  putmat(paa,nn-1,iup,nn,nn,apu);
  getmat(paa,iup,nn-1,nn,nn,apu);
  apu := apu-1;
  putmat(paa,iup,nn-1,nn,nn,apu);
  {then downstream bus}
  getmat(paa,nn,idw,nn,nn,apu);
  apu := apu-1;
  putmat(paa,nn,idw,nn,nn,apu);
  getmat(paa,idw,nn,nn,nn,apu);
  apu := apu+1;
  putmat(paa,idw,nn,nn,nn,apu);
  {"voltage" source to right hand side}
  putvec(pbb,nn-1,nn,Eup);
  {solve: decompose}
  LUdecomp(paa,pww,nn,pii,dodd,sngl,tout);
  {solve: backsubstitute}
  LUbacksub(paa,nn,pii,pbb);
  {results to lines}
  for ii := 0 to ConnLines_r.count-1 do begin   {all lines connected to up- and downstr. buses}
    pLine := ConnLines_r[ii];
    iup := pLine^.iup_c;                        {index of upstream node}
    idw := pLine^.idown_c;
    getvec(pbb,iup,nn,Vup);                     {upstream "voltage"}
    pLine^.Vup_c := Vup;
    getvec(pbb,idw,nn,Vdw);
    pLine^.Vdown_c := Vdw;
    apu := Vup-Vdw;                             {"current" in line}
    pLine^.Curr_c := apu;
  end;
  {"currents" in and out (upstr, and downstr) to separate variables}
  getvec(pbb,nNodes_r+1,nn,CurrUp_r);
  getvec(pbb,nNodes_r+2,nn,CurrDown_r);
  {finally, release the reserved memory}
  freemem(paa,nn*nn*Sizeof(single));     {for admittance matrix}
  freemem(pww,nn*Sizeof(single));        {for working space}
  freemem(pbb,nn*Sizeof(single));        {for right hand side}
  freemem(pii,nn*Sizeof(integer));       {for index array}
end;

procedure TRelayCalcForm.FindLinkBetweenBuses;
{In order to find the lines between the given buses, solve fictive currents in the
 network consisting of the lines connected to the up- and downstream buses}
const
  Eup = 270720.0;          {fictive upstream voltage}
var
  apu     : single;        {temporary}
  dCurr   : single;        {current difference}
  ii,jj   : integer;       {index}
  ix,iy   : integer;       {coordinates}
  iup,idw : integer;       {indices of upstream and downstream nodes (buses)}
  lbl     : string;        {label}
  nupdown : integer;       {number  of lines with nearly the upstr. and downstr. current}
  nzero   : integer;       {number of lines with nearly zero current}
  pLine   : TpLineSection; {pointer to a line}
  pUp,pDw : pInteger;      {upstr, downstr. node wrt the network, as pointers}
  Volt    : single;        {voltage of the unconnected end}
begin
  if (ConnLines_r.count > 0) then begin
    {get indices of up- and downstream nodes}
    FindUpDownIndices(iup,idw);
    {continue, if indices for upstr. and downstr. nodes found}
    if (iup >= 0) and (idw >= 0) then begin
      {calculate the "currents" in the lines, in order to determine the connections}
      CalculateFictiveCurrents(Eup,iup,idw);
      {a unique path between upstream and downstream buses exists, if abs(some currents)
       are (nearly) equal, including the currents in and out, and other currents are (nearly) zero}
      {if connected, there should be a reasonable current (actually, much > 2)}
      if (abs(CurrUp_r) > 2) and (abs(CurrDown_r) > 2) then begin
        apu := abs(CurrUp_r)-abs(CurrDown_r);         {abs not necessary?}
        {upst. and downstr. currents should be (nearly) equal}
        dCurr := abs(CurrUp_r)/512.0;
        if (abs(apu) < dCurr) then begin
          {count the number of lines with neary zero current, and nearly up. or downstr. current}
          nZero := 0;
          nUpDown := 0;
          for ii := 0 to ConnLines_r.count-1 do begin
            pLine := ConnLines_r[ii];
            {nearly zero current}
            if (abs(pLine^.Curr_c) < dCurr) then begin
              inc(nZero);
              pLine^.inLink_c := false;           {certainly not in the link between the buses}
              pLine^.included_c := false;         {initialize (although not needed?)}
            {nearly same current as upstr. or downstr. current}
            end else if (abs(abs(pLine^.curr_c)-abs(CurrUp_r)) < dCurr) then begin
              inc(nUpDown);
              pLine^.inLink_c := true;            {probably in the link between buses}
              pLine^.included_c := false;         {initialize: not yet included in the list}
            end;
          end;
          {if all lines counted (either zero current, or in/out current), unique link exists}
          if (nZero+nUpDown = ConnLines_r.count) then begin
            LinkFound_r := true;
            {collect the lines of the link in a list, from upstream to downstream bus}
            LinkList_r.clear;
            LinkRev_r.clear;                               {flags for reversed lines. Nil = not reversed}
            LinkDown_r.clear;
            LinkUp_r.clear;

            Volt := Eup;                                   {initialize as voltage of first node}
            for ii := 1 to nUpDown do begin                {all lines in the link}
              for jj := 0 to ConnLines_r.count-1 do begin  {check all (for simplicity?)}
                pLine := ConnLines_r[jj];
                {this line belongs to the link (as found above), but is not yet included in the list}
                if (pLine^.inLink_c) and not(pLine^.included_c) then begin
                  pLine^.pComp_c^.GetLabel(lbl,ix,iy);
                  {upstr.node connected to the previous node?}
                  if (abs(pLine^.Vup_c-Volt) < dCurr) then begin
                    LinkList_r.add(pLine^.pComp_c);        {add to link}
                    pLine^.included_c := true;             {set flag that already in the list}
                    Volt := pLine^.Vdown_c;                {voltage of "unconnected" end}
                  {downstr.node connected to the previous node?}
                  end else if (abs(pLine^.Vdown_c-Volt) < dCurr) then begin
                    LinkList_r.add(pLine^.pComp_c);
                    pLine^.included_c := true;
                    Volt := pLine^.Vup_c;
                  end else begin
                    {should not be possible...?}
                  end;
                  {check, is the line reversed}
                  {sure: same as in LinkList:ss ????? (objects ..._c better !!}
                  if (pLine^.Curr_c < 0) then begin
                    LinkRev_r.add(pLine^.pComp_c);      {reversed = negative current}
                    {upstream (wrt buses) conn.point (within comp.) , as pointer}
                    LinkUp_r.add(pInteger(pLine^.cpDown_c));
                    LinkDown_r.add(pInteger(pLine^.cpUp_c));
                  end else begin                        {not reversed, "nil" as pointer}
                    LinkRev_r.add(nil);
                    {upstream (wrt buses) conn.point (within comp.) , as pointer}
                    LinkUp_r.add(pInteger(pLine^.cpUp_c));
                    LinkDown_r.add(pInteger(pLine^.cpDown_c));
                  end;


                end;
              end;
            end;
          end else begin
            {parallel lines somewhere. Must ask user, which ones included}


          end;
        end else begin
          {current in and out not equal. Some error?}
        end;
      end else begin
        {no current, not connected (should be, checked above)}
      end;
    end;
  end;
end;

end.

