unit Routines;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, StdCtrls,utildef,Imagodef, JpgImg;

procedure SaveJpegImage(pForm: TpForm; pictbit: Tbitmap; FileName: string);
procedure DecimalPoint(var dec_p: Char);
procedure FlagDecimalPoint(text: string; var dpflag : integer);
procedure ExtractHint(Txin : String; var Txout: String);
procedure ExtractParam(SetNo: Integer; sc: char; Txin : String; var Txout: String);
procedure ExtractNextParam(iStrt: integer; sc: char; Txin: string;
                           var Txout: string; var iEnd: integer);
procedure ReplaceSpecials(Txin : String; xch1,xch2,xch3,xch4,xch5,xch6,xch7,xch8 :char;
                          var Txout: String);
procedure chkfloat(linein: String; var ercod: Integer; var line: string);
procedure chkint(line : string; var err : integer);
procedure LongintFromLine(line: String; nth: integer; var llpar: longint;
                                                      var err: integer);
procedure ValuesFromLine(line: String; nstrt :Integer; shower: boolean;
                         var ipar: Integer;
                         var pa1,pa2,pa3,pa4 : Single;
                         var st1,st2,st3,st4 : string;
                         var errc: Integer);
procedure NextValueFromLine(line: String; kstrt :Integer; var kend : integer;
                        var par : Single; var str : string; var errc :Integer);
procedure NumberOfParametersOnLine(line : string; var np :Integer);
procedure NumberOfWordsX(hintx, spec :String; onlyspace:boolean; wno: Integer;
                    var npar,wlen: Integer; var oneword:String);
procedure FindWord(text : string; istrt : integer; var wout : string; var iend : integer);
procedure RemoveSpaces(rnum: Single; var Disp2:String);
procedure AlignText(line,value:String; var newlin:String);
function NearestGrid(Xin:Integer;Half:Boolean):Integer;
procedure CenterToGrid(width, height: Integer; var left,top: Integer);
procedure DrawMarker(pMark: TpImage; MarkColor : Tcolor);
procedure OnlyValue(Txin : string; var Txut : string);
procedure ReduceSpaces(Txin: string; var Txut: string);
function ManyChars(rr : single; Etoe: boolean) : string;
function spaceless(text : string): string;
procedure EngFormat(rr : single; var engrr : string);
procedure EngFormat5(rr : single; var engrr : string; remsp: boolean);
function AppendTxtIf(lbl : string; OldTxt: string; sep : char): string;

implementation

uses
  skemadef;

function ManyChars(rr : single; Etoe : boolean) : string;
{write a positive or negative real using several places, fill with leading spaces (?)
 rr    the real
 Etoe  if true, a 'E' is changed to 'e'}
const
  small = 1e-9;
var
  aa       : single;     {abs value of rr}
  efound   : boolean;    {found 'e' or 'E' }
  first    : boolean;
  ii,jj,kk : integer;
  len      : integer;    {length of line}
  line     : string;     {text under construction}
  ss       : string;     {space or minus sign}
  started  : boolean;    {nonzero number found}
  text,txt : string;
begin
  aa := abs(rr);
  if (aa < small) then begin
    text := ' 0.0      ';
{   k0Form.edit1.text := floattostr(aa);}
  end else if (aa < 0.0001) then
    text := format({'%9.7g'}'%6.4g',[aa])
  else if (aa < 1.0) then begin
    line := format({'%10.8f'}'%7.5f',[aa]);
    {remove trailing zeroes}
    len := length(line);
    if (len > 1) then begin
      text := '';
      for ii := 1 to len do begin
        text := text+' ';          {lengt same as line, but only spaces}
      end;
      started := false;            {not yet found a nonzero number}
      kk := len;                   {last char. in text}
      for ii := 1 to len do begin
        jj := len-ii+1;
        if (line[jj] = '0') and (not started) then begin
          {zeroes not copied}
        end else begin
          text[kk] := line[jj];
          dec(kk);
          started := true;         {a nonzero number found}
        end;
      end;
    end else begin
      text := line;
    end;
  end else if (aa < {1.e5}5e5) then begin
    if (aa = round(aa)) then begin
      txt := format('%6.5g',[aa]);{+'.0'}  {integer}
      {add a .zero, if not scientific notation}
      len := length(txt);
      efound := false;
      if (len > 0) then begin
        text := '';
        for ii := 1 to len do begin
          if (txt[ii] = 'e') or (txt[ii] = 'E') then begin
            efound := true;
            break;
          end;
        end;
        if (not efound) then text := txt+'.0' else text := txt;
      end else begin
        text := txt;
      end;
    end else text := format({'%9.8g'}'%6.5g',[aa]);
  end else if (aa < 1.e20) then
    text := format({'%9.8g'}'%6.5g',[aa])
  else
    text := '1.0e20    ';
  len := length(text);
  line := '';
  if (len > 0) then begin
    {add the minus sign for a negative number}
    if (aa >= small) then begin    {no minus sign to zero}
      if (rr < 0) then ss := '-'
      else             ss := ' ';
      first := true;
      for ii := 1 to len do begin
        if (text[ii] <> ' ') and first then begin
          line := line+ss;
          first := false;
        end;
        line := line+text[ii];
      end;
    end else begin
      line := text;      {zero...}
    end;
  end;
  {change E to e}
  len := length(line);
  if (len > 1) and (Etoe) then begin
    for ii := 1 to len do begin
      if (line[ii] = 'E') then line[ii] := 'e';
    end;
  end;
  ManyChars := line;
end;

function spaceless(text : string): string;
{remove spaces from text}
var
  ii    : integer;
  len   : integer;
  txout : string;
begin
  len := length(text);
  txout := '';
  if (len > 0)  then begin
    for ii := 1 to len do begin
      if (text[ii] <> ' ') then txout := txout+text[ii];
    end;
  end;
  spaceless := txout;
end;

procedure EngFormat(rr : single; var engrr : string);
{format a variable in the engineering style = ten to multiples of three (E3, E6, etc)
 remove any spaces
 rr     the variable to be formatted
 engrr  the variable rr formatted}
var
  apu : single;   {temporary}
  ar  : single;   {abs. value of rr}
  arf : string;   {formatted ar}
  ii  : integer;  {index}
  len : integer;  {length}
  txt : string;   {temporary}
begin
  ar := abs(rr);  {use abs.value, add the sign later}
  if (ar < 1.e-6) then begin
    arf := format('%12.6g',[ar]);
  end else if (ar < 0.001) then begin
    apu := ar*1e6;
    arf := format('%12.6g',[apu])+'e-6';
  end else if (ar < 1.0) then begin
    arf := format('%12.5g',[ar]);
  end else if (ar < 1000.0) then begin
    arf := format('%12.6g',[ar]);
  end else if (ar < 1e6) then begin
    apu := ar*0.001;
    arf := format('%12.6g',[apu])+'e3';
  end else if (ar < 1e9) then begin
    apu := ar*1.e-6;
    arf := format('%12.6g',[apu])+'e6';
  end else begin
    arf := Format('%12.6g',[ar]);
  end;
  {remove spaces}
  len := length(arf);        {length of the formatted string}
  if (len > 0) then begin
    txt := '';
    for ii := 1 to len do begin
      if (arf[ii] <> ' ') then txt := txt+arf[ii];
    end;
  end else begin
    txt := '';
  end;
  {add sign}
  if (rr < 0) then txt := '-'+txt;
  {copy to output}
  engrr := txt;
end;

procedure EngFormat5(rr : single; var engrr : string; remsp: boolean);
{format a variable in the engineering style = ten to multiples of three (E3, E6, etc)
 remove any spaces, if desired
 rr     the variable to be formatted
 engrr  the variable rr formatted
 remsp  remove spaces, if true}
var
  apu : single;   {temporary}
  ar  : single;   {abs. value of rr}
  arf : string;   {formatted ar}
  ii  : integer;  {index}
  len : integer;  {length}
  rfs : string;   {formatted, with sign, with spaces}
  sgn : boolean;  {sign added}
  txt : string;   {temporary}
begin
  ar := abs(rr);  {use abs.value, add the sign later}
  if (ar < 1.e-6) then begin
    arf := format('%11.5g',[ar]);
  end else if (ar < 0.001) then begin
    apu := ar*1e6;
    arf := format('%11.5g',[apu])+'e-6';
  end else if (ar < 1.0) then begin
    arf := format('%11.5g',[ar]);
  end else if (ar < 1000.0) then begin
    arf := format('%11.5g',[ar]);
  end else if (ar < 1e6) then begin
    apu := ar*0.001;
    arf := format('%11.5g',[apu])+'e3';
  end else if (ar < 1e9) then begin
    apu := ar*1.e-6;
    arf := format('%11.5g',[apu])+'e6';
  end else begin
    arf := Format('%11.5g',[ar]);
  end;
  {add sign}
  if (rr < 0) then begin
    len := length(arf);
    if (len > 1) then begin
      if (arf[1] <> ' ') then begin              {first char is nonspace}
        txt := '-'+arf;
      end else begin                             {some space(s) first, must insert -}
        txt := '';
        for ii := 1 to len-1 do begin
          {look for first nonspace char}
          if (arf[ii] = ' ') then begin          {this is space, but...}
            if (arf[ii+1] <> ' ') then           {.. next is the first non-space }
              txt := txt+'-'                     {add - sign instead of the space}
            else
              txt := txt+arf[ii];
          end else begin
            txt := txt+arf[ii];
          end;
        end;
        {add the last char. in any case}
        txt := txt+arf[len];
      end;
    end else begin        {length =1 (or 0?), but is negative}
      txt := '-'+arf;
    end;
    rfs := txt;
  end else begin
    rfs := arf;            {positive, copy as such}
  end;
  {add some spaces, for equal length (can be removed below!}
  len := length(rfs);
  if (len = 11) then txt := '  '+rfs
  else if (len = 12) then txt := ' '+rfs
  else if (len = 13) then txt := rfs
  else if (len = 14) then begin  {if too long, leave first char out, if space}
    if (rfs[1] = ' ') then begin
      txt := '';
      for ii := 2 to len do txt := txt+rfs[ii];
    end else begin
      txt := rfs;
    end;
  end else txt := rfs;
  rfs := txt;           {copy back}
  {remove spaces, if desired}
  if (remsp) then begin
    len := length(rfs);        {length of the formatted string}
    if (len > 0) then begin
      txt := '';
      for ii := 1 to len do begin
        if (rfs[ii] <> ' ') then txt := txt+rfs[ii];
      end;
    end else begin
      txt := '';
    end;
  end else begin
    txt := rfs;
  end;
  {copy to output}
  engrr := txt;
end;

procedure SaveJpegImage(pForm: TpForm; pictbit: Tbitmap; FileName: string);
{save a bitmap in the Jpeg form to a file
 pForm     pointer to the form where the bitmap is defined (needed as owner and parent)
 pictbit   the bitmap to be saved
 FileName  name of the file where saved}
var
  FormJpeg    : TJpegImage; {for saving the bitmap as a jpeg-image}
begin
  FormJpeg := TJpegImage.create(pForm^);
  FormJpeg.parent := pForm^;
  FormJpeg.quality := 100;                   {default = 75, but now the file is larger}
  FormJpeg.picture.bitmap.assign(pictbit);   {copy in jpeg-format}
  FormJpeg.savetofile(FileName);
  FormJpeg.free;
end;

procedure FlagDecimalPoint(text: string; var dpflag : integer);
{set the flag, if the decimal point is in the text}
var
  len : integer;
  ii  : integer;
begin
  len := length(text);            {length of text}
  dpflag := 0;                    {initialize flag for decimal point}
  if (len > 0) then begin
    for ii := 1 to len do begin
      if (text[ii] = '.') or
         (text[ii] = ',') then begin
          dpflag := 1;            {flag the decimal point}
          break;
      end;
    end;
  end;
end;

procedure DecimalPoint(var dec_p: Char);
{determines the character for decimal point, is it a full stop (.),
 or a comma (,), and copies it to dec_p}
var
  apu   : Single;    {temporary}
  i     : Integer;   {counter, or index}
  iapu  : Integer;   {length of line, temporary}
  line  : String;    {apu as string, temporary}
  tx    : Char;      {one character, temporary}
begin
  {determine, is  comma (,) or period (.) used as decimal point}
  apu := 0.5;                   {need a value with decimal point}
  line := floattostr(apu);      {change it to string}
  iapu := length(line);         {length of the string (should be 3 !)}
  tx := ',';                    {default decimal point}
  for i:=1 to iapu do begin
    if (line[i] = '.') or (line[i] = ',') then begin
      tx := line[i];            {pick . or ,}
      break;
    end;
  end;
  dec_p := tx;                  {copy the decimal point to output}
end;

procedure ExtractHint(Txin : String; var Txout: String);
{Extracts from thext in Txin  the first part ending with a semicolon,
 writes it to Txout
 (The input text is assumed to contain several pieces of information,
  separated by semicolons}
const
  sc = ';';
var
  i   : Integer;   {index, or counter}
  ltx : Integer;   {length of the text}
begin
  ltx := length(Txin);    {length of the input string}
  Txout := '';            {initialize output string as empty}
  if (ltx > 0) then begin
    for i:= 1 to ltx do begin
      if (Txin[i] <> sc) then Txout := Txout+Txin[i]
      else break;         {quit at first semicolon}
    end;
  end else begin
    Txout := '';          {no text}
  end;
end;

procedure ExtractNextParam(iStrt: integer; sc: char; Txin: string;
                           var Txout: string; var iEnd: integer);
{extract from Txin the substring starting at index iStrt and ending just before
 the char. sc
 Note: the end-character sc is not copied to Txout
 Txout  contains the substring
 iEnd   index in Txin of the end-char sc (or index of the last char of Txin
 if the end char sc is not found, Txout is the substring of Txin starting at iStrt}
var
  found : boolean;  {true, when end-char. found}
  ii    : integer;
  len   : integer;  {length of string}
begin
  len := length(Txin);
  found := false;
  if (len >= iStrt) and (iStrt > 0) then begin  {reasonable start-index}
    Txout := '';
    for ii := iStrt to len do begin
      if (Txin[ii] = sc) then begin    {end-character found}
        iEnd := ii;
        found := true;
        break;                         {string found, stop}
      end else begin
        Txout := Txout+Txin[ii];
      end;
    end;
    {if end char. not found, set iEnd = index of last char.}
    if (not found) then iEnd := len;
  end else begin
    Txout := '';
    iEnd := 0;
  end;
end;

procedure ExtractParam(SetNo: Integer; sc: char; Txin : String; var Txout: String);
{Extracts from text in Txin  the  given set ending with a separating character,
 writes it to Txout
 (The input text is assumed to contain several sets of information,
  separated by some special character (; or \, mostly)
  SetNo  tells, which set is copied
  sc     the separating character}
var
  i        : Integer;   {index, or counter}
  i2s      : Integer;   {start of the second part}
  iset     : Integer;   {set under study}
  found_sc : Boolean;   {flag indicating that a semicolon was found}
  ltx      : Integer;   {length of the text}
begin
  Txout := '';                         {initialize output string as empty}
  ltx := length(Txin);                 {length of the input string}
  found_sc := false;                   {initialize 1.10.2002}
  i2s := ltx+1;                        {initialize 1.10.2002}
  if (ltx > 0) then begin              {scan only, if there is text}
    if (SetNo > 1) then begin          {not the first set}
      iset := 1;                       {initialize set no under study}
      for i:=1 to ltx do begin         {in principle, scan the whole text}
        if (Txin[i] = sc) then begin   {found a separating char. ?}
          iset := iset+1;              {increment set no. under study}
          if (iset = SetNo) then begin {desired set found}
            i2s := i+1;                {start of the second part}
            found_sc := true;          {set flag for finding a semicolon}
            break;                     {jump out of loop}
          end else begin
            found_sc := false;         {no semicolon found yet}
            i2s := ltx+1;              {just to be sure...}
          end;
        end;
      end;
    end else begin
      i2s := 1;                       {asking for the first set}
      found_sc := true;               {as if there had been a separating char}
    end;
    {now copy the desired set}
    if ((i2s <= ltx) and (found_sc)) then begin
      for i:= i2s to ltx do begin
        if (Txin[i] <> sc) then Txout := Txout+Txin[i]
        else break;         {quit at first semicolon}
      end;
    end else begin
      Txout := '';          {no second part}
    end;
  end else begin
    Txout := '';            {no text}
  end;
end;

procedure ReplaceSpecials(Txin : String; xch1,xch2,xch3,xch4,xch5,xch6,xch7,xch8 :char;
                          var Txout: String);
{replaces special characters in Txin with spaces, writes it to Txout}
{special characters = not letters, not numbers, but
 as an exception the characters xch1,xch2,...,xch7 are not replaced }

var
  i   : Integer;   {index, or counter}
  ltx : Integer;   {length of the text}
  ch  : Char;      {one character, temporary}
  ex1  : Char;     {a special character, that is accepted}
  ex2  : Char;     {a special character, that is accepted}
  ex3  : Char;     {a special character, that is accepted}
  ex4  : Char;     {a special character, that is accepted}
  ex5  : Char;     {a special character, that is accepted}
  ex6  : Char;     {a special character, that is accepted}
  ex7  : Char;     {a special character, that is accepted}
  ex8  : Char;     {a special character, that is accepted}
begin
  {check the special characters, to be accepted}
  if (xch1 <> '') then ex1 := xch1
  else                 ex1 := ' ';
  if (xch2 <> '') then ex2 := xch2
  else                 ex2 := ' ';
  if (xch3 <> '') then ex3 := xch3
  else                 ex3 := ' ';
  if (xch4 <> '') then ex4 := xch4
  else                 ex4 := ' ';
  if (xch5 <> '') then ex5 := xch5
  else                 ex5 := ' ';
  if (xch6 <> '') then ex6 := xch6
  else                 ex6 := ' ';
  if (xch7 <> '') then ex7 := xch7
  else                 ex7 := ' ';
  if (xch8 <> '') then ex8 := xch8
  else                 ex8 := ' ';
  ltx := length(Txin);    {length of the input string}
  Txout := '';            {initialize output string as empty}
  if (ltx > 0) then begin
    for i:= 1 to ltx do begin
      ch := Txin[i];      {copy to local, for simplicity}
      if ((ch >= '0') and (ch <= '9')) or
         ((ch >= 'a') and (ch <= 'z')) or
         ((ch >= 'A') and (ch <= 'Z')) or
          (ch=ex1) or (ch=ex2) or (ch=ex3) or
          (ch=ex4) or (ch=ex5) or (ch=ex6) or
          (ch=ex7) or (ch=ex8) then begin
           Txout := Txout+ch;    {copy the character}
      end else begin
           Txout := Txout+' ';   {replace special char. with a space}
      end;
    end;
  end else begin
    Txout := '';          {no text}
  end;
end;

procedure LongintFromLine(line: String; nth: integer; var llpar: longint;
                                                      var err: integer);
{extract extracts the nth a parameter as a longint from line
 the parameters in line are separated by one or more spaces
 line   the string with the parameters as text
 nth    the parameter number
 llpar  the parameter
 err    error flag}
var
  bsp   : boolean;    {previous was space}
  ii    : integer;    {index}
  isp   : integer;    {counts spaces}
  len   : integer;    {length of line}
  txt   : string;     {temporary text}
begin
  bsp := false;
  err := 0;           {initialize}
  len := length(line);
  isp := 0;
  txt := '';
  if (len > 0) then begin
    for ii := 1 to len do begin
      if (isp = nth-1) then begin           {nth-1 spaces found, copying the parameter}
        if (line[ii] >= '0') and (line[ii] <= '9') then begin  {copy only numbers}
          txt := txt+line[ii];
        end else begin                      {copy up to first non-number}
          break;
        end;
      end else begin
        if (line[ii] = ' ') then begin
          bsp := true
        end else begin
          if (bsp) then begin
            inc(isp);           {increment coung of spaces, when a nonspace char encountered}
            if (isp = nth-1) then txt := line[ii];    {save first nonspace char, for constructing the parameter}
          end;
          bsp := false
        end;
      end;
    end;
    {parameter copied to txt, change to integer}
    if (length(txt) > 0) then begin
      llpar := strtoint(txt);
    end else begin
      llpar := 0;
      err := 2;
    end;
  end else begin    {empty line}
    llpar := 0;
    err := 1;
  end;  
end;

procedure ValuesFromLine(line: String; nstrt :Integer; shower: boolean;
                         var ipar: Integer;
                         var pa1,pa2,pa3,pa4 : Single;
                         var st1,st2,st3,st4 : string;
                         var errc :Integer);
{extracts (numeric) values of parameters from a text line of numbers
          values (words) separated by space(s)
          at most 4 parameters
 line     the text line with the numbers (in)
 nstrt    start copying of parameters from parameter nstrt (at most 4 par.)
 shower   if true, error message is displayed
 ipar     number of parameters found in the line (out)
 pa1,pa2,pa3,pa4    the numeric values (out)
 st1,st2,st3,st4    the parameters as text (out), as they are on the line
 errc     error code (defined in chckfloat), = 0, if no errors}
var
  apu   : Single;   {temporary}
  dec_p : Char;     {decimal point}
  err   : integer;  {error flag}
  j     : Integer;  {index, or counter}
  ll    : Integer;  {length of line}
  numb  : boolean;
  tx    : char;     {one character}
  word  : String;   {one word in the line}
  wfnd  : boolean;  {word found}
  txt   : string;   {temporary}
begin
  {first determine the character used as decimal point}
  DecimalPoint(dec_p);
  st1 := ''; st2 := ''; st3 := ''; st4 := '';
  {extract the parameter values from the line, separated by spaces etc}
  ll := length(line);             {length of the line}
  {check that there are numbers}
  numb := false;
  if (ll > 0) then begin
    for j := 1 to ll do begin
      if (line[j] >= '0') and (line[j] <= '9') then begin
        numb := true;
        break;
      end;
    end;
  end;
  ipar := 0;                      {initialize parameter count}
  wfnd := false;                  {initialize flag for finding a word}
  word := '';                     {clear the word}
  errc := 0;                      {initialize error flag}
  if (ll > 0) and (numb) then begin {there are numbers on the line}
    for j:=1 to ll do begin         {purpose is to read to end of line}
      tx := line[j];                {copy one character, study it}
      {a space or tab or end of line => end of word}
      if (tx=' ') or (j=ll) or (Ord(tx) = 9) then begin
        if (j=ll) then begin        {last char. treated separately}
          if (tx <> ' ') and (Ord(tx) <> 9) then begin {last char. not a space or tab}
            word := word+tx;        {append last character}
            wfnd := true;           {a non-space char. found (number?)}
          end;
        end;
        if (wfnd) then begin        {was constructing a word}
          ipar := ipar+1;           {increment parameter counter}
          if      (ipar = nstrt)   then st1 := word   {parameter also as a string}
          else if (ipar = nstrt+1) then st2 := word
          else if (ipar = nstrt+2) then st3 := word
          else if (ipar = nstrt+3) then st4 := word;  {at most 4 params.}
{          ipar := ipar+1;           {increment parameter counter}
          wfnd := false;             {for next time}
          chkfloat(word,err,txt);    {check is the word a number. txt with correct dec.point}
          errc := errc+err;          {"total" error}
          if (err <> 0) then begin   {not a number}
            if (shower) then         {show error message, if allowed}
              show_message('parameter '+inttostr(ipar)+' is not a number,'
                          +  ' error code '+inttostr(errc)+'   '+word);
            word := '';
          end else begin             {is a number}
            apu := strtofloat(txt{word}); {change to number}
            if      (ipar = nstrt)   then pa1 := apu   {copy to component}
            else if (ipar = nstrt+1) then pa2 := apu
            else if (ipar = nstrt+2) then pa3 := apu
            else if (ipar = nstrt+3) then pa4 := apu;  {at most 4 params.}
            word := '';             {reinitialize the word}
          end;
        end else begin              {not a word, spaces in a row}
          wfnd := false;
          {apu := 0;}
        end;
      end else begin                {not a space, assumed is part of a number}
        wfnd := true;               {found or constructing a word}
        {accept both . and , as decimal point, eventually must change in order
         to correspond to system default}
         if      (dec_p = ',') and (tx = '.') then tx := ','
         else if (dec_p = '.') and (tx = ',') then tx := '.';
         word := word+tx             {append this char. to word}
      end;
    end;
  end else begin                     {no text on line}
    pa1 := 0.0;
    pa2 := 0.0;
    pa3 := 0.0;
    pa4 := 0.0;
    ipar := 0;
    errc := 10;
  end;
end;

procedure NextValueFromLine(line: String; kstrt :Integer; var kend : integer;
                        var par : Single; var str : string; var errc :Integer);
{extracts a numeric value of one parameter from a text line of parameters
          values (words) are separated by space(s)
          some parameters may be strings
 line     the text line with the numbers (in)
 kstrt    start studying of the parameters at character number kstrt of line
 kend     last studied character
 par      the numeric value (out)
 str      the parameter as text (out), as it is on the line
 errc     error code (defined in chckfloat), = 0, if no errors}
var
  apu   : Single;   {temporary}
  dec_p : Char;     {decimal point}
  ch1   : char;     {first character}
  jj    : integer;  {index, or counter}
  ll    : integer;  {length of line}
  lw    : integer;  {length of word}
  tx    : char;     {one character}
  txt   : string;   {temporary}
  word  : String;   {one word in the line}
  wfnd  : boolean;  {start of word found}
begin
  {first determine the character used as decimal point}
  DecimalPoint(dec_p);
  str := '';
  {extract the parameter value from the line, separated by space(s)}
  ll := length(line);             {length of the line}
  word := '';                     {clear the word}
  errc := 0;                      {initialize error flag}
  {search the word}
  if (ll >= kstrt) and (kstrt > 0) then begin {length and start pos.reasonable }
    wfnd := false;                  {start of word not yet found}
    ch1 := ' ';
    for jj:=kstrt to ll do begin    {prepare to read to end of line}
      kend := jj;                   {index of last checked character}
      tx := line[jj];               {copy one character, study it}
      if (tx=' ') or (jj = ll) then begin {end of word or end of line}
        if (jj = ll) and (tx <> ' ') then begin
          {use the decimal point of this machine, but not in string parameters}
          if (ch1 <> 'T') and ((tx = ',') or (tx = '.')) then
            word := word+dec_p            {use correct decimal point}
          else word := word+tx;           {include the last char, if end of line}
          wfnd := true;
        end;
        if (wfnd) then begin              {word ready or end of line}
          str := word;                    {parameter out as string}
          lw := length(word);
          if (lw >= 1) then begin         {not empty}
            if (word[1] = 'T') then begin {parameter is a string}
              errc := -1;                 {flag the string}
              par := 0;                   {just some value}
            end else begin                {parameter is a numerical value}
              chkfloat(word,errc,txt);    {check is the word a number}
              if (errc = 0) then begin    {a number }
                par := strtofloat(word);  {change to a numerical value}
              end else begin
                par := 0;                 {some value}
              end;
            end;
          end else begin            {empty }
            str := '';
            par := 0;               {just some value}
          end;
{         kend := jj;               {index of last checked character}
          break;
        end else begin              {still searching the beginning of the word}
          {do nothing}
        end;
      end else begin                {a proper char., not a space}
        wfnd := true;
        if (ch1 = ' ') then ch1 := tx; {save first character}
        {use the decimal point of this machine, but not in string parameters}
        if (ch1 <> 'T') and ((tx = ',') or (tx = '.')) then
          word := word+dec_p        {use correct decimal point}
        else word := word+tx;       {construct the word}
      end;
    end;
  end else begin                    {indices not correct}
    par := 0;                       {just some value}
    str := '';
    errc := -2;
  end;
end;

procedure NumberOfParametersOnLine(line : string; var np :Integer);
{counts the number of parameters on the line
 parameters are separated by one or more spaces
 line     the text line with the parameters (in)
 np       number of parameters}
var
  ch1   : char;     {first character}
  jj    : integer;  {index, or counter}
  ll    : integer;  {length of line}
  lw    : integer;  {length of word}
  tx    : char;     {one character}
  wfnd  : boolean;  {start of word found}
begin
  ll := length(line);               {length of the line}
  np := 0;
  {search the word}
  if (ll > 0) then begin            {length reasonable }
    wfnd := false;                  {start of word not yet found}
    for jj := 1 to ll do begin      {read to end of line}
      tx := line[jj];               {copy one character, study it}
      if (tx=' ') then begin        {end of word (or word not yet started)}
        wfnd := false;
      end else begin                {a proper char., not a space}
        if (wfnd) then begin        {word already found, do nothing}
          {}
        end else begin              {first non-space character of (this word)}
          wfnd := true;
          inc(np);                  {one more parameter}
        end;
      end;
    end;
  end else begin                    {empty line}
    np := 0;                        {no parameters}
  end;
end;

procedure chkint(line : string; var err : integer);
{check that line represents a valid integer
 leading spaces are allowed, but not other spaces
 line   the string to be studied
 err    error flag = 0, if no error}
var
  ii    : integer;  {index}
  len   : integer;  {lenght of line}
  first : boolean;  {first non-space char.}
  found : boolean;  {a non-space character found}
begin
  err := 0;                                {initialize}
  len := length(line);
  if (len > 0) then begin
    found := false;
    for ii := 1 to len do begin
      if (line[ii] <> ' ') then begin
        if (not found) then begin
          found := true; {start of text (number) found}
          first := true; {first non-space character}
        end else begin   {not first char}
          first := false;
        end;
        if (line[ii] >='0') and (line[ii] <= '9') then begin  {a number}
          {do nothing}
        end else begin                         {not a number = error}
          if (first) then begin
            if (line[ii] = '+') or (line[ii] = '-') then begin
              if (ii = len) then begin         {first is also last}
                err := 1;                       {'+' or '-' alone not accepted}
                break;
              end;
            end else begin
              err := 1;
              break;                           {no need to study further}
            end;
          end else begin                       {not first char.}
            err := 1;
            break;
          end;
        end;
      end else begin                       {is a space, leading spaces allowed, check}
        if (found) then begin              {not a leading space, error}
          err := 2;
          break;                           {no need to study further}
        end else begin                     {a leading space, continue}
          {do nothing}
        end;
      end;
    end;
    {only spaces?}
    if (not found) then err := 3;
  end else begin
    err := 4;                              {set error flag}
  end;
end;

procedure chkfloat(linein: String; var ercod: Integer; var line: string);
{checks, whether the line corresponds to a valid floating point
 (or integer) number
 linein  the string that should be a number (in)
 ercod   error code,  = 0, if correct number
 line    corrected line, where a comma or a full stop has been changed
         to the valid decimal point}
var
  dp   : Char;      {decimal point: (,) or (.)}
  epart: string;    {exponential part}
  i    : integer;   {index, or counter}
  nch  : integer;   {number of characters in the string to be studied}
  ph   : integer;   {phases, depending what has been found
                     0 = start
                     1 = only numbers found
                     2 = + or -  found
                     3 = , (or .) found
                     4 = , (or .) and numbers found
                     5 = e or E found
                     6 = + or - after e or E found
                     7 = one number found after e or E or e+,e-,E+E-
                     8 = two numbers found after e ...}
  tx   : char;      { a single character}
begin
  DecimalPoint(dp);             {get the decimal point character}
  ph := 0;                      {initialize phase}
  ercod := 0;                   {initialize error code}
  epart := '';                  {initialize exponential part}
  nch := length(linein);        {number of characters}
  if (nch > 0) then begin
    {first, check the decimal point, if any}
    line := '';
    for i := 1 to nch do begin
      if (linein[i] = '.') or (linein[i] = ',') then line := line+dp
      else line := line+linein[i];
    end;
    {next, check that the line is a (floating point) number}
    for i:=1 to nch do begin      {scan the whole line}
      tx := line[i];              {copy to local}
      if (ph = 0) then begin      {just starting}
      {first character must be only + - , e E  a number  space}
        if      (tx = ' ')                 then ph := 0
        else if (tx >='0') and (tx <= '9') then ph := 1
        else if (tx ='+') or (tx = '-')    then ph := 2
        else if (tx = dp)                  then ph := 3
{       else if (tx = 'e') or (tx = 'E')   then ph := 5} {not as the first char.}
        else begin
          ercod := 1;             {set error code}
          break;                  {errror found, stop}
        end;
      end else if (ph = 1) then begin
      {after a number only  another number  ,  e E allowed}
        if      (tx>='0') and (tx <= '9')  then ph := 1
        else if (tx = dp)                  then ph := 3
        else if (tx = 'e') or (tx = 'E')   then ph := 5
        else  begin
          ercod := 2;
          break;
        end;
      end else if (ph = 2) then begin
      {after + or - only  a number   ,  NOT e E allowed}
        if (tx >='0') and (tx <= '9')      then ph := 1
        else if (tx = dp)                  then ph := 3
{       else if (tx = 'e') or (tx = 'E')   then ph := 5} {e or E not directly after + or -}
        else begin
          ercod := 3;
          break;
        end;
      end else if (ph = 3) then begin
      {after a comma only a number allowed or e or E}
        if (tx >= '0') and (tx <='9')      then ph := 4
        else if (tx = 'e') or (tx = 'E')   then ph := 5
        else begin
          ercod := 5;
          break;
        end;
      end else if (ph = 4) then begin
      {after a comma and numbers only  nunbers  e   E allowed}
        if (tx >= '0') and (tx <='9')     then ph := 4
        else if (tx = 'e') or (tx = 'E')  then ph := 5
        else begin
          ercod := 5;
          break;
        end;
      end else if (ph = 5) then begin
        {after e or E only + -  and numbers allowed}
        if (tx ='+') or (tx = '-')         then begin
          {there must be a number after the '+' or '-'}
          if (nch > i) then begin          {not the last character}
            if (line[i+1] >= '0') and (line[i+1] <= '9') then ph := 6
            else begin
              ercod := 6;
              break;
            end;
          end else begin                   {last char.cannot be + or -}
            ercod := 6;
            break;
          end;
        end else if (tx >='0') and (tx <= '9') then begin
          epart := tx;
          ph := 7;
        end else begin
          ercod := 6;
          break;
        end;
      end else if (ph = 6) then begin
      {after e+ etc only numbers allowed}
        if (tx >='0') and (tx <= '9')      then begin
          epart := tx;                     {save exp.part}
          ph := 7
        end else begin
          ercod := 7;
          break;
        end;
      end else if (ph = 7) then begin
      {after  e+ only two numbers allowed}
        if (tx >='0') and (tx <= '9')      then begin
          epart := epart+tx;               {complete exponential part}
          if (epart < '37') then           ph := 8
          else begin
            ercod := 11;
            break;
          end;
        end else begin
          ercod := 8;
          break;
        end;
      end else if (ph = 8) then begin
      {after e+$$ only spaces allowed}
        if (tx = ' ')                      then ph := 8
        else begin
          ercod := 9;
          break;
        end;
      end else begin
      {there should not be any other phases}
        ercod := 10;
        break;
      end;
    end;
    {single non-number char. not allowed}
    if (linein = '+') or (linein = '-') or (linein = 'e') or (linein = 'E') or
       (linein = ',') or (linein = '.') then ercod := 12;
  end else begin  {empty line}
    ercod := 11;
  end;
end;

procedure NumberOfWordsX(hintx,spec :String; onlyspace:boolean; wno: Integer;
                    var npar,wlen: Integer; var oneword:String);
{determines the number of words separated by commas or other non-letter chars.
 and returns the wno'th word (first, second, third, etc.)
 hintx      the text to be studied  (in)
 spec       special characters that are accepted , as one strig
 onlyspace  if true => only spaces accepted to separate words (in)
 wno        1 = first word is retuned, 2 = second word is returned etc (in)
 npar       number of words (out)
 wlen       length of the selected word WITH trailing spaces ! (out)
 oneword    the returned word  (out)}
var
  i,j     : Integer;   {index, or counter}
  iapu    : Integer;   {temporary}
  hintxi  : char;      {one char of hintx}
  lngt    : Integer;   {word length}
  lensp   : integer;   {length = number of special char}
  spcha   : string;    {special caracters}
  spechar : boolean;   {a special character found}
  text    : String;    {local}
  txt     : string;    {local, temporary}
  wflag   : boolean;   {flag for (eventual) start of a word}
begin
  spcha := spec;                        {just copy to local variable}
  lensp := length(spcha);               {number of special char}
(*  if (oneword = 'xxxx') then showmessage(inttostr(lensp));*)
  iapu := length(hintx);                {length of the hint text}
if (iapu > 2) then txt := hintx[1]+hintx[2]+hintx[3];
  npar := 0;                            {initialize number of parameters}
  wflag := false;                       {initialize flag for a new word}
  text :='';                            {initialize (each) word}
  lngt := 0;                            {initialize}
  oneword := '';
  for i:=1 to iapu do begin             {scan the hint text}
    hintxi := hintx[i];                 {copy one char}
    {check first special characters, if any}
    spechar := false;                   {initialize}
    if (lensp > 0) then begin
      for j:=1 to lensp do begin
        if (hintxi = spec[j]) then begin
(*          if (txt = 'Ik''') then showmessage(hintxi+'  '+spec[j]);*)
          spechar := true;
          break;
        end;
      end;
    end;
    if (spechar) or
       ((hintxi >='0') and (hintxi <= '9')) or    {number ?}
       ((hintxi >='A') and (hintxi <= 'Z')) or    {capital letter ?}
       ((hintxi >='a') and (hintxi <= 'z')) or    {lower case ?}
       {optionally only spaces considered as separators}
       ((hintxi <>' ') and (onlyspace))  then begin
       if (not wflag) then begin        {first character of a word}
         if (npar = wno) then begin     {output data for the previous word}
           wlen := lngt;
         end;
         npar := npar+1;                {increment word count}
         wflag := true;                 {set flag for first letter}
         text := hintxi;                {copy first letter of the word}
         lngt := 1;                     {start to calculate length}
       end else begin                   {start of word already found}
         text := text+hintxi;           {continue constructing the word}
         lngt := lngt+1;                {increment length}
(*          if (txt = 'Ik''') then showmessage(text+'  '+inttostr(lngt));*)
       end;
       if (i=iapu) then begin           {special treatment at end of line}
         if (npar = wno) then begin
           oneword := text;             {return the desired word}
           wlen := lngt+1;              {its length, with a space (?)}
         end;
       end;
    end else begin                      {not a letter or number}
      if (wflag) then begin             {end of a word}
        wflag := false;                 {reset flag}
        if (npar = wno) then oneword := text;  {return the desired word}
        text := '';                     {reinitialize text}
      end;
      if (lngt > 0) then lngt := lngt+1;{inclrement only if word found}
      if (i=iapu) then  begin           {end of line, special treatment}
        if (npar = wno) then wlen := lngt; {length of the word, WITH spaces}
      end;
    end;
  end;
end;

procedure FindWord(text : string; istrt : integer; var wout : string; var iend : integer);
{finds a word in text when search starts at text[istrt]. Words are separated
 by spaces
 text   text to be searched
 istrt  start search at text[istrt]
 wout   the word that was found, if not found word = ''
 iend   index of the first unchecked character}
var
  found : boolean;  {true, when a word was found}
  ii    : integer;  {index}
  len   : integer;  {length of text}
begin
  len := length(text);
  if (len > 0) and (istrt <= len) and (istrt > 0) then begin   {keep inside text}
    found := false;
    wout := '';
    for ii := istrt to len do begin
      iend := ii+1;
      if (text[ii] <> ' ') then begin  {not a space}
        wout := wout+text[ii];   {copy all nonspace characters}
        found := true;           {text found}
      end else begin             {a space}
        if (found) then begin    {space after a non-space char. was found}
          break;                 {one word is enough}
        end;
      end;
    end;
  end else begin
    wout := '';
    iend := len+1;
  end;
end;

procedure RemoveSpaces(rnum: Single; var Disp2:String);
{copies the rnum as string to Disp2 in given format, removes (leading) spaces
 rnum    the number to be copied (in)
 Disp2   the number as text, without spaces (out)}
var
  i    : Integer;    {index, or counter}
  iapu : Integer;    {temporary}
  Disp1: String;     {temporary string}
begin
  Disp1 := Format('%12.6g',[rnum]);     {copy formatted to temporary}
  Disp2 := '';                          {clear text}
  iapu := length(Disp1);
  for i:=1 to iapu do begin             {length depends on format}
    if (Disp1[i] <> ' ') then begin     {skip all spaces}
      Disp2 := Disp2+Disp1[i];          {append "non-space" characters}
    end;
  end;
end;

procedure AlignText(line,value:String; var newlin:String);
{
 line     contains words (in)
 value    contains numbers, separated by spaces (out)
 newlin   line copied here, with spaces added (out)

 line is copied to newlin, and spaces are added between the words,
 so that the words in newlin are aligned with the numbers in value
 (a font with fixed length for each character assumed)

 That is: From this:

 aa  bb  cc  dd                    (line)
 123    4,56     70    8           (value)

 should become this

 aa     bb       cc    dd          (newlin)
 123    4,56     70    8           (value)
 }
var
  i,j   : Integer;       {index, or counter}
  iapu  : Integer;       {temporary}
  iapv  : Integer;       {temporary}
  nlin  : Integer;       {number of words in line}
  nval  : Integer;       {number of words in value}
  onewrd: String;        {one returned word}
  wlen  : Integer;       {length of the value (as string)}
  xxstr : String;        {temporary}
begin
 {adjust the length of the space between the words in the parameter list,
  so that the text and the values are aligned}
  onewrd := '';                         {initialize}

  NumberOfWordsX(line,'',true,-1,nlin,iapu,xxstr);  {number of parameters}
  NumberOfWordsX(value,'',true,-1,nval,iapu,xxstr); {number of numeric values,
                                                 separated by spaces}
  newlin := '';                                 {initialize new line}
  {if different number of words => either error, or not complete,
   if one word (or less), no need to adjust}
  if (nlin=nval) and (nlin>1)then begin {more than one word => there is space}
    for i:=1 to nlin do begin         {scan all words}
      NumberOfWordsX(line,'',true{false},i,iapu,iapv,onewrd);  {pick word  i}
      onewrd := onewrd+' ';           {add one space, to separate words}
      NumberOfWordsX(value,'',true,i,iapu,wlen,xxstr); {length of parameter i,
                                                    WITH spaces}
      {adjust the length of the parameter text, if necessary and possible}
      iapu := length(onewrd);         {length of the parameter text}
      if (iapu < wlen) then begin     {shorter than the value}
        iapv := wlen-iapu;            {difference in length}
        for j:=1 to iapv do begin
          onewrd := onewrd+' ';       {add spaces}
        end;
      end;
      newlin := newlin+onewrd;        {new parameter list}
    end;
  end else begin
    newlin := line;                   {copy as such}
  end;
end;

function NearestGrid(Xin:Integer;Half:Boolean):Integer;
{Calculates the nearest grid point for a given integer
 If Half = true, use denser grid = half of default
 Xin      the integer for which the nearest grid point is calculated (in)
 Half     flag for denser grid}
(*const
    Igrid = 16;   {the default grid spacing, in pixels}*)
  var
    iapu : integer;
    ipu  : integer;
    ng   : integer;
  begin
    {normal or denser grid ?}
    if (Half) then iapu := Igrid_g div 2
    else           iapu := Igrid_g;
    {because "div" rounds into direction of zero (0), must treat
     pos. and neg. Xin separately}
    if (Xin >= 0) then begin
      ng :=iapu*((Xin+(iapu div 2) ) div iapu);
    end else begin
      {if Xin = iapu div 2 + N*iapu, must round upwards, as is done in the pos.side}
      ipu := (Xin+(iapu div 2)) div iapu;
      if (ipu*iapu-(iapu div 2) = Xin) then ng := ipu*iapu
      else    ng :=iapu*((Xin-(iapu div 2) ) div iapu);
    end;
    NearestGrid := ng;
  end;

procedure CenterToGrid(width, height: Integer; var left,top: Integer);
{sets the center of a component (image) to the nearest grid point
 width  = width of the component
 height = height of the component
 left   = x-coordinate of the upper left corner of the component
 top    = y-coordinate of the upper left corner of the component
 }
 var
 ix,iy : Integer;  {coordinates of the center}
 begin
    iy := top+(height div 2);
    iy := NearestGrid(iy,false);
    top := iy-height div 2;
    ix := left+(width div 2);
    ix := NearestGrid(ix,false);
    left := ix-(width div 2);
 end;

procedure DrawMarker(pMark : TpImage; MarkColor : Tcolor);
{draws small red rectangles to the corners of an image
 pMark       pointer to the image
 MarkColor   the color of the rectangles
 dl          size of the rectangles}
const
  dl = 4;     {size of marker rectangles}
var
 x1,y1 : Integer;    {temporary}
 x2,y2 : Integer;    {temporary}
begin
  pMark^.canvas.pen.color := MarkColor{clRed};
  pMark^.canvas.brush.color := MarkColor{clRed};       {select color}
  pMark^.canvas.brush.style := bsSolid;     {filled figure}
  x1 := 0;  y1 := 0;  x2 := dl;  y2 := dl;
  pMark^.canvas.rectangle(x1,y1,x2,y2);     {draw a rectangle}
  x2 := pMark^.width;
  x1 := x2-dl;
  y1 := 0;
  y2 := dl;
  pMark^.canvas.rectangle(x1,y1,x2,y2);     {draw a rectangle}
  x1 := 0;
  x2 := dl;
  y2 := pMark^.height;
  y1 := y2-dl;
  pMark^.canvas.rectangle(x1,y1,x2,y2);     {draw a rectangle}
  x2 := pMark^.width;
  x1 := x2-dl;
  y2 := pMark^.height;
  y1 := y2-dl;
  pMark^.canvas.rectangle(x1,y1,x2,y2);     {draw a rectangle}
end;

procedure OnlyValue(Txin : string; var Txut : string);
{pickup the parameter = remove additional characters, accept only
 numbers and decimal point (exponentials are not accepted !)}
var
  dp  : char;     {decimal point}
  ii  : integer;
  len : integer;
begin
  DecimalPoint(dp);   {determine char. for the decimal point}
  Txut := '';
  len := length(Txin);
  if (len > 0) then begin
    for ii := 1 to len do begin
      if ((Txin[ii] >= '0') and (Txin[ii] <= '9')) or
          (Txin[ii] = '-') then Txut := Txut+Txin[ii]
      else if ((Txin[ii] = '.') or (Txin[ii] = ',')) then Txut := Txut+dp;
    end;
  end;
end;

procedure ReduceSpaces(Txin: string; var Txut: string);
{remove successive spaces
 Txin  input string
 Txut  output string}
var
  ch  : char;     {one character}
  ii  : integer;  {index}
  len : integer;  {length of string}
  sp  : boolean;  {space found}
begin
  len := length(Txin);
  Txut := '';
  if (len > 0) then begin
    sp := false;
    for ii := 1 to len do begin
      ch := Txin[ii];
      if (ch = ' ') then begin
        if (not sp) then Txut := Txut+ch;  {previous was not a space}
        sp := true;
      end else begin
        Txut := Txut+ch;
        sp := false;
      end;
    end;
  end else begin
    Txut := '';
  end;
end;

function AppendTxtIf(lbl : string; OldTxt: string; sep : char): string;
{output = OldTxt+separator+lbl, if lbl is not yet included in OldTxt
 OldTxt is assumed to be a collection of labels, separated by sep, like
 T1,T2,T123 where T1,T2,T123 are labels and comma (,) is the separator.
 If the new label lbl is not yet included in OldTxt, it is added
 lbl     text to be added = label
 OldTxt  existing string to which lbl added
 sep     character separating labels}
var
  ii    : integer;
  found : boolean;  {label found in old text}
  txt   : string;
begin
  if (length(lbl) > 0) then begin             {some label given}
    if (length(OldTxt) > 0) then begin        {some text to be checked}
      txt := '';
      found := false;
      {try to extract labels = strings separated by the separator}
      for ii := 1 to length(OldTxt) do begin  {scan existing text}
        if (OldTxt[ii] = sep) then begin      {one label constructed}
          if (txt = lbl) then begin           {the given label found}
            found := true;
            break;
          end else begin                      {not found, start again}
            txt := '';
          end;
        end else begin
          {continue to construct the label}
          txt := txt+OldTxt[ii];
          {check again, if last char.}
          if (ii = length(OldTxt)) then begin
            if (txt = lbl) then begin
              found := true;
              break;                          {actually, not needed...}
            end;
          end;
        end;
      end;
      {if label found in old text, do not add, else add}
      if (found) then result := OldTxt
      else result := OldTxt+sep+lbl;
    end else begin                            {no old text, just add the new label}
      result := lbl;
    end;
  end else begin                              {no label, do not change text}
    result := OldTxt;
  end;
end;

end.
