unit SkemObj;

interface

uses
  {SysUtils,WinTypes, WinProcs,} Messages,Classes,Graphics,{Controls,Forms, Dialogs,
  ExtCtrls,ComCtrls, StdCtrls,}
  skemadef, utildef ;

{object for some parameters and results etc specific to current trafos...}
type
  TpCTData = ^TCTData;             {define pointer first !}
  TCTData  = Class(TObject)        {define class for data of current transformers}
  procedure initialize;
  procedure PutAcTime1(flg: integer; Pt,Gt,Qt: string);
  procedure GetAcTime1(var Pt,Gt,Qt: string);
  procedure PutAcTime2(flg: integer; Pt,Gt,Qt: string);
  procedure GetAcTime2(var Pt,Gt,Qt: string);
  procedure AddRelay(pRelay: TpComp);
  procedure RemoveRelay(pRelay: TpComp);
  procedure FreeReList;
  procedure PutRelFlag(flg: string);
  function  GetRelFlag: string;
  procedure PutCurr(Cre,Cim: string);
  procedure GetCurr(var Cre,Cim: string);
  procedure PutFloatLabel(flg: integer; tx1,tx2,tx3: string);
  procedure GetFloatLabel(var tx1,tx2,tx3: string);
  procedure PutFont(fName: string; fSize: integer; fStyle: TFontStyles ; fColor: TColor);
  procedure GetFont(var fName: string; var fSize: integer;
                          var fStyle: TFontStyles; var fColor: TColor);
private
  AcTimeP: string;  {P-act.time for current trafos..in ShowMoreResults of Skemadef...}
    {....and in ActivationTime of Shortcmp.pas, ClearCTActivation of Skemproc.pas...}
    {....and in OutputTimeCurr of Skemproc.pas..}
    {....and in DrawActivationTime of DrawComp}
    {....and in DrawRelayTime of DrawComp}
  pReList: TpList;  {pointers to relay(s) connected to this current tr..}
  {where is the relay removed from the list, when the relay is deleted? Nowhere, maybe not needed? }
    {....in GroupActivation of Shortcmp.pas...}
    {....and in ClearCTActivation of Skemproc.pas}
    {....and in FormDeactivate of CTparam.pas}
  RelFlag: string; {flag for PQ-, RC-relay for current tr..., in GroupActivation...}
    {...of ShortCmp.pas, in ClearCTActivation of Skemproc.pas}
    {...needed in OutputTimeCurr of Skemproc.pas}
  AcTimeG: string;  {G-act.time for current trafos, in ShowMoreResults, here...}
    {....in ActivationTime of Shortcmp.pas}
    {....and in DrawActivationTime of DrawComp}
  Currre: string;  {real comp. of current for current trafos, ShowCurrRes of Elplex.pas}
    {....and DrawCurrent of DrawComp.pas}
  Currim: string;  {imag.comp. of current for current trafos, ShowCurrRes of Elplex.pas}
    {....and DrawCurrent of DrawComp.pas}
  AcTimeQ: string;  {Q-act.time for current trafos, in ShowMoreResults of Skemadef.pas, and..}
    {....in ActivationTime of Shortcmp.pas}
    {....and in DrawActivationTime of DrawComp}
  FLtext1    : string;   {first line of text in the floating label}
  FLtext2    : string;   {second line of text in the floating label}
  FLtext3    : string;   {third line of text in the floating label}
  FLfontName : string;   {font name}
  FLfontSize : integer;  {font size}
  FLfontStyle: TFontStyles;   {bold, etc...}
  FLfontColor: TColor;   {font color}
  FLleft     : integer;  {left-coordinate of the label}
  FLtop      : integer;  {top-coordinate}
    {floating labels, in OKButClick and ...}
    {....in FloatLabelAMouseUp, and ShowFloatingLabel of Relcurr.pas}
  AcTimeP2: string;      {phase-activation time of 2nd recloser relay...}
    {.... in ShowMoreResults of Skemadef.pas }
  AcTimeG2: string;      {ground-activation time of 2nd recloser relay}
    {.... in ShowMoreResults of Skemadef.pas}
  AcTimeQ2: string;      {sequence-activation time of 2nd recloser relay}
    {.... in ShowMoreResults of Skemadef.pas }
end;

{procedures for the use of the object above, without an explicite pointer}
procedure PutAcTimeP1(pComp: TpComp; Pt: string);
procedure PutAcTimeG1(pComp: TpComp; Gt: string);
procedure PutAcTimeQ1(pComp: TpComp; Qt: string);
procedure PutAcTimeP2(pComp: TpComp; Pt: string);
procedure PutAcTimeG2(pComp: TpComp; Gt: string);
procedure PutAcTimeQ2(pComp: TpComp; Qt: string);
procedure GetAcTimes1(pComp: TpComp; var Pt,Gt,Qt: string);
procedure GetAcTimes2(pComp: TpComp; var Pt,Gt,Qt: string);
procedure ClearAcTimes1(pComp: TpComp);
procedure ClearAcTimes2(pComp: TpComp);

implementation

procedure TCTData.initialize;
begin
  AcTimeP := '';
  pReList := nil;
  RelFlag := '';
  AcTimeG := '';
  Currre := '0';
  Currim := '0';
  AcTimeQ := '';
  FLtext1     := '';
  FLtext2     := '';
  FLtext3     := '';
  FLfontName  := 'arial';
  FLfontSize  := 8;
  FLfontStyle := [];
  FLfontColor := clBlack;
  FLleft      := 0;
  FLtop       := 0;
  AcTimeP2 := '';
  AcTimeG2 := '';
  AcTimeQ2 := '';
end;

procedure TCTData.PutAcTime1(flg: integer; Pt,Gt,Qt: string);
{save the activation time(s) to the object
 flg  flag for saving the different times
 Pt   phase time
 Gt   ground time
 Qt   sequence time}
begin
  if ((flg and 1) <> 0) then AcTimeP := Pt;
  if ((flg and 2) <> 0) then AcTimeG := Gt;
  if ((flg and 4) <> 0) then AcTimeQ := Qt;
end;

procedure TCTData.GetAcTime1(var Pt,Gt,Qt: string);
{get the activation times
 Pt   phase time
 Gt   ground time
 Qt   sequence time}
begin
  Pt := AcTimeP;
  Gt := AcTimeG;
  Qt := AcTimeQ;
end;

procedure TCTData.PutAcTime2(flg: integer; Pt,Gt,Qt: string);
{save the second activation time(s) to the object (reclosers and user def.relays)
 flg  flag for saving the different times
 Pt   phase time
 Gt   ground time
 Qt   sequence time}
begin
  if ((flg and 1) <> 0) then AcTimeP2 := Pt;
  if ((flg and 2) <> 0) then AcTimeG2 := Gt;
  if ((flg and 4) <> 0) then AcTimeQ2 := Qt;
end;

procedure TCTData.GetAcTime2(var Pt,Gt,Qt: string);
{get the second activation times (reclosers and user def.relays)
 Pt   phase time
 Gt   ground time
 Qt   sequence time}
begin
  Pt := AcTimeP2;
  Gt := AcTimeG2;
  Qt := AcTimeQ2;
end;

procedure TCTData.AddRelay(pRelay: TpComp);
{add relay to the list of relays connected to this CT,
 create list if it does not exist}
begin
  if (pReList = nil) then begin   {list does not exist}
    new(pReList);
    pReList^ := TList.create;
    pReList.add(pRelay);
  end else begin
    pReList.add(pRelay);
  end;
end;

procedure TCTData.RemoveRelay(pRelay: TpComp);
{remove relay from the list}
var
  ir : integer;  {index of the relay}
begin
  if (pReList <> nil) then begin
    ir := pReList^.IndexOf(pRelay);
    if (ir <> -1) then begin
      pReList^.Delete(ir);
      pReList^.Pack;
    end;
    if (pReList^.count = 0) then begin
      FreeReList;
    end;
  end;
end;

procedure TCTData.FreeReList;
begin
  if (pReList <> nil) then begin
    pReList^.free;
    dispose(pReList);
    pReList := nil;
  end;
end;

procedure TCTData.PutRelFlag(flg: string);
begin
  RelFlag := flg;
end;

function  TCTData.GetRelFlag: string;
begin
  GetRelFlag := RelFlag;
end;

procedure TCTData.PutCurr(Cre,Cim: string);
begin
  CurrRe := Cre;
  CurrIm := Cim;
end;

procedure TCTData.GetCurr(var Cre,Cim: string);
begin
  Cre := CurrRe;
  Cim := CurrIm;
end;

procedure TCTData.PutFloatLabel(flg: integer; tx1,tx2,tx3: string);
begin
  if (flg and 1 <> 0) then FLtext1 := tx1;
  if (flg and 2 <> 0) then FLtext2 := tx2;
  if (flg and 4 <> 0) then FLtext3 := tx3;
end;

procedure TCTData.GetFloatLabel(var tx1,tx2,tx3: string);
begin
  tx1 := FLtext1;
  tx2 := FLtext2;
  tx3 := FLtext3;
end;

procedure TCTData.PutFont(fName: string; fSize: integer;
                          fStyle: TFontStyles; fColor: TColor);
begin
  FLfontName := fName;    {font name}
  FLfontSize := fSize;    {font size}
  FLfontStyle := fStyle;  {bold, etc...}
  FLfontColor := fColor;  {font color}
end;

procedure TCTData.GetFont(var fName: string; var fSize: integer;
                          var fStyle: TFontStyles; var fColor: TColor);
begin
  fName := FLfontName;    {font name}
  fSize := FLfontSize;    {font size}
  fStyle := FLfontStyle;  {bold, etc...}
  fColor := FLfontColor;  {font color}
end;

procedure PutAcTimeP1(pComp: TpComp; Pt: string);
{save the phase activation time to the data object of the current trafo, as string
 called in ActivationTime of Shortcmp.pas
 pComp   pointer to the current trafo
 Pt      activation time, as string}
var
  ll   : longint;   {temporary}
  pCTD : TpCTData;  {pointer to the object for data}
begin
  pComp^.GetAdint(ll);
  if (ll <> 0) then begin
    pCTD := TpCTData(ll);        {pointer to the object}
    pCTD^.AcTimeP := Pt;
  end;
end;

procedure PutAcTimeG1(pComp: TpComp; Gt: string);
{save the ground activation time to the data object of the current trafo, as string
 called in ActivationTime of Shortcmp.pas
 pComp   pointer to the current trafo
 Gt      activation time, as string}
var
  ll   : longint;   {temporary}
  pCTD : TpCTData;  {pointer to the object for data}
begin
  pComp^.GetAdint(ll);
  if (ll <> 0) then begin
    pCTD := TpCTData(ll);        {pointer to the object}
    pCTD^.AcTimeG := Gt;
  end;
end;

procedure PutAcTimeQ1(pComp: TpComp; Qt: string);
{save the sequence activation time to the data object of the current trafo, as sting
 called in ActivationTime of Shortcmp.pas
 pComp   pointer to the current trafo
 qt      activation time, as string}
var
  ll   : longint;   {temporary}
  pCTD : TpCTData;  {pointer to the object for data}
begin
  pComp^.GetAdint(ll);
  if (ll <> 0) then begin
    pCTD := TpCTData(ll);          {pointer to the object}
    pCTD^.AcTimeQ := Qt;
  end;
end;

procedure PutAcTimeP2(pComp: TpComp; Pt: string);
{save the second phase activation time to the data object of the current trafo, as string
 called in ActivationTime of Shortcmp.pas
 pComp   pointer to the current trafo
 Pt      activation time, as string}
var
  ll   : longint;   {temporary}
  pCTD : TpCTData;  {pointer to the object for data}
begin
  pComp^.GetAdint(ll);
  if (ll <> 0) then begin
    pCTD := TpCTData(ll);        {pointer to the object}
    pCTD^.AcTimeP2 := Pt;
  end;
end;

procedure PutAcTimeG2(pComp: TpComp; Gt: string);
{save the second ground activation time to the data object of the current trafo, as string
 called in ActivationTime of Shortcmp.pas
 pComp   pointer to the current trafo
 Gt      activation time, as string}
var
  ll   : longint;   {temporary}
  pCTD : TpCTData;  {pointer to the object for data}
begin
  pComp^.GetAdint(ll);
  if (ll <> 0) then begin
    pCTD := TpCTData(ll);        {pointer to the object}
    pCTD^.AcTimeG2 := Gt;
  end;
end;

procedure PutAcTimeQ2(pComp: TpComp; Qt: string);
{save the second sequence activation time to the data object of the current trafo, as sting
 called in ActivationTime of Shortcmp.pas
 pComp   pointer to the current trafo
 qt      activation time, as string}
var
  ll   : longint;   {temporary}
  pCTD : TpCTData;  {pointer to the object for data}
begin
  pComp^.GetAdint(ll);
  if (ll <> 0) then begin
    pCTD := TpCTData(ll);          {pointer to the object}
    pCTD^.AcTimeQ2 := Qt;
  end;
end;

procedure GetAcTimes1(pComp: TpComp; var Pt,Gt,Qt: string);
{get the activation times as strings from the object for data
called in OutputTimeCurr of skemproc.pas
          ShowMoreResults of skemadef.pas
          DrawRelayTime of Drawcomp.pas
          DrawActivationTime of Drawcomp.pas
 pComp  pointer to the current trafo
 Pt,Gt,Qt  the activation times}
var
  ll   : longint;   {temporary}
  pCTD : TpCTData;  {pointer to the object for data}
begin
  pComp^.GetAdint(ll);
  if (ll <> 0) then begin
    pCTD := TpCTData(ll);          {pointer to the object}
    Pt := pCTD^.AcTimeP;
    Gt := pCTD^.AcTimeG;
    Qt := pCTD^.AcTimeQ;
  end;
end;

procedure GetAcTimes2(pComp: TpComp; var Pt,Gt,Qt: string);
{get the second activation times as strings from the object for data
called in OutputTimeCurr of skemproc.pas
          ShowMoreResults of skemadef.pas
          DrawRelayTime of Drawcomp.pas
 pComp  pointer to the current trafo
 Pt,Gt,Qt  the activation times}
var
  ll   : longint;   {temporary}
  pCTD : TpCTData;  {pointer to the object for data}
begin
  pComp^.GetAdint(ll);
  if (ll <> 0) then begin
    pCTD := TpCTData(ll);          {pointer to the object}
    Pt := pCTD^.AcTimeP2;
    Gt := pCTD^.AcTimeG2;
    Qt := pCTD^.AcTimeQ2;
  end;
end;

procedure ClearAcTimes1(pComp: TpComp);
{clear the activation times, as strings
 called in ClearCTactivation of skemproc.pas
 pComp  pointer to the current trafo}
var
  ll   : longint;   {temporary}
  pCTD : TpCTData;  {pointer to the object for data}
begin
  pComp^.GetAdint(ll);
  if (ll <> 0) then begin
    pCTD := TpCTData(ll);          {pointer to the object}
    pCTD^.AcTimeP := '';
    pCTD^.AcTimeG := '';
    pCTD^.AcTimeQ := '';
  end;
end;

procedure ClearAcTimes2(pComp: TpComp);
{clear the second activation times, as strings
 called in ClearCTactivation of skemproc.pas
 pComp  pointer to the current trafo}
var
  ll   : longint;   {temporary}
  pCTD : TpCTData;  {pointer to the object for data}
begin
  pComp^.GetAdint(ll);
  if (ll <> 0) then begin
    pCTD := TpCTData(ll);          {pointer to the object}
    pCTD^.AcTimeP2 := '';
    pCTD^.AcTimeG2 := '';
    pCTD^.AcTimeQ2 := '';
  end;
end;

end.
