unit specialCT;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, routines, skemadef, skemproc, utildef, StdCtrls, imagodef, Compdef,
  Elplex,Twoshort,RelCurr, Shortcir,Cmatmul, Shortcmp, ExtCtrls, phasor, CurrPhas,
  emtp;

procedure ShowCTlist        (ipComp: longint); far;  {show list of current trafos}
procedure SpecTrafoStart    (ipComp: longint); far;
procedure AddCurrTrafoToList(ipComp: longint); far;
procedure UpdateAndDisplay(pSCT: TpComp);
procedure RemoveSpecCT(pComp, pSCT: TpComp);
function  GetipCT: longint; {get pointer to this current trafo}

type
  TSummingForm = class(TForm)
    CTgrid: TStringGrid;
    DelBut: TButton;
    CancelBut: TButton;
    OKbut: TButton;
    CancelDataBut: TButton;
    ApplyBut: TButton;
    CloseBut: TButton;
    HintBut: TButton;
    SumModeBox: TComboBox;
    SumModeLabel: TLabel;
    ConnImg: TImage;
    procedure FormCreate(Sender: TObject);
    procedure CTgridSelectCell(Sender: TObject; Col, Row: Longint;
      var CanSelect: Boolean);
    procedure CTgridMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure DelButClick(Sender: TObject);
    procedure FormClick(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure OKbutClick(Sender: TObject);
    procedure CancelButClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure CancelDataButClick(Sender: TObject);
    procedure ApplyButClick(Sender: TObject);
    procedure CloseButClick(Sender: TObject);
    procedure CTgridDrawCell(Sender: TObject; Col, Row: Longint;
      Rect: TRect; State: TGridDrawState);
    procedure HintButClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure CTgridKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SumModeBoxChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure UpdateConnImage(pSCT : TpComp);
  end;

var
  SummingForm: TSummingForm;

implementation

uses Imagopas, CTParam;

{$R *.DFM}
const
  pointCol = 0;  {column for pointers}
  IDcol    = 1;  {column for identifiers}
  magnCol  = 2;  {column for magnitude of the multiplier}
  angleCol = 3;  {column for the angle of the multiplier}
  multCol  = 4;  {column for the multiplier symbol}
  labelCol = 5;  {column for the label}
  delCol   = 6;  {column for the delete "button"}
  DelRow : integer = 10; {row to be deleted}

var
  dp       : char;    {the decimal point}
  pGrid    : TpGrid;  {pointer to the grid of connected trafos}
  pCT      : TpComp;  {pointer to the special current trafo, in SpecTrafoStart, ShowCTlist}
  {an list for "back-up" = temporary saving of parameters for "cancel"}
  backList : TStringList;
  backMode : string; {backup of the summing mode}

function  GetipCT: longint;
{get pointer to this current trafo as integer}
begin
  GetipCT := longint(pCT);
end;

procedure ClearGrid;
{clear the grid}
var
  ii : integer;
begin
  for ii := 1 to pGrid^.rowcount-1 do begin
    pGrid^.cells[pointCol,ii] := '';
    pGrid^.cells[IDCol,ii] := '';
    pGrid^.cells[magnCol,ii] := '1'+dp+'0';
    pGrid^.cells[angleCol,ii] := '0'+dp+'0';
    pGrid^.cells[labelCol,ii] := '';
  end;
end;

procedure IdentAsDescript;
{put the identifiers into description Q2}
var
  ii  : integer;
  IDs : string;   {identifiers as one string}
begin
  IDs := '';
  for ii := 2 to pGrid^.rowcount-1 do begin          {CT itself not included}
    if (pGrid^.cells[IDcol,ii] <> '') then begin
      IDs := IDs+pGrid^.cells[IDcol,ii]+CTIdent_g; {use $ as a separator}
    end;
  end;
  pCT^.PutDescrQ(2,'',IDs,'');  {save as desicription Q2}
end;

procedure UpdatePointerList;
{update the list of pointers to the connected current trafos:
 read pointer (as integer) and save it to the list}
var
  ii    : integer; {index}
  ll    : longint; {temporary}
  pComp : TpComp;  {pointer to a component}
  pList : TpList;  {pointer to the list of pointers}
begin
  pCT^.GetpList(pList);   {pointer to the list of pointers to current trafos}
  pList^.clear;           {clear initially}
  pList^.add(pCT);        {the first pointer is a pointer to this current trafo}
  for ii := 2 to pGrid^.rowcount-1 do begin           {check all rows}
    if (pGrid^.cells[pointCol,ii] <> '') then begin   {not empty}
      ll := strtoint(pGrid^.cells[pointCol,ii]);      {pointer as integer}
      pComp := TpComp(ll);                            {pointer to ct}
      pList^.add(pComp);                              {add pointer to list}
    end else begin
      break;                                          {no more pointers}
    end;
  end;
end;

//procedure UpdateSpecCTLists;
//{check and update the lists in ordinary CT's, that list those special CT's
// that contain the ordinary CT in their lists (is this necessary?)}


procedure TSummingForm.FormCreate(Sender: TObject);
var
  ii : integer;
begin
  DecimalPoint(dp);         {determine the char. for the decimal point}
  {initialize the grid}
  CTGrid.cells[magnCol,0] := 'magnit.';
  CTGrid.cells[angleCol,0] := 'angle ()';
  CTGrid.cells[labelCol,0] := 'Label';
  CTGrid.cells[delCol,0] := 'del';
  {default values for the coefficients}
  for ii := 1 to CTGrid.RowCount-1 do begin
    CTGrid.cells[magnCol,ii] := '1'+dp+'0';
    CTGrid.cells[angleCol,ii] := '0'+dp+'0';
    CTGrid.cells[multCol,ii] := 'x';         {multiplier sign}
  end;
  {delete "button"}
  for ii := 2 to CTGrid.RowCount-1 do begin
    CTGrid.cells[delCol,ii] := '(X)';
  end;
  pGrid := @CTGrid;
  backList := TStringList.create;  {create list for saving data for "cancel"}
  {add flag that form created}
  Imagoo.ReadyEdit.text := Imagoo.ReadyEdit.text+'S';
end;

procedure UpdateWeighedSum(pSCT: TpComp);
{update the weighed sum of the currents at the special current trafo,
 but only after a fault calculation
 pSCT  pointer to the special current trafo}
var
  apu         : single;    {temporary}
  cpu,cpv     : complex;   {temporary}
  fa,fb,fc    : single;    {phase of currents}
  fp,fm,fz    : single;    {phase of sequence currents}
  ipSet       : longint;   {pointer to the common, as integer}
  it          : integer;   {index of time step}
  Ia,Ib,Ic    : single;    {magnitude of currents}
  Isx,Isy,Isz : complex;   {currents of the phases}
  Ip,Im,Iz    : single;    {magnitude of sequence currents}
  Ipx,Imx,Izx : complex;   {sequence currents}
  nvar        : integer;   {number of output variables}
  pSet        : TpCompSet; {pointer to the common}
begin
//showmessage('update WS');
  pSCT^.GetIpset(ipSet);
  pSet := TpCompSet(ipSet); {pointer to the common}
  if ((pSet^.appl_op = 6) or (pSet^.appl_op =  7) or  {fault calculation}
      (pSet^.appl_op = 8) or (pSet^.appl_op = 11)) and
      not(pSet^.appl_type = std )then begin           {not standard calc.}
    for it := 1{0} to pSet^.nCalc do begin            {all time steps  (0 or 1 ?) }
      WeighedSumCurrent(pSCT,it, Isx,Isy,Isz,'UpWS'); {calculate the weighed sum at step it..}
      {save initial currents}                         {..in elplex.pas}
      {if (it = 0) then begin}
      PhaseToSeq(Isx,Isy,Isz,Ipx,Imx,Izx);            {sequence currents, in twoshort.pas}
      {calculate magnitude and phase}
      Ia := Cabs(Isx);
      Ib := Cabs(Isy);
      Ic := Cabs(Isz);
      apu := 180/pi;
      fa := apu*Cangle(Isx);
      fb := apu*Cangle(Isy);
      fc := apu*Cangle(Isz);
      {sequence currents, times 3}   {OR maybe NOT  25.4.2014}
      Ip := Cabs(Ipx);
      Im := Cabs(Imx);
      Iz := Cabs(Izx);
      fp := apu*Cangle(Ipx);
      fm := {3*}apu*Cangle(Imx);
      fz := {3*}apu*Cangle(Izx);
      {save}
      pSCT^.PutTriple(it,Ia,Ib,Ic,Iz,Im);   {save magnitude}
      pSCT^.PutPhase(it,fa,fb,fc,fz,fm);    {save phase}
      {find and save largest current}
      apu := Ia;
      if (Ib > apu) then apu := Ib;
      if (Ic > apu) then apu := Ic;
      pSCT^.PutSingle(it,apu);
    end;
  end else begin    {not a fault calc., or fault calc. according to standard}
    if not({(pSet^.appl_op = 6) or} (pSet^.appl_op =  7) or  {not unsymm.fault calculation}
           (pSet^.appl_op = 8) or (pSet^.appl_op = 11)) then begin
      WeighedSumCurrent(pSCT,-1, Isx,cpu,cpv,'UpWS2'); { in elplex.pas}
      Isy := Cmult(emifii,Isx);               {phase b, emifii defined in elplex }
      Isz := Cmult(eifii,Isx);                {phase c, eifii defined in elplex.pas}
    end else if (pSet^.appl_op = 15) then begin  {unsymm.fault}
      WeighedSumCurrent(pSCT,1, Isx,Isy,Isz,'UpWS3');     { in elplex.pas}
    end else begin                                        {fault calc. with standard}
      WeighedSumCurrent(pSCT,1{-1}, Isx,cpu,cpv,'UpWS4'); { in elplex.pas}
      Isy := cpu;
      Isz := cpv;
    end;
    pSCT^.PutVar(gSpecCT_Ir,Isx.x,'UpdateWeighedSum');
    pSCT^.PutVar(gSpecCT_Ii,Isx.y,'UpdateWeighedSum');
    pSCT^.GetNvar(nvar);                     {number of output variables}
    pSCT^.PutVar(gSpecCT_Ir+nvar,Isy.x,'UpdateWeighedSum');
    pSCT^.PutVar(gSpecCT_Ii+nvar,Isy.y,'UpdateWeighedSum');
    pSCT^.PutVar(gSpecCT_Ir+nvar*2,Isz.x,'UpdateWeighedSum');
    pSCT^.PutVar(gSpecCT_Ii+nvar*2,Isz.y,'UpdateWeighedSum');
    {results saved also as "current out" of the (nonexistent) third node}
    pSCT^.PutCurrOut(3,Isx.x,Isx.y);  {?needed in SaveComplex, SaveCurr, in Shortcmp.pas }
  end;
end;

procedure UpdateRelayCurrents;
{update the initial current(s) of relay(s) connected to the special relay}
var
  apu,apv  : single;    {temporary}
  apw      : single;    {temporary}
  Ca,Cb,Cc : complex;   {currents from the CT}
  conn     : single;    {connection type, actually only Y}
  err      : integer;   {error flag}
  fault    : boolean;   {fault calculation}
  fa,fb,fc : single;    {phase of current}
  Ia,Ib,Ic : single;    {magnitude of current}
  iCT      : longint;   {pointer to the current trafo as an integer}
  Ipr,Isc  : single;    {prim. sec. nominal currents of the CT}
  Ix,Iy,Iz : complex;   {complex currents }
  Ja,Jb,Jc : single;    {magnitude of current}
  jcomp    : integer;   {counts components}
  ll       : longint;   {temporary}
  mode     : single;    {connection mode to relay}
  name     : string;    {name = type of the relay}
  nvar     : integer;   {number of result variables}
  pComp    : TpComp;    {pointer to a component}
  pSet     : TpCompSet; {pointer to the common}
  ratio    : single;    {transformation ratio of the CT, Ipr/Isc}
begin
   pCT^.GetipSet(ll);
   GetCTmainPar(pCT, ratio, Ipr, Isc, conn, mode);
   pSet := TpCompSet(ll);              {pointer to the common}
   {get initial currents, may be needed for the relays}
   if ((pSet^.appl_op = 6) or (pSet^.appl_op =  7) or  {fault calculation}
      (pSet^.appl_op = 8) or (pSet^.appl_op = 11)) then begin
     pCT^.GetTriple(1,Ja,Jb,Jc{Ia,Ib,Ic},apu,apv); {magnitude of the currents}
     pCT^.GetPhase(1,fa,fb,fc,apu,apv);  {phase of the currents}
     {update secondary current of CT, (if sec. in use), magnitude only because Y-connected}
     {(neg.seq and sum not needed)}
     SecondaryCTCurrents(0,Ja,Jb,Jc,0,0,fa,fb,fc,0,0,conn,Isc,mode,ratio,apu,Ia,Ib,Ic,apv,apw);
     fault := true;
   end else begin                        {"normal" calculation}
     pCT^.getVar(gSpecCT_Ir,Ca.x{Ix.x});
     pCT^.getVar(gSpecCT_Ii,Ca.y{Ix.y});
     Cb{Iy} := Cmult(emifii,Ca{Ix});              {phase b, emifii defined in elplex }
     Cc{Iz} := Cmult(eifii,Ca{Ix});               {phase c, eifii defined in elplex.pas}
     {take connection, ratio etc. of CT into account}
     ProcessCTcurr(Ca,Cb,Cc, mode, ratio, conn, Isc, Ix,Iy,Iz); {in skemproc.pas}
     fault := false;
   end;
   {search relay(s) connected to this current trafo}
   iCT := longint(pCT);              {pointer to the CT as an integer}
   pComp := nil;                     {initialize pointer to comp.}
   err := 0;
   jcomp := 0;
   while (err = 0) do begin                 {scan all components}
     pSet^.NextComp(pComp, err,jcomp,true); {pointer to next component}
     if (err = 0) then begin                {no errors, else no more components}
       pComp^.GetName(name);                {name = type of the component}
       if ((name = gRelay) or IsInvTimeRelay(name) or  {is it a relay (in Shortcir.pas)}
           (name = gPQrel) or (name = gRCrel) or
           (name = gUDrel) or (name = gEMrel)) then begin
         pComp^.GetipComp(ll);       {pointer to another component}
         if (ll = iCT) then begin    {points to this current trafo}
           pComp^.GetNvar(nvar);     {number of variables}
           {index depends on relay type}
           if (name = gRelay) or IsInvTimeRelay(name) then begin  {"plain" relay}
             {if not fault calculation, must calculate magnitude and phase}
             if (not fault) then begin
               Ia := Cabs(Ix);
               fa := Cangle(Ix)*180/pi;
               Ib := Cabs(Iy);
               fb := Cangle(Iy)*180/pi;
               Ic := Cabs(Iz);
               fc := Cangle(Iz)*180/pi;
             end else begin
               {fault calc., magnitude and phase known}
             end;

             pComp^.putVar(gRelay_Ik,Ia,'UpdateRelayCurrents');
             pComp^.putVar(gRelay_fii,fa,'UpdateRelayCurrents');
             pComp^.putVar(gRelay_Ik +nvar,Ib,'UpdateRelayCurrents');
             pComp^.putVar(gRelay_fii+nvar,fb,'UpdateRelayCurrents');
             pComp^.putVar(gRelay_Ik +nvar*2,Ic,'UpdateRelayCurrents');
             pComp^.putVar(gRelay_fii+nvar*2,fc,'UpdateRelayCurrents');
           end else begin            {PGQ-, EM-, etc relay}
             {if fault calculation, must calculate real and imag.components}
             if (fault) then begin
               apu := pi*fa/180;
               Ix := cplx(Ia*cos(apu),Ia*sin(apu));
               apu := pi*fb/180;
               Iy := cplx(Ib*cos(apu),Ib*sin(apu));
               apu := pi*fc/180;
               Iz := cplx(Ic*cos(apu),Ic*sin(apu));
             end else begin          {"normal" calculation, real and imag.comp. known}
               {}
             end;
             {real and imag. components saved}
             pComp^.putVar(gPQ_Ir,Ix.x,'UpdateRelayCurrents');
             pComp^.putVar(gPQ_Ii,Ix.y,'UpdateRelayCurrents');
             pComp^.putVar(gPQ_Ir+nvar,Iy.x,'UpdateRelayCurrents');
             pComp^.putVar(gPQ_Ii+nvar,Iy.y,'UpdateRelayCurrents');
             pComp^.putVar(gPQ_Ir+nvar*2,Iz.x,'UpdateRelayCurrents');
             pComp^.putVar(gPQ_Ii+nvar*2,Iz.y,'UpdateRelayCurrents');
           end;
         end;
       end;
     end;
  end;
end;

procedure TSummingForm.UpdateConnImage(pSCT : TpComp);
{update the image showing the connection type etc. of the current transformers
 in the list of the special current trafo
 pSCT  pointer to the special current trafo}
var
  conn    : single;   {connection type}
  dy      : integer;  {distance in y-direction}
  ii      : integer;  {index}
  Ipr,Isc : single;   {primary, secondary current}
  ipu,ipv : integer;  {temporary}
  iy      : integer;  {coordinate}
  mode    : single;   {relay setting mode }
  pCTr    : TpComp;   {pointer to the current transformers}
  pImg    : TpImage;  {pointer to the image}
  pList   : TpList;   {pointer to the list of the current trafos}
  ratio   : single;   {transformation ratio}
  txt     : string;   {temporary}
begin
  pImg := @ConnImg;              {local pointer to the image}
  pImg^.picture := nil;          {clear initially}
  {draw background}
  pImg^.canvas.pen.width := 1;
  pImg^.canvas.pen.color := clBlack;
  pImg^.canvas.brush.style := bsSolid;
  pImg^.canvas.brush.color := clBtnFace;
  pImg^.canvas.rectangle(0,0,pImg^.width,pImg^.height);
  {draw lines}
  pImg^.canvas.pen.color := clSilver;
  dy := CTGrid.DefaultRowHeight+CTGrid.GridLineWidth;
  iy := 1;
  for ii := 1 to CTGrid.RowCount-1 do begin
    iy := ii*dy;
    pImg^.canvas.MoveTo(1,iy);
    pImg^.canvas.LineTo(pImg^.width-1,iy);
  end;
  {captions}
  pImg^.canvas.font.name := 'arial';
  pImg^.canvas.font.size := 8;
  pImg^.canvas.font.color := clBlack;
  pImg^.canvas.TextOut(2,3,'Connect.  CT ratio');
  {vertical line}
  ipu := pImg^.width div 2;
  pImg^.canvas.MoveTo(ipu,1);
  pImg^.canvas.LineTo(ipu,pImg^.height-1);
  {write connection type and ratio of the current transformers}
  pSCT^.GetpList(pList);
  if (pList <> nil) then begin
    if (pList^.count > 0) then begin
      for ii := 0 to pList^.count-1 do begin
        pCTr := pList^.items[ii];
        GetCTmainPar(pCTr, ratio, Ipr, Isc, conn, mode);
        {write connection type: 0 = Y, 1 = Delta a-b, 2 = Delta a-c}
        ipu := (ii+1)*dy+1;
        if (conn = 0) then begin
          pImg^.canvas.font.name := 'arial';
          txt := 'Y';
          pImg^.canvas.textout(2,ipu,txt);
        end else begin
          pImg^.canvas.font.name := 'symbol';
          txt := 'D';
          pImg^.canvas.textout(4,ipu,txt);
          pImg^.canvas.font.name := 'arial';
          if (conn = 1) then txt := 'a-b' else txt := 'a-c';
          pImg^.canvas.textout(14,ipu,txt);
        end;
        {write transformation ratio}
        pImg^.canvas.font.name := 'arial';
        txt := sixplaces(ratio);
        ipv := (pImg^.width div 2)+4;
        pImg^.canvas.textout(ipv,ipu,txt);
      end;
    end;
  end;

end;

procedure ShowCTlist(ipComp : longint);
{show list of current trafos, when special CT clicked}
var
  apu   : single;   {temporary}
  ident : string;   {identifier}
  IDs   : string;   {all identifiers as one string}
  ii,jj : integer;  {index}
  ix,iy : integer;  {coordinates}
  lbl   : string;   {label}
  ll    : longint;  {temporary}
  npar  : integer;  {number of parameters}
  pComp : TpComp;   {pointer to a trafo}
  pList : TpList;   {pointer to the list of pointers to the curr.trafos}
  txt   : string;   {temporary}
begin
  {first, clear the grid}
  ClearGrid;
  {start filling the grid}
  pCT := TpComp(ipComp);           {pointer to the current trafo}
  pCT^.GetpList(pList);
  IDs := '';
  {fill the grid}
  if (pList <> nil) then begin
    if (pList^.count > 0) then begin
      for ii := 0 to pList^.count-1 do begin
        pComp := pList^.items[ii];
        ll := longint(pComp);                        {pointer to integer}
        pGrid^.cells[pointCol,ii+1] := inttostr(ll); {in the grid as string}
        ident := pComp^.getID;                       {unique identifier}
        pGrid^.cells[IDCol,ii+1] := ident;           {put into the grid}
        pComp^.GetLabel(lbl,ix,iy);                  {label of the current trafo}
        pGrid^.cells[labelCol,ii+1] := lbl;          {label to the grid}
      end;
      {coefficients = parameters}
      pCT^.GetNpar(npar);                          {number of parameters}
      if (pGrid^.RowCount <= (npar div 2)) then begin
        for jj:= 1 to pGrid^.RowCount-1 {(npar div 2)} do begin
          pCT^.GetPar(2*jj-1,apu);                   {get magnitude of multiplier}
          RemoveSpaces(apu,txt);                     {format, and remove spaces}
          pGrid^.cells[magnCol,jj] := txt;           {magnitude to grid}
          pCT^.GetPar(2*jj,apu);                     {angle}
          RemoveSpaces(apu,txt);
          pGrid^.cells[angleCol,jj] := txt;          {angle to grid}
        end;
      end else begin
        {error case ?}
      end;
    end else begin                                 {empty list, add this CT}
      {}
    end;
    {identifiers must be saved at once (will be saved later, again)}
{   IdentAsDescript;         {save identifiers as description Q2}
    {save all, to be recalled in the case of a "cancel"}
    backList.clear;                                {initialize, to be sure}
    for ii := 1 to pGrid^.rowcount-1 do begin      {row 0 is for fixed captions}
      backList.add(pGrid^.cells[PointCol,ii]);
      backList.add(pGrid^.cells[IDCol,ii]);
      backList.add(pGrid^.cells[magnCol,ii]);
      backList.add(pGrid^.cells[angleCol,ii]);
      backList.add(pGrid^.cells[labelCol,ii]);
    end;
  end;
  pCT^.GetPar(gSCT_summode,apu);    {summing mode: prim. or sec}
  {show the summing mode}
  if (apu = 0) then SummingForm.SumModeBox.text := SummingForm.SumModeBox.Items[0]
  else SummingForm.SumModeBox.text := SummingForm.SumModeBox.Items[1];
  BackMode := SummingForm.SumModeBox.text;  {backup of the summing mode}
  SummingForm.CTgrid.FixedColor := clBtnFace;
  SummingForm.visible := true;      {only when manually creating (not from file)}
  {show also the phasors, if phasor form visible}
  ShowCurrPhasors(ipComp);
  SummingForm.activecontrol := nil; {prepare for deleting a comp., see FormKeyDown}
  SummingForm.UpdateConnImage(pCT);
end;

procedure TSummingForm.CTgridSelectCell(Sender: TObject; Col, Row: Longint;
  var CanSelect: Boolean);
begin
  {must not edit multiplier, label, or delete cells}
  if (col = multCol) or (col = labelCol) or (col = delCol) then begin
    CTgrid.options := CTgrid.options-[goEditing,goAlwaysShowEditor];
  end else begin
    CTgrid.options := CTgrid.options+[goEditing,goAlwaysShowEditor];
  end;
end;

procedure SaveCoeff;
{read the magnitude and angle of the coefficients in the grid, and
 save them as parameters}
var
  errc    : integer;   {error flag}
  errow   : integer;   {index of error row}
  ii,jj   : integer;   {indices}
  ipu     : integer;   {temporary}
  par     : single;    {parameter}
  txt,txx : string;    {temporary texts}
begin
  {save coefficients}
  errow := 0;                                          {initialize error flag}
  for ii := 1 to pGrid^.rowcount-1 do begin
    for jj := 1 to 2 do begin                          {multiplier, and angle}
      if (jj = 1) then txt := pGrid^.cells[magnCol,ii] {multiplier}
      else            txt := pGrid^.cells[angleCol,ii];{angle}
      NextValueFromLine(txt,1, ipu, par,txx, errc);    {string to numerical, in routines.pas}
      if (errc = 0) then begin
        pCT^.PutPar(2*(ii-1)+jj,par);                  {save as parameter}
      end else begin
        {is it an empty row}
        txt := pGrid^.cells[PointCol,ii];
        txx := pGrid^.cells[IDcol,ii];
        if (txt <> '') and (txx <> '') then errow := ii;  {error row, if non-empy}
      end;
    end;
  end;
  {announce errors}
  if (errow > 0) then show_message('error on row '+inttostr(errow));
end;

procedure SpecTrafoStart(ipComp: longint);
{create image for results, clear descr., add CT to grid}
var
  ident : string;    {unique identifier}
  ipSet : longint;   {pointer to the common as integer}
  ix,iy : integer;   {coordinates}
  lbl   : string;    {label}
  ll    : longint;   {temporary}
  pList : TpList;    {pointer to a list of pointers to the current trafos}
  pSet  : TpCompSet; {pointer to the common}
begin
  CTresultImage(ipComp);      {create image for results}
  ClearCTactivation(ipComp);  {clear activation data, eventually read in from file}
  pCT := TpComp(ipComp);
  if (pCT <> nil) then begin
    pCT^.GetipSet(ipSet);
    pSet := TpCompSet(ipSet);
    if (pSet^.create_comp) then begin  {show only when (manually) creating comp.}
      pCT^.PutDescrQ(2,'','','');      {initialize description Q2}
      ClearGrid;                       {remove (eventual) old parameters}
      ll := longint(pCT);                          {pointer as integer}
      pGrid^.cells[pointCol,1] := inttostr(ll);    {in the grid as string}
      pCT^.GetLabel(lbl,ix,iy);
      pGrid^.cells[labelCol,1] := lbl;             {label to the grid}
      ident := pCT^.getID;                         {unique identifier}
      pGrid^.cells[IDcol,1] := ident;              {put into the grid}
{     SummingForm.visible := true;}                {do not show initially!}
    end;
    pCT^.CreateList;      {create list for pointers to the other current trafos}
    pCT^.GetpList(pList); {pointer to the list of pointers to current trafos}
    pList^.clear;         {clear initially, well..., necessary?}
    pList^.add(pCT);      {first entry = pointer to this trafo}
    if (pSet^.create_comp) then begin  {save only when (manually) creating comp.}
      {save unique identifiers (necessary? this will been done later }
      IdentAsDescript;
      {save coefficients}
      SaveCoeff;                     {well, not much to save}
      pCT^.PutPar(gSCT_summode,0);   {initialize summing mode = primary}
    end;
    CTForm.caption := 'Special Curr. Transf. '+lbl;
    if (pSet^.create_comp) then CTForm.CTParamShow(ipComp);      {in CTParam.pas}
    {create object for data, ddefined in skemobj.pas}
    CreateObjForCTdata(pCT);
  end;
end;

procedure AddCurrTrafoToList(ipComp: longint);
{add a current trafo to the list of connected trafos, if possible
 ipComp  pointer to the current trafo as longint}
var
  ii      : integer;  {index}
  iRow    : integer;  {index of first empty row}
  isThere : boolean;  {trafo is in the list}
  IDcomp  : string;   {identifier of the comp.}
  ix,iy   : integer;  {coordinates}
  lbl     : string;   {label}
  pComp   : TpComp;   {pointer to the trafo}
  pList   : TpList;   {pointer of list of special CT's}
begin
  pComp := TpComp(ipComp);  {pointer to the CT}
  IDcomp := pComp^.GetID;   {unique identifier of the component}
  {scan the list, check that the comp. is not there, and that there is room}
  isThere := false;
  iRow := 0;
  for ii := 2 to pGrid^.rowcount-1 do begin           {0=title,1=this trafo}
    if (IDcomp = pGrid^.cells[IDcol,ii]) then begin   {trafo is already in the list}
      isThere := true;
      break;
    end else if (pGrid^.cells[IDcol,ii] = '') then begin  {first empty row}
      iRow := ii;
      break;
    end;
  end;
  {there is room, and trafo not yet in the list}
  if (iRow > 0) and (not isThere) then begin
    pComp^.GetLabel(lbl,ix,iy);                       {label of the component}
    pGrid^.Cells[labelCol,iRow] := lbl;               {label to the grid}
    pGrid^.Cells[IDcol,iRow] := IDcomp;               {identifier to the grid}
    pGrid^.Cells[pointCol,iRow] := inttostr(ipComp);  {pointer to the grid, as integer}
    SummingForm.CTGrid.FixedColor := clYellow;        {to indicate a change}
    pComp^.GetpList(pList);                           {get the pointer to the list of spec.CT's}
    if (pList = nil) then begin
      pComp^.CreateList;                              {create list for pointers to special CT}
      pComp^.GetpList(pList);
    end;
    pList^.Add(pCT);                                  {add in list of spec.CT's containing this CT}
    SummingForm.UpdateConnImage(pCT);
  end;
  {update symbol of this trafo, if first new entry}
  if (iRow >= 2) then begin            {well, update every time ?}
    ChangeIconColor(@(pCT^ as TImage),@(pCT^ as TImage),clSilver, clRed);
  end;
{ IdentAsDescript;         {save identifiers as description Q2}
end;

procedure TSummingForm.CTgridMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  ii   : integer;
  rh   : integer;  {row height}
  xr   : integer;  {x of the right edge}
  yrow : integer;  {row where clicked (from coordinate)}
begin
  xr := CTgrid.left{+CTgrid.GridLineWidth};   {initialize x-position of left boundary}
  for ii := 0 to CTGrid.ColCount-1 do begin
    xr := xr+CTgrid.ColWidths[ii]+CTgrid.GridLineWidth;  {width of columns+grid lines}
  end;
  {find row where clicked}
  rh := CTgrid.DefaultRowHeight+CTgrid.GridLineWidth;
  yrow := y div rh;
  {clicking the "delete"-column?}
  if (x < xr) and
     (x > xr-CTgrid.ColWidths[CTgrid.ColCount-1]) then begin
    {first CT cannot be deleted}
    if (yrow > 1) and (yrow < CTgrid.rowcount) then begin
      DelBut.top := CTgrid.top+rh*yrow+1;  {put button on the clicked row}
      DelBut.visible := true;
      CancelBut.top := DelBut.top;
      CancelBut.visible := true;
      DelRow := yrow;                      {save for deleting operation}
    end else begin
      DelBut.visible := false;             {not a reasonable row}
      CancelBut.visible := false;
    end;
  end else begin                           {not delete column}
    DelBut.visible := false;
    CancelBut.visible := false;
  end;
end;

procedure RemoveSpecCT(pComp, pSCT: TpComp);
{remove a pointer to a special current trafo from list of special current trafos
 This list is in an ordinary current trafo, and it contanis pointers to such
 special current trafos, that have this ordinary CT in its own list (for summing)
 pComp  pointer to the ordinary current trafo
 pSCT   pointer to the special current trafo}
var
  ipu    : integer; {temporary}
  pSList : TpList;  {pointer to list of special current trafos}
begin
  pComp^.GetpList(pSList);          {pointer to the list of spec.CT's}
  if (pSList^.count > 0) then begin {something in the list}
    ipu := pSList^.IndexOf(pSCT);   {index of this special ct}
    if (ipu >= 0) then begin        {spec.CT in the list}
      pSList^.delete(ipu);          {remove the CT from the list}
      pSList^.pack;
      if (pSList.count = 0) then pComp^.FreeList; {if list empty, free it}
    end;
  end;
end;

procedure TSummingForm.DelButClick(Sender: TObject);
{delete the entry in the grid}
var
  ii,jj  : integer;   {index}
  ipu    : integer;   {temporary}
  ll     : longint;   {temporary}
  pComp  : TpComp;    {pointer to the CT to be removed}
  pList  : TpList;    {pointer to list of connected CT's}
  pMod   : TpElComp;  {pointer to the model component}
  pSList : TpList;    {pointer to list of connected spe.CT's}
begin
  {delete the entry in the clicked row, and move up the texts below}
  if (DelRow > 1) and (DelRow <= CTgrid.RowCount-1) then begin {reasonable row}
    if (DelRow < CTgrid.RowCount-1) then begin           {but not the last one}
      {remove link to this special CT from the CT to be removed from the list}
      ll := strtoint(CTGrid.Cells[pointCol,DelRow]);
      if (ll <> 0) then begin
        pComp := TpComp(ll);
        RemoveSpecCT(pComp,pCT);
//        pComp^.GetpList(pSList);          {pointer to the list of spec.CT's}
//        if (pSList^.count > 0) then begin {something in the list}
//          ipu := pSList^.IndexOf(pCT);    {index of this special ct}
//          if (ipu >= 0) then begin        {spec.CT in the list}
//            pSList^.delete(ipu);          {remove the CT from the list}
//            pSList^.pack;
//            if (pSList.count = 0) then pComp^.FreeList; {if list empty, free it}
//          end;
//        end;
      end;
      {now, delete and move}
      for ii := DelRow to CTgrid.RowCount-2 do begin
        for jj := 0{1} to CTgrid.ColCount-2 do begin
          CTgrid.cells[jj,ii] := CTgrid.cells[jj,ii+1];  {shift up}
        end;
      end;
    end else begin                                       {not reasonable row}
      {do nothing}
    end;
    {clear the last row}
    ipu := CTgrid.RowCount-1;    {index of the last row}
    CTgrid.cells[pointCol,ipu] := '';
    CTgrid.cells[IDcol,ipu] := '';
    CTgrid.cells[magnCol,ipu] := '1'+dp+'0';
    CTgrid.cells[angleCol,ipu] := '0'+dp+'0';
    CTgrid.cells[labelCol,ipu] := '';
{    IdentAsDescript;   {save identifiers as description Q2}{NOT here, use OK-button}
    ApplyButClick(sender);
//    UpdateConnImage(pCT);   {in ApplyButClick}
  end;
  {update the symbol, if last CT deleted}
  pCT^.GetpList(pList);             {pointer to list of connected current trafos}
  if (pList^.count <= 1) then begin {only one CT left, this one}
    pCT^.GetipMod(ll);              {get the pointer to the model comp. as integer}
    pMod := TpElcomp(ll);           {pointer to the model comp.}
    pCT^.picture := pMod^.picture;  {copy "original" picture}
  end;
  {hide also the buttons}
  DelBut.visible := false;
  CancelBut.visible := false;
end;

procedure TSummingForm.FormClick(Sender: TObject);
begin
  DelBut.visible := false;
  CancelBut.visible := false;
end;

procedure TSummingForm.FormDeactivate(Sender: TObject);
begin
  DelBut.visible := false;
  CancelBut.visible := false;
end;

procedure UpdateActivationTimes;
{update the activation times of all overcurrent relays}
var
  ipSet  : longint;   {pointer to the common, as integer}
  nAM    : integer;   {number of asynch.motors}
  nCT    : integer;   {number of current transformers}
  nFlt   : integer;   {number of faults}
  nGM    : integer;   {number of generators and synch.motors}
  nQRl   : integer;   {number of PGQ- etc. relays}
  nRel   : integer;   {number of relays}
  nSrc   : integer;   {number of sources}
  pRelo  : TpRelay;   {pointer to the object for relays}
  pSet   : TpCompSet; {pointer to the common}
begin
  pCT^.GetipSet(ipSet);                  {pointer to the common as integer}
  pSet := TpCompSet(ipSet);
  {count the number of different components, only some needed}
  CountComp(ipSet,nGM,nRel,nFlt,nCT,nAM,nSrc,nQRl);
  {if there are current transformers, create object for operations with current trafos}
  {if there are relays, create object for operations with relays}
  CreateRelays(ipSet, nRel,nQRl, pRelo);                {normal and PQ-relay}
  {Note: The current trafos for the relays must be known}
  if (pRelo <> nil) then pRelo^.GroupActivation         {CheckActivation};
  {done. Delete objects...}
  if (nRel > 0) then begin
    pRelo^.Destr;                   {destroy object for relays}
    pRelo^.Free;
    dispose(pRelo);
    pRelo := nil;
  end;
end;

procedure InitialWeighedSum(pSCT: TpComp);
{get the initial weighed sum current of a special (summing) current trafo,
 if fault, else get the "normal" weighed sum current
 pSCT  pointer to the special current trafo}
var
  apu,apv  : single;     {temporary}
  fa,fb,fc : single;     {phase of currents}
  Ia,Ib,Ic : single;     {magnitude of currents}
  Icx      : complex;    {current}
  ll       : longint;    {temporary}
  nvar     : integer;    {number of output variables}
  pSet     : TpCompSet;  {pointer to the common}
begin
  pSCT^.GetipSet(ll);
  pSet := TpCompSet(ll);  {pointer to the common}
  pSCT^.GetNvar(nvar);                   {number of output variables}
  {after a short circuit calculation, get the current at the  first time step}
  if ((pSet^.appl_op = 6 ) or (pSet^.appl_op = 7 ) or
     (pSet^.appl_op = 8 ) or (pSet^.appl_op = 11)) and
     not(pSet^.appl_type = std ) then begin  {dynamical, not standard calc.}
    {save the variables as output variables}
    pSCT^.GetTriple(1,Ia,Ib,Ic,apu,apv);   {magnitude of the initial current}
    pSCT^.GetPhase(1,fa,fb,fc,apu,apv);    {phase of current}
    Icx.x := Ia*cos(pi*fa/180);
    Icx.y := Ia*sin(pi*fa/180);
    pSCT^.PutVar(gSpecCT_Ir,Icx.x,'InitialWeighedSum');          {real part of current to comp}
    pSCT^.PutVar(gSpecCT_Ii,Icx.y,'InitialWeighedSum');          {imag part of current to comp}
    Icx.x := Ib*cos(pi*fb/180);
    Icx.y := Ib*sin(pi*fb/180);
    pSCT^.PutVar(gSpecCT_Ir+nvar,Icx.x,'InitialWeighedSum');     {real part of current to comp}
    pSCT^.PutVar(gSpecCT_Ii+nvar,Icx.y,'InitialWeighedSum');     {imag part of current to comp}
    Icx.x := Ic*cos(pi*fc/180);
    Icx.y := Ic*sin(pi*fc/180);
    pSCT^.PutVar(gSpecCT_Ir+nvar*2,Icx.x,'InitialWeighedSum');   {real part of current to comp}
    pSCT^.PutVar(gSpecCT_Ii+nvar*2,Icx.y,'InitialWeighedSum');   {imag part of current to comp}
  end else begin                            {not a fault, get output currents}
    {currents saved to pCT in UpdateWeighedSum}
  end;
end;

procedure TSummingForm.OKbutClick(Sender: TObject);
{save the data (pointers, identifiers, coefficients) in the grid,
 update activation times, result boxes (etc)}
begin
  ApplyButClick(sender);
  SummingForm.visible := false;
  SummingForm.CTgrid.FixedColor := clBtnFace;
end;

procedure TSummingForm.CancelButClick(Sender: TObject);
begin
  CancelBut.visible := false;
  DelBut.visible := false;
end;

procedure TSummingForm.FormDestroy(Sender: TObject);
begin
  backList.free;
end;

procedure UpdateAndDisplay(pSCT: TpComp);
{update the weighed sum of the special current trafo, and display the results
 pSCT   pointer to the special current trafo}
var
  ll   : longint;    {temporary}
  pSet : TpCompSet;  {pointer to the common}
begin
  pSCT^.GetipSet(ll);
  pSet := TpCompSet(ll);  {pointer to the common}
//showmessage('upd');
  UpdateWeighedSum(pSCT);                  {recalculate and save weighed sum of currents}
  {update graphics, if visible, and ...}
  RelayShowIf(RelayCharact.tag);          {in Skemproc.pas (pointer to the relay as tag)}
  {update result boxes. Get the currents first. The current of the current trafo itself first}
  InitialWeighedSum(pSCT);
  {and the relay currents}
  UpdateRelayCurrents;                    {update initial currents}
  {update activation times. This is complicated. Actually only the activation time
  of this relay should be updated. But it is simpler to use existing modules to
  update act.times of all relays}
  if ((pSet^.appl_op = 6) or (pSet^.appl_op =  7) or    {fault calculation}
      (pSet^.appl_op = 8) or (pSet^.appl_op = 11)) and
      not(pSet^.appl_type = std ) then begin            {but not according to standard}
    UpdateActivationTimes;
    {finally, update the result boxes}
    pSet^.UpdateResultBoxes(3);           {..but maybe already updated, in RelayShowIf, if..}
  end else begin
    pSet^.UpdateResultBoxes(1);           {just update, but not activation times}
  end;
  {update the reading next to the current trafo}
  if (pSCT^.pImg_s <> nil) then begin             {image defined}
    ShowCurrRes(pSCT,Imagoo.ShowCurrBut.Caption);  {show the desired phase of the current, in Elplex.pas}
  end;
end;

procedure TSummingForm.CancelDataButClick(Sender: TObject);
{return the original data}
var
  ii,jj : integer;
  ll    : longint;  {temporary}
  pList : TpList;   {list of pointers to connected components}
  pMod  : TpElComp; {pointer to the model component}
begin
  jj := 0;
  {return the grid to the original state (state when clicking the special CT}
  if (backlist.count >= 5*(pGrid^.rowcount-1)) then begin  {anything in backup}
    for ii := 1 to pGrid^.rowcount-1 do begin
      pGrid^.cells[PointCol,ii] := backList.strings[jj];
      inc(jj);
      pGrid^.cells[IDCol,ii] := backList.strings[jj];
      inc(jj);
      pGrid^.cells[magnCol,ii] := backList.strings[jj];
      inc(jj);
      pGrid^.cells[angleCol,ii] := backList.strings[jj];
      inc(jj);
      pGrid^.cells[labelCol,ii] := backList.strings[jj];
      inc(jj);
    end;
    {also the summing mode}
    SummingForm.SumModeBox.text := BackMode;  {backup of the summing mode}
    if (SumModeBox.text <> SumModeBox.items[0]) then   {not primary}
      {pCT initialized in ShowCTList}
      pCT^.PutPar(gSCT_summode,1)         {sum mode = secondary currents}
    else
      pCT^.PutPar(gSCT_summode,0);        {sum mode = primary currents}
      {undo eventual changes in the result boxes etc.}
    ApplyButClick(sender);
  end;
  {update the picture (symbol) of this current trafo, if needed}
  pCT^.GetpList(pList);             {pointer to list of connected current trafos}
  if (pList^.count <= 1) then begin {only one CT left, this one}
    pCT^.GetipMod(ll);              {get the pointer to the model comp. as integer}
    pMod := TpElcomp(ll);           {pointer to the model comp.}
    pCT^.picture := pMod^.picture;  {copy "original" picture}
  end else begin
    ChangeIconColor(@(pCT^ as TImage),@(pCT^ as TImage),clSilver, clRed);
  end;
{ SummingForm.visible := false;}
  SummingForm.CTgrid.FixedColor := clBtnFace;
end;

procedure TSummingForm.ApplyButClick(Sender: TObject);
{carry out calculations with the new data. First, data must be saved}
var
  ll       : longint;   {temporary}
  pSet     : TpCompSet; {pointer to the common}
begin
  {update (save) the list of pointers to connected current trafos}
  UpdatePointerList;       {necessary ?}
  {save unique identifiers (necessary? this has been done several times }
  IdentAsDescript;
  {save coefficients}
  SaveCoeff;
  UpdateAndDisplay(pCT);   {update the weighed sum, and display results}
  UpdateConnImage(pCT);    {update display of connection&ratio of CT's}
(*
  pCT^.GetipSet(ll);
  pSet := TpCompSet(ll);  {pointer to the common}
  UpdateWeighedSum(pCT);                  {recalculate and save weighed sum of currents}
  {update graphics, if visible, and ...}
  RelayShowIf(RelayCharact.tag);          {in Skemproc.pas (pointer to the relay as tag)}
  {update result boxes. Get the currents first. The current of the current trafo itself first}
  InitialWeighedSum(pCT);
  {and the relay currents}
  UpdateRelayCurrents;                    {update initial currents}
  {update activation times. This is complicated. Actually only the activation time
  of this relay should be updated. But it is simpler to use existing modules to
  update act.times of all relays}
  if ((pSet^.appl_op = 6) or (pSet^.appl_op =  7) or    {fault calculation}
      (pSet^.appl_op = 8) or (pSet^.appl_op = 11)) and
      not(pSet^.appl_type = std ) then begin            {but not according to standard}
    UpdateActivationTimes;
    {finally, update the result boxes}
    pSet^.UpdateResultBoxes(3);           {..but maybe already updated, in RelayShowIf, if..}
  end else begin
    pSet^.UpdateResultBoxes(1);           {just update, but not activation times}
  end;
  {update the reading next to the current trafo}
  if (pCT^.pImg_s <> nil) then begin             {image defined}
    ShowCurrRes(pCT,Imagoo.ShowCurrBut.Caption);  {show the desired phase of the current, in Elplex.pas}
  end;
*)
  SummingForm.CTgrid.FixedColor := clBtnFace;
end;

procedure TSummingForm.CloseButClick(Sender: TObject);
begin
  SummingForm.visible := false;
  SummingForm.CTgrid.FixedColor := clBtnFace;
end;

procedure TSummingForm.CTgridDrawCell(Sender: TObject; Col, Row: Longint;
  Rect: TRect; State: TGridDrawState);
{color the small rectangles between the multipliers and labels}
begin
  if (col = MultCol) and (row > 0) then begin
    pGrid^.canvas.pen.width := 1;
    pGrid^.canvas.pen.color := clGray;
    pGrid^.canvas.brush.color := clBtnFace;
    pGrid^.canvas.rectangle(rect.left,rect.top,rect.left+
               pGrid^.ColWidths[col],rect.top+pGrid^.RowHeights[row]);
    pGrid^.canvas.font.color := clBlue;
    pGrid^.canvas.font.name := 'arial';
    pGrid^.canvas.font.size := 8;
    pGrid^.canvas.font.style := [fsBold];
    pGrid^.canvas.textout(rect.left+6,rect.top+1,'x');
  end;
end;

procedure TSummingForm.HintButClick(Sender: TObject);
{display the help-memo}
var
  pHelp : TpMemo;     {pointer to the help-memo}
  pMod  : TpElComp;   {pointer to the model component}
begin
  if (pCT <> nil) then begin
    pCT^.GetpMod(pMod);
    pMod^.GetpHelp(pHelp);
    if (pHelp <> nil) then begin
      pHelp.top := 200;
      pHelp.left := 100;
      pHelp.width := 450;
      pHelp.height := 300;
      pHelp.visible := true;
    end;
  end;
end;

procedure TSummingForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  {eventual "delete component" must be handled here, because the form has focus}
  if (SetComp.pActComp <> nil) then begin     {some component active}
    if (key = 46) then begin                  {delete-key}
      SetComp.FormKeyDown(Key, Shift);        {delete the component}
    end;
  end;
end;

procedure TSummingForm.CTgridKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  SummingForm.CTgrid.FixedColor := clYellow; {to indicate a change}
end;

procedure TSummingForm.SumModeBoxChange(Sender: TObject);
{save summing mode, recalculate sum}
begin
  if (SumModeBox.text <> SumModeBox.items[0]) then   {not primary}
    {pCT initialized in ShowCTList}
    pCT^.PutPar(gSCT_summode,1)         {sum mode = secondary currents}
  else
    pCT^.PutPar(gSCT_summode,0);        {sum mode = primary currents}
  {update sum, result boxes etc}
  ApplyButClick(Sender);
end;

end.
