unit Units;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Imagopas, Skemproc, CurrPhas, VoltPhas,CompPhas;

type
  TUnitsForm = class(TForm)
    CurrentBox: TGroupBox;
    AmperBut: TRadioButton;
    KiloAmperBut: TRadioButton;
    VoltBox: TGroupBox;
    VoltBut: TRadioButton;
    KiloVoltBut: TRadioButton;
    PowerBox: TGroupBox;
    VABut: TRadioButton;
    WattLabel: TLabel;
    VArLabel: TLabel;
    kVABut: TRadioButton;
    KiloWattLabel: TLabel;
    kVArBut: TLabel;
    MVABut: TRadioButton;
    MWLabel: TLabel;
    Label1: TLabel;
    OKBut: TButton;
    CancelBut: TButton;
    procedure OKButClick(Sender: TObject);
    procedure CancelButClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    A0 : integer;  {initial state of the ampere buttons}
    V0 : integer;
    W0 : integer;
  public
    { Public declarations }
  end;

var
  UnitsForm: TUnitsForm;

implementation

uses TimeDiff;

{$R *.DFM}

procedure TUnitsForm.OKButClick(Sender: TObject);
{save the flags for the units}
var
  A,V,W : string;
begin
  if (KiloAmperBut.checked) then begin
    SetComp.unit_A := 1;
    A := 'kA';
    TimeDiffForm.AmpLabel.caption := '[ kA ]';
  end else begin
    SetComp.unit_A := 0;
    A := 'A';
    TimeDiffForm.AmpLabel.caption := '[ A ]';
  end;
  if (KiloVoltBut.checked ) then begin
    SetComp.unit_V := 1;
    V := 'kV';
  end else begin
    SetComp.unit_V := 0;
    V := 'V';
  end;
  if (kVABut.checked) then begin
    SetComp.unit_W := 1;
    W := 'kW (kVA)';
  end else if (MVABut.checked) then begin
    SetComp.unit_W := 2;
    W := 'MW (MVA)';
  end else begin
    SetComp.unit_w := 0;
    W := 'W (VA)';
  end;
  {must still update the displayed results}
  SetComp.UpdateResultBoxes(1);
  ShowCurrOrNot(@SetComp, Imagoo.ShowCurrBut.down,Imagoo.ShowCurrBut.caption);  {in Skemproc.pas}
  ShowVoltagesOrNot(@SetComp, Imagoo.BusBut.down, Imagoo.BusBut.caption);   {in skemproc.pas}
  UpdateCurrPhasors;        {in CurrPhas.pas}
  UpdateVoltPhasors;
  UpdateCompPhasors;
  {update the caption}
  Imagoo.UnitsMenu.caption := A+' '+V+' '+W;
  UnitsForm.visible := false;
end;

procedure TUnitsForm.CancelButClick(Sender: TObject);
{restore the state of the buttons, hide the form}
begin
  if (A0 = 1) then kiloAmperBut.checked := true
  else AmperBut.checked := true;
  if (V0 = 1) then kiloVoltBut.checked := true
  else VoltBut.checked := true;
  if (W0 = 2) then MVABut.checked := true
  else if (W0 = 1) then kVABut.checked := true
  else VABut.checked := true;
  {hide the form}
  UnitsForm.visible := false;
end;

procedure TUnitsForm.FormActivate(Sender: TObject);
{save the present state of the buttons}
begin
  if (kiloAmperBut.checked) then A0 := 1 else A0 := 0;
  if (kiloVoltBut.checked) then V0 := 1 else V0 := 0;
  if (MVABut.checked) then W0 := 2
  else if (kVABut.checked) then W0 := 1
  else W0 := 0;
end;

procedure TUnitsForm.FormCreate(Sender: TObject);
begin
{add flag that form created}
  Imagoo.ReadyEdit.text := Imagoo.ReadyEdit.text+'U';
end;

end.
